/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/arrayiterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_arrayiterator.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "arrayiterator.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/arrayiterator.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: arrayiterator.pmc 40628 2009-08-18 17:24:24Z NotFound $

=head1 NAME

src/pmc/arrayiterator.pmc - Implementation of Iterator for Arrays.

=head1 DESCRIPTION

Generic iterator for traversing arrays.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = iter array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:


=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = iter array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 Warning!

NB: for different direction you have to use different ops!

TODO: Discuss idea of having separate get_iter/get_reverse_iter VTABLE methods
to avoid this caveat.

=head1 Methods

=over 4

=cut

*/
#line 75 "./src/pmc/arrayiterator.c"
static  PMC*  Parrot_ArrayIterator_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_ArrayIterator_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  INTVAL  Parrot_ArrayIterator_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_ArrayIterator_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  INTVAL  Parrot_ArrayIterator_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_ArrayIterator_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  FLOATVAL  Parrot_ArrayIterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_ArrayIterator_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  PMC  * Parrot_ArrayIterator_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ArrayIterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_ArrayIterator_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  STRING  * Parrot_ArrayIterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_ArrayIterator_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  void  Parrot_ArrayIterator_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ArrayIterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *array);
static  void  Parrot_ArrayIterator_mark(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_ArrayIterator_pop_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_pop_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ArrayIterator_pop_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_ArrayIterator_pop_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ArrayIterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  FLOATVAL  Parrot_ArrayIterator_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ArrayIterator_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_ArrayIterator_shift_string(PARROT_INTERP, PMC *pmc);
void    Parrot_ArrayIterator_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_get_vtable(PARROT_INTERP);
void    Parrot_ArrayIterator_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_ro_get_vtable(PARROT_INTERP);
static  PMC* 
Parrot_ArrayIterator_clone(PARROT_INTERP, PMC *pmc)
{
#line 123 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);
    PMC                             * const clone =
            pmc_new_init(interp, enum_class_ArrayIterator, attrs->array);
    Parrot_ArrayIterator_attributes * const clone_attrs =
            PARROT_ARRAYITERATOR(clone);

    clone_attrs->pos     = attrs->pos;
    clone_attrs->reverse = attrs->reverse;
    return clone;
#line 126 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 538 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_defined_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 134 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 552 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);
    /* Cheat! */
    const INTVAL final_pos = attrs->pos + idx - attrs->reverse;

    return VTABLE_defined_keyed_int(interp, attrs->array, final_pos);
#line 147 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_elements(PARROT_INTERP, PMC *pmc)
{
#line 160 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);
    if (attrs->reverse)
        return attrs->pos;
    else
        return attrs->length - attrs->pos;
#line 160 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 507 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_exists_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 168 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 521 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);
    /* Cheat! */
    const INTVAL final_pos = attrs->pos + idx - attrs->reverse;

    return VTABLE_exists_keyed_int(interp, attrs->array, final_pos);
#line 181 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 146 "./src/pmc/arrayiterator.pmc"

    return VTABLE_elements(interp, pmc) > 0;
#line 189 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 169 "./src/pmc/arrayiterator.pmc"

    return VTABLE_elements(interp, pmc);
#line 197 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 422 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_integer_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 205 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 436 "./src/pmc/arrayiterator.pmc"

    return VTABLE_get_integer_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            PARROT_ARRAYITERATOR(pmc)->pos + idx);
#line 214 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 449 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_number_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 222 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 463 "./src/pmc/arrayiterator.pmc"

    return VTABLE_get_number_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            PARROT_ARRAYITERATOR(pmc)->pos + idx);
#line 231 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 214 "./src/pmc/arrayiterator.pmc"

    PMC *array;
    GETATTR_ArrayIterator_array(interp, pmc, array);
    return array ? array : PMCNULL;
#line 241 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 396 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 249 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 410 "./src/pmc/arrayiterator.pmc"

    return VTABLE_get_pmc_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            PARROT_ARRAYITERATOR(pmc)->pos + idx);
#line 258 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 478 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_string_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 266 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 492 "./src/pmc/arrayiterator.pmc"

    return VTABLE_get_string_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            PARROT_ARRAYITERATOR(pmc)->pos + idx);
#line 275 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_init(PARROT_INTERP, PMC *pmc)
{
#line 71 "./src/pmc/arrayiterator.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "ArrayIterator init without aggregate");
#line 284 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *array)
{
#line 87 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
        (Parrot_ArrayIterator_attributes *) PMC_data(pmc);

    attrs->array     = array;

    PObj_custom_mark_SET(pmc);

    /* by default, iterate from start */
    VTABLE_set_integer_native(interp, pmc, ITERATE_FROM_START);
#line 300 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_mark(PARROT_INTERP, PMC *pmc)
{
#line 109 "./src/pmc/arrayiterator.pmc"

    PMC *array;
    GETATTR_ArrayIterator_array(interp, pmc, array);
    if (array)
         Parrot_gc_mark_PObj_alive(interp, (PObj *)array);
#line 311 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 334 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_number_keyed_int(interp, attrs->array, --attrs->pos);
#line 326 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 315 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_integer_keyed_int(interp, attrs->array, --attrs->pos);
#line 341 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 376 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_pmc_keyed_int(interp, attrs->array, --attrs->pos);
#line 356 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 354 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_string_keyed_int(interp, attrs->array, --attrs->pos);
#line 371 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 186 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);
    if (value == ITERATE_FROM_START) {
        attrs->reverse   = 0;
        attrs->pos       = 0;
        attrs->length    = VTABLE_elements(interp, attrs->array);
    }
    else if (value == ITERATE_FROM_END) {
        attrs->reverse   = 1;
        attrs->pos       = attrs->length
                         = VTABLE_elements(interp, attrs->array);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Wrong direction for ArrayIterator");
#line 393 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 250 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_number_keyed_int(interp, attrs->array, attrs->pos++);
#line 408 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 231 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (attrs->pos >= attrs->length)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_integer_keyed_int(interp, attrs->array, attrs->pos++);
#line 423 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 292 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_pmc_keyed_int(interp, attrs->array, attrs->pos++);
#line 438 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 270 "./src/pmc/arrayiterator.pmc"

    Parrot_ArrayIterator_attributes * const attrs =
            PARROT_ARRAYITERATOR(pmc);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    return VTABLE_get_string_keyed_int(interp, attrs->array, attrs->pos++);
#line 453 "./src/pmc/arrayiterator.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ArrayIterator_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ArrayIterator_clone;
    vt->defined_keyed = Parrot_ArrayIterator_defined_keyed;
    vt->defined_keyed_int = Parrot_ArrayIterator_defined_keyed_int;
    vt->elements = Parrot_ArrayIterator_elements;
    vt->exists_keyed = Parrot_ArrayIterator_exists_keyed;
    vt->exists_keyed_int = Parrot_ArrayIterator_exists_keyed_int;
    vt->get_bool = Parrot_ArrayIterator_get_bool;
    vt->get_integer = Parrot_ArrayIterator_get_integer;
    vt->get_integer_keyed = Parrot_ArrayIterator_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_ArrayIterator_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_ArrayIterator_get_number_keyed;
    vt->get_number_keyed_int = Parrot_ArrayIterator_get_number_keyed_int;
    vt->get_pmc = Parrot_ArrayIterator_get_pmc;
    vt->get_pmc_keyed = Parrot_ArrayIterator_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ArrayIterator_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_ArrayIterator_get_string_keyed;
    vt->get_string_keyed_int = Parrot_ArrayIterator_get_string_keyed_int;
    vt->init = Parrot_ArrayIterator_init;
    vt->init_pmc = Parrot_ArrayIterator_init_pmc;
    vt->mark = Parrot_ArrayIterator_mark;
    vt->pop_float = Parrot_ArrayIterator_pop_float;
    vt->pop_integer = Parrot_ArrayIterator_pop_integer;
    vt->pop_pmc = Parrot_ArrayIterator_pop_pmc;
    vt->pop_string = Parrot_ArrayIterator_pop_string;
    vt->set_integer_native = Parrot_ArrayIterator_set_integer_native;
    vt->shift_float = Parrot_ArrayIterator_shift_float;
    vt->shift_integer = Parrot_ArrayIterator_shift_integer;
    vt->shift_pmc = Parrot_ArrayIterator_shift_pmc;
    vt->shift_string = Parrot_ArrayIterator_shift_string;
    vt->attr_size = sizeof(Parrot_ArrayIterator_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ArrayIterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ArrayIterator_clone;
    vt->defined_keyed = Parrot_ArrayIterator_defined_keyed;
    vt->defined_keyed_int = Parrot_ArrayIterator_defined_keyed_int;
    vt->elements = Parrot_ArrayIterator_elements;
    vt->exists_keyed = Parrot_ArrayIterator_exists_keyed;
    vt->exists_keyed_int = Parrot_ArrayIterator_exists_keyed_int;
    vt->get_bool = Parrot_ArrayIterator_get_bool;
    vt->get_integer = Parrot_ArrayIterator_get_integer;
    vt->get_integer_keyed = Parrot_ArrayIterator_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_ArrayIterator_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_ArrayIterator_get_number_keyed;
    vt->get_number_keyed_int = Parrot_ArrayIterator_get_number_keyed_int;
    vt->get_pmc = Parrot_ArrayIterator_get_pmc;
    vt->get_pmc_keyed = Parrot_ArrayIterator_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ArrayIterator_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_ArrayIterator_get_string_keyed;
    vt->get_string_keyed_int = Parrot_ArrayIterator_get_string_keyed_int;
    vt->init = Parrot_ArrayIterator_init;
    vt->init_pmc = Parrot_ArrayIterator_init_pmc;
    vt->mark = Parrot_ArrayIterator_mark;
    vt->attr_size = sizeof(Parrot_ArrayIterator_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ArrayIterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_get_vtable(interp);
    Parrot_ArrayIterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ArrayIterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_ro_get_vtable(interp);
    Parrot_ArrayIterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ArrayIterator_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Iterator_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "ArrayIterator", 13, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ArrayIterator_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Iterator_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ArrayIterator")), PMCNULL);
    return isa;
}

void
Parrot_ArrayIterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Farray Ipos Ilength Ireverse ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ArrayIterator_get_vtable(interp);
        vt->base_type      = enum_class_ArrayIterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ArrayIterator");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_ArrayIterator_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ArrayIterator_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ArrayIterator;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ArrayIterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ArrayIterator_class_init */
#line 559 "./src/pmc/arrayiterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
