/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bigint.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bigint.h"
#include "pmc_default.h"
#include "bigint.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/bigint.pmc"
/*
Copyright (C) 2004-2009, Parrot Foundation.
$Id: bigint.pmc 41230 2009-09-12 13:37:58Z bacek $

=head1 NAME

src/pmc/bigint.pmc - BigInt PMC class

=head1 DESCRIPTION

C<BigInt> provides arbitrary precision integer mathematic functions.

=head2 Functions

=over 4

=item C<static void bigint_set_long(Interp*, PMC *, long value)>

=item C<static void bigint_set_double(Interp*, PMC *, double value)>

=cut

*/

/* TODO split that out into a separate file */

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
typedef struct BIGINT {
    mpz_t b;
} BIGINT;


static void
bigint_init(PARROT_INTERP, PMC *self) {
    Parrot_BigInt_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_BigInt_attributes);
    attrs->bi = mem_allocate_zeroed_typed(BIGINT);
    mpz_init(attrs->bi->b);
    PMC_data(self) = attrs;
}

static void
bigint_clear(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_clear(bi->b);
}

static void
bigint_set(PARROT_INTERP, PMC *dest, PMC *src) {
    BIGINT *bi_dest, *bi_src;
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    GETATTR_BigInt_bi(interp, src,  bi_src);
    mpz_clear(bi_dest->b);
    mpz_init(bi_dest->b);
    mpz_set(bi_dest->b, bi_src->b);
}

static void
bigint_set_long(PARROT_INTERP, PMC *self, long value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_si(bi->b, value);
}

static void
bigint_set_double(PARROT_INTERP, PMC *self, double value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_d(bi->b, value);
}

static void
bigint_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_str(bi->b, value, base);
}

static BIGINT*
bigint_get_self(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return bi;
}

static void
bigint_set_self(PARROT_INTERP, PMC *self, BIGINT *value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set(bi->b, (mpz_srcptr)((BIGINT*)value)->b);
}

static long
bigint_get_long(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    if (mpz_fits_slong_p(bi->b))
        return mpz_get_si(bi->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bigint_get_long: number too big");
}

static int
bigint_get_bool(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    if (mpz_sgn(bi->b) != 0)
        return 1;
    else
        return 0;
}

static char *
bigint_get_string(PARROT_INTERP, PMC *self, int base) {
    BIGINT *bi;
    size_t  n;
    char   *s;

    GETATTR_BigInt_bi(interp, self, bi);
    n = mpz_sizeinbase(bi->b, base) + 2;
    s = (char *)mem_sys_allocate(n);
    return mpz_get_str(s, base, bi->b);
}

static double
bigint_get_double(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return mpz_get_d(bi->b);
}

static void
bigint_add_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_add(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_add_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    if (value < 0)
        mpz_sub_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    else
        mpz_add_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_sub_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_sub(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_sub_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    if (value < 0)
        mpz_add_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    else
        mpz_sub_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_mul_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_mul(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_mul_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_mul_si(bi_dest->b, bi_self->b, value);
}

static void
bigint_pow_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_pow_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value) {
    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bigint_check_divide_zero(PARROT_INTERP, PMC *value) {
    /* Throw an exception if we are dividing by zero. */
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, value, bi);
    if (mpz_cmp_si(bi->b, 0) == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bigint_div_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    bigint_check_divide_zero(interp, value);
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    /* this is mpz_fdiv_q */
    mpz_div(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_div_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpz_div_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
        mpz_neg(bi_dest->b, bi_dest->b);
    }
    else
        mpz_div_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_fdiv_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    bigint_check_divide_zero(interp, value);
    mpz_fdiv_q(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_fdiv_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_fdiv_q_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
        mpz_neg(bi_dest->b, bi_dest->b);
    }
    else
        mpz_fdiv_q_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_mod_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    bigint_check_divide_zero(interp, value);
    mpz_mod(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_mod_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_mod_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    }
    else
        mpz_mod_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static INTVAL
bigint_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    BIGINT *bi_self, *bi_value;
    GETATTR_BigInt_bi(interp, self,  bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    return mpz_cmp(bi_self->b, bi_value->b);
}

static INTVAL
bigint_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return mpz_cmp_si(bi->b, value);
}

static void
bigint_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_abs(bi_dest->b, bi_self->b);
}

static void
bigint_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_neg(bi_dest->b, bi_self->b);
}

static void
bigint_bitwise_shl_bigint_int(PARROT_INTERP, PMC *self,
                              INTVAL value, PMC *dest)
{
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_mul_2exp(bi_dest->b, bi_self->b, (unsigned long int)value);
    else
        mpz_tdiv_q_2exp(bi_dest->b, bi_self->b, (unsigned long int)-value);
}

static void
bigint_bitwise_shr_bigint_int(PARROT_INTERP, PMC *self,
                              INTVAL value, PMC *dest)
{
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_tdiv_q_2exp(bi_dest->b, bi_self->b, (unsigned long int)value);
    else
        mpz_mul_2exp(bi_dest->b, bi_self->b, (unsigned long int)-value);
}

#else /* ifdef PARROT_HAS_GMP */

typedef struct BIGINT {
    INTVAL b; /* bogus definition for users without libgmp*/
} BIGINT;

static void
bigint_init(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_clear(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_long(PARROT_INTERP, PMC *self, long value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set(PARROT_INTERP, PMC *dest, PMC *src) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_double(PARROT_INTERP, PMC *self, double value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_self(PARROT_INTERP, PMC *self, BIGINT *value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static BIGINT*
bigint_get_self(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static char *
bigint_get_string(PARROT_INTERP, PMC *self, int base) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static long
bigint_get_long(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static long
bigint_get_bool(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static double
bigint_get_double(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_add_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_add_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_sub_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_sub_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mul_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mul_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_pow_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_div_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_div_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_fdiv_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_fdiv_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mod_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mod_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static INTVAL
bigint_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static INTVAL
bigint_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shl_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shl_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

#endif /* ifdef PARROT_HAS_GMP */
#line 586 "./src/pmc/bigint.c"
static  PMC  * Parrot_BigInt_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_BigInt_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_BigInt_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_BigInt_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_BigInt_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_BigInt_cmp(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_decrement(PARROT_INTERP, PMC *pmc);
static  void  Parrot_BigInt_destroy(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_BigInt_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_BigInt_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_BigInt_get_bignum(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_BigInt_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_BigInt_get_integer(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_BigInt_get_number(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_BigInt_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_BigInt_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_BigInt_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base);
static  void  Parrot_BigInt_i_absolute(PARROT_INTERP, PMC *pmc);
static  void Parrot_BigInt_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigInt_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigInt_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigInt_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigInt_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigInt_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigInt_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_BigInt_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigInt_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_BigInt_i_neg(PARROT_INTERP, PMC *pmc);
static  void Parrot_BigInt_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigInt_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_BigInt_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_BigInt_init(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_BigInt_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC * Parrot_BigInt_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_BigInt_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_BigInt_neg(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_BigInt_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_BigInt_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_BigInt_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigInt_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value);
static  void  Parrot_BigInt_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  PMC * Parrot_BigInt_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_BigInt_nci_version(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_BigInt_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_add_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigInt_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_subtract_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigInt_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigInt_multi_pow_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigInt_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigInt_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_modulus_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_modulus_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigInt_multi_cmp_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigInt_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigInt_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigInt_multi_is_equal_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigInt_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigInt_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigInt_multi_bitwise_shl_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_bitwise_shl_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_bitwise_shl_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_bitwise_shl_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_bitwise_shl_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_bitwise_shl_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigInt_multi_bitwise_shr_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_bitwise_shr_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_bitwise_shr_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigInt_multi_i_bitwise_shr_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_bitwise_shr_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigInt_multi_i_bitwise_shr_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
void    Parrot_BigInt_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_BigInt_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_BigInt_get_vtable(PARROT_INTERP);
void    Parrot_BigInt_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_BigInt_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_BigInt_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_BigInt_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1166 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_abs(interp, pmc, dest);
    return dest;
#line 716 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_add_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_add_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_add_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 826 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_add_bigint_int(interp, pmc, value, dest);
    return dest;
#line 755 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_bitwise_shl_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_bitwise_shl_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_bitwise_shl_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "bitwise_shl", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1243 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_bitwise_shl_bigint_int(interp, pmc, value, dest);
    return dest;
#line 794 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_bitwise_shr_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_bitwise_shr_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_bitwise_shr_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "bitwise_shr", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1316 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_bitwise_shr_bigint_int(interp, pmc, value, dest);
    return dest;
#line 833 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_clone(PARROT_INTERP, PMC *pmc)
{
#line 599 "./src/pmc/bigint.pmc"

    PMC *res = pmc_new(interp, pmc->vtable->base_type);
    bigint_set(interp, res, pmc);
    return res;
#line 843 "./src/pmc/bigint.c"
}
static  INTVAL
Parrot_BigInt_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_cmp_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_cmp_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_cmp_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  void 
Parrot_BigInt_decrement(PARROT_INTERP, PMC *pmc)
{
#line 800 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, 1, pmc);
#line 879 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_destroy(PARROT_INTERP, PMC *pmc)
{
#line 605 "./src/pmc/bigint.pmc"

    BIGINT                   *bi;
    Parrot_BigInt_attributes *attrs;

    bigint_clear(interp, pmc);

    attrs = (Parrot_BigInt_attributes*)PMC_data(pmc);
    mem_sys_free(attrs->bi);
    mem_sys_free(attrs);
    PMC_data(pmc) = NULL;
#line 895 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_divide_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_divide_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1017 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_div_bigint_int(interp, pmc, value, dest);
    return dest;
#line 934 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_floor_divide_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_floor_divide_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1063 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_fdiv_bigint_int(interp, pmc, value, dest);
    return dest;
#line 973 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_get_bignum(PARROT_INTERP, PMC *pmc)
{
#line 721 "./src/pmc/bigint.pmc"

    return pmc;
#line 981 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 735 "./src/pmc/bigint.pmc"

    return bigint_get_bool(interp, pmc);
#line 989 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 707 "./src/pmc/bigint.pmc"

    return bigint_get_long(interp, pmc);
#line 997 "./src/pmc/bigint.c"
}
static  FLOATVAL 
Parrot_BigInt_get_number(PARROT_INTERP, PMC *pmc)
{
#line 693 "./src/pmc/bigint.pmc"

    return bigint_get_double(interp, pmc);
#line 1005 "./src/pmc/bigint.c"
}
static  STRING  *
Parrot_BigInt_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 772 "./src/pmc/bigint.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    return Parrot_str_append(interp, s, CONST_STRING(interp, "L"));
#line 1014 "./src/pmc/bigint.c"
}
static  STRING  *
Parrot_BigInt_get_string(PARROT_INTERP, PMC *pmc)
{
#line 758 "./src/pmc/bigint.pmc"

    char   * const s  = bigint_get_string(interp, pmc, 10);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 1025 "./src/pmc/bigint.c"
}
static  STRING  *
Parrot_BigInt_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 765 "./src/pmc/bigint.pmc"

    char   * const s  = bigint_get_string(interp, pmc, base);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 1036 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1173 "./src/pmc/bigint.pmc"

    bigint_abs(interp, pmc, pmc);
#line 1044 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_add_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_add_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_add_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigInt_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 852 "./src/pmc/bigint.pmc"

    UNUSED(value)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_add_float' for FLOATVAL");
#line 1083 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 848 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, value, pmc);
#line 1091 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_bitwise_shl_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_bitwise_shl_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_bitwise_shl_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_bitwise_shl", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigInt_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1269 "./src/pmc/bigint.pmc"

    bigint_bitwise_shl_bigint_int(interp, pmc, value, pmc);
#line 1127 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_bitwise_shr_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_bitwise_shr_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_bitwise_shr_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_bitwise_shr", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigInt_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1342 "./src/pmc/bigint.pmc"

    bigint_bitwise_shr_bigint_int(interp, pmc, value, pmc);
#line 1163 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_divide_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_divide_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigInt_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1037 "./src/pmc/bigint.pmc"

    bigint_div_bigint_int(interp, pmc, value, pmc);
#line 1199 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_floor_divide_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_floor_divide_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_floor_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigInt_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1085 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint_int(interp, pmc, value, pmc);
#line 1235 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_modulus_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_modulus_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_modulus_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_modulus", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void
Parrot_BigInt_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_multiply_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_multiply_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_multiply_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigInt_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 962 "./src/pmc/bigint.pmc"

    UNUSED(value)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_multiply_float' for FLOATVAL");
#line 1302 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 958 "./src/pmc/bigint.pmc"

    bigint_mul_bigint_int(interp, pmc, value, pmc);
#line 1310 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 1197 "./src/pmc/bigint.pmc"

    bigint_neg(interp, pmc, pmc);
#line 1318 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_subtract_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigInt_multi_i_subtract_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigInt_multi_i_subtract_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigInt_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 908 "./src/pmc/bigint.pmc"

    UNUSED(value)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_subtract_float' for FLOATVAL");
#line 1357 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 904 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, value, pmc);
#line 1365 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_increment(PARROT_INTERP, PMC *pmc)
{
#line 786 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, 1, pmc);
#line 1373 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_init(PARROT_INTERP, PMC *pmc)
{
#line 594 "./src/pmc/bigint.pmc"

    bigint_init(interp, pmc);
    PObj_custom_destroy_SET(pmc);
#line 1382 "./src/pmc/bigint.c"
}
static  INTVAL
Parrot_BigInt_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_is_equal_BigInt(interp, pmc, value);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_is_equal_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_is_equal_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_BigInt_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_modulus_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_modulus_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_modulus_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "modulus", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_BigInt_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_multiply_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_multiply_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_multiply_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 938 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_mul_bigint_int(interp, pmc, value, dest);
    return dest;
#line 1477 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1190 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_neg(interp, pmc, dest);
    return dest;
#line 1488 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_pow_PMC_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "pow", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 969 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_pow_bigint_int(interp, pmc, value, dest);
    return dest;
#line 1519 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 625 "./src/pmc/bigint.pmc"

    bigint_set_long(interp, pmc, (long)value);
#line 1527 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 639 "./src/pmc/bigint.pmc"

    bigint_set_double(interp, pmc, (double)value);
#line 1535 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 679 "./src/pmc/bigint.pmc"

    bigint_set_self(interp, pmc, bigint_get_self(interp, value));
#line 1543 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value)
{
#line 664 "./src/pmc/bigint.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, base);
    Parrot_str_free_cstring(s);
#line 1553 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 658 "./src/pmc/bigint.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, 10);
    Parrot_str_free_cstring(s);
#line 1563 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_subtract_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigInt_multi_subtract_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigInt_multi_subtract_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigInt_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 882 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_sub_bigint_int(interp, pmc, value, dest);
    return dest;
#line 1602 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_nci_version(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1640 "./src/pmc/bigint.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1656 "./src/pmc/bigint.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 584 "./src/pmc/bigint.pmc"

    STRING *version;
#ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
#else
    version = CONST_STRING(interp, "0.0.0");
#endif
    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
    /*BEGIN GENERATED ACCESSORS */
#line 1675 "./src/pmc/bigint.pmc"
    CTX_REG_STR(_ctx, 0) = version;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto version_returns;
    /*END RETURN STRING *version */
    }
#line 591 "./src/pmc/bigint.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
version_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1720 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 804 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_add_bigint(interp, pmc, value, dest);
    return dest;
#line 1731 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 811 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_add_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1742 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 818 "./src/pmc/bigint.pmc"

    UNUSED(dest)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'add' for %Ss",
        VTABLE_name(interp, value));
#line 1754 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_add_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 833 "./src/pmc/bigint.pmc"

    bigint_add_bigint(interp, pmc, value, pmc);
#line 1762 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 837 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1770 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 841 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_add' for %Ss",
        VTABLE_name(interp, value));
#line 1781 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 860 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_sub_bigint(interp, pmc, value, dest);
    return dest;
#line 1792 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 867 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_sub_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1803 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 874 "./src/pmc/bigint.pmc"

    UNUSED(dest)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1815 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_subtract_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 889 "./src/pmc/bigint.pmc"

    bigint_sub_bigint(interp, pmc, value, pmc);
#line 1823 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 893 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1831 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 897 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1842 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 916 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_mul_bigint(interp, pmc, value, dest);
    return dest;
#line 1853 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 923 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_mul_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1864 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 930 "./src/pmc/bigint.pmc"

    UNUSED(dest)
     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1876 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 945 "./src/pmc/bigint.pmc"

    bigint_mul_bigint(interp, pmc, value, pmc);
#line 1884 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 948 "./src/pmc/bigint.pmc"

    bigint_mul_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1892 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 951 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1903 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_pow_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 976 "./src/pmc/bigint.pmc"

    /* XXX only Integer RHS currently */
    const INTVAL r = VTABLE_get_integer(interp, value);
    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_pow_bigint_int(interp, pmc, r, dest);
    return dest;
#line 1916 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 985 "./src/pmc/bigint.pmc"

    BIGINT *bi;
    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_div_bigint(interp, pmc, value, dest);
#if 0
    /* to downgrade or not that's the question */
    GETATTR_BigInt_bi(interp, dest, bi);
    if (mpz_fits_slong_p(bi->b)) {
        long iresult = mpz_get_si(bi->b);
        VTABLE_morph(interp, dest, enum_class_Integer);
        VTABLE_set_integer_native(interp, dest, iresult);
    }
#endif
    return dest;
#line 1937 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1002 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_div_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1948 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1009 "./src/pmc/bigint.pmc"

    UNUSED(dest)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'divide' for %Ss",
        VTABLE_name(interp, value));
#line 1960 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1024 "./src/pmc/bigint.pmc"

    bigint_div_bigint(interp, pmc, value, pmc);
#line 1968 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1027 "./src/pmc/bigint.pmc"

    bigint_div_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1976 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1030 "./src/pmc/bigint.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1987 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1041 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_fdiv_bigint(interp, pmc, value, dest);
    return dest;
#line 1998 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1048 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_fdiv_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2009 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1055 "./src/pmc/bigint.pmc"

    UNUSED(dest)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 2021 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1070 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint(interp, pmc, value, pmc);
#line 2029 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1074 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 2037 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1078 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 2048 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1089 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_mod_bigint(interp, pmc, value, dest);
    return dest;
#line 2059 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_modulus_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1096 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_mod_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2070 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1103 "./src/pmc/bigint.pmc"

    UNUSED(dest)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'modulus' for %Ss",
        VTABLE_name(interp, value));
#line 2082 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1111 "./src/pmc/bigint.pmc"

    bigint_mod_bigint(interp, pmc, value, pmc);
#line 2090 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_modulus_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1114 "./src/pmc/bigint.pmc"

    bigint_mod_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 2098 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1117 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_modulus' for %Ss",
        VTABLE_name(interp, value));
#line 2109 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_cmp_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1124 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, pmc, value);
#line 2117 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1128 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 2125 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1132 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'cmp' for %Ss",
        VTABLE_name(interp, value));
#line 2136 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_is_equal_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1139 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, pmc, value) == 0;
#line 2144 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1143 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, pmc, VTABLE_get_integer(interp, value)) == 0;
#line 2152 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1147 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'is_equal' for %Ss",
        VTABLE_name(interp, value));
#line 2163 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_bitwise_shl_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1219 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_bitwise_shl_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  dest);
    return dest;
#line 2176 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_bitwise_shl_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1228 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_bitwise_shl_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2188 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_bitwise_shl_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1235 "./src/pmc/bigint.pmc"

    UNUSED(dest)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'bitwise_shl' for %Ss",
        VTABLE_name(interp, value));
#line 2200 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_bitwise_shl_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1251 "./src/pmc/bigint.pmc"

    bigint_bitwise_shl_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  pmc);
#line 2210 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_bitwise_shl_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1257 "./src/pmc/bigint.pmc"

    bigint_bitwise_shl_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), pmc);
#line 2219 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_bitwise_shl_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1262 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_bitwise_shl' for %Ss",
        VTABLE_name(interp, value));
#line 2230 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_bitwise_shr_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1291 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_bitwise_shr_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  dest);
    return dest;
#line 2243 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_bitwise_shr_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1300 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    bigint_bitwise_shr_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2255 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_bitwise_shr_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1308 "./src/pmc/bigint.pmc"

    UNUSED(dest)
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'bitwise_shr' for %Ss",
        VTABLE_name(interp, value));
#line 2267 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_bitwise_shr_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1324 "./src/pmc/bigint.pmc"

    bigint_bitwise_shr_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  pmc);
#line 2277 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_bitwise_shr_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1330 "./src/pmc/bigint.pmc"

    bigint_bitwise_shr_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), pmc);
#line 2286 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_bitwise_shr_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1335 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_bitwise_shr' for %Ss",
        VTABLE_name(interp, value));
#line 2297 "./src/pmc/bigint.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_BigInt_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_BigInt_absolute;
    vt->add = Parrot_BigInt_add;
    vt->add_int = Parrot_BigInt_add_int;
    vt->bitwise_shl = Parrot_BigInt_bitwise_shl;
    vt->bitwise_shl_int = Parrot_BigInt_bitwise_shl_int;
    vt->bitwise_shr = Parrot_BigInt_bitwise_shr;
    vt->bitwise_shr_int = Parrot_BigInt_bitwise_shr_int;
    vt->clone = Parrot_BigInt_clone;
    vt->cmp = Parrot_BigInt_cmp;
    vt->decrement = Parrot_BigInt_decrement;
    vt->destroy = Parrot_BigInt_destroy;
    vt->divide = Parrot_BigInt_divide;
    vt->divide_int = Parrot_BigInt_divide_int;
    vt->floor_divide = Parrot_BigInt_floor_divide;
    vt->floor_divide_int = Parrot_BigInt_floor_divide_int;
    vt->get_bignum = Parrot_BigInt_get_bignum;
    vt->get_bool = Parrot_BigInt_get_bool;
    vt->get_integer = Parrot_BigInt_get_integer;
    vt->get_number = Parrot_BigInt_get_number;
    vt->get_repr = Parrot_BigInt_get_repr;
    vt->get_string = Parrot_BigInt_get_string;
    vt->get_string_keyed_int = Parrot_BigInt_get_string_keyed_int;
    vt->i_absolute = Parrot_BigInt_i_absolute;
    vt->i_add = Parrot_BigInt_i_add;
    vt->i_add_float = Parrot_BigInt_i_add_float;
    vt->i_add_int = Parrot_BigInt_i_add_int;
    vt->i_bitwise_shl = Parrot_BigInt_i_bitwise_shl;
    vt->i_bitwise_shl_int = Parrot_BigInt_i_bitwise_shl_int;
    vt->i_bitwise_shr = Parrot_BigInt_i_bitwise_shr;
    vt->i_bitwise_shr_int = Parrot_BigInt_i_bitwise_shr_int;
    vt->i_divide = Parrot_BigInt_i_divide;
    vt->i_divide_int = Parrot_BigInt_i_divide_int;
    vt->i_floor_divide = Parrot_BigInt_i_floor_divide;
    vt->i_floor_divide_int = Parrot_BigInt_i_floor_divide_int;
    vt->i_modulus = Parrot_BigInt_i_modulus;
    vt->i_multiply = Parrot_BigInt_i_multiply;
    vt->i_multiply_float = Parrot_BigInt_i_multiply_float;
    vt->i_multiply_int = Parrot_BigInt_i_multiply_int;
    vt->i_neg = Parrot_BigInt_i_neg;
    vt->i_subtract = Parrot_BigInt_i_subtract;
    vt->i_subtract_float = Parrot_BigInt_i_subtract_float;
    vt->i_subtract_int = Parrot_BigInt_i_subtract_int;
    vt->increment = Parrot_BigInt_increment;
    vt->init = Parrot_BigInt_init;
    vt->is_equal = Parrot_BigInt_is_equal;
    vt->modulus = Parrot_BigInt_modulus;
    vt->multiply = Parrot_BigInt_multiply;
    vt->multiply_int = Parrot_BigInt_multiply_int;
    vt->neg = Parrot_BigInt_neg;
    vt->pow = Parrot_BigInt_pow;
    vt->pow_int = Parrot_BigInt_pow_int;
    vt->set_integer_native = Parrot_BigInt_set_integer_native;
    vt->set_number_native = Parrot_BigInt_set_number_native;
    vt->set_pmc = Parrot_BigInt_set_pmc;
    vt->set_string_keyed_int = Parrot_BigInt_set_string_keyed_int;
    vt->set_string_native = Parrot_BigInt_set_string_native;
    vt->subtract = Parrot_BigInt_subtract;
    vt->subtract_int = Parrot_BigInt_subtract_int;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_BigInt_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_BigInt_absolute;
    vt->add = Parrot_BigInt_add;
    vt->add_int = Parrot_BigInt_add_int;
    vt->bitwise_shl = Parrot_BigInt_bitwise_shl;
    vt->bitwise_shl_int = Parrot_BigInt_bitwise_shl_int;
    vt->bitwise_shr = Parrot_BigInt_bitwise_shr;
    vt->bitwise_shr_int = Parrot_BigInt_bitwise_shr_int;
    vt->clone = Parrot_BigInt_clone;
    vt->cmp = Parrot_BigInt_cmp;
    vt->destroy = Parrot_BigInt_destroy;
    vt->divide = Parrot_BigInt_divide;
    vt->divide_int = Parrot_BigInt_divide_int;
    vt->floor_divide = Parrot_BigInt_floor_divide;
    vt->floor_divide_int = Parrot_BigInt_floor_divide_int;
    vt->get_bignum = Parrot_BigInt_get_bignum;
    vt->get_bool = Parrot_BigInt_get_bool;
    vt->get_integer = Parrot_BigInt_get_integer;
    vt->get_number = Parrot_BigInt_get_number;
    vt->get_repr = Parrot_BigInt_get_repr;
    vt->get_string = Parrot_BigInt_get_string;
    vt->get_string_keyed_int = Parrot_BigInt_get_string_keyed_int;
    vt->init = Parrot_BigInt_init;
    vt->is_equal = Parrot_BigInt_is_equal;
    vt->modulus = Parrot_BigInt_modulus;
    vt->multiply = Parrot_BigInt_multiply;
    vt->multiply_int = Parrot_BigInt_multiply_int;
    vt->neg = Parrot_BigInt_neg;
    vt->pow = Parrot_BigInt_pow;
    vt->pow_int = Parrot_BigInt_pow_int;
    vt->subtract = Parrot_BigInt_subtract;
    vt->subtract_int = Parrot_BigInt_subtract_int;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigInt_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_BigInt_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigInt_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_BigInt_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_BigInt_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "BigInt", 6, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_BigInt_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "BigInt")), PMCNULL);
    return isa;
}

void
Parrot_BigInt_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":bi ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_BigInt_get_vtable(interp);
        vt->base_type      = enum_class_BigInt;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "BigInt");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_BigInt_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_BigInt;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_BigInt_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_BigInt_nci_version), CONST_STRING_GEN(interp, "version"));
        {
        STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
        STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
        STRING * const mfl_2 = CONST_STRING_GEN(interp, "BigInt,BigInt,PMC");
        STRING * const mfl_3 = CONST_STRING_GEN(interp, "BigInt");
        STRING * const mfl_4 = CONST_STRING_GEN(interp, "BigInt,Integer,PMC");
        STRING * const mfl_5 = CONST_STRING_GEN(interp, "BigInt,DEFAULT,PMC");
        STRING * const mfl_6 = CONST_STRING_GEN(interp, "i_add");
        STRING * const mfl_7 = CONST_STRING_GEN(interp, "vJPP");
        STRING * const mfl_8 = CONST_STRING_GEN(interp, "BigInt,BigInt");
        STRING * const mfl_9 = CONST_STRING_GEN(interp, "BigInt,Integer");
        STRING * const mfl_10 = CONST_STRING_GEN(interp, "BigInt,DEFAULT");
        STRING * const mfl_11 = CONST_STRING_GEN(interp, "subtract");
        STRING * const mfl_12 = CONST_STRING_GEN(interp, "i_subtract");
        STRING * const mfl_13 = CONST_STRING_GEN(interp, "multiply");
        STRING * const mfl_14 = CONST_STRING_GEN(interp, "i_multiply");
        STRING * const mfl_15 = CONST_STRING_GEN(interp, "pow");
        STRING * const mfl_16 = CONST_STRING_GEN(interp, "BigInt,PMC,PMC");
        STRING * const mfl_17 = CONST_STRING_GEN(interp, "divide");
        STRING * const mfl_18 = CONST_STRING_GEN(interp, "i_divide");
        STRING * const mfl_19 = CONST_STRING_GEN(interp, "floor_divide");
        STRING * const mfl_20 = CONST_STRING_GEN(interp, "i_floor_divide");
        STRING * const mfl_21 = CONST_STRING_GEN(interp, "modulus");
        STRING * const mfl_22 = CONST_STRING_GEN(interp, "i_modulus");
        STRING * const mfl_23 = CONST_STRING_GEN(interp, "cmp");
        STRING * const mfl_24 = CONST_STRING_GEN(interp, "IJPP");
        STRING * const mfl_25 = CONST_STRING_GEN(interp, "is_equal");
        STRING * const mfl_26 = CONST_STRING_GEN(interp, "bitwise_shl");
        STRING * const mfl_27 = CONST_STRING_GEN(interp, "i_bitwise_shl");
        STRING * const mfl_28 = CONST_STRING_GEN(interp, "bitwise_shr");
        STRING * const mfl_29 = CONST_STRING_GEN(interp, "i_bitwise_shr");

             const  multi_func_list _temp_multi_func_list[] = {
                        { mfl_0,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_add_BigInt_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_add_Integer_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_add_DEFAULT_PMC }
,
        { mfl_6,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_add_BigInt }
,
        { mfl_6,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_add_Integer }
,
        { mfl_6,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_add_DEFAULT }
,
        { mfl_11,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_subtract_BigInt_PMC }
,
        { mfl_11,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_subtract_Integer_PMC }
,
        { mfl_11,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_subtract_DEFAULT_PMC }
,
        { mfl_12,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_subtract_BigInt }
,
        { mfl_12,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_subtract_Integer }
,
        { mfl_12,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_subtract_DEFAULT }
,
        { mfl_13,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_multiply_BigInt_PMC }
,
        { mfl_13,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_multiply_Integer_PMC }
,
        { mfl_13,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_multiply_DEFAULT_PMC }
,
        { mfl_14,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_multiply_BigInt }
,
        { mfl_14,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_multiply_Integer }
,
        { mfl_14,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_multiply_DEFAULT }
,
        { mfl_15,
          mfl_1,
          mfl_16,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_pow_PMC_PMC }
,
        { mfl_17,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_divide_BigInt_PMC }
,
        { mfl_17,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_divide_Integer_PMC }
,
        { mfl_17,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_divide_DEFAULT_PMC }
,
        { mfl_18,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_divide_BigInt }
,
        { mfl_18,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_divide_Integer }
,
        { mfl_18,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_divide_DEFAULT }
,
        { mfl_19,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_floor_divide_BigInt_PMC }
,
        { mfl_19,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_floor_divide_Integer_PMC }
,
        { mfl_19,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_floor_divide_DEFAULT_PMC }
,
        { mfl_20,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_floor_divide_BigInt }
,
        { mfl_20,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_floor_divide_Integer }
,
        { mfl_20,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_floor_divide_DEFAULT }
,
        { mfl_21,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_modulus_BigInt_PMC }
,
        { mfl_21,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_modulus_Integer_PMC }
,
        { mfl_21,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_modulus_DEFAULT_PMC }
,
        { mfl_22,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_modulus_BigInt }
,
        { mfl_22,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_modulus_Integer }
,
        { mfl_22,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_modulus_DEFAULT }
,
        { mfl_23,
          mfl_24,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_cmp_BigInt }
,
        { mfl_23,
          mfl_24,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_cmp_Integer }
,
        { mfl_23,
          mfl_24,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_cmp_DEFAULT }
,
        { mfl_25,
          mfl_24,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_is_equal_BigInt }
,
        { mfl_25,
          mfl_24,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_is_equal_Integer }
,
        { mfl_25,
          mfl_24,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_is_equal_DEFAULT }
,
        { mfl_26,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_bitwise_shl_BigInt_PMC }
,
        { mfl_26,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_bitwise_shl_Integer_PMC }
,
        { mfl_26,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_bitwise_shl_DEFAULT_PMC }
,
        { mfl_27,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shl_BigInt }
,
        { mfl_27,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shl_Integer }
,
        { mfl_27,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shl_DEFAULT }
,
        { mfl_28,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_bitwise_shr_BigInt_PMC }
,
        { mfl_28,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_bitwise_shr_Integer_PMC }
,
        { mfl_28,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_bitwise_shr_DEFAULT_PMC }
,
        { mfl_29,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shr_BigInt }
,
        { mfl_29,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shr_Integer }
,
        { mfl_29,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shr_DEFAULT }

            };
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_BigInt_class_init */
#line 1344 "./src/pmc/bigint.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
