/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/continuation.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_continuation.h"
#include "pmc_default.h"
#include "continuation.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/continuation.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: continuation.pmc 41262 2009-09-14 18:31:31Z NotFound $

=head1 NAME

src/pmc/continuation.pmc - Continuation PMC

=head1 DESCRIPTION

A C<Continuation> has a copy of the interpreter's context at the location where
the Continuation was constructed.  See the L<Glossary|docs/glossary.pod> for
more information.

=head2 Functions

=over 4

=cut

*/


#include "parrot/oplib/ops.h"
#include "pmc_sub.h"

/*

=back

=head2 Methods

=over 4

=cut

*/


/*
 * A Continuation (and RetContinuation, ExceptionHandler) has in its
 * context a pointer to the register frame, which contains active objects.
 * Additionally ct->current_cont has the continuation of the caller.
 * To avoid deep recursion during marking of nested subroutines, we
 * need the next_for_GC pointer.
 */
#line 69 "./src/pmc/continuation.c"
static  PMC  * Parrot_Continuation_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Continuation_defined(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Continuation_get_bool(PARROT_INTERP, PMC *pmc);
static  void  * Parrot_Continuation_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Continuation_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_init_pmc(PARROT_INTERP, PMC *pmc, PMC *values);
static  opcode_t  * Parrot_Continuation_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_Continuation_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_set_pmc(PARROT_INTERP, PMC *pmc, PMC *src);
static  void  Parrot_Continuation_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void Parrot_Continuation_nci_caller(PARROT_INTERP, PMC *pmc);
static  void Parrot_Continuation_nci_continuation(PARROT_INTERP, PMC *pmc);
void    Parrot_Continuation_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Continuation_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Continuation_get_vtable(PARROT_INTERP);
void    Parrot_Continuation_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Continuation_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Continuation_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Continuation_clone(PARROT_INTERP, PMC *pmc)
{
#line 150 "./src/pmc/continuation.pmc"

    /* Start to prepare for subclassable continuations */
    INTVAL type = pmc->vtable->base_type;
    PMC * ret = pmc_new_init(interp, type, pmc);
    return ret;
#line 98 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_defined(PARROT_INTERP, PMC *pmc)
{
#line 222 "./src/pmc/continuation.pmc"

    return PARROT_CONTINUATION(pmc)->address != NULL;
#line 106 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 226 "./src/pmc/continuation.pmc"

    return PARROT_CONTINUATION(pmc)->address != NULL;
#line 114 "./src/pmc/continuation.c"
}
static  void  *
Parrot_Continuation_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 206 "./src/pmc/continuation.pmc"

    return PARROT_CONTINUATION(pmc)->address;
#line 122 "./src/pmc/continuation.c"
}
static  STRING  *
Parrot_Continuation_get_string(PARROT_INTERP, PMC *pmc)
{
#line 292 "./src/pmc/continuation.pmc"

    return Parrot_Context_infostr(interp, PARROT_CONTINUATION(pmc)->to_ctx);
#line 130 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_init(PARROT_INTERP, PMC *pmc)
{
#line 69 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const attrs = PARROT_CONTINUATION(pmc);

    attrs->to_ctx     = CURRENT_CONTEXT(interp);
    attrs->from_ctx   = CURRENT_CONTEXT(interp);
    attrs->runloop_id = 0;
    attrs->seg        = interp->code;
    attrs->address    = NULL;
    attrs->current_results = Parrot_pcc_get_results(interp, attrs->to_ctx);

    PObj_custom_mark_SET(pmc);

    /* PANIC("don't do that"); */
    /*
     * Whenever we create a continuation, all return continuations
     * up the call chain may be reused due to invoking the
     * continuation. To avoid that all return continuations are
     * converted to true continuations.
     */
    invalidate_retc_context(interp, pmc);
#line 156 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_init_pmc(PARROT_INTERP, PMC *pmc, PMC *values)
{
#line 92 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const attrs  = PARROT_CONTINUATION(pmc);
    Parrot_Continuation_attributes * const theirs = PARROT_CONTINUATION(values);

    attrs->to_ctx     = theirs->to_ctx;
    attrs->from_ctx   = CURRENT_CONTEXT(interp);
    attrs->runloop_id = 0;
    attrs->seg        = theirs->seg;
    attrs->address    = theirs->address;
    attrs->current_results = Parrot_pcc_get_results(interp, attrs->to_ctx);

    PObj_custom_mark_SET(pmc);

    /* PANIC("don't do that"); */
    /*
     * Whenever we create a continuation, all return continuations
     * up the call chain may be reused due to invoking the
     * continuation. To avoid that all return continuations are
     * converted to true continuations.
     */
    invalidate_retc_context(interp, pmc);
#line 183 "./src/pmc/continuation.c"
}
static  opcode_t  *
Parrot_Continuation_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 241 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const cc = PARROT_CONTINUATION(pmc);
    PMC      *from_ctx = CURRENT_CONTEXT(interp);
    PMC      *to_ctx   = cc->to_ctx;
    opcode_t *pc       = cc->address;
    UNUSED(next)

    Parrot_continuation_check(interp, pmc);
    Parrot_continuation_rewind_environment(interp, pmc);

    /* pass args to where caller wants result */
    if (cc->current_results)
        Parrot_pcc_set_results(interp, to_ctx, cc->current_results);

    if (Parrot_pcc_get_results(interp, to_ctx) && interp->current_args) {
        /*
         * the register pointer is already switched back
         * to the caller, therefore the registers of the
         * sub we are returning from aren't marked, if
         * inside argument passing a GC run is triggered
         * therefore we have to block GC
         */
        opcode_t *src_indexes  = interp->current_args;
        opcode_t *dest_indexes = Parrot_pcc_get_results(interp, to_ctx);
        interp->current_args   = NULL;

        Parrot_block_GC_mark(interp);
        parrot_pass_args(interp, from_ctx, to_ctx,
                         src_indexes, dest_indexes, PARROT_PASS_PARAMS);
        Parrot_unblock_GC_mark(interp);
    }

    /* switch segment */
    interp->current_args = NULL;

    if (interp->code != cc->seg)
        Parrot_switch_to_cs(interp, cc->seg, 1);

    return pc;
#line 228 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_mark(PARROT_INTERP, PMC *pmc)
{
#line 127 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const cc = PARROT_CONTINUATION(pmc);

    /* If Continuation wasn't fully constructed yet */
    if (!cc)
        return;

    if (cc->to_ctx)
        Parrot_gc_mark_PObj_alive(interp, (PObj *) cc->to_ctx);
    if (cc->from_ctx)
        Parrot_gc_mark_PObj_alive(interp, (PObj *) cc->from_ctx);
#line 245 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pmc(PARROT_INTERP, PMC *pmc, PMC *src)
{
#line 166 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const cc_self = PARROT_CONTINUATION(pmc);
    Parrot_Continuation_attributes * const cc_src  = PARROT_CONTINUATION(src);

    STRUCT_COPY(cc_self, cc_src);
#line 256 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 183 "./src/pmc/continuation.pmc"

    opcode_t                       * const pos = (opcode_t *)value;
    Parrot_Continuation_attributes * const cc  = PARROT_CONTINUATION(pmc);

    cc->address    = pos;
    cc->runloop_id = interp->current_runloop_id;

    if (pos && (*pos == PARROT_OP_get_results_pc))
        cc->current_results = pos;
    else
        cc->current_results = NULL;
#line 273 "./src/pmc/continuation.c"
}
static  void
Parrot_Continuation_nci_caller(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 311 "./src/pmc/continuation.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 327 "./src/pmc/continuation.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 306 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const cc = PARROT_CONTINUATION(pmc);
    PMC *caller = Parrot_pcc_get_sub(interp, cc->to_ctx);

    if (!caller)
        caller = PMCNULL;
    else {
        Parrot_Sub_attributes *sub;
        PMC_get_sub(interp, caller, sub);
        if (!sub->seg)
            caller = PMCNULL;
    }

    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *caller */
    /*BEGIN GENERATED ACCESSORS */
#line 352 "./src/pmc/continuation.pmc"
    CTX_REG_PMC(_ctx, 0) = caller;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto caller_returns;
    /*END RETURN PMC *caller */
    }
#line 319 "./src/pmc/continuation.pmc"


#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
caller_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 398 "./src/pmc/continuation.c"
}
static  void
Parrot_Continuation_nci_continuation(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 436 "./src/pmc/continuation.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 452 "./src/pmc/continuation.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 332 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const cc = PARROT_CONTINUATION(pmc);
    PMC * const cont = Parrot_pcc_get_continuation(interp, cc->to_ctx);

    if (cont)
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *cont */
    /*BEGIN GENERATED ACCESSORS */
#line 469 "./src/pmc/continuation.pmc"
    CTX_REG_PMC(_ctx, 0) = cont;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto continuation_returns;
    /*END RETURN PMC *cont */
    }
#line 337 "./src/pmc/continuation.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 493 "./src/pmc/continuation.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto continuation_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 339 "./src/pmc/continuation.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
continuation_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 538 "./src/pmc/continuation.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Continuation_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->init = Parrot_Continuation_init;
    vt->init_pmc = Parrot_Continuation_init_pmc;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;
    vt->set_pmc = Parrot_Continuation_set_pmc;
    vt->set_pointer = Parrot_Continuation_set_pointer;
    vt->attr_size = sizeof(Parrot_Continuation_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Continuation_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->init = Parrot_Continuation_init;
    vt->init_pmc = Parrot_Continuation_init_pmc;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;
    vt->attr_size = sizeof(Parrot_Continuation_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Continuation_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Continuation_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Continuation_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Continuation", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Continuation_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Continuation")), PMCNULL);
    return isa;
}

void
Parrot_Continuation_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :address Fto_ctx Ffrom_ctx :current_results :runloop_id :invoked ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Continuation_get_vtable(interp);
        vt->base_type      = enum_class_Continuation;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Continuation");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Continuation_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Continuation;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Continuation_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Continuation_nci_caller), CONST_STRING_GEN(interp, "caller"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Continuation_nci_continuation), CONST_STRING_GEN(interp, "continuation"));
        {
        }
    } /* pass */
} /* Parrot_Continuation_class_init */
#line 340 "./src/pmc/continuation.pmc"


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
