/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/coroutine.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_coroutine.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "coroutine.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/coroutine.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: coroutine.pmc 41245 2009-09-13 02:24:40Z jkeenan $

=head1 NAME

src/pmc/coroutine.pmc - Co-Routine PMC

=head1 DESCRIPTION

C<Coroutine> extends C<Sub> to provide a subroutine that can
stop in the middle, and start back up later at the point at which it
stopped. See the L<Glossary|docs/glossary.pod> for more information.

=head2 Flags

=over 4

=item private0 call flip flop

=item private3 restore current sub after "flop".  Used by generators.

=back

=head2 Methods

=over 4

=cut

*/

#include "parrot/oplib/ops.h"

static void
print_sub_name(PARROT_INTERP, PMC *sub_pmc)
{
    /* It's actually a Parrot_coro, but this avoids casting warnings. */
    Parrot_Sub_attributes *co = PARROT_SUB(sub_pmc);
    Interp      * const tracer = (interp->pdb && interp->pdb->debugger) ?
        interp->pdb->debugger :
        interp;

    Parrot_io_eprintf(tracer, "# %s coro '%Ss'",
        !(PObj_get_FLAGS(sub_pmc) & SUB_FLAG_CORO_FF) ?
        "Calling" : "yielding from",
        Parrot_full_sub_name(interp, sub_pmc));

    if (co->ctx && (PObj_get_FLAGS(sub_pmc) & SUB_FLAG_CORO_FF)) {
        Parrot_io_eprintf(tracer, " to '%Ss'",
                Parrot_full_sub_name(interp,
                    Parrot_pcc_get_sub(interp, Parrot_pcc_get_caller_ctx(interp, co->ctx))));
    }

    Parrot_io_eprintf(tracer, "\n# ");
    print_pbc_location(interp);
}
#line 80 "./src/pmc/coroutine.c"
static  PMC  * Parrot_Coroutine_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Coroutine_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Coroutine_init(PARROT_INTERP, PMC *pmc);
static  opcode_t  * Parrot_Coroutine_invoke(PARROT_INTERP, PMC *pmc, void *next);
void    Parrot_Coroutine_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Coroutine_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Coroutine_get_vtable(PARROT_INTERP);
void    Parrot_Coroutine_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Coroutine_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Coroutine_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Coroutine_clone(PARROT_INTERP, PMC *pmc)
{
#line 98 "./src/pmc/coroutine.pmc"

    PMC * const ret = pmc_new(interp, pmc->vtable->base_type);
    Parrot_Coroutine_attributes * const sub      = PARROT_COROUTINE(pmc);
    Parrot_Coroutine_attributes * const coro_sub = PARROT_COROUTINE(ret);

    PObj_custom_mark_destroy_SETALL(ret);

    memcpy(coro_sub, sub, sizeof (Parrot_Coroutine_attributes));

    coro_sub->name = Parrot_str_copy(interp, coro_sub->name);

    return ret;
#line 107 "./src/pmc/coroutine.c"
}
static  void 
Parrot_Coroutine_increment(PARROT_INTERP, PMC *pmc)
{
#line 122 "./src/pmc/coroutine.pmc"

    SETATTR_Coroutine_yield(interp, pmc, 1);
#line 115 "./src/pmc/coroutine.c"
}
static  void 
Parrot_Coroutine_init(PARROT_INTERP, PMC *pmc)
{
#line 78 "./src/pmc/coroutine.pmc"

    Parrot_Coroutine_attributes *attrs = PARROT_COROUTINE(pmc);

    attrs->seg = interp->code;
    attrs->ctx = PMCNULL;

    PObj_custom_mark_destroy_SETALL(pmc);
#line 128 "./src/pmc/coroutine.c"
}
static  opcode_t  *
Parrot_Coroutine_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 136 "./src/pmc/coroutine.pmc"

    PackFile_ByteCode *wanted_seg;
    Parrot_Coroutine_attributes * const co = PARROT_COROUTINE(pmc);
    opcode_t * dest = co->address;
    opcode_t * const next_op = (opcode_t *)next;

    if (Interp_trace_TEST(interp, PARROT_TRACE_SUB_CALL_FLAG))
        print_sub_name(interp, pmc);

    if (PMC_IS_NULL(co->ctx)) {
        PMC * const caller_ctx = CURRENT_CONTEXT(interp);
        PMC *ctx;
        PMC *ccont = interp->current_cont;

        if (ccont == NEED_CONTINUATION)
            ccont = (PMC *)new_ret_continuation_pmc(interp, next_op);

        if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL)
            Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
                    "tail call to coro not allowed");

        /* first time set current sub, cont, object */
        ctx     = Parrot_set_new_context(interp, co->n_regs_used);

        co->ctx = ctx;

        PARROT_CONTINUATION(ccont)->from_ctx = ctx;
        Parrot_pcc_set_sub(interp, ctx, pmc);
        Parrot_pcc_set_continuation(interp, ctx, ccont);
        Parrot_pcc_set_object(interp, ctx, PMCNULL);
        interp->current_object = PMCNULL;
        interp->current_cont   = PMCNULL;

        /* create pad if needed */
        if (!PMC_IS_NULL(co->lex_info)) {
            const INTVAL hlltype = Parrot_get_ctx_HLL_type(interp, enum_class_LexPad);
            PMC * const lexpad = pmc_new_init(interp, hlltype, co->lex_info);
            Parrot_pcc_set_lex_pad(interp, ctx, lexpad);
            VTABLE_set_pointer(interp, lexpad, ctx);
        }

        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg            = co->seg;
        co->caller_seg        = interp->code;
        co->address           = co->seg->base.data + co->start_offs;
    }

    /* if calling the Coro we need the segment of the Coro */
    else if (!(PObj_get_FLAGS(pmc) & SUB_FLAG_CORO_FF)) {
        PMC * const ctx   = co->ctx;
        PMC * const ccont = Parrot_pcc_get_continuation(interp, ctx);

        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg            = co->seg;

        /* remember segment of caller */
        co->caller_seg        = interp->code;

        /* and the recent call context */
        PARROT_CONTINUATION(ccont)->to_ctx = CURRENT_CONTEXT(interp);
        Parrot_pcc_set_caller_ctx(interp, ctx, CURRENT_CONTEXT(interp));

        /* set context to coro context */
        CURRENT_CONTEXT(interp) = ctx;
    }
    else {
        PMC * const ccont = Parrot_pcc_get_continuation(interp, co->ctx);
        PMC * const ctx   = PARROT_CONTINUATION(ccont)->to_ctx;
        INTVAL yield;
        GETATTR_Coroutine_yield(interp, pmc, yield);
        if (! yield)
            Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
                           "Cannot resume dead coroutine.");
        SETATTR_Coroutine_yield(interp, pmc, 0);

        PObj_get_FLAGS(pmc) &= ~SUB_FLAG_CORO_FF;
        /* switch back to last remembered code seg and context */

        wanted_seg            = co->caller_seg;

        if (PMC_IS_NULL(ctx)) {
            /* This still isn't quite right, but it beats segfaulting.  See
               the "Call an exited coroutine" case in t/pmc/coroutine.t; the
               problem is that the defunct coroutine yields up one more
               result before we get here.  -- rgr, 7-Oct-06.
             * This may be unneeded after the yield fix, see TT #1003
             */
            Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
                           "Cannot resume dead coroutine.");
        }

        CURRENT_CONTEXT(interp) = ctx;
    }

    /* toggle address */
    dest        = co->address;
    co->address = (opcode_t *)next;

    if (interp->code != wanted_seg)
        Parrot_switch_to_cs(interp, wanted_seg, 1);

    return dest;
#line 236 "./src/pmc/coroutine.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Coroutine_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Coroutine_clone;
    vt->increment = Parrot_Coroutine_increment;
    vt->init = Parrot_Coroutine_init;
    vt->invoke = Parrot_Coroutine_invoke;
    vt->attr_size = sizeof(Parrot_Coroutine_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Coroutine_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Coroutine_clone;
    vt->init = Parrot_Coroutine_init;
    vt->invoke = Parrot_Coroutine_invoke;
    vt->attr_size = sizeof(Parrot_Coroutine_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Coroutine_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_get_vtable(interp);
    Parrot_Coroutine_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Coroutine_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_ro_get_vtable(interp);
    Parrot_Coroutine_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Coroutine_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Sub_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Coroutine", 9, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Coroutine_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Sub_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Coroutine")), PMCNULL);
    return isa;
}

void
Parrot_Coroutine_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :start_offs :end_offs IHLL_id Fnamespace_name Fnamespace_stash Sname Smethod_name Sns_entry_name Ssubid Ivtable_index Fmulti_signature In_regs_used Flex_info Fouter_sub Feval_pmc Fctx :comp_flags :arg_info Fouter_ctx :caller_seg :address Iyield ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Coroutine_get_vtable(interp);
        vt->base_type      = enum_class_Coroutine;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Coroutine");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_Coroutine_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Coroutine_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Coroutine;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Coroutine_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Coroutine_class_init */
#line 239 "./src/pmc/coroutine.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
