/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/cpointer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_cpointer.h"
#include "pmc_default.h"
#include "cpointer.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/cpointer.pmc"
/*
Copyright (C) 2008-2009, Parrot Foundation.
$Id: cpointer.pmc 41196 2009-09-10 23:28:30Z bacek $

=head1 NAME

src/pmc/cpointer.pmc - CPointer

=head1 DESCRIPTION

The CPointer PMC creates a PMC abstraction for a typed C pointer. It is
particularly used by the C<CallSignature> PMC, for the return values of a
C-level PCC invocation using a C<CallSignature> to pass the arguments and fetch
the results.

=head2 Attributes

A CPointer PMC has two attributes:

=over 4

=item pointer

A C<void *> pointer to an integer, number, string, or PMC.

=item sig

A string signature for the pointer. The possible signature values follow the
standard defined for PCC.

  I   a Parrot integer (INTVAL)
  N   a Parrot number  (FLOATVAL)
  S   a Parrot string  (STRING *)
  P   a Parrot object  (PMC *)

=back


=head2 Vtable Functions

These are the vtable functions for the CPointer class.

=over 4

=cut

*/
#line 69 "./src/pmc/cpointer.c"
static  PMC  * Parrot_CPointer_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_CPointer_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_CPointer_get_integer(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_CPointer_get_number(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_CPointer_get_pmc(PARROT_INTERP, PMC *pmc);
static  void  * Parrot_CPointer_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_CPointer_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_CPointer_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_CPointer_init(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_CPointer_is_same(PARROT_INTERP, PMC *pmc, PMC *pmc2);
static  void  Parrot_CPointer_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_CPointer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_CPointer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_CPointer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_CPointer_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void  Parrot_CPointer_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void  Parrot_CPointer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
void    Parrot_CPointer_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CPointer_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CPointer_get_vtable(PARROT_INTERP);
void    Parrot_CPointer_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CPointer_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CPointer_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_CPointer_clone(PARROT_INTERP, PMC *pmc)
{
#line 114 "./src/pmc/cpointer.pmc"

    PMC * const dest = pmc_new_noinit(interp, pmc->vtable->base_type);
    void       *ptr;
    STRING     *sig;

    GETATTR_CPointer_pointer(interp, pmc, ptr);
    SETATTR_CPointer_pointer(interp, dest, ptr);

    GETATTR_CPointer_sig(interp, pmc, sig);
    SETATTR_CPointer_sig(interp, dest, sig);

    PObj_custom_mark_SET(dest);
    return dest;
#line 110 "./src/pmc/cpointer.c"
}
static  INTVAL 
Parrot_CPointer_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 410 "./src/pmc/cpointer.pmc"

    const Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);
    return (INTVAL)(data->pointer != NULL);
#line 119 "./src/pmc/cpointer.c"
}
static  INTVAL 
Parrot_CPointer_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 204 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "I"))) {
        const INTVAL * const int_pointer = (INTVAL *) data->pointer;
        return *int_pointer;
    }
    else if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        return VTABLE_get_integer(interp, *pmc_pointer);
    }
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unable to fetch integer value, the pointer is not an integer");

#line 139 "./src/pmc/cpointer.c"
}
static  FLOATVAL 
Parrot_CPointer_get_number(PARROT_INTERP, PMC *pmc)
{
#line 259 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "N"))) {
        const FLOATVAL * const num_pointer = (FLOATVAL *) data->pointer;
        return *num_pointer;
    }
    else if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        return VTABLE_get_number(interp, *pmc_pointer);
    }
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unable to fetch number value, the pointer is not a number");
#line 158 "./src/pmc/cpointer.c"
}
static  PMC  *
Parrot_CPointer_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 366 "./src/pmc/cpointer.pmc"

    const Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        return *pmc_pointer;
    }
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unable to fetch PMC value, the pointer is not a PMC");
#line 173 "./src/pmc/cpointer.c"
}
static  void  *
Parrot_CPointer_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 139 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);
    return data->pointer;
#line 182 "./src/pmc/cpointer.c"
}
static  STRING  *
Parrot_CPointer_get_string(PARROT_INTERP, PMC *pmc)
{
#line 313 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "S"))) {
        STRING ** const str_pointer = (STRING **) data->pointer;
        return *str_pointer;
    }
    else if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        return VTABLE_get_string(interp, *pmc_pointer);
    }
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unable to fetch string value, the pointer is not a string");
#line 201 "./src/pmc/cpointer.c"
}
static  STRING  *
Parrot_CPointer_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 169 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);
    UNUSED(key)

    return data->sig;
#line 212 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_init(PARROT_INTERP, PMC *pmc)
{
#line 63 "./src/pmc/cpointer.pmc"

    SETATTR_CPointer_pointer(interp, pmc, NULL);
    SETATTR_CPointer_sig(interp, pmc, NULL);

    PObj_custom_mark_SET(pmc);
#line 223 "./src/pmc/cpointer.c"
}
static  INTVAL 
Parrot_CPointer_is_same(PARROT_INTERP, PMC *pmc, PMC *pmc2)
{
#line 425 "./src/pmc/cpointer.pmc"

    const Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);
    return (INTVAL)(pmc->vtable  == pmc2->vtable &&
                    data->pointer == VTABLE_get_pointer(interp, pmc2));
#line 233 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_mark(PARROT_INTERP, PMC *pmc)
{
#line 81 "./src/pmc/cpointer.pmc"

    STRING *sig;
    GETATTR_CPointer_sig(interp, pmc, sig);
    if (sig) {
        void *pointer;
        GETATTR_CPointer_pointer(interp, pmc, pointer);
        Parrot_gc_mark_PObj_alive(interp, (PObj *)sig);

        if (pointer) {
            if (Parrot_str_equal(interp, sig, CONST_STRING(interp, "P"))) {
                PMC ** const pmc_pointer = (PMC **) pointer;
                PARROT_ASSERT(*pmc_pointer);
                Parrot_gc_mark_PObj_alive(interp, (PObj *) *pmc_pointer);
            }
            else if (Parrot_str_equal(interp, sig, CONST_STRING(interp, "S"))) {
                STRING ** const str_pointer = (STRING **) pointer;
                PARROT_ASSERT(*str_pointer);
                Parrot_gc_mark_PObj_alive(interp, (PObj *) *str_pointer);
            }
        }
    }
#line 260 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 231 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "I"))) {
        INTVAL * const int_pointer = (INTVAL *) data->pointer;
        *int_pointer = value;
    }
    else if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        VTABLE_set_integer_native(interp, *pmc_pointer, value);
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Unable to set integer value, the pointer is not an integer");
    }
#line 281 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 285 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "N"))) {
        FLOATVAL * const num_pointer = (FLOATVAL *) data->pointer;
        *num_pointer = value;
    }
    else if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        VTABLE_set_number_native(interp, *pmc_pointer, value);
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Unable to set number value, the pointer is not a number");
    }
#line 302 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 387 "./src/pmc/cpointer.pmc"

    const Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        *pmc_pointer = value;
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Unable to set PMC value, the pointer is not a PMC");
    }
#line 319 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 154 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);
    data->pointer = value;
#line 328 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 186 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);
    UNUSED(key)

    data->sig = value;
#line 339 "./src/pmc/cpointer.c"
}
static  void 
Parrot_CPointer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 339 "./src/pmc/cpointer.pmc"

    Parrot_CPointer_attributes * const data = PARROT_CPOINTER(pmc);

    if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "S"))) {
        STRING ** const str_pointer = (STRING **) data->pointer;
        *str_pointer = value;
    }
    else if (Parrot_str_equal(interp, data->sig, CONST_STRING(interp, "P"))) {
        PMC ** const pmc_pointer = (PMC **) data->pointer;
        VTABLE_set_string_native(interp, *pmc_pointer, value);
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Unable to set string value, the pointer is not a string");
    }
#line 360 "./src/pmc/cpointer.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_CPointer_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_CPointer_clone;
    vt->get_bool = Parrot_CPointer_get_bool;
    vt->get_integer = Parrot_CPointer_get_integer;
    vt->get_number = Parrot_CPointer_get_number;
    vt->get_pmc = Parrot_CPointer_get_pmc;
    vt->get_pointer = Parrot_CPointer_get_pointer;
    vt->get_string = Parrot_CPointer_get_string;
    vt->get_string_keyed_str = Parrot_CPointer_get_string_keyed_str;
    vt->init = Parrot_CPointer_init;
    vt->is_same = Parrot_CPointer_is_same;
    vt->mark = Parrot_CPointer_mark;
    vt->set_integer_native = Parrot_CPointer_set_integer_native;
    vt->set_number_native = Parrot_CPointer_set_number_native;
    vt->set_pmc = Parrot_CPointer_set_pmc;
    vt->set_pointer = Parrot_CPointer_set_pointer;
    vt->set_string_keyed_str = Parrot_CPointer_set_string_keyed_str;
    vt->set_string_native = Parrot_CPointer_set_string_native;
    vt->attr_size = sizeof(Parrot_CPointer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_CPointer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_CPointer_clone;
    vt->get_bool = Parrot_CPointer_get_bool;
    vt->get_integer = Parrot_CPointer_get_integer;
    vt->get_number = Parrot_CPointer_get_number;
    vt->get_pmc = Parrot_CPointer_get_pmc;
    vt->get_pointer = Parrot_CPointer_get_pointer;
    vt->get_string = Parrot_CPointer_get_string;
    vt->get_string_keyed_str = Parrot_CPointer_get_string_keyed_str;
    vt->init = Parrot_CPointer_init;
    vt->is_same = Parrot_CPointer_is_same;
    vt->mark = Parrot_CPointer_mark;
    vt->attr_size = sizeof(Parrot_CPointer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CPointer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_CPointer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CPointer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_CPointer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_CPointer_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "CPointer", 8, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_CPointer_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "CPointer")), PMCNULL);
    return isa;
}

void
Parrot_CPointer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":pointer Ssig ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_CPointer_get_vtable(interp);
        vt->base_type      = enum_class_CPointer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "CPointer");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_CPointer_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_CPointer;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_CPointer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_CPointer_class_init */
#line 429 "./src/pmc/cpointer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
