/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/eval.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_eval.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "eval.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/eval.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: eval.pmc 41212 2009-09-11 15:12:29Z mikehh $

=head1 NAME

src/pmc/eval.pmc - Dynamic code evaluation

=head1 DESCRIPTION

C<Eval> extends C<Sub> to provide C<eval>-like dynamic code
evaluation and execution.

=head2 Methods

=over 4

=cut

*/

#include "pmc_sub.h"

static void
clear_fixups(PARROT_INTERP, Parrot_Sub_attributes *sub_data)
{
    INTVAL               i;
    PackFile_ByteCode   *seg = sub_data->seg;
    PackFile_FixupTable *ft;
    PackFile_ConstTable *ct;

    if (!seg)
        return;

    ft = seg->fixups;
    if (!ft)
        return;

    ct = seg->const_table;
    if (!ct)
        return;

    for (i = 0; i < ft->fixup_count; i++) {
        PackFile_FixupEntry *e = ft->fixups[i];

        if (e->type == enum_fixup_sub) {
            opcode_t  ci             = e->offset;

            ct->constants[ci]->u.key = NULL;
            ft->fixups[i]->type      = 0;
        }
    }
}

static PMC*
get_sub(PARROT_INTERP, PMC *self, int idx)
{
    INTVAL                 i, n;
    Parrot_Sub_attributes *sub;
    PackFile_ByteCode     *seg;
    PackFile_FixupTable   *ft;
    PackFile_ConstTable   *ct;

    PMC_get_sub(interp, self, sub);
    seg = sub->seg;

    if (!seg)
        return PMCNULL;

    ft = seg->fixups;
    if (!ft)
        return PMCNULL;

    ct = seg->const_table;
    if (!ct)
        return PMCNULL;

    for (i = n = 0; i < ft->fixup_count; i++) {
        PackFile_FixupEntry *e = ft->fixups[i];

        if (e->type == enum_fixup_sub) {
            opcode_t ci = e->offset;

            if (n++ == idx)
                return ct->constants[ci]->u.key;
        }
    }

    return PMCNULL;
}

static void
mark_subs(PARROT_INTERP, PMC *self)
{
    Parrot_Sub_attributes *sub;
    PackFile_ByteCode   *seg;
    PackFile_FixupTable *ft;
    PackFile_ConstTable *ct;
    INTVAL               i;

    PMC_get_sub(interp, self, sub);
    seg = sub->seg;

    if (!seg)
        return;

    ft = seg->fixups;
    if (!ft)
        return;

    ct = seg->const_table;
    if (!ct)
        return;

    for (i = 0; i < ft->fixup_count; i++) {
        PackFile_FixupEntry *e = ft->fixups[i];

        if (e->type == enum_fixup_sub) {
            opcode_t  ci  = e->offset;
            PMC      *sub = ct->constants[ci]->u.key;

            if (!PMC_IS_NULL(sub))
                Parrot_gc_mark_PObj_alive(interp, (PObj *)sub);
        }
    }
}
#line 149 "./src/pmc/eval.c"
static  void  Parrot_Eval_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Eval_elements(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Eval_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  PMC  * Parrot_Eval_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  STRING  * Parrot_Eval_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Eval_init(PARROT_INTERP, PMC *pmc);
static  opcode_t  * Parrot_Eval_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_Eval_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Eval_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
void    Parrot_Eval_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Eval_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Eval_get_vtable(PARROT_INTERP);
void    Parrot_Eval_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Eval_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Eval_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_Eval_destroy(PARROT_INTERP, PMC *pmc)
{
#line 153 "./src/pmc/eval.pmc"

    /*
     * If the compiled code contained any .sub (or .pcc.sub)
     * subroutines, these subs got installed in the globals
     * during compiling this bytecode segment.
     *
     * These globals still exist, calling them will segfault
     * as the segment is destroyed now.
     *
     * RT#46683 walk the fixups for this segment, locate globals
     *      and nullify the Sub PMC.
     * This probably needs a pointer into the globals.
     *
     * OTOH - if the global exists - this eval pmc ought
     *        to be alive and destroy isn't called.
     */
    PackFile_Segment  *seg;
    PackFile_ByteCode *cur_cs;
    Parrot_Sub_attributes *sub_data;

    PMC_get_sub(interp, pmc, sub_data);

    if (!sub_data) {
        interp->vtables[enum_class_Sub]->destroy(interp, pmc);
        return;
    }

    clear_fixups(interp, sub_data);
    cur_cs = sub_data->seg;

    if (!cur_cs) {
        interp->vtables[enum_class_Sub]->destroy(interp, pmc);
        return;
    }

    /* XXX Quick and dirty fix for TT #995 */
    if ((struct PackFile *)cur_cs == interp->initial_pf
            || cur_cs == interp->code) {
        interp->vtables[enum_class_Sub]->destroy(interp, pmc);
        return;
    }

    /* RT#46685 create PF API, move it there */
    seg = (PackFile_Segment *)cur_cs->const_table;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
        cur_cs->const_table = NULL;
    }

    seg = (PackFile_Segment *)cur_cs->debugs;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
        cur_cs->debugs = NULL;
    }

    seg = (PackFile_Segment *)cur_cs->fixups;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
        cur_cs->fixups = NULL;
    }

    seg = cur_cs->pic_index;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
        cur_cs->pic_index = NULL;
    }

/* XXX Commenting out this to fix TT #995 and related problems.
 * May leak some memory, need further revision.

    seg = (PackFile_Segment *)cur_cs;
    if (seg)
        PackFile_Segment_destroy(interp, seg);
 * XXX End of commented out section.
 */

    sub_data->seg = NULL;

    interp->vtables[enum_class_Sub]->destroy(interp, pmc);
#line 248 "./src/pmc/eval.c"
}
static  INTVAL 
Parrot_Eval_elements(PARROT_INTERP, PMC *pmc)
{
#line 391 "./src/pmc/eval.pmc"

    INTVAL               i, n;
    Parrot_Sub_attributes *sub;
    PackFile_ByteCode   *seg;
    PackFile_FixupTable *ft;

    PMC_get_sub(interp, pmc, sub);
    seg = sub->seg;

    if (!seg)
        return 0;

    ft = seg->fixups;
    if (!ft)
        return 0;

    for (i = n = 0; i < ft->fixup_count; i++) {
        PackFile_FixupEntry *e = ft->fixups[i];

        if (e->type == enum_fixup_sub)
            n++;
    }

    return n;
#line 278 "./src/pmc/eval.c"
}
static  void 
Parrot_Eval_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 345 "./src/pmc/eval.pmc"

    IMAGE_IO *io     = info->image_io;
    STRING   *packed = VTABLE_get_string(interp, pmc);
    VTABLE_push_string(interp, io, packed);

    interp->vtables[enum_class_Sub]->freeze(interp, pmc, info);
#line 290 "./src/pmc/eval.c"
}
static  PMC  *
Parrot_Eval_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 327 "./src/pmc/eval.pmc"

    return get_sub(interp, pmc, key);
#line 298 "./src/pmc/eval.c"
}
static  STRING  *
Parrot_Eval_get_string(PARROT_INTERP, PMC *pmc)
{
#line 250 "./src/pmc/eval.pmc"

    Parrot_Sub_attributes *sub;
    PackFile          *pf  = PackFile_new(interp, 0);
    PackFile_ByteCode *seg;
    STRING            *res;
    size_t             size, aligned_size;

    PMC_get_sub(interp, pmc, sub);
    seg = sub->seg;

    PackFile_add_segment(interp, &pf->directory, (PackFile_Segment *)seg);

    if (seg->const_table)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->const_table);

    if (seg->debugs)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->debugs);

    if (seg->fixups)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->fixups);

    if (seg->pic_index)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->pic_index);

    size = PackFile_pack_size(interp, pf) * sizeof (opcode_t);

    /*
     * work around packfile bug:
     * as far as I have checked it the story is:
     * - PackFile_pack_size() assumes 16 byte alignment but doesn't
     *   have the actual start of the code (packed)
     * - PackFile_pack() uses 16 bye alignment relative to the start
     *   of the code, which isn't really the same
     * Therefore align code at 16, which should give the desired
     * effect
     */
    aligned_size = size + 15;
    res          = Parrot_str_new_noinit(interp, enum_stringrep_one,
                                     aligned_size);
    res->strlen  = res->bufused = size;

    if ((size_t)(res->strstart) & 0xf) {
        char *adr     = res->strstart;
        adr          += 16 - ((size_t)adr & 0xf);
        res->strstart = adr;
    }

    /* We block GC while doing the packing, since GC run during a pack
       has been observed to cause problems. There may be a Better Fix.
       See RT #40410 for example of the problem (note on line that
       segfaults, it is *cursor that is pointing to dealloced memory). */
    Parrot_block_GC_mark(interp);
    PackFile_pack(interp, pf, (opcode_t *)res->strstart);
    Parrot_unblock_GC_mark(interp);

    /* now remove all segments from directory again and destroy
     * the packfile */
    pf->directory.num_segments = 0;
    PackFile_destroy(interp, pf);

    return res;
#line 369 "./src/pmc/eval.c"
}
static  void 
Parrot_Eval_init(PARROT_INTERP, PMC *pmc)
{
#line 130 "./src/pmc/eval.pmc"

    Parrot_Sub_attributes *sub_data;
    interp->vtables[enum_class_Sub]->init(interp, pmc);

    PMC_get_sub(interp, pmc, sub_data);
    sub_data->seg = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
#line 382 "./src/pmc/eval.c"
}
static  opcode_t  *
Parrot_Eval_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 148 "./src/pmc/eval.pmc"

    PMC *sub = VTABLE_get_pmc_keyed_int(interp, pmc, 0);
    return VTABLE_invoke(interp, sub, next);
#line 391 "./src/pmc/eval.c"
}
static  void 
Parrot_Eval_mark(PARROT_INTERP, PMC *pmc)
{
#line 234 "./src/pmc/eval.pmc"

    interp->vtables[enum_class_Sub]->mark(interp, pmc);
    mark_subs(interp, pmc);
#line 400 "./src/pmc/eval.c"
}
static  void 
Parrot_Eval_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 353 "./src/pmc/eval.pmc"

    IMAGE_IO         *io     = info->image_io;
    STRING           *packed = VTABLE_shift_string(interp, io);
    PackFile         *pf;
    PackFile_Segment *seg;
    Parrot_Sub_attributes *sub;
    size_t            i;

    interp->vtables[enum_class_Sub]->thaw(interp, pmc, info);
    pf = PackFile_new(interp, 0);

    if (!PackFile_unpack(interp, pf, (opcode_t *)packed->strstart,
            packed->strlen))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            "couldn't unpack packfile");

    do_sub_pragmas(interp, pf->cur_cs, PBC_PBC, pmc);

    for (i = 0; i < pf->directory.num_segments; ++i) {
        seg = pf->directory.segments[i];

        if (seg->type == PF_BYTEC_SEG) {
            PMC_get_sub(interp, pmc, sub);
            sub->seg = (PackFile_ByteCode *)seg;
            break;
        }
    }

    pf->directory.num_segments = 0;

    /*
     * RT#46687 this isn't ok - it seems that the packfile
     *     gets attached to interp->code and is
     *     destroyed again during interpreter destruction
     */
    /* PackFile_destroy(interp, pf); */
#line 442 "./src/pmc/eval.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Eval_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_Eval_destroy;
    vt->elements = Parrot_Eval_elements;
    vt->freeze = Parrot_Eval_freeze;
    vt->get_pmc_keyed_int = Parrot_Eval_get_pmc_keyed_int;
    vt->get_string = Parrot_Eval_get_string;
    vt->init = Parrot_Eval_init;
    vt->invoke = Parrot_Eval_invoke;
    vt->mark = Parrot_Eval_mark;
    vt->thaw = Parrot_Eval_thaw;
    vt->attr_size = sizeof(Parrot_Eval_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Eval_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_Eval_destroy;
    vt->elements = Parrot_Eval_elements;
    vt->freeze = Parrot_Eval_freeze;
    vt->get_pmc_keyed_int = Parrot_Eval_get_pmc_keyed_int;
    vt->get_string = Parrot_Eval_get_string;
    vt->init = Parrot_Eval_init;
    vt->invoke = Parrot_Eval_invoke;
    vt->mark = Parrot_Eval_mark;
    vt->attr_size = sizeof(Parrot_Eval_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Eval_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_get_vtable(interp);
    Parrot_Eval_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Eval_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_ro_get_vtable(interp);
    Parrot_Eval_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Eval_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Sub_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Eval", 4, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Eval_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Sub_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Eval")), PMCNULL);
    return isa;
}

void
Parrot_Eval_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :start_offs :end_offs IHLL_id Fnamespace_name Fnamespace_stash Sname Smethod_name Sns_entry_name Ssubid Ivtable_index Fmulti_signature In_regs_used Flex_info Fouter_sub Feval_pmc Fctx :comp_flags :arg_info Fouter_ctx ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Eval_get_vtable(interp);
        vt->base_type      = enum_class_Eval;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Eval");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_Eval_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Eval_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Eval;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Eval_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Eval_class_init */
#line 415 "./src/pmc/eval.pmc"


/*

=back

=head1 HISTORY

Initial version by leo 2003/01/16.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
