/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hashiterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_hashiterator.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "hashiterator.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/hashiterator.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: hashiterator.pmc 40672 2009-08-20 09:28:47Z chromatic $

=head1 NAME

src/pmc/hashiterator.pmc - Implementation of Iterator for Hashes.

=head1 DESCRIPTION

Generic iterator for traversing Hash.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, hash, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key. Some key
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head2 C++-style usage

    .local pmc iterator, hash, iter_key, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    iter_key = shift iterator     # get the key
    key = iter_key.'key'()        # get an original key used to put value
    key = iter_key.'value'()      # get an entry
    ...
    goto iter_loop
  iter_end:


=head1 Methods

=over 4

=cut

*/

#include "pmc_hash.h"
#include "pmc_hashiteratorkey.h"

/*

Advance to next position. Return found (if any) HashBucket.

*/
static HashBucket*
advance_to_next(PARROT_INTERP, PMC *self) {
    Parrot_HashIterator_attributes * const attrs  = PARROT_HASHITERATOR(self);
    HashBucket                            *bucket = attrs->bucket;

    /* Try to advance current bucket */
    if (bucket)
        bucket = bucket->next;

    while (!bucket) {
        /* If there is no more buckets */
        if (attrs->pos == attrs->total_buckets)
            break;

        bucket = attrs->parrot_hash->bi[attrs->pos++];
    }
    attrs->bucket = bucket;
    attrs->elements--;
    return bucket;
}
#line 99 "./src/pmc/hashiterator.c"
static  PMC*  Parrot_HashIterator_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_HashIterator_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_HashIterator_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_HashIterator_get_integer(PARROT_INTERP, PMC *pmc);
static  PMC*  Parrot_HashIterator_get_pmc(PARROT_INTERP, PMC *pmc);
static  void  Parrot_HashIterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *hash);
static  void  Parrot_HashIterator_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_HashIterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  PMC  * Parrot_HashIterator_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING*  Parrot_HashIterator_shift_string(PARROT_INTERP, PMC *pmc);
void    Parrot_HashIterator_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_HashIterator_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_HashIterator_get_vtable(PARROT_INTERP);
void    Parrot_HashIterator_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_HashIterator_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_HashIterator_ro_get_vtable(PARROT_INTERP);
static  PMC* 
Parrot_HashIterator_clone(PARROT_INTERP, PMC *pmc)
{
#line 141 "./src/pmc/hashiterator.pmc"

    return PMCNULL;
#line 122 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_elements(PARROT_INTERP, PMC *pmc)
{
#line 204 "./src/pmc/hashiterator.pmc"

    return PARROT_HASHITERATOR(pmc)->elements;
#line 130 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 190 "./src/pmc/hashiterator.pmc"

    return PARROT_HASHITERATOR(pmc)->bucket != 0;
#line 138 "./src/pmc/hashiterator.c"
}
static  INTVAL 
Parrot_HashIterator_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 208 "./src/pmc/hashiterator.pmc"

    return VTABLE_elements(interp, pmc);
#line 146 "./src/pmc/hashiterator.c"
}
static  PMC* 
Parrot_HashIterator_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 176 "./src/pmc/hashiterator.pmc"

    return PARROT_HASHITERATOR(pmc)->pmc_hash;
#line 154 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *hash)
{
#line 97 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
        (Parrot_HashIterator_attributes *) PMC_data(pmc);

    attrs->pmc_hash         = hash;
    attrs->parrot_hash      = (Hash*)VTABLE_get_pointer(interp, hash);
    attrs->total_buckets    = attrs->parrot_hash->mask + 1;
    attrs->bucket           = 0;
    attrs->pos              = 0;
    /* Will be decreased on initial advance_to_next */
    /* XXX Do we really need to support this use-case ? */
    attrs->elements         = attrs->parrot_hash->entries + 1;

    PObj_custom_mark_SET(pmc);

    /* Initial state of iterator is "before start" */
    /* So, advance to first element */
    advance_to_next(interp, pmc);
#line 178 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_mark(PARROT_INTERP, PMC *pmc)
{
#line 127 "./src/pmc/hashiterator.pmc"

    PMC *hash = PARROT_HASHITERATOR(pmc)->pmc_hash;
    if (hash)
         Parrot_gc_mark_PObj_alive(interp, (PObj *)hash);
    /* We don't mark underlying parrot_hash. Hash PMC will mark it */
#line 189 "./src/pmc/hashiterator.c"
}
static  void 
Parrot_HashIterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 152 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
            PARROT_HASHITERATOR(pmc);

    if (value == 0) {
        /* Restart iterator */
        attrs->bucket           = 0;
        attrs->pos              = 0;
        advance_to_next(interp, pmc);
        return;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "HashIterator: unknown iterator type");
#line 209 "./src/pmc/hashiterator.c"
}
static  PMC  *
Parrot_HashIterator_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 223 "./src/pmc/hashiterator.pmc"

    Parrot_HashIterator_attributes * const attrs =
            PARROT_HASHITERATOR(pmc);

    PMC        *ret;

    if (!attrs->bucket)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    ret = pmc_new(interp, enum_class_HashIteratorKey);
    /* Poke directly into HIK. We don't want to create any kind of public API for this */
    PARROT_HASHITERATORKEY(ret)->parrot_hash = attrs->parrot_hash;
    PARROT_HASHITERATORKEY(ret)->bucket      = attrs->bucket;

    /* Move to next bucket */
    advance_to_next(interp, pmc);

    return ret;
#line 234 "./src/pmc/hashiterator.c"
}
static  STRING* 
Parrot_HashIterator_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 248 "./src/pmc/hashiterator.pmc"

    PMC    * const key = VTABLE_shift_pmc(interp, pmc);
    STRING * const ret = VTABLE_get_string(interp, key);
    temporary_pmc_free(interp, key);
    return ret;
#line 245 "./src/pmc/hashiterator.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_HashIterator_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_HashIterator_clone;
    vt->elements = Parrot_HashIterator_elements;
    vt->get_bool = Parrot_HashIterator_get_bool;
    vt->get_integer = Parrot_HashIterator_get_integer;
    vt->get_pmc = Parrot_HashIterator_get_pmc;
    vt->init_pmc = Parrot_HashIterator_init_pmc;
    vt->mark = Parrot_HashIterator_mark;
    vt->set_integer_native = Parrot_HashIterator_set_integer_native;
    vt->shift_pmc = Parrot_HashIterator_shift_pmc;
    vt->shift_string = Parrot_HashIterator_shift_string;
    vt->attr_size = sizeof(Parrot_HashIterator_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_HashIterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_HashIterator_clone;
    vt->elements = Parrot_HashIterator_elements;
    vt->get_bool = Parrot_HashIterator_get_bool;
    vt->get_integer = Parrot_HashIterator_get_integer;
    vt->get_pmc = Parrot_HashIterator_get_pmc;
    vt->init_pmc = Parrot_HashIterator_init_pmc;
    vt->mark = Parrot_HashIterator_mark;
    vt->attr_size = sizeof(Parrot_HashIterator_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_HashIterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_get_vtable(interp);
    Parrot_HashIterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_HashIterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_ro_get_vtable(interp);
    Parrot_HashIterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_HashIterator_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Iterator_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "HashIterator", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_HashIterator_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Iterator_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "HashIterator")), PMCNULL);
    return isa;
}

void
Parrot_HashIterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fpmc_hash :parrot_hash :bucket Itotal_buckets Ipos Ielements ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_HashIterator_get_vtable(interp);
        vt->base_type      = enum_class_HashIterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "HashIterator");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_HashIterator_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_HashIterator_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_HashIterator;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_HashIterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_HashIterator_class_init */
#line 254 "./src/pmc/hashiterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
