/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/integer.pmc"
/*
Copyright (C) 2003-2008, Parrot Foundation.
$Id: integer.pmc 41230 2009-09-12 13:37:58Z bacek $

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages that want a value-restricted
integer type without going to an I register.

=head2 Functions

=over 4

=cut

*/

#include "pmc_bigint.h"

static void
maybe_throw_overflow_error(PARROT_INTERP)
{
    /* check to see what the behavior is. If the interpreter is set
       to throw an exception on overflow. If so, throw the exception,
       otherwise, chill out it's no big deal. */
    if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ERR_OVERFLOW,
            "Integer overflow");
}

static PMC*
upgrade_self_to_bignum(PARROT_INTERP, PMC *self)
{
    /* Do an in-place upgrade to a Bignum of SELF and return a pointer
       to it (which is probably redundant, but whatever). */
    const INTVAL a = VTABLE_get_integer(interp, self);
    pmc_reuse(interp, self, enum_class_BigInt, 0);
    VTABLE_set_integer_native(interp, self, a);
    return self;
}
#line 68 "./src/pmc/integer.c"
static  PMC  * Parrot_Integer_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_Integer_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_add_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest);
static  PMC  * Parrot_Integer_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Integer_cmp(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_Integer_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_decrement(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Integer_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Integer_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_Integer_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  PMC  * Parrot_Integer_get_bignum(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Integer_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Integer_get_integer(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Integer_get_number(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Integer_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Integer_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Integer_i_absolute(PARROT_INTERP, PMC *pmc);
static  void Parrot_Integer_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL b);
static  void Parrot_Integer_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Integer_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Integer_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Integer_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b);
static  void  Parrot_Integer_i_pow(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Integer_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b);
static  void  Parrot_Integer_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Integer_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Integer_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init);
static  PMC  * Parrot_Integer_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags);
static  INTVAL  Parrot_Integer_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC * Parrot_Integer_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Integer_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Integer_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest);
static  PMC * Parrot_Integer_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_pow_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest);
static  void  Parrot_Integer_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Integer_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Integer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_Integer_share(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Integer_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest);
static  void  Parrot_Integer_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  PMC  * Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_pow_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_pow_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  INTVAL  Parrot_Integer_multi_cmp_String(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *pmc);
void    Parrot_Integer_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP);
void    Parrot_Integer_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Integer_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1283 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));

    /* RT #46635 overflow for -maxint */
    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;

#line 191 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_add_Integer_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_add_Complex_PMC(interp, pmc, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_add_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_add_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_add_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 363 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_add_int(interp, temp, b, dest);
    }
#line 245 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_clone(PARROT_INTERP, PMC *pmc)
{
#line 86 "./src/pmc/integer.pmc"

    PMC * const clone = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, clone, VTABLE_get_integer(interp, pmc));
    return clone;
#line 255 "./src/pmc/integer.c"
}
static  INTVAL
Parrot_Integer_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_String(interp, pmc, value);
            break;

        case enum_class_Float:
            return Parrot_Integer_multi_cmp_Float(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_cmp_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  INTVAL
Parrot_Integer_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_num_String(interp, pmc, value);
            break;

        case enum_class_Float:
            return Parrot_Integer_multi_cmp_num_Float(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_cmp_num_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp_num", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  void 
Parrot_Integer_decrement(PARROT_INTERP, PMC *pmc)
{
#line 1257 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - 1;

    if ((c^a) >= 0 || (c^~1) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        pmc_reuse(interp, pmc, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, pmc, a);
        VTABLE_decrement(interp, pmc);
    }
#line 328 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_divide_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_Integer_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_floor_divide_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_floor_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 849 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 395 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 834 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 414 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1337 "./src/pmc/integer.pmc"

    IMAGE_IO * const io = info->image_io;
    interp->vtables[enum_class_default]->freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_get_integer(interp, pmc));
#line 424 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_get_bignum(PARROT_INTERP, PMC *pmc)
{
#line 213 "./src/pmc/integer.pmc"

    const INTVAL val = VTABLE_get_integer(interp, pmc);
    PMC * const  ret = pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;
#line 435 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 180 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);
    return iv ? 1 : 0;
#line 445 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 164 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);
    return iv;
#line 455 "./src/pmc/integer.c"
}
static  FLOATVAL 
Parrot_Integer_get_number(PARROT_INTERP, PMC *pmc)
{
#line 196 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);
    return (FLOATVAL)iv;
#line 465 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 236 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, pmc));
#line 473 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_string(PARROT_INTERP, PMC *pmc)
{
#line 232 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, pmc));
#line 481 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1295 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));
    VTABLE_set_integer_native(interp, pmc, a);
#line 490 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_add_Integer(interp, pmc, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_add_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_add_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 431 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a + value);
#line 527 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 416 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        VTABLE_i_add_int(interp, temp, b);
    }
#line 545 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_divide_BigInt(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void
Parrot_Integer_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_floor_divide_BigInt(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_floor_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 895 "./src/pmc/integer.pmc"

    FLOATVAL f;
    INTVAL   self_val;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 609 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 883 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 624 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_modulus_BigInt(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_modulus_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_modulus", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1010 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , (INTVAL)value));
#line 661 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1000 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , value));
#line 674 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_multiply_Integer(interp, pmc, value);
            break;

        case enum_class_BigInt:
            Parrot_Integer_multi_i_multiply_BigInt(interp, pmc, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_multiply_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_multiply_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 722 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a * value);
#line 715 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 707 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_multiply_int(interp, pmc, b);
    }
#line 733 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1100 "./src/pmc/integer.pmc"

    VTABLE_pow(interp, pmc, value, pmc);
#line 741 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1105 "./src/pmc/integer.pmc"

    Parrot_Integer_pow_int(interp, pmc, value, pmc);
#line 749 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_subtract_Integer(interp, pmc, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_subtract_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_subtract_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 590 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a - value);
#line 786 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 576 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        pmc = upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_subtract_int(interp, pmc, b);
    }
#line 803 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_increment(PARROT_INTERP, PMC *pmc)
{
#line 1231 "./src/pmc/integer.pmc"

    INTVAL a, c;
    GETATTR_Integer_iv(interp, pmc, a);
    c = a + 1;

    /* did not overflow */
    if ((c^a) >= 0 || (c^1) >= 0)
        SETATTR_Integer_iv(interp, pmc, c);
    else {
        pmc_reuse(interp, pmc, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, pmc, a);
        VTABLE_increment(interp, pmc);
    }
#line 822 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init(PARROT_INTERP, PMC *pmc)
{
#line 63 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(pmc);

    attrs->iv      = 0;
#line 833 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 70 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(pmc);

    attrs->iv      = VTABLE_get_integer(interp, init);
#line 844 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
#line 102 "./src/pmc/integer.pmc"

    const INTVAL type = pmc->vtable->base_type;
    PMC * const  res  = (flags & PObj_constant_FLAG)
        ? constant_pmc_new(interp, type)
        : pmc_new(interp, type);

    /* Parrot_str_to_int catches overflow automatically, so we don't need to
       worry about it here. */
    VTABLE_set_integer_native(interp, res, Parrot_str_to_int(interp, rep));
    return res;
#line 860 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1120 "./src/pmc/integer.pmc"

    INTVAL retval;
    PMC *temp;

    switch (value->vtable->base_type) {
        case enum_class_BigInt:
            temp = pmc_new(interp, enum_class_BigInt);
            VTABLE_set_integer_native(interp, temp, VTABLE_get_integer(interp, pmc));
            Parrot_mmd_multi_dispatch_from_c_args(interp,
                "is_equal", "PP->I", temp, value, &retval);
            return retval;
            break;
        default:
            return (VTABLE_get_integer(interp, pmc)
                ==  VTABLE_get_integer(interp, value));
            break;
    }
#line 883 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_modulus_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_modulus_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "modulus", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 968 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), (INTVAL)value));
    return dest;
#line 923 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 955 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), value));
    return dest;
#line 939 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_multiply_Integer_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_multiply_Complex_PMC(interp, pmc, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_multiply_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_String:
            return Parrot_Integer_multi_multiply_String_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_multiply_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 653 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_multiply_int(interp, temp, b, dest);
    }
#line 998 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_pow_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_pow_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "pow", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_pow_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 1054 "./src/pmc/integer.pmc"

    const INTVAL a      = VTABLE_get_integer(interp, pmc);
    const INTVAL orig_b = b;
    INTVAL       r      = 1;

    if (b < 0)
        return interp->vtables[enum_class_scalar]->pow_int(interp, pmc, b, dest);

    if (a) {
        INTVAL temp = a;
        while (b > 0) {
            INTVAL prev = r;
            if (b & 1) {
                r *= temp;
                if (r / temp != prev) {
                    PMC *temp;
                    maybe_throw_overflow_error(interp);
                    temp = VTABLE_get_bignum(interp, pmc);
                    return VTABLE_pow_int(interp, temp, orig_b, dest);
                }
            }

            b >>= 1;
            if (!b)
                break;

            prev  = temp;
            temp *= temp;

            if (prev != 0 && temp / prev != prev) {
                PMC *temp;
                maybe_throw_overflow_error(interp);
                temp = VTABLE_get_bignum(interp, pmc);
                return VTABLE_pow_int(interp, temp, orig_b, dest);
            }
        }
    }

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, r);
    return dest;

#line 1071 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 289 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_BigInt, 0);
    VTABLE_set_integer_native(interp, pmc, value);
#line 1080 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 283 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_Boolean, 0);
    VTABLE_set_bool(interp, pmc, value);
#line 1089 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 251 "./src/pmc/integer.pmc"

    SETATTR_Integer_iv(interp, pmc, value);
#line 1097 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 277 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_Float, 0);
    VTABLE_set_number_native(interp, pmc, value);
#line 1106 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 125 "./src/pmc/integer.pmc"

    VTABLE_set_integer_native(interp, pmc, VTABLE_get_integer(interp, value));
#line 1114 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 295 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_String, 0);
    VTABLE_set_string_native(interp, pmc, value);
#line 1123 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_share(PARROT_INTERP, PMC *pmc)
{
#line 140 "./src/pmc/integer.pmc"

    /*
     * assume that the access to a long is atomic.
     * integers are most often (1) equal to C longs,
     * not C ints, and this makes a difference in 64-bit
     * platforms where longs are 64-bit but ints are 32-bit.
     * (1) Not equal when integers have been configured
     *     to be software-emulated long longs.
     */
    if (sizeof (INTVAL) != sizeof (long))
        interp->vtables[enum_class_default]->share(interp, pmc);
#line 1140 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_subtract_Integer_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_subtract_Complex_PMC(interp, pmc, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_subtract_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_subtract_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 511 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_subtract_int(interp, temp, b, dest);
    }
#line 1194 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1353 "./src/pmc/integer.pmc"

    IMAGE_IO * const io = info->image_io;
    interp->vtables[enum_class_default]->thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, io));
#line 1205 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 312 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        /* need this for e.g. Undef PMC */
        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC * temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_add(interp, temp, value, dest);
    }
#line 1229 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 333 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    dest           = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 1245 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 346 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_add(interp, temp, value, dest);
#line 1256 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 354 "./src/pmc/integer.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
    return dest;
#line 1268 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 396 "./src/pmc/integer.pmc"

    Parrot_Integer_i_add_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 1276 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 401 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
#line 1288 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 410 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
#line 1297 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 451 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_subtract(interp, temp, value, dest);
    }
#line 1320 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 471 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    dest           = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 1336 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 484 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_subtract(interp, temp, value, dest);
#line 1347 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 492 "./src/pmc/integer.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_number(interp, value));
    return dest;
#line 1359 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 544 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        pmc = upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_subtract(interp, pmc, value);
    }
#line 1377 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 559 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            (FLOATVAL)a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, pmc, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
#line 1391 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 570 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_number(interp, value));
#line 1400 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 608 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL b  = VTABLE_get_integer(interp, value);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_multiply(interp, temp, value, dest);
    }
#line 1424 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 629 "./src/pmc/integer.pmc"

    return VTABLE_multiply(interp, value, pmc, dest);
#line 1432 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 634 "./src/pmc/integer.pmc"

    return VTABLE_multiply_int(interp, value, pmc->vtable->get_integer(interp, pmc), dest);
#line 1440 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 639 "./src/pmc/integer.pmc"

    return Parrot_Integer_multi_multiply_Integer_PMC(interp, pmc, value, dest);
#line 1448 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 644 "./src/pmc/integer.pmc"

    const FLOATVAL valf = VTABLE_get_number(interp, value);
    dest                = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) * valf);
    return dest;
#line 1460 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 686 "./src/pmc/integer.pmc"

    Parrot_Integer_i_multiply_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 1468 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 691 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_BigInt]->multiply_int(interp, value, pmc->vtable->get_integer(interp, pmc), pmc);
#line 1476 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 696 "./src/pmc/integer.pmc"

    VTABLE_multiply(interp, value, pmc, pmc);
#line 1484 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 701 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) * VTABLE_get_number(interp, value));
#line 1493 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 750 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_divide(interp, temp, value, dest);
#line 1504 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 757 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) / d);
    return dest;
#line 1520 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 770 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_divide(interp, pmc, value);
#line 1530 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 777 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc, pmc->vtable->get_number(interp, pmc) / d);
#line 1544 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 810 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_floor_divide(interp, temp, value, dest);
#line 1555 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 818 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(pmc->vtable->get_number(interp, pmc) / d);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);
    return dest;
#line 1574 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 864 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_floor_divide(interp, pmc, value);
#line 1584 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 870 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(pmc->vtable->get_number(interp, pmc) / d);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 1600 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 932 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_modulus(interp, temp, value, dest);
#line 1611 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 940 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(pmc->vtable->get_integer(interp, pmc), d));
    return dest;
#line 1629 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 981 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_modulus(interp, pmc, value);
#line 1639 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 988 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(pmc->vtable->get_integer(interp, pmc), d));
#line 1654 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_pow_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1040 "./src/pmc/integer.pmc"

    const INTVAL v = VTABLE_get_integer(interp, value);
    return Parrot_Integer_pow_int(interp, pmc, v, dest);
#line 1663 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_pow_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1046 "./src/pmc/integer.pmc"

    PMC * const auxval = pmc_new(interp, VTABLE_type(interp, value));
    FLOATVAL selfval = pmc->vtable->get_integer(interp, pmc);
    VTABLE_set_number_native(interp, auxval, selfval);
    return VTABLE_pow(interp, auxval, value, dest);
#line 1674 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1150 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1690 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1163 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);

    {
        const FLOATVAL diff = (FLOATVAL)iv - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    }
#line 1704 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1174 "./src/pmc/integer.pmc"

    /* int or undef */
    INTVAL selfint;
    GETATTR_Integer_iv(interp, pmc, selfint);
    {
        const INTVAL valueint = VTABLE_get_integer(interp, value);
        return selfint > valueint ? 1 : selfint < valueint ? -1 : 0;
    }
#line 1718 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1195 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1734 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1208 "./src/pmc/integer.pmc"

    const FLOATVAL diff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1743 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1214 "./src/pmc/integer.pmc"

    /* int or undef */
    const INTVAL diff = pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1753 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1792 "./src/pmc/integer.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1808 "./src/pmc/integer.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL base = CTX_REG_INT(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1312 "./src/pmc/integer.pmc"

    char buf[128];
    STRING *result;

    if ((base < 2) || (base > 36))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "get_as_base: base out of bounds");

    result = Parrot_str_from_int_base(interp, buf,
            (HUGEINTVAL)VTABLE_get_integer(interp, pmc),
            (unsigned int)base);

    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
    /*BEGIN GENERATED ACCESSORS */
#line 1833 "./src/pmc/integer.pmc"
    CTX_REG_STR(_ctx, 0) = result;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto get_as_base_returns;
    /*END RETURN STRING *result */
    }
#line 1324 "./src/pmc/integer.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_as_base_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1878 "./src/pmc/integer.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Integer_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->decrement = Parrot_Integer_decrement;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bignum = Parrot_Integer_get_bignum;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->i_absolute = Parrot_Integer_i_absolute;
    vt->i_add = Parrot_Integer_i_add;
    vt->i_add_float = Parrot_Integer_i_add_float;
    vt->i_add_int = Parrot_Integer_i_add_int;
    vt->i_divide = Parrot_Integer_i_divide;
    vt->i_floor_divide = Parrot_Integer_i_floor_divide;
    vt->i_floor_divide_float = Parrot_Integer_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_Integer_i_floor_divide_int;
    vt->i_modulus = Parrot_Integer_i_modulus;
    vt->i_modulus_float = Parrot_Integer_i_modulus_float;
    vt->i_modulus_int = Parrot_Integer_i_modulus_int;
    vt->i_multiply = Parrot_Integer_i_multiply;
    vt->i_multiply_float = Parrot_Integer_i_multiply_float;
    vt->i_multiply_int = Parrot_Integer_i_multiply_int;
    vt->i_pow = Parrot_Integer_i_pow;
    vt->i_pow_int = Parrot_Integer_i_pow_int;
    vt->i_subtract = Parrot_Integer_i_subtract;
    vt->i_subtract_float = Parrot_Integer_i_subtract_float;
    vt->i_subtract_int = Parrot_Integer_i_subtract_int;
    vt->increment = Parrot_Integer_increment;
    vt->init = Parrot_Integer_init;
    vt->init_pmc = Parrot_Integer_init_pmc;
    vt->instantiate_str = Parrot_Integer_instantiate_str;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->pow = Parrot_Integer_pow;
    vt->pow_int = Parrot_Integer_pow_int;
    vt->set_bignum_int = Parrot_Integer_set_bignum_int;
    vt->set_bool = Parrot_Integer_set_bool;
    vt->set_integer_native = Parrot_Integer_set_integer_native;
    vt->set_number_native = Parrot_Integer_set_number_native;
    vt->set_pmc = Parrot_Integer_set_pmc;
    vt->set_string_native = Parrot_Integer_set_string_native;
    vt->share = Parrot_Integer_share;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->thaw = Parrot_Integer_thaw;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bignum = Parrot_Integer_get_bignum;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->init = Parrot_Integer_init;
    vt->init_pmc = Parrot_Integer_init_pmc;
    vt->instantiate_str = Parrot_Integer_instantiate_str;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->pow = Parrot_Integer_pow;
    vt->pow_int = Parrot_Integer_pow_int;
    vt->share = Parrot_Integer_share;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_get_vtable(interp);
    Parrot_Integer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_ro_get_vtable(interp);
    Parrot_Integer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Integer_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_scalar_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Integer", 7, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Integer_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_scalar_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Integer")), PMCNULL);
    return isa;
}

void
Parrot_Integer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iiv ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Integer_get_vtable(interp);
        vt->base_type      = enum_class_Integer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Integer");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar integer");
        vt->isa_hash     = Parrot_Integer_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Integer_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Integer;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Integer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Integer_nci_get_as_base), CONST_STRING_GEN(interp, "get_as_base"));
        {
        STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
        STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
        STRING * const mfl_2 = CONST_STRING_GEN(interp, "Integer,Integer,PMC");
        STRING * const mfl_3 = CONST_STRING_GEN(interp, "Integer");
        STRING * const mfl_4 = CONST_STRING_GEN(interp, "Integer,Complex,PMC");
        STRING * const mfl_5 = CONST_STRING_GEN(interp, "Integer,BigInt,PMC");
        STRING * const mfl_6 = CONST_STRING_GEN(interp, "Integer,DEFAULT,PMC");
        STRING * const mfl_7 = CONST_STRING_GEN(interp, "i_add");
        STRING * const mfl_8 = CONST_STRING_GEN(interp, "vJPP");
        STRING * const mfl_9 = CONST_STRING_GEN(interp, "Integer,Integer");
        STRING * const mfl_10 = CONST_STRING_GEN(interp, "Integer,Complex");
        STRING * const mfl_11 = CONST_STRING_GEN(interp, "Integer,DEFAULT");
        STRING * const mfl_12 = CONST_STRING_GEN(interp, "subtract");
        STRING * const mfl_13 = CONST_STRING_GEN(interp, "i_subtract");
        STRING * const mfl_14 = CONST_STRING_GEN(interp, "multiply");
        STRING * const mfl_15 = CONST_STRING_GEN(interp, "Integer,String,PMC");
        STRING * const mfl_16 = CONST_STRING_GEN(interp, "i_multiply");
        STRING * const mfl_17 = CONST_STRING_GEN(interp, "Integer,BigInt");
        STRING * const mfl_18 = CONST_STRING_GEN(interp, "divide");
        STRING * const mfl_19 = CONST_STRING_GEN(interp, "i_divide");
        STRING * const mfl_20 = CONST_STRING_GEN(interp, "floor_divide");
        STRING * const mfl_21 = CONST_STRING_GEN(interp, "i_floor_divide");
        STRING * const mfl_22 = CONST_STRING_GEN(interp, "modulus");
        STRING * const mfl_23 = CONST_STRING_GEN(interp, "i_modulus");
        STRING * const mfl_24 = CONST_STRING_GEN(interp, "pow");
        STRING * const mfl_25 = CONST_STRING_GEN(interp, "cmp");
        STRING * const mfl_26 = CONST_STRING_GEN(interp, "IJPP");
        STRING * const mfl_27 = CONST_STRING_GEN(interp, "Integer,String");
        STRING * const mfl_28 = CONST_STRING_GEN(interp, "Integer,Float");
        STRING * const mfl_29 = CONST_STRING_GEN(interp, "cmp_num");

             const  multi_func_list _temp_multi_func_list[] = {
                        { mfl_0,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_Integer_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_Complex_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_BigInt_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_DEFAULT_PMC }
,
        { mfl_7,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_add_Integer }
,
        { mfl_7,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_add_Complex }
,
        { mfl_7,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_add_DEFAULT }
,
        { mfl_12,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_Integer_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_Complex_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_BigInt_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_DEFAULT_PMC }
,
        { mfl_13,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_subtract_Integer }
,
        { mfl_13,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_subtract_Complex }
,
        { mfl_13,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_subtract_DEFAULT }
,
        { mfl_14,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_Integer_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_Complex_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_BigInt_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_15,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_String_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_DEFAULT_PMC }
,
        { mfl_16,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_Integer }
,
        { mfl_16,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_BigInt }
,
        { mfl_16,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_Complex }
,
        { mfl_16,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_DEFAULT }
,
        { mfl_18,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_divide_BigInt_PMC }
,
        { mfl_18,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_divide_DEFAULT_PMC }
,
        { mfl_19,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_divide_BigInt }
,
        { mfl_19,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_divide_DEFAULT }
,
        { mfl_20,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_floor_divide_BigInt_PMC }
,
        { mfl_20,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_floor_divide_DEFAULT_PMC }
,
        { mfl_21,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_floor_divide_BigInt }
,
        { mfl_21,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_floor_divide_DEFAULT }
,
        { mfl_22,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_modulus_BigInt_PMC }
,
        { mfl_22,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_modulus_DEFAULT_PMC }
,
        { mfl_23,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_modulus_BigInt }
,
        { mfl_23,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_modulus_DEFAULT }
,
        { mfl_24,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_pow_Integer_PMC }
,
        { mfl_24,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_pow_DEFAULT_PMC }
,
        { mfl_25,
          mfl_26,
          mfl_27,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_String }
,
        { mfl_25,
          mfl_26,
          mfl_28,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_Float }
,
        { mfl_25,
          mfl_26,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_DEFAULT }
,
        { mfl_29,
          mfl_26,
          mfl_27,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_num_String }
,
        { mfl_29,
          mfl_26,
          mfl_28,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_num_Float }
,
        { mfl_29,
          mfl_26,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_num_DEFAULT }

            };
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_Integer_class_init */
#line 1358 "./src/pmc/integer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
