/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/namespace.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_namespace.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "namespace.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/namespace.pmc"
/*
Copyright (C) 2005-2009, Parrot Foundation.
$Id: namespace.pmc 40755 2009-08-24 10:50:01Z NotFound $

=head1 NAME

src/pmc/namespace.pmc - NameSpace PMC

=head1 DESCRIPTION

These are the vtable functions for the namespace PMC.

=head2 Functions

=over 4

=cut

*/

#include "pmc_sub.h"

static void add_to_class(
        Interp *interp,
        Parrot_NameSpace_attributes * const nsinfo,
        PMC * const classobj,
        STRING *key,
        PMC *value)
{
    /* Insert it in class, if there is a class */
    if (!PMC_IS_NULL(classobj) && PObj_is_class_TEST(classobj))
        VTABLE_add_method(interp, classobj, key, value);

    /* Otherwise, store it in the namespace for the class to
     * retrieve later */
    else {
        /* If we don't have a place to hang methods, make one. */
        if (PMC_IS_NULL(nsinfo->methods))
            nsinfo->methods = pmc_new(interp, enum_class_Hash);

        /* Insert it. */
        VTABLE_set_pmc_keyed_str(interp, nsinfo->methods, key, value);
    }
}

static int
ns_insert_sub_keyed_str(PARROT_INTERP, PMC *self, STRING *key, PMC *value)
{
    Parrot_NameSpace_attributes * const nsinfo   = PARROT_NAMESPACE(self);
    PMC              *       vtable   = nsinfo->vtable;
    PMC              * const classobj = VTABLE_get_class(interp, self);
    STRING           * vtable_key     = NULL;
    Parrot_Sub_attributes *sub;

    PMC_get_sub(interp, value, sub);

    /* Handle vtable methods with two underscores at the start. */
    if (sub->vtable_index == -1) {
        if (Parrot_str_find_index(interp, key, CONST_STRING(interp, "__"), 0) == 0) {
            STRING * const meth_name = Parrot_str_substr(interp, key, 2,
                (INTVAL)(Parrot_str_byte_length(interp, key) - 2), NULL, 0);
            sub->vtable_index        =
                Parrot_get_vtable_index(interp, meth_name);
        }
    }

    if (sub->vtable_index != -1) {
        /* Insert it in class, if there is a class */
        if (!PMC_IS_NULL(classobj) && PObj_is_class_TEST(classobj)) {
            const char * const vtable_key_c =
                Parrot_get_vtable_name(interp, sub->vtable_index);
            PARROT_ASSERT(vtable_key_c);
            vtable_key = Parrot_str_new(interp, vtable_key_c,
                strlen(vtable_key_c));
            VTABLE_add_vtable_override(interp, classobj, vtable_key, value);
        }

        /* Otherwise, store it in the namespace for the class to
         * retrieve later */
        else {
            /* If we don't have a place to hang vtable methods, make one. */
            if (PMC_IS_NULL(vtable))
                nsinfo->vtable = vtable = pmc_new(interp, enum_class_Hash);

            /* Insert it. */
            VTABLE_set_pmc_keyed_int(interp, vtable, sub->vtable_index, value);
        }
    }

    if (sub->comp_flags & SUB_COMP_FLAG_METHOD) {
        STRING *method_name = key;

        if (Parrot_str_equal(interp, sub->method_name, CONST_STRING(interp, ""))) {
            if (sub->vtable_index != -1 && vtable_key != NULL) {
                method_name = Parrot_str_copy(interp, vtable_key);
            }
        }
        else {
            method_name = sub->method_name;
        }
        add_to_class(interp, nsinfo, classobj, method_name, value);
    }

    return 0;
}

/*
 * Typically a named slot contains either another namespace or a
 * var/sub (not both).
 * In case that the bucket->value is occupied, a FixedPMCArray is
 * created, and the items are moved over to that extra storage.
 * The array is flagged with FPA_is_ns_ext to distinguish it from a
 * plain array variable.
 *
 * This could easily expand to a full-fledged typed namespace if needed.
 */

typedef enum {
    NS_slot_ns,
    NS_slot_var_sub,         /* unspecified ~half-raw slot */
    NS_max_slots
} NS_slot_enum;

#define FPA_is_ns_ext PObj_private0_FLAG
#line 148 "./src/pmc/namespace.c"
static  PMC  * Parrot_NameSpace_get_class(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_NameSpace_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_NameSpace_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_NameSpace_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  * Parrot_NameSpace_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  * Parrot_NameSpace_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING  * Parrot_NameSpace_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_NameSpace_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_NameSpace_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_NameSpace_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_NameSpace_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_NameSpace_nci_make_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_add_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_add_sub(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_add_var(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_name(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_find_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_find_sub(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_find_var(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_del_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_del_sub(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_del_var(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_sym(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_export_to(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_parent(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_class(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_set_class(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_associated_methods(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_associated_vtable_methods(PARROT_INTERP, PMC *pmc);
void    Parrot_NameSpace_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_NameSpace_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_NameSpace_get_vtable(PARROT_INTERP);
void    Parrot_NameSpace_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_NameSpace_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_NameSpace_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_NameSpace_get_class(PARROT_INTERP, PMC *pmc)
{
#line 187 "./src/pmc/namespace.pmc"

    return PARROT_NAMESPACE(pmc)->_class;
#line 190 "./src/pmc/namespace.c"
}
static  PMC  *
Parrot_NameSpace_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 382 "./src/pmc/namespace.pmc"

    /* PMC    *ns = interp->vtables[enum_class_Hash]->get_pmc_keyed(interp, pmc, key); */
    PMC    *ns = interp->vtables[enum_class_Hash]->get_pmc_keyed(interp, pmc, key);

    if (!PMC_IS_NULL(ns))
        return ns;

    ns = pmc;

    if (key->vtable->base_type == enum_class_Key) {
        STRING * const part = VTABLE_get_string(interp, key);
        key                 = VTABLE_shift_pmc(interp, key);

        if (!key)
            return VTABLE_get_pmc_keyed_str(interp, ns, part);

        ns = Parrot_get_namespace_keyed_str(interp, ns, part);

        if (PMC_IS_NULL(ns))
            return PMCNULL;

        return VTABLE_get_pmc_keyed(interp, ns, key);
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
        "Invalid namespace key in get_pmc_keyed_str");
#line 222 "./src/pmc/namespace.c"
}
static  PMC  *
Parrot_NameSpace_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 410 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
    PMC              * const vtable = nsinfo->vtable;

    if (PMC_IS_NULL(vtable))
        return PMCNULL;

    return VTABLE_get_pmc_keyed_int(interp, vtable, key);
#line 236 "./src/pmc/namespace.c"
}
static  PMC  *
Parrot_NameSpace_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 369 "./src/pmc/namespace.pmc"

    PMC *ns = (PMC *)parrot_hash_get(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key);

    if (!ns)
        return PMCNULL;

    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
            ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_ns);

    return ns;
#line 253 "./src/pmc/namespace.c"
}
static  void  *
Parrot_NameSpace_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 449 "./src/pmc/namespace.pmc"

    PMC    *ns = pmc;

    if (PMC_IS_NULL(key))
        return PMCNULL;

    switch (key->vtable->base_type) {
        case enum_class_String:
            return VTABLE_get_pointer_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
        case enum_class_Key: {
            /* this loop (and function) could use a rewrite for clarity */
            while (1) {
                STRING * const part = VTABLE_get_string(interp, key);
                key                 = VTABLE_shift_pmc(interp, key);

                if (!key)
                    return VTABLE_get_pointer_keyed_str(interp, ns, part);

                ns = Parrot_get_namespace_keyed_str(interp, ns, part);

                if (PMC_IS_NULL(ns))
                    return PMCNULL;
            }
        }
        case enum_class_ResizableStringArray: {
            const INTVAL elements = VTABLE_elements(interp, key);
            INTVAL i;
            for (i = 0; i < elements; ++i)  {
                STRING * const part = VTABLE_get_string_keyed_int(interp, key, i);

                /* Last entry in the array */
                if ((i + 1) >= elements)
                    return VTABLE_get_pointer_keyed_str(interp, ns, part);

                ns = Parrot_get_namespace_keyed_str(interp, ns, part);

                if (PMC_IS_NULL(ns))
                    return PMCNULL;
            }
            return ns;
        }
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
                "Invalid namespace key of type '%S' in get_pointer_keyed",
                key->vtable->whoami);
    }
#line 305 "./src/pmc/namespace.c"
}
static  void  *
Parrot_NameSpace_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 435 "./src/pmc/namespace.pmc"

    PMC *ns = (PMC *)parrot_hash_get(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key);

    /* Be extra careful about returning PMCNULL */
    if (! PMC_IS_NULL(ns)) {
        if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
                ns->vtable->base_type == enum_class_FixedPMCArray)
            ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_var_sub);
    }
    if (PMC_IS_NULL(ns))
        ns = PMCNULL;
    return ns;
#line 323 "./src/pmc/namespace.c"
}
static  STRING  *
Parrot_NameSpace_get_string(PARROT_INTERP, PMC *pmc)
{
#line 507 "./src/pmc/namespace.pmc"

    const Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
    return nsinfo->name;
#line 332 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_init(PARROT_INTERP, PMC *pmc)
{
#line 146 "./src/pmc/namespace.pmc"

    PARROT_NAMESPACE(pmc)->vtable = PMCNULL;
    PARROT_NAMESPACE(pmc)->_class = PMCNULL;
    VTABLE_set_pointer(interp, pmc, parrot_new_hash(interp));
    PObj_custom_mark_destroy_SETALL(pmc);
#line 343 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_mark(PARROT_INTERP, PMC *pmc)
{
#line 162 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
    interp->vtables[enum_class_Hash]->mark(interp, pmc);
    if (nsinfo->parent)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)nsinfo->parent);
    if (nsinfo->name)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)nsinfo->name);
    if (nsinfo->_class)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)nsinfo->_class);
    if (nsinfo->vtable)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)nsinfo->vtable);
    if (nsinfo->methods)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)nsinfo->methods);
#line 362 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 328 "./src/pmc/namespace.pmc"

    PMC *ns = pmc;

    if (key->vtable->base_type == enum_class_String) {
        VTABLE_set_pmc_keyed_str(interp, pmc, VTABLE_get_string(interp, key), value);
        return;
    }

    if (key->vtable->base_type == enum_class_Key) {
        while (1) {
            STRING * const part = VTABLE_get_string(interp, key);
            key                 = VTABLE_shift_pmc(interp, key);

            if (!key) {
                Parrot_set_global(interp, ns, part, value);
                return;
            }

            ns = Parrot_make_namespace_keyed_str(interp, ns, part);
        }
    }

    if (key->vtable->base_type == enum_class_ResizableStringArray) {
        const INTVAL elements = VTABLE_elements(interp, key);
        INTVAL i;
        for (i = 0; i < elements; ++i)  {
            STRING * const part = VTABLE_get_string_keyed_int(interp, key, i);

            if ((i + 1) >= elements) { /* Last entry in the array */
                Parrot_set_global(interp, ns, part, value);
                return;
            }

            ns = Parrot_make_namespace_keyed_str(interp, ns, part);
        }
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
        "Invalid namespace key in set_pmc_keyed");
#line 407 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 224 "./src/pmc/namespace.pmc"

    PMC        *new_tuple = NULL;
    const int   val_is_NS = PMC_IS_NULL(value)
                          ? 0
                          :value->vtable->base_type == enum_class_NameSpace;

    /* don't need this everywhere yet */
    PMC * const old = (PMC *)parrot_hash_get(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key);

    /* If it's a sub... */
    if (!PMC_IS_NULL(value) && VTABLE_isa(interp, value, CONST_STRING(interp, "Sub"))) {
        /* TT #10; work around that Sub doesn't use PMC ATTRs */
        if (value->vtable->base_type != enum_class_Object) {
            if (ns_insert_sub_keyed_str(interp, pmc, key, value))
                return;
        }
    }

    /* If it's an NCI method */
    if (!PMC_IS_NULL(value) && VTABLE_isa(interp, value, CONST_STRING(interp, "NCI"))) {
        Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
        PMC * const classobj = VTABLE_get_class(interp, pmc);

        /* Insert it in class, if there is a class */
          add_to_class(interp, nsinfo, classobj, key, value);
    }

    /* If it's a multi-sub and the first in this NS... */
    if (!PMC_IS_NULL(value)
    &&   VTABLE_isa(interp, value, CONST_STRING(interp, "MultiSub"))) {

        /* TT #10; work around that Sub doesn't use PMC ATTRs */
        if (value->vtable->base_type != enum_class_Object
        && VTABLE_elements(interp, value) > 0) {
            Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
            PMC * const classobj = VTABLE_get_class(interp, pmc);

            /* Extract the first alternate and check if it is a method */
            PMC *pmc_sub = VTABLE_get_pmc_keyed_int(interp, value, 0);
            Parrot_Sub_attributes *sub;
            PMC_get_sub(interp, pmc_sub, sub);

            if (sub->comp_flags & SUB_COMP_FLAG_METHOD) {
                STRING *method_name = key;

                if (Parrot_str_not_equal(interp, sub->method_name, CONST_STRING(interp, "")))
                    method_name = sub->method_name;

                add_to_class(interp, nsinfo, classobj, method_name, value);

                interp->vtables[enum_class_Hash]->set_pmc_keyed_str(interp, pmc, key, value);
            }
        }
    }

    if (!old)
        interp->vtables[enum_class_Hash]->set_pmc_keyed_str(interp, pmc, key, value);
    else {
        if ((old->vtable->base_type == enum_class_NameSpace) == val_is_NS) {
            /* simple ns or simple var/sub changed */
            interp->vtables[enum_class_Hash]->set_pmc_keyed_str(interp, pmc, key, value);
        }
        else if ((PObj_get_FLAGS(old) & FPA_is_ns_ext) &&
                old->vtable->base_type == enum_class_FixedPMCArray) {
            /* we have a tuple extension already */
            VTABLE_set_pmc_keyed_int(interp, old,
                    val_is_NS ? NS_slot_ns : NS_slot_var_sub,
                    value);
        }
        else {
            /* create new tuple */
            new_tuple = pmc_new(interp, enum_class_FixedPMCArray);

            /* flag it as special */
            PObj_get_FLAGS(new_tuple) |= FPA_is_ns_ext;

            /* for a fully typed namespace, we'd need 3 or 4 */
            VTABLE_set_integer_native(interp, new_tuple, NS_max_slots);
        }
    }

    if (val_is_NS) {
        /* TODO - this hack needs to go */
        Parrot_NameSpace_attributes *nsinfo = PARROT_NAMESPACE(value);
        nsinfo->parent = pmc;  /* set parent */
        nsinfo->name   = key;   /* and name */

        if (new_tuple) {
            VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_ns, value);
            VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_var_sub,
                                     old);

            parrot_hash_put(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key, new_tuple);
            /* distinction from a plain FPA, which doesn't extend the
             * namespace storage */
        }
    }
    else if (new_tuple) {
        VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_ns, old);
        VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_var_sub, value);
        parrot_hash_put(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key, new_tuple);
    }
#line 515 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_make_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 554 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 570 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* key = CTX_REG_PMC(_ctx, 1);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 535 "./src/pmc/namespace.pmc"

    PMC *ns = Parrot_get_namespace_keyed(interp, pmc, key);
    if (PMC_IS_NULL(ns)) {
        ns = Parrot_make_namespace_keyed(interp, pmc, key);
    }
    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ns */
    /*BEGIN GENERATED ACCESSORS */
#line 588 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = ns;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto make_namespace_returns;
    /*END RETURN PMC *ns */
    }
#line 540 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
make_namespace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 633 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_add_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 673 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 689 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    PMC* _namespace = CTX_REG_PMC(_ctx, 1);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 554 "./src/pmc/namespace.pmc"

    STRING * const s_ns = CONST_STRING(interp, "NameSpace");

    if (!VTABLE_isa(interp, _namespace, s_ns))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Invalid type %d in add_namespace()",
            _namespace->vtable->base_type);

    VTABLE_set_pmc_keyed_str(interp, pmc, name, _namespace);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 722 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_add_sub(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 762 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 778 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    PMC* sub = CTX_REG_PMC(_ctx, 1);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 576 "./src/pmc/namespace.pmc"

    STRING * const s_sub      = CONST_STRING(interp, "Sub");
    STRING * const s_multisub = CONST_STRING(interp, "MultiSub");

    if (!VTABLE_isa(interp, sub, s_sub)
    &&  !VTABLE_isa(interp, sub, s_multisub))
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Invalid type %d in add_sub()", sub->vtable->base_type);

    VTABLE_set_pmc_keyed_str(interp, pmc, name, sub);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 813 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_add_var(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 853 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 869 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    PMC* var = CTX_REG_PMC(_ctx, 1);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 599 "./src/pmc/namespace.pmc"

    VTABLE_set_pmc_keyed_str(interp, pmc, name, var);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 895 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_name(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 933 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 949 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 616 "./src/pmc/namespace.pmc"

    PMC * const ar = pmc_new(interp, enum_class_ResizableStringArray);
    INTVAL elements = 0;
    PMC *ns        = pmc;

    while (ns) {
        Parrot_NameSpace_attributes *nsinfo = PARROT_NAMESPACE(ns);
        VTABLE_unshift_string(interp, ar, nsinfo->name);
        ns = nsinfo->parent;
        elements++;
    }

    /* remove the NULL string of the namespace root */
    if (elements > 0)
        VTABLE_shift_string(interp, ar);

    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ar */
    /*BEGIN GENERATED ACCESSORS */
#line 977 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = ar;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_name_returns;
    /*END RETURN PMC *ar */
    }
#line 632 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_name_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1022 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_find_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1061 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1077 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* key = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 644 "./src/pmc/namespace.pmc"

    STRING * const s_ns = CONST_STRING(interp, "NameSpace");
    PMC    * const ns   = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc),
                                                 key);

    if (!ns)
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1096 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_namespace_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 650 "./src/pmc/namespace.pmc"


    /* it's a NameSpace */
    if (VTABLE_isa(interp, ns, s_ns))
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ns */
    /*BEGIN GENERATED ACCESSORS */
#line 1122 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = ns;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_namespace_returns;
    /*END RETURN PMC *ns */
    }
#line 654 "./src/pmc/namespace.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1146 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_namespace_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 656 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
find_namespace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1191 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_find_sub(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1230 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1246 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* key = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 669 "./src/pmc/namespace.pmc"

    STRING * const s_sub = CONST_STRING(interp, "Sub");
    PMC    * const sub   = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc),
                                                  key);

    if (!sub)
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1265 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_sub_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 675 "./src/pmc/namespace.pmc"


    /* it's a Sub */
    if (VTABLE_isa(interp, sub, s_sub))
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *sub */
    /*BEGIN GENERATED ACCESSORS */
#line 1291 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = sub;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_sub_returns;
    /*END RETURN PMC *sub */
    }
#line 679 "./src/pmc/namespace.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1315 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_sub_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 681 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
find_sub_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1360 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_find_var(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1399 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1415 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* key = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 694 "./src/pmc/namespace.pmc"

    PMC * const val = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc), key);

    if (!val)
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1432 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_var_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 698 "./src/pmc/namespace.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *val */
    /*BEGIN GENERATED ACCESSORS */
#line 1456 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = val;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_var_returns;
    /*END RETURN PMC *val */
    }
#line 700 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
find_var_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1501 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_del_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1540 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1556 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 715 "./src/pmc/namespace.pmc"

    Hash   * const hash = (Hash *)pmc->vtable->get_pointer(interp, pmc);
    PMC    * const ns   = (PMC *)parrot_hash_get(interp, hash, name);
    STRING * const s_ns = CONST_STRING(interp, "NameSpace");

    if (PMC_IS_NULL(ns))
        #line 221 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*BEGIN RETURN void */
    goto no_return;
    /*END RETURN void */
#line 721 "./src/pmc/namespace.pmc"


    if (!VTABLE_isa(interp, ns, s_ns))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Invalid type %d for '%Ss' in del_namespace()",
            ns->vtable->base_type, name);

    parrot_hash_delete(interp, hash, name);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
del_namespace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1610 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_del_sub(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1649 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1665 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 743 "./src/pmc/namespace.pmc"

    Hash   * const hash  = (Hash *)pmc->vtable->get_pointer(interp, pmc);
    PMC    * const sub   = (PMC *)parrot_hash_get(interp, hash, name);
    STRING * const s_sub = CONST_STRING(interp, "Sub");

    if (PMC_IS_NULL(sub))
        #line 221 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*BEGIN RETURN void */
    goto no_return;
    /*END RETURN void */
#line 749 "./src/pmc/namespace.pmc"


    if (!VTABLE_isa(interp, sub, s_sub))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Invalid type %d for '%Ss' in del_sub()",
            sub->vtable->base_type, name);

    parrot_hash_delete(interp, hash, name);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
del_sub_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1719 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_del_var(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1758 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1774 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 769 "./src/pmc/namespace.pmc"

    parrot_hash_delete(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc), name);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1799 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_sym(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 1838 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1854 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* key = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 784 "./src/pmc/namespace.pmc"

    PMC *ns = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc), key);

    if (!ns)
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1871 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_sym_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 788 "./src/pmc/namespace.pmc"


    /* it's a NameSpace */
    if (ns->vtable == pmc->vtable)
        #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1897 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_sym_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 792 "./src/pmc/namespace.pmc"


    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext)
    &&  ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_var_sub);

    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ns */
    /*BEGIN GENERATED ACCESSORS */
#line 1925 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = ns;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_sym_returns;
    /*END RETURN PMC *ns */
    }
#line 798 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_sym_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1970 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_export_to(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 3 };
    opcode_t _param_indexes[]     = { 0, 1, 2 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 2010 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2026 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* dest = CTX_REG_PMC(_ctx, 1);
    PMC* what = CTX_REG_PMC(_ctx, 2);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 821 "./src/pmc/namespace.pmc"

    STRING * const s_hash  = CONST_STRING(interp, "hash");
    STRING * const s_array = CONST_STRING(interp, "array");

    if (PMC_IS_NULL(dest))
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "destination namespace not specified");

    if (PMC_IS_NULL(what) || !VTABLE_elements(interp, what))
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "exporting default object set not yet implemented");

    /* if "what" does "hash", we extract string key/value pairs,
     * lookup the object with the name specified in the key,
     * and export it with the name specified as value. */
    if (VTABLE_does(interp, what, s_hash)) {
        PMC * const  iter = VTABLE_get_iter(interp, what);
        const INTVAL n    = VTABLE_elements(interp, what);
        INTVAL       i;

        for (i = 0; i < n; ++i) {
            STRING *dest_name;
            PMC    *object;
            STRING * const src_name = VTABLE_shift_string(interp, iter);

            if (STRING_IS_NULL(src_name) || STRING_IS_EMPTY(src_name))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "source object name not specified");

            if (PMC_IS_NULL(VTABLE_get_pmc_keyed_str(interp, what, src_name))) {
                dest_name = src_name;
            }
            else {
                dest_name = VTABLE_get_string_keyed_str(interp, what, src_name);
                if (STRING_IS_NULL(dest_name) || STRING_IS_EMPTY(dest_name))
                    dest_name = src_name;
            }

            object = VTABLE_get_pmc_keyed_str(interp, pmc, src_name);

            if (PMC_IS_NULL(object))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "object '%Ss' not found in current namespace", src_name);

            VTABLE_set_pmc_keyed_str(interp, dest, dest_name, object);
        }
    }
    else if (VTABLE_does(interp, what, s_array)) {
        const INTVAL n = VTABLE_elements(interp, what);
        INTVAL       i;

        for (i = 0; i < n; ++i) {
            PMC    *object;
            STRING * const name = VTABLE_get_string_keyed_int(interp, what, i);

            if (STRING_IS_NULL(name) || STRING_IS_EMPTY(name))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "object name not specified");

            object = VTABLE_get_pmc_keyed_str(interp, pmc, name);

            if (PMC_IS_NULL(object))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "object '%Ss' not found in current namespace", name);

            VTABLE_set_pmc_keyed_str(interp, dest, name, object);
        }
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "can't handle argument of type %s", what->vtable->base_type);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2121 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_parent(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 2159 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2175 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 904 "./src/pmc/namespace.pmc"

    PMC *parent = PARROT_NAMESPACE(pmc)->parent ? PARROT_NAMESPACE(pmc)->parent : PMCNULL;
    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *parent */
    /*BEGIN GENERATED ACCESSORS */
#line 2189 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = parent;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_parent_returns;
    /*END RETURN PMC *parent */
    }
#line 906 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_parent_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2234 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_class(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 2272 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2288 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 919 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
    PMC              *ret_class     = nsinfo->_class;

    if (PMC_IS_NULL(ret_class))
        ret_class = PMCNULL;

    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_class */
    /*BEGIN GENERATED ACCESSORS */
#line 2307 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_class;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_class_returns;
    /*END RETURN PMC *ret_class */
    }
#line 926 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_class_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2352 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_set_class(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 2391 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2407 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* class_or_role = CTX_REG_PMC(_ctx, 1);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 939 "./src/pmc/namespace.pmc"

    PARROT_NAMESPACE(pmc)->_class = class_or_role;
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2432 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_associated_methods(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 2470 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2486 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 954 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo      = PARROT_NAMESPACE(pmc);
    PMC              * const ret_methods = nsinfo->methods;

    nsinfo->methods = PMCNULL;

    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_methods */
    /*BEGIN GENERATED ACCESSORS */
#line 2504 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_methods;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_associated_methods_returns;
    /*END RETURN PMC *ret_methods */
    }
#line 960 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_associated_methods_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2549 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_associated_vtable_methods(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 2587 "./src/pmc/namespace.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2603 "./src/pmc/namespace.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 974 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo      = PARROT_NAMESPACE(pmc);
    PMC              * const ret_methods = nsinfo->vtable;

    nsinfo->vtable = PMCNULL;

    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_methods */
    /*BEGIN GENERATED ACCESSORS */
#line 2621 "./src/pmc/namespace.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_methods;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_associated_vtable_methods_returns;
    /*END RETURN PMC *ret_methods */
    }
#line 980 "./src/pmc/namespace.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_associated_vtable_methods_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2666 "./src/pmc/namespace.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_NameSpace_update_vtable(VTABLE *vt) {
    vt->get_class = Parrot_NameSpace_get_class;
    vt->get_pmc_keyed = Parrot_NameSpace_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_NameSpace_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_NameSpace_get_pmc_keyed_str;
    vt->get_pointer_keyed = Parrot_NameSpace_get_pointer_keyed;
    vt->get_pointer_keyed_str = Parrot_NameSpace_get_pointer_keyed_str;
    vt->get_string = Parrot_NameSpace_get_string;
    vt->init = Parrot_NameSpace_init;
    vt->mark = Parrot_NameSpace_mark;
    vt->set_pmc_keyed = Parrot_NameSpace_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_NameSpace_set_pmc_keyed_str;
    vt->attr_size = sizeof(Parrot_NameSpace_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_NameSpace_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_class = Parrot_NameSpace_get_class;
    vt->get_pmc_keyed = Parrot_NameSpace_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_NameSpace_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_NameSpace_get_pmc_keyed_str;
    vt->get_pointer_keyed = Parrot_NameSpace_get_pointer_keyed;
    vt->get_pointer_keyed_str = Parrot_NameSpace_get_pointer_keyed_str;
    vt->get_string = Parrot_NameSpace_get_string;
    vt->init = Parrot_NameSpace_init;
    vt->mark = Parrot_NameSpace_mark;
    vt->attr_size = sizeof(Parrot_NameSpace_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_NameSpace_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_get_vtable(interp);
    Parrot_NameSpace_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_NameSpace_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_ro_get_vtable(interp);
    Parrot_NameSpace_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_NameSpace_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Hash_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "NameSpace", 9, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_NameSpace_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Hash_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "NameSpace")), PMCNULL);
    return isa;
}

void
Parrot_NameSpace_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash Sname F_class Fmethods Fvtable Fparent ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_NameSpace_get_vtable(interp);
        vt->base_type      = enum_class_NameSpace;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "NameSpace");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_NameSpace_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_NameSpace_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_NameSpace;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_NameSpace_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_make_namespace), CONST_STRING_GEN(interp, "make_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_add_namespace), CONST_STRING_GEN(interp, "add_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_add_sub), CONST_STRING_GEN(interp, "add_sub"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_add_var), CONST_STRING_GEN(interp, "add_var"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_name), CONST_STRING_GEN(interp, "get_name"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_find_namespace), CONST_STRING_GEN(interp, "find_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_find_sub), CONST_STRING_GEN(interp, "find_sub"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_find_var), CONST_STRING_GEN(interp, "find_var"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_del_namespace), CONST_STRING_GEN(interp, "del_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_del_sub), CONST_STRING_GEN(interp, "del_sub"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_del_var), CONST_STRING_GEN(interp, "del_var"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_sym), CONST_STRING_GEN(interp, "get_sym"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_export_to), CONST_STRING_GEN(interp, "export_to"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_parent), CONST_STRING_GEN(interp, "get_parent"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_class), CONST_STRING_GEN(interp, "get_class"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_set_class), CONST_STRING_GEN(interp, "set_class"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_associated_methods), CONST_STRING_GEN(interp, "get_associated_methods"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_associated_vtable_methods), CONST_STRING_GEN(interp, "get_associated_vtable_methods"));
        {
        }
    } /* pass */
} /* Parrot_NameSpace_class_init */
#line 982 "./src/pmc/namespace.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd21_namespaces.pod>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
