/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/orderedhash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_orderedhash.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "orderedhash.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/orderedhash.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: orderedhash.pmc 40739 2009-08-23 15:04:07Z whiteknight $

=head1 NAME

src/pmc/orderedhash.pmc - Ordered Hash

=head1 DESCRIPTION

C<OrderedHash> extends C<Hash> to provide the interfaces of C<array> and
C<hash>. To achieve ordering, hash there are a few restrictions:
C<delete_keyed> never removes items; they are just nulled.

Please note that if values are set via integer idx, these indices have to be in
strict order. Using C<push_xx> simplifies this task.  This creates a key
"\1idx" for C<idx> and is therefore not fully transparent.

There are two iterator interfaces:

=over 4

=item * retrieve values (in creation order)

Please note that after a C<delete_keyed> operation, iterating over
values doesn't work any more.  You'll get an error 'No such key'.

=item * retrieve keys (in creation order)

=back

See F<t/pmc/orderedhash.t>.

=head2 Methods

=over 4

=cut

*/
#line 63 "./src/pmc/orderedhash.c"
static  PMC  * Parrot_OrderedHash_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  void  Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  void  Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  INTVAL  Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  INTVAL  Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  INTVAL  Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  PMC  * Parrot_OrderedHash_get_iter(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  STRING  * Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  void  Parrot_OrderedHash_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, INTVAL value);
static  void  Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, FLOATVAL value);
static  void  Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *val);
static  void  Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, STRING *value);
static  void  Parrot_OrderedHash_visit(PARROT_INTERP, PMC *pmc, visit_info *info);
void    Parrot_OrderedHash_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_OrderedHash_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_OrderedHash_get_vtable(PARROT_INTERP);
void    Parrot_OrderedHash_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_OrderedHash_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_OrderedHash_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_OrderedHash_clone(PARROT_INTERP, PMC *pmc)
{
#line 592 "./src/pmc/orderedhash.pmc"

    PMC  * const dest   = pmc_new(interp, pmc->vtable->base_type);
    Hash * const hash   = (Hash *)VTABLE_get_pointer(interp, pmc);
    Hash * const h_dest = (Hash *)VTABLE_get_pointer(interp, dest);
    UINTVAL     i;

    for (i = 0; i <= N_BUCKETS(hash->mask-1); i++) {
        HashBucket * const b      = hash->bs + i;
        void       * const key    = b->key;

        if (key)
            parrot_hash_put(interp, h_dest, key,
                (void *)VTABLE_clone(interp, (PMC *)b->value));
    }

    return dest;
#line 118 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 462 "./src/pmc/orderedhash.pmc"

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        Hash * const h   = (Hash *)VTABLE_get_pointer(interp, pmc);
        INTVAL       idx = VTABLE_get_integer(interp, key);
        const INTVAL n   = h->entries;

        HashBucket *b;
        PMC        *item, *next;

        if (idx < 0)
            idx += n;

        /* XXX non-existent is undefined - is this correct */
        if (idx < 0 || idx >= n)
            return 0;

        b = h->bs + idx;

        if (!b->key)
            return 0;

        item = (PMC *)b->value;
        next = VTABLE_shift_pmc(interp, key);

        if (!next)
            return VTABLE_defined(interp, item);

        return VTABLE_defined_keyed(interp, item, next);
    }

    return interp->vtables[enum_class_Hash]->defined_keyed(interp, pmc, key);
#line 155 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 495 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL n = h->entries;
    HashBucket  *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return 0;

    b = h->bs + idx;

    if (b->key)
        return VTABLE_defined(interp, (PMC *)b->value);

    return 0;
#line 178 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 528 "./src/pmc/orderedhash.pmc"

    PMC * const next = key_next(interp, key);

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        if (next) {
            PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
            VTABLE_delete_keyed(interp, item, next);
            return;
        }

        VTABLE_delete_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
    }
    else {
        if (next) {
            PMC * const item = VTABLE_get_pmc_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
            VTABLE_delete_keyed(interp, item, next);
            return;
        }
        VTABLE_delete_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
    }
#line 204 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 550 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL n = h->entries;
    HashBucket  *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return;

    b = h->bs + idx;

    if (!b)
        return;

    b->key       = NULL;
    b->value     = NULL;
#line 228 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 570 "./src/pmc/orderedhash.pmc"

    const Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, h, key);

    if (!b)
        return;

    b->key       = NULL;
    b->value     = NULL;
#line 243 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 412 "./src/pmc/orderedhash.pmc"

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        PMC        *item, *next;
        HashBucket *b;
        Hash       * const h   = (Hash *)VTABLE_get_pointer(interp, pmc);
        INTVAL             idx = VTABLE_get_integer(interp, key);
        const INTVAL       n   = h->entries;

        if (idx < 0)
            idx += n;

        if (idx < 0 || idx >= n)
            return 0;

        b = h->bs + idx;

        if (!b->key)
            return 0;

        item = (PMC *)b->value;
        next = VTABLE_shift_pmc(interp, key);

        if (!next)
            return 1;

        return VTABLE_exists_keyed(interp, item, next);
    }

    return interp->vtables[enum_class_Hash]->exists_keyed(interp, pmc, key);
#line 278 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 393 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL n = h->entries;
    HashBucket  *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return 0;

    b = h->bs + idx;

    if (b->key)
        return 1;

    return 0;
#line 301 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 443 "./src/pmc/orderedhash.pmc"

    const Hash       * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const HashBucket * const b = parrot_hash_get_bucket(interp, h, key);

    return (b && b->key);
#line 312 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 221 "./src/pmc/orderedhash.pmc"


    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
        PMC * const next = VTABLE_shift_pmc(interp, key);

        if (!next)
            return VTABLE_get_integer(interp, item);

        return VTABLE_get_integer_keyed(interp, item, next);
    }

    return interp->vtables[enum_class_Hash]->get_integer_keyed(interp, pmc, key);
#line 331 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 200 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_integer(interp, (PMC *)b->value);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 356 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 88 "./src/pmc/orderedhash.pmc"

    return pmc_new_init(interp, enum_class_OrderedHashIterator, pmc);
#line 364 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 271 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
        PMC * const next = VTABLE_shift_pmc(interp, key);

        if (!next)
            return VTABLE_get_number(interp, item);

        return VTABLE_get_number_keyed(interp, item, next);
    }

    return interp->vtables[enum_class_Hash]->get_number_keyed(interp, pmc, key);
#line 382 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 250 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_number(interp, (PMC *)b->value);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 407 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 125 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
        PMC * const next = VTABLE_shift_pmc(interp, key);

        if (!next)
            return item;

        return VTABLE_get_pmc_keyed(interp, item, next);
    }

    return interp->vtables[enum_class_Hash]->get_pmc_keyed(interp, pmc, key);
#line 425 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 104 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return (PMC *)b->value;

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 450 "./src/pmc/orderedhash.c"
}
static  STRING  *
Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 173 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
        PMC * const next = VTABLE_shift_pmc(interp, key);

        if (!next)
            return VTABLE_get_string(interp, item);

        return VTABLE_get_string_keyed(interp, item, next);
    }

    return interp->vtables[enum_class_Hash]->get_string_keyed(interp, pmc, key);
#line 468 "./src/pmc/orderedhash.c"
}
static  STRING  *
Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 151 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL n = h->entries;

    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_string(interp, (PMC *)b->value);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 494 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_mark(PARROT_INTERP, PMC *pmc)
{
#line 54 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)VTABLE_get_pointer(interp, pmc);
    INTVAL  i;

    if (!h)
        return;

    /* RT #53890 - keys can be NULL on purpose; move to src/hash.c ? */
    for (i = h->mask; i >= 0; --i) {
        HashBucket *b = h->bi[i];

        while (b) {

            if (b->key) {
                Parrot_gc_mark_PObj_alive(interp, (PObj *)b->key);
                if (b->value)
                    Parrot_gc_mark_PObj_alive(interp, (PObj *)b->value);
            }

            b = b->next;
        }
    }
#line 522 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 366 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_number_keyed_int(interp, pmc, n, value);
#line 531 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 371 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, n, value);
#line 540 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 361 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_pmc_keyed_int(interp, pmc, n, value);
#line 549 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 376 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, n, value);
#line 558 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, INTVAL value)
{
#line 327 "./src/pmc/orderedhash.pmc"

    PMC * const v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));
    VTABLE_set_integer_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 569 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, FLOATVAL value)
{
#line 334 "./src/pmc/orderedhash.pmc"

    PMC * const v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Float));
    VTABLE_set_number_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 580 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *val)
{
#line 302 "./src/pmc/orderedhash.pmc"

    Hash * const     h = (Hash *)VTABLE_get_pointer(interp, pmc);
    const INTVAL     n = h->entries;
    STRING * const fmt = CONST_STRING(interp, "\1%d");

    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;

    if (idx >= n) {
        /* TODO warn or fill if there are holes */
        STRING * const key = Parrot_sprintf_s(interp, fmt, idx);
        VTABLE_set_pmc_keyed_str(interp, pmc, key, val);
    }
    else {
        HashBucket * const b = h->bs + idx;

        if (!b->key)
            b->key = Parrot_sprintf_s(interp, fmt, idx);

        b->value     = val;
    }
#line 609 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, STRING *value)
{
#line 341 "./src/pmc/orderedhash.pmc"

    PMC * const v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));
    VTABLE_set_string_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 620 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 630 "./src/pmc/orderedhash.pmc"

    info->container  = pmc;

    switch (info->what) {
        case VISIT_THAW_NORMAL:
        case VISIT_THAW_CONSTANTS:
            interp->vtables[enum_class_Hash]->visit(interp, pmc, info);
            break;

        case VISIT_FREEZE_NORMAL:
        case VISIT_FREEZE_AT_DESTRUCT:
            {
                Hash     * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
                IMAGE_IO * const io   = info->image_io;
                const UINTVAL entries = hash->entries;
                UINTVAL i;

                for (i = 0; i < entries; i++) {
                    HashBucket * const b   = hash->bs + i;

                    if (b) {
                        STRING * const key = (STRING *)b->key;
                        if (key) {
                            VTABLE_push_string(interp, io, key);
                            (info->visit_pmc_now)(interp, (PMC *)b->value, info);
                        }
                    }
                }
            }
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "unhandled visit action (%d)", info->what);
    }
#line 661 "./src/pmc/orderedhash.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_OrderedHash_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_OrderedHash_clone;
    vt->defined_keyed = Parrot_OrderedHash_defined_keyed;
    vt->defined_keyed_int = Parrot_OrderedHash_defined_keyed_int;
    vt->delete_keyed = Parrot_OrderedHash_delete_keyed;
    vt->delete_keyed_int = Parrot_OrderedHash_delete_keyed_int;
    vt->delete_keyed_str = Parrot_OrderedHash_delete_keyed_str;
    vt->exists_keyed = Parrot_OrderedHash_exists_keyed;
    vt->exists_keyed_int = Parrot_OrderedHash_exists_keyed_int;
    vt->exists_keyed_str = Parrot_OrderedHash_exists_keyed_str;
    vt->get_integer_keyed = Parrot_OrderedHash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_OrderedHash_get_integer_keyed_int;
    vt->get_iter = Parrot_OrderedHash_get_iter;
    vt->get_number_keyed = Parrot_OrderedHash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_OrderedHash_get_number_keyed_int;
    vt->get_pmc_keyed = Parrot_OrderedHash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_OrderedHash_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_OrderedHash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_OrderedHash_get_string_keyed_int;
    vt->mark = Parrot_OrderedHash_mark;
    vt->push_float = Parrot_OrderedHash_push_float;
    vt->push_integer = Parrot_OrderedHash_push_integer;
    vt->push_pmc = Parrot_OrderedHash_push_pmc;
    vt->push_string = Parrot_OrderedHash_push_string;
    vt->set_integer_keyed_int = Parrot_OrderedHash_set_integer_keyed_int;
    vt->set_number_keyed_int = Parrot_OrderedHash_set_number_keyed_int;
    vt->set_pmc_keyed_int = Parrot_OrderedHash_set_pmc_keyed_int;
    vt->set_string_keyed_int = Parrot_OrderedHash_set_string_keyed_int;
    vt->visit = Parrot_OrderedHash_visit;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_OrderedHash_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_OrderedHash_clone;
    vt->defined_keyed = Parrot_OrderedHash_defined_keyed;
    vt->defined_keyed_int = Parrot_OrderedHash_defined_keyed_int;
    vt->exists_keyed = Parrot_OrderedHash_exists_keyed;
    vt->exists_keyed_int = Parrot_OrderedHash_exists_keyed_int;
    vt->exists_keyed_str = Parrot_OrderedHash_exists_keyed_str;
    vt->get_integer_keyed = Parrot_OrderedHash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_OrderedHash_get_integer_keyed_int;
    vt->get_iter = Parrot_OrderedHash_get_iter;
    vt->get_number_keyed = Parrot_OrderedHash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_OrderedHash_get_number_keyed_int;
    vt->get_pmc_keyed = Parrot_OrderedHash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_OrderedHash_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_OrderedHash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_OrderedHash_get_string_keyed_int;
    vt->mark = Parrot_OrderedHash_mark;
    vt->visit = Parrot_OrderedHash_visit;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OrderedHash_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_get_vtable(interp);
    Parrot_OrderedHash_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OrderedHash_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_ro_get_vtable(interp);
    Parrot_OrderedHash_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_OrderedHash_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Hash_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "OrderedHash", 11, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_OrderedHash_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Hash_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "OrderedHash")), PMCNULL);
    return isa;
}

void
Parrot_OrderedHash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_OrderedHash_get_vtable(interp);
        vt->base_type      = enum_class_OrderedHash;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "OrderedHash");
        vt->provides_str = CONST_STRING_GEN(interp, "array hash");
        vt->isa_hash     = Parrot_OrderedHash_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_OrderedHash_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_OrderedHash;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_OrderedHash_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_OrderedHash_class_init */
#line 665 "./src/pmc/orderedhash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=head1 HISTORY

Initial rev by leo 2003-08-21.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
