/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/packfile.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_packfile.h"
#include "pmc_default.h"
#include "packfile.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/packfile.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: packfile.pmc 41228 2009-09-12 12:55:08Z bacek $

=head1 NAME

src/pmc/packfile.pmc - Packfile PMC

=head1 DESCRIPTION

This class implements a Packfile object, as specified in PDD13.  This object is
the top level parser and serializer for *.pbc files.

=head2 Methods

=over 4

=cut

*/

#include "pmc_packfiledirectory.h"

/*
Copy attributes from PackFile* to Packfile PMC.
*/
static void
copy_packfile_header(PARROT_INTERP, PMC *self, PackFile *pf) {
    Parrot_Packfile_attributes *attrs = PARROT_PACKFILE(self);

    attrs->wordsize         = pf->header->wordsize;
    attrs->byteorder        = pf->header->byteorder;
    attrs->fptype           = pf->header->floattype;
    attrs->version_major    = pf->header->major;
    attrs->version_minor    = pf->header->minor;
    attrs->version_patch    = pf->header->patch;
    attrs->bytecode_major   = pf->header->bc_major;
    attrs->bytecode_minor   = pf->header->bc_minor;
    attrs->uuid_type        = pf->header->uuid_type;

    attrs->uuid = Parrot_str_new(interp, (char*)pf->header->uuid_data,
            pf->header->uuid_size);

}
#line 67 "./src/pmc/packfile.c"
static  INTVAL  Parrot_Packfile_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Packfile_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING  * Parrot_Packfile_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Packfile_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_Packfile_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Packfile_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Packfile_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Packfile_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL val);
static  void  Parrot_Packfile_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void  Parrot_Packfile_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *val);
static  void  Parrot_Packfile_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void  Parrot_Packfile_set_string_native(PARROT_INTERP, PMC *pmc, STRING *str);
static  void Parrot_Packfile_nci_pack(PARROT_INTERP, PMC *pmc);
static  void Parrot_Packfile_nci_unpack(PARROT_INTERP, PMC *pmc);
static  void Parrot_Packfile_nci_get_directory(PARROT_INTERP, PMC *pmc);
void    Parrot_Packfile_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Packfile_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Packfile_get_vtable(PARROT_INTERP);
void    Parrot_Packfile_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Packfile_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Packfile_ro_get_vtable(PARROT_INTERP);
static  INTVAL 
Parrot_Packfile_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 275 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_integer_keyed_str(interp, pmc, s);
#line 96 "./src/pmc/packfile.c"
}
static  INTVAL 
Parrot_Packfile_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 214 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes *attrs = PARROT_PACKFILE(pmc);
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "wordsize")))
        return attrs->wordsize;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "byteorder")))
        return attrs->byteorder;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "fptype")))
        return attrs->fptype;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_major")))
        return attrs->version_major;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_minor")))
        return attrs->version_minor;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_patch")))
        return attrs->version_patch;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "bytecode_major")))
        return attrs->bytecode_major;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "bytecode_minor")))
        return attrs->bytecode_minor;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid_type")))
        return attrs->uuid_type;

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such integer key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 126 "./src/pmc/packfile.c"
}
static  STRING  *
Parrot_Packfile_get_string(PARROT_INTERP, PMC *pmc)
{
#line 114 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes * attrs = PARROT_PACKFILE(pmc);
    PackFile                   * pf =
            (PackFile*)VTABLE_get_pointer(interp, attrs->directory);

    opcode_t    length;
    opcode_t    *ptr;
    STRING      *str;

    /* Calculate required memory */
    length  = PackFile_pack_size(interp, pf) * sizeof (opcode_t);
    ptr     = (opcode_t*)mem_sys_allocate(length);

    /* Copy related attributes to header */
    pf->header->major     = attrs->version_major;
    pf->header->minor     = attrs->version_minor;
    pf->header->patch     = attrs->version_patch;
    pf->header->uuid_type = attrs->uuid_type;

    /* And pack it! */
    PackFile_pack(interp, pf, ptr);

    str = Parrot_str_new_init(interp, (const char*)ptr, length,
            PARROT_FIXED_8_ENCODING, PARROT_BINARY_CHARSET, 0);
    mem_sys_free(ptr);

    PackFile_destroy(interp, pf);
    return str;
#line 160 "./src/pmc/packfile.c"
}
static  STRING  *
Parrot_Packfile_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 291 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_string_keyed_str(interp, pmc, s);
#line 169 "./src/pmc/packfile.c"
}
static  STRING  *
Parrot_Packfile_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 255 "./src/pmc/packfile.pmc"

    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid")))
        return PARROT_PACKFILE(pmc)->uuid;

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such string key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 182 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_init(PARROT_INTERP, PMC *pmc)
{
#line 68 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes *attrs =
            PMC_data_typed(pmc, Parrot_Packfile_attributes*);
    PackFile                   *pf;

    attrs->uuid     = Parrot_str_new_noinit(interp, enum_stringrep_one, 0);
    attrs->directory = pmc_new(interp, enum_class_PackfileDirectory);

    /* Create dummy PackFile and copy default attributes to self */
    pf = PackFile_new(interp, 0);
    copy_packfile_header(interp, pmc, pf);
    PackFile_destroy(interp, pf);

    PObj_custom_mark_SET(pmc);
#line 202 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_mark(PARROT_INTERP, PMC *pmc)
{
#line 95 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes * attrs = PARROT_PACKFILE(pmc);

    if (attrs->uuid)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)attrs->uuid);
    if (!PMC_IS_NULL(attrs->directory))
        Parrot_gc_mark_PObj_alive(interp, (PObj *)attrs->directory);
#line 215 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL val)
{
#line 351 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    VTABLE_set_integer_keyed_str(interp, pmc, s, val);
#line 224 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 317 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes *attrs = PARROT_PACKFILE(pmc);
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_major"))) {
        attrs->version_major = value;
        return;
    }
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_minor"))) {
        attrs->version_minor = value;
        return;
    }
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_patch"))) {
        attrs->version_patch = value;
        return;
    }
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid_type"))) {
        attrs->uuid_type = value;
        return;
    }
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such integer key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 251 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *val)
{
#line 394 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    VTABLE_set_string_keyed_str(interp, pmc, s, val);
#line 260 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 373 "./src/pmc/packfile.pmc"

    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid"))) {
        PARROT_PACKFILE(pmc)->uuid = value;
        return;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such string key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 275 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_string_native(PARROT_INTERP, PMC *pmc, STRING *str)
{
#line 154 "./src/pmc/packfile.pmc"

    PackFile        *pf = PackFile_new(interp, 0);
    const opcode_t  *ptr =
            (const opcode_t*)Parrot_string_cstring(interp, str);
    int             length = Parrot_str_byte_length(interp, str);
    Parrot_Packfile_attributes * attrs = PARROT_PACKFILE(pmc);

    if (!PackFile_unpack(interp, pf, ptr, length)) {
        PackFile_destroy(interp, pf);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_MALFORMED_PACKFILE,
                                    "Can't unpack packfile.");
    }

    /* Disable GC during copy data into internal structures. */
    Parrot_block_GC_mark(interp);

    /* Copy values from PackFile header to own attributes */
    copy_packfile_header(interp, pmc, pf);

    VTABLE_set_pointer(interp, attrs->directory, &pf->directory);

    Parrot_unblock_GC_mark(interp);

    PackFile_destroy(interp, pf);
#line 305 "./src/pmc/packfile.c"
}
static  void
Parrot_Packfile_nci_pack(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 343 "./src/pmc/packfile.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 359 "./src/pmc/packfile.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 410 "./src/pmc/packfile.pmc"

    STRING * ret = pmc->vtable->get_string(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING * ret */
    /*BEGIN GENERATED ACCESSORS */
#line 373 "./src/pmc/packfile.pmc"
    CTX_REG_STR(_ctx, 0) = ret;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto pack_returns;
    /*END RETURN STRING * ret */
    }
#line 412 "./src/pmc/packfile.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
pack_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 418 "./src/pmc/packfile.c"
}
static  void
Parrot_Packfile_nci_unpack(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 457 "./src/pmc/packfile.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 473 "./src/pmc/packfile.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* str = CTX_REG_STR(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 426 "./src/pmc/packfile.pmc"

    pmc->vtable->set_string_native(interp, pmc, str);
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 498 "./src/pmc/packfile.c"
}
static  void
Parrot_Packfile_nci_get_directory(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 536 "./src/pmc/packfile.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 552 "./src/pmc/packfile.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 440 "./src/pmc/packfile.pmc"

    PMC *dir = PARROT_PACKFILE(pmc)->directory;
    #line 237 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *dir */
    /*BEGIN GENERATED ACCESSORS */
#line 566 "./src/pmc/packfile.pmc"
    CTX_REG_PMC(_ctx, 0) = dir;

#line 256 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_directory_returns;
    /*END RETURN PMC *dir */
    }
#line 442 "./src/pmc/packfile.pmc"

#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 470 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_directory_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        Parrot_pcc_get_results(interp, _caller_ctx), PARROT_PASS_RESULTS);
#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 611 "./src/pmc/packfile.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Packfile_update_vtable(VTABLE *vt) {
    vt->get_integer_keyed = Parrot_Packfile_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Packfile_get_integer_keyed_str;
    vt->get_string = Parrot_Packfile_get_string;
    vt->get_string_keyed = Parrot_Packfile_get_string_keyed;
    vt->get_string_keyed_str = Parrot_Packfile_get_string_keyed_str;
    vt->init = Parrot_Packfile_init;
    vt->mark = Parrot_Packfile_mark;
    vt->set_integer_keyed = Parrot_Packfile_set_integer_keyed;
    vt->set_integer_keyed_str = Parrot_Packfile_set_integer_keyed_str;
    vt->set_string_keyed = Parrot_Packfile_set_string_keyed;
    vt->set_string_keyed_str = Parrot_Packfile_set_string_keyed_str;
    vt->set_string_native = Parrot_Packfile_set_string_native;
    vt->attr_size = sizeof(Parrot_Packfile_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Packfile_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_integer_keyed = Parrot_Packfile_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Packfile_get_integer_keyed_str;
    vt->get_string = Parrot_Packfile_get_string;
    vt->get_string_keyed = Parrot_Packfile_get_string_keyed;
    vt->get_string_keyed_str = Parrot_Packfile_get_string_keyed_str;
    vt->init = Parrot_Packfile_init;
    vt->mark = Parrot_Packfile_mark;
    vt->attr_size = sizeof(Parrot_Packfile_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Packfile_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Packfile_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Packfile_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Packfile_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Packfile_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Packfile", 8, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Packfile_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Packfile")), PMCNULL);
    return isa;
}

void
Parrot_Packfile_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iwordsize Ibyteorder Ifptype Iversion_major Iversion_minor Iversion_patch Ibytecode_major Ibytecode_minor Iuuid_type Suuid Fdirectory ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Packfile_get_vtable(interp);
        vt->base_type      = enum_class_Packfile;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Packfile");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Packfile_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Packfile;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Packfile_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Packfile_nci_pack), CONST_STRING_GEN(interp, "pack"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Packfile_nci_unpack), CONST_STRING_GEN(interp, "unpack"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Packfile_nci_get_directory), CONST_STRING_GEN(interp, "get_directory"));
        {
        }
    } /* pass */
} /* Parrot_Packfile_class_init */
#line 445 "./src/pmc/packfile.pmc"

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
