/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/packfileannotations.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_packfileannotations.h"
#include "pmc_packfilesegment.h"
#include "pmc_default.h"
#include "packfileannotations.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/packfileannotations.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: packfileannotations.pmc 41228 2009-09-12 12:55:08Z bacek $

=head1 NAME

src/pmc/packfileannotations.pmc - PackfileAnnotations PMC

=head1 DESCRIPTION

This class implements a PackfileAnnotations object, a segment of the .pbc data
file used for listing annotations.  It is a container for PackfileAnnotation
objects.

See packfile.pmc for the toplevel Packfile interface, see packfilesegment.pmc
for the list of common methods every packfile segment pmc must implement; see
PDD13 for the design spec.

To works properly PackfileAnnotations has to be added to PackfileDirectory with
PackfileConstantTable. Otherwise PackfileAnnotationKey can't be created.

=head2 Methods

=over 4

=cut

*/

#include "pmc_packfileannotation.h"
#line 54 "./src/pmc/packfileannotations.c"
static  INTVAL  Parrot_PackfileAnnotations_elements(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_PackfileAnnotations_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL index);
static  void  * Parrot_PackfileAnnotations_get_pointer(PARROT_INTERP, PMC *pmc);
static  void  Parrot_PackfileAnnotations_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_PackfileAnnotations_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_PackfileAnnotations_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL index, PMC *annotation);
static  void  Parrot_PackfileAnnotations_set_pointer(PARROT_INTERP, PMC *pmc, void *pointer);
static  void Parrot_PackfileAnnotations_nci_set_directory(PARROT_INTERP, PMC *pmc);
void    Parrot_PackfileAnnotations_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_PackfileAnnotations_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_PackfileAnnotations_get_vtable(PARROT_INTERP);
void    Parrot_PackfileAnnotations_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_PackfileAnnotations_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_PackfileAnnotations_ro_get_vtable(PARROT_INTERP);
static  INTVAL 
Parrot_PackfileAnnotations_elements(PARROT_INTERP, PMC *pmc)
{
#line 94 "./src/pmc/packfileannotations.pmc"

    return VTABLE_elements(interp,
            PARROT_PACKFILEANNOTATIONS(pmc)->annotations);
#line 76 "./src/pmc/packfileannotations.c"
}
static  PMC  *
Parrot_PackfileAnnotations_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL index)
{
#line 109 "./src/pmc/packfileannotations.pmc"

    return VTABLE_get_pmc_keyed_int(interp,
            PARROT_PACKFILEANNOTATIONS(pmc)->annotations, index);
#line 85 "./src/pmc/packfileannotations.c"
}
static  void  *
Parrot_PackfileAnnotations_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 263 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes *attrs =
            PARROT_PACKFILEANNOTATIONS(pmc);
    PackFile_Annotations *res = mem_allocate_zeroed_typed(PackFile_Annotations);
    INTVAL                i, num;
    INTVAL                key_type;
    PMC                  *keys;             /* Temporary representation of Keys */
    PMC                  *names;            /* Constants for Key's names */
    PMC                  *types;            /* Types of Keys */
    INTVAL                key_id;
    INTVAL                last_key_id;
    INTVAL                name_id;

    res->base.type = PF_ANNOTATIONS_SEG;

    /*
        Create keys. Hash will be created in next structure:
        keys => {
            name => [
                $int_key_id,
                $str_key_id,
                $num_key_id,
            ]
        }

        Each key has name from ConstantTable. We store them in names Array.
        names => [
            $constant_id_1,
            $contsant_id_2,
            ...
        ]
    */
    keys        = pmc_new(interp, enum_class_Hash);
    names       = pmc_new(interp, enum_class_ResizableIntegerArray);
    types       = pmc_new(interp, enum_class_ResizableIntegerArray);
    last_key_id = -1;

    /* Iterate over stored annotations and create Key if required. */
    num = VTABLE_elements(interp, attrs->annotations);
    res->num_entries = num;
    res->entries = mem_allocate_n_typed(num, PackFile_Annotations_Entry*);
    for (i = 0; i < num; ++i) {
        PMC  *entity = VTABLE_get_pmc_keyed_int(interp, attrs->annotations, i);
        Parrot_PackfileAnnotation_attributes *entity_attrs = PARROT_PACKFILEANNOTATION(entity);

        /* Handle creating of Key */
        PMC * key_array = VTABLE_get_pmc_keyed_str(interp, keys, entity_attrs->name);
        if (PMC_IS_NULL(key_array)) {
            /* Never see this name before. Create new FIA and add to keys. */
            key_array = pmc_new(interp, enum_class_FixedIntegerArray);
            VTABLE_set_integer_native(interp, key_array, 3);
            VTABLE_set_integer_keyed_int(interp, key_array, 0, -1);
            VTABLE_set_integer_keyed_int(interp, key_array, 1, -1);
            VTABLE_set_integer_keyed_int(interp, key_array, 2, -1);

            VTABLE_set_pmc_keyed_str(interp, keys, entity_attrs->name, key_array);
        }

        /* PackfileAnnotation.value_type exactly the same as key.type */
        key_id = VTABLE_get_integer_keyed_int(interp, key_array, entity_attrs->value_type);

        /* If key_id is -1 it means we have to create new key. */
        if (key_id == -1) {
            key_id = ++last_key_id;
            VTABLE_set_integer_keyed_int(interp, key_array, entity_attrs->value_type, key_id);

            /* Store type */
            VTABLE_set_integer_keyed_int(interp, types, key_id, entity_attrs->value_type);


            /* Store constant for name. */
            Parrot_mmd_multi_dispatch_from_c_args(interp, "get_or_create_constant",
                        "PS->I", attrs->const_table, entity_attrs->name, &name_id);

            VTABLE_set_integer_keyed_int(interp, names, key_id, name_id);
        }

        /* At this point we have create (if nesassary) key and name constant. */
        /* Start storing real entity */
        res->entries[i] = mem_allocate_zeroed_typed(PackFile_Annotations_Entry);

        res->entries[i]->bytecode_offset = entity_attrs->offset;
        res->entries[i]->key             = key_id;

        /* Handle value */
        switch (entity_attrs->value_type) {
            case PF_ANNOTATION_KEY_TYPE_INT:
                res->entries[i]->value = entity_attrs->int_value;
                break;
            case PF_ANNOTATION_KEY_TYPE_STR:
                Parrot_mmd_multi_dispatch_from_c_args(interp, "get_or_create_constant",
                        "PS->I", attrs->const_table, entity_attrs->str_value,
                        &res->entries[i]->value);
                break;
            case PF_ANNOTATION_KEY_TYPE_NUM:
                Parrot_mmd_multi_dispatch_from_c_args(interp, "get_or_create_constant",
                        "PN->I", attrs->const_table, entity_attrs->num_value,
                        &res->entries[i]->value);
                break;
            default:
                Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_MALFORMED_PACKFILE,
                        "Unknown value type in PackfileAnnotation");
        }
    }

    /* Time to pack keys */
    num = VTABLE_elements(interp, types);
    res->num_keys = num;
    res->keys = mem_allocate_n_typed(num, PackFile_Annotations_Key*);
    for (i = 0; i < num; ++i) {
        res->keys[i] = mem_allocate_typed(PackFile_Annotations_Key);
        res->keys[i]->name = VTABLE_get_integer_keyed_int(interp, names, i);
        res->keys[i]->type = VTABLE_get_integer_keyed_int(interp, types, i);
    }

    return res;
#line 207 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_init(PARROT_INTERP, PMC *pmc)
{
#line 48 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes * attrs =
            PMC_data_typed(pmc, Parrot_PackfileAnnotations_attributes*);

    attrs->annotations = pmc_new(interp, enum_class_ResizablePMCArray);
    /*
    Don't initialize C<const_table>. It will be set to NULL bu auto_attrs
    handling. And should be set to proper PMC in set_directory.
    */

    PObj_custom_mark_SET(pmc);
#line 224 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_mark(PARROT_INTERP, PMC *pmc)
{
#line 71 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes * attrs =
            PARROT_PACKFILEANNOTATIONS(pmc);

    if (!PMC_IS_NULL(attrs->const_table))
        Parrot_gc_mark_PObj_alive(interp, (PObj *)attrs->const_table);

    if (!PMC_IS_NULL(attrs->annotations))
        Parrot_gc_mark_PObj_alive(interp, (PObj *)attrs->annotations);

    interp->vtables[enum_class_PackfileSegment]->mark(interp, pmc);
#line 241 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL index, PMC *annotation)
{
#line 139 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes * attrs =
            PARROT_PACKFILEANNOTATIONS(pmc);
    Parrot_PackfileAnnotation_attributes  * entity_attrs =
            PARROT_PACKFILEANNOTATION(annotation);
    INTVAL dummy;

    /* TODO: add checks desribed above */
    VTABLE_set_pmc_keyed_int(interp, attrs->annotations, index, annotation);

    /* Add required constants */
    Parrot_mmd_multi_dispatch_from_c_args(interp,
        "get_or_create_constant", "PS->I", attrs->const_table,
        entity_attrs->name, &dummy);

    switch (entity_attrs->value_type) {
        case PF_ANNOTATION_KEY_TYPE_STR:
            Parrot_mmd_multi_dispatch_from_c_args(interp,
                "get_or_create_constant", "PS->I", attrs->const_table,
                entity_attrs->str_value, &dummy);
            break;

        case PF_ANNOTATION_KEY_TYPE_NUM:
            Parrot_mmd_multi_dispatch_from_c_args(interp,
                "get_or_create_constant", "PN->I", attrs->const_table,
                entity_attrs->num_value, &dummy);
            break;

        default:
            /* Do nothing. If value_type if INT it will be stored directly */
            break;
    }
#line 279 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_set_pointer(PARROT_INTERP, PMC *pmc, void *pointer)
{
#line 213 "./src/pmc/packfileannotations.pmc"

    PackFile_Annotations * a = (PackFile_Annotations*)pointer;
    Parrot_PackfileAnnotations_attributes *attrs =
            PARROT_PACKFILEANNOTATIONS(pmc);
    opcode_t  i;
    PMC      *annotation;
    Parrot_PackfileAnnotation_attributes *annotation_attrs;

    /* Copy annotations to own array */
    VTABLE_set_integer_native(interp, attrs->annotations, a->num_entries);
    for (i = 0; i < a->num_entries; ++i) {
        PackFile_Annotations_Entry *entry = a->entries[i];
        PackFile_Annotations_Key   *key   = a->keys[entry->key];
        annotation = pmc_new(interp, enum_class_PackfileAnnotation);

        /* Poke directly to annotation attributes. */
        annotation_attrs         = PARROT_PACKFILEANNOTATION(annotation);
        annotation_attrs->offset = entry->bytecode_offset;
        annotation_attrs->name   = VTABLE_get_string_keyed_int(interp,
                attrs->const_table, key->name);
        switch (key->type) {
            case PF_ANNOTATION_KEY_TYPE_INT:
                VTABLE_set_integer_native(interp, annotation, entry->value);
                break;
            case PF_ANNOTATION_KEY_TYPE_STR:
                VTABLE_set_string_native(interp, annotation,
                    VTABLE_get_string_keyed_int(interp, attrs->const_table, entry->value));
                break;
            case PF_ANNOTATION_KEY_TYPE_NUM:
                VTABLE_set_number_native(interp, annotation,
                    VTABLE_get_number_keyed_int(interp, attrs->const_table, entry->value));
                break;
            default:
                Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_MALFORMED_PACKFILE,
                        "Unknown value type %d in Packfile Annotation", key->type);
        }

        VTABLE_set_pmc_keyed_int(interp, attrs->annotations, i, annotation);
    }
#line 324 "./src/pmc/packfileannotations.c"
}
static  void
Parrot_PackfileAnnotations_nci_set_directory(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    PMC        *_caller_ctx = interp->ctx;
    PMC * const _ret_cont   = new_ret_continuation_pmc(interp, NULL);
    PMC        *_ctx        = Parrot_push_context(interp, _n_regs_used);
    PMC        *_ccont      = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = Parrot_pcc_get_continuation(interp, _caller_ctx);
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    Parrot_pcc_set_continuation(interp, _ctx, _ret_cont);
    PARROT_CONTINUATION(_ret_cont)->from_ctx       = _ctx;

    _current_args                       = interp->current_args;
    interp->current_args                = NULL;

#line 363 "./src/pmc/packfileannotations.pmc"

#line 439 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        Parrot_pcc_dec_recursion_depth(interp, _ctx);
        Parrot_pcc_set_caller_ctx(interp, _ctx, Parrot_pcc_get_caller_ctx(interp, _caller_ctx));
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 379 "./src/pmc/packfileannotations.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* directory = CTX_REG_PMC(_ctx, 1);

#line 447 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 186 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes *attrs =
            PARROT_PACKFILEANNOTATIONS(pmc);
    STRING *name;
    PMC    *segment;

    PMC *iter = VTABLE_get_iter(interp, directory);
    while (VTABLE_get_bool(interp, iter)) {
        name = VTABLE_shift_string(interp, iter);
        segment = VTABLE_get_pmc_keyed_str(interp, directory, name);
        if (VTABLE_isa(interp, segment,
                Parrot_str_new_constant(interp, "PackfileConstantTable"))) {
            attrs->const_table = segment;
            break;
        }
    }
#line 456 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 480 "/builddir/build/BUILD/parrot-1.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 418 "./src/pmc/packfileannotations.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_PackfileAnnotations_update_vtable(VTABLE *vt) {
    vt->elements = Parrot_PackfileAnnotations_elements;
    vt->get_pmc_keyed_int = Parrot_PackfileAnnotations_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileAnnotations_get_pointer;
    vt->init = Parrot_PackfileAnnotations_init;
    vt->mark = Parrot_PackfileAnnotations_mark;
    vt->set_pmc_keyed_int = Parrot_PackfileAnnotations_set_pmc_keyed_int;
    vt->set_pointer = Parrot_PackfileAnnotations_set_pointer;
    vt->attr_size = sizeof(Parrot_PackfileAnnotations_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_PackfileAnnotations_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->elements = Parrot_PackfileAnnotations_elements;
    vt->get_pmc_keyed_int = Parrot_PackfileAnnotations_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileAnnotations_get_pointer;
    vt->init = Parrot_PackfileAnnotations_init;
    vt->mark = Parrot_PackfileAnnotations_mark;
    vt->attr_size = sizeof(Parrot_PackfileAnnotations_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileAnnotations_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_PackfileSegment_get_vtable(interp);
    Parrot_PackfileAnnotations_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileAnnotations_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_PackfileSegment_ro_get_vtable(interp);
    Parrot_PackfileAnnotations_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_PackfileAnnotations_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_PackfileSegment_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "PackfileAnnotations", 19, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_PackfileAnnotations_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_PackfileSegment_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "PackfileAnnotations")), PMCNULL);
    return isa;
}

void
Parrot_PackfileAnnotations_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fdirectory Fconst_table Fannotations ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_PackfileAnnotations_get_vtable(interp);
        vt->base_type      = enum_class_PackfileAnnotations;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "PackfileAnnotations");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_PackfileAnnotations_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_PackfileAnnotations_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_PackfileAnnotations;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_PackfileAnnotations_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_PackfileAnnotations_nci_set_directory), CONST_STRING_GEN(interp, "set_directory"));
        {
        }
    } /* pass */
} /* Parrot_PackfileAnnotations_class_init */
#line 379 "./src/pmc/packfileannotations.pmc"

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
