/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablebooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablebooleanarray.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "resizablebooleanarray.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/resizablebooleanarray.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: resizablebooleanarray.pmc 40946 2009-09-03 05:30:53Z NotFound $

=head1 NAME

src/pmc/resizablebooleanarray.pmc - resizable array for booleans only

=head1 DESCRIPTION

The C<ResizableBooleanArray PMC> implements an array of resizable size, which
stores booleans.  It uses the C<Boolean PMC> for all conversions.  The
C<ResizableBooleanArray PMC> extends the C<FixedBooleanArray PMC>.

=head2 Functions

=over 4

=cut

*/

#define BITS_PER_CHAR 8
/* MIN_ALLOC is 8 * BITS_PER_CHAR */
#define MIN_ALLOC 64

/* Round a given size in bits to the nearest allocation unit, then convert it
 * to bytes. */
#define ROUND_BYTES(size) (((size) / MIN_ALLOC + 1) * MIN_ALLOC / BITS_PER_CHAR)
/* Convert a size in bits to a size in bytes */
#define BITS_TO_BYTES(size) ((size) / BITS_PER_CHAR)
#line 54 "./src/pmc/resizablebooleanarray.c"
static  PMC  * Parrot_ResizableBooleanArray_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ResizableBooleanArray_elements(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ResizableBooleanArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  INTVAL  Parrot_ResizableBooleanArray_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ResizableBooleanArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL  Parrot_ResizableBooleanArray_pop_integer(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ResizableBooleanArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_ResizableBooleanArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void  Parrot_ResizableBooleanArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size);
static  INTVAL  Parrot_ResizableBooleanArray_shift_integer(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ResizableBooleanArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void  Parrot_ResizableBooleanArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
void    Parrot_ResizableBooleanArray_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableBooleanArray_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableBooleanArray_get_vtable(PARROT_INTERP);
void    Parrot_ResizableBooleanArray_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableBooleanArray_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableBooleanArray_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_ResizableBooleanArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 372 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL         tail_pos, head_pos;
    unsigned char * my_bit_array, * dest_bit_array;

    PMC * const     dest = pmc_new(interp, pmc->vtable->base_type);

    GETATTR_ResizableBooleanArray_bit_array(interp, pmc, my_bit_array);
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    SETATTR_ResizableBooleanArray_size(interp, dest, tail_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, dest, head_pos);

    if (my_bit_array) {
        size_t size_in_bits = tail_pos / BITS_PER_CHAR + 1;
        dest_bit_array = (unsigned char *)mem_sys_allocate(size_in_bits);
        mem_sys_memcopy(dest_bit_array, my_bit_array, size_in_bits);
    }
    else
        dest_bit_array = NULL;

    SETATTR_ResizableBooleanArray_bit_array(interp, dest, dest_bit_array);

    PObj_custom_destroy_SET(dest);
    return dest;
#line 102 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_elements(PARROT_INTERP, PMC *pmc)
{
#line 341 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL tail_pos, head_pos;
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    return tail_pos - head_pos;
#line 113 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 414 "./src/pmc/resizablebooleanarray.pmc"

    /* XXX Dino - I'm concerned about freezing the entire
        allocated block of memory, it's dependent on the
        BITS_PER_CHAR value.
        Maybe we need to store that during the freeze as well
        and use it during thaw?
    */

    STRING           *s;
    UINTVAL           tail_pos, rounded_size, head_pos;
    unsigned char    *bit_array;
    IMAGE_IO * const  io = info->image_io;

    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    GETATTR_ResizableBooleanArray_bit_array(interp, pmc, bit_array);
    rounded_size = ROUND_BYTES(tail_pos);

    VTABLE_push_integer(interp, io, head_pos);
    VTABLE_push_integer(interp, io, tail_pos);

    s = Parrot_str_new(interp, (char*)bit_array, rounded_size);

    VTABLE_push_string(interp, io, s);
#line 143 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 358 "./src/pmc/resizablebooleanarray.pmc"

    return VTABLE_elements(interp, pmc);
#line 151 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 55 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL offsetkey, tail_pos, head_pos;

    /* Try to make negative index into a real index */
    if (key < 0) {
        key = VTABLE_elements(interp, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Check if key is greater than allocated size */
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    offsetkey = key + head_pos;

    if (offsetkey >= tail_pos)
        return 0;

    return interp->vtables[enum_class_FixedBooleanArray]->get_integer_keyed_int(interp, pmc, offsetkey);
#line 179 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 204 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL new_size, tail_pos, head_pos;
    INTVAL  value;

    if (VTABLE_elements(interp, pmc) < 1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableBooleanArray: Can't pop from an empty array!");

    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    new_size  = tail_pos - head_pos;
    value = VTABLE_get_integer_keyed_int(interp, pmc, new_size - 1);
    VTABLE_set_integer_native(interp, pmc, new_size - 1);

    return value;
#line 201 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 182 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL tail_pos, head_pos;
    INTVAL  new_size;

    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    new_size = tail_pos - head_pos;
    VTABLE_set_integer_native(interp, pmc, new_size + 1);
    VTABLE_set_integer_keyed_int(interp, pmc, new_size, value);
#line 217 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 89 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL offsetkey, tail_pos, head_pos;

    /* Try to make negative index into a real index */
    if (key < 0) {
        key = VTABLE_elements(interp, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Check if key is greater than allocated size */
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    offsetkey = key + head_pos;

    if (offsetkey >= tail_pos)
        VTABLE_set_integer_native(interp, pmc, key+1);

    interp->vtables[enum_class_FixedBooleanArray]->set_integer_keyed_int(interp, pmc, offsetkey, value);
#line 245 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 123 "./src/pmc/resizablebooleanarray.pmc"


    unsigned char * bit_array;
    size_t          old_tail_pos, new_tail_pos, new_size_in_bytes, old_size_in_bytes;

    /* Size respects any existing head position offset from unshift */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, new_tail_pos);
    GETATTR_ResizableBooleanArray_size(interp, pmc, old_tail_pos);
    new_tail_pos += size;

    /* We are already at the requested size. Yay */
    if (new_tail_pos == old_tail_pos)
        return;

    if (size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableBooleanArray: Can't resize!");

    /* now set the new size, in bits */
    SETATTR_ResizableBooleanArray_size(interp, pmc, new_tail_pos);

    /* convert sizes to bytes */
    new_size_in_bytes = ROUND_BYTES(new_tail_pos);
    old_size_in_bytes = ROUND_BYTES(old_tail_pos);

    /* Nothing allocated yet */
    GETATTR_ResizableBooleanArray_bit_array(interp, pmc, bit_array);
    if (!bit_array) {
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc,
                (unsigned char *)mem_sys_allocate_zeroed(new_size_in_bytes));

    /* The size is different, and doesn't fit within the current
     * allocation */
    }
    else if (new_size_in_bytes != old_size_in_bytes) {
        unsigned char * old_store = bit_array;
        unsigned char * new_store =
            (unsigned char *)mem_sys_allocate_zeroed(new_tail_pos);
        size_t          copy_size =
            new_size_in_bytes < old_size_in_bytes ? new_size_in_bytes : old_size_in_bytes;

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc,
                (unsigned char *)mem_sys_memmove(
                    new_store, old_store, copy_size));
        mem_sys_free(old_store);
    }
#line 298 "./src/pmc/resizablebooleanarray.c"
}
static  INTVAL 
Parrot_ResizableBooleanArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 288 "./src/pmc/resizablebooleanarray.pmc"

    INTVAL value;
    UINTVAL tail_pos, head_pos;

    if (VTABLE_elements(interp, pmc) < 1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableBooleanArray: Can't shift from an empty array!");

    /* Get head value */
    value = VTABLE_get_integer_keyed_int(interp, pmc, 0);

    /* Move the head position */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc,   head_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, ++head_pos);

    /* If the head position offset is greater than our allocation unit
     * size, size this thing down */
    if (head_pos >= MIN_ALLOC) {
        /* Allocate one allocation unit less of space in new array */
        unsigned char *new_bit_array, *old_bit_array;
        size_t         new_mem_size;
        GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
        new_mem_size  = ROUND_BYTES(tail_pos - MIN_ALLOC);
        new_bit_array =
            (unsigned char *)mem_sys_allocate_zeroed(new_mem_size);

        /* Copy contents of old array to new array, move the head position
         * offset back by one allocation unit (in bytes) */
        GETATTR_ResizableBooleanArray_bit_array(interp, pmc, old_bit_array);
        mem_sys_memmove(new_bit_array, old_bit_array + (BITS_TO_BYTES(MIN_ALLOC)),
            new_mem_size);

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc, new_bit_array);
        mem_sys_free(old_bit_array);

        /* Removed one allocation unit from the head position offset */
        SETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos - MIN_ALLOC);
        GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
        SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos- MIN_ALLOC);
    }

    return value;
#line 347 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 449 "./src/pmc/resizablebooleanarray.pmc"

    unsigned char   *bit_array;
    IMAGE_IO * const io       = info->image_io;
    const UINTVAL    head_pos = VTABLE_shift_integer(interp, io);
    const UINTVAL    tail_pos = VTABLE_shift_integer(interp, io);
    STRING * const   s        = VTABLE_shift_string(interp, io);

    bit_array      = (unsigned char*)Parrot_str_to_cstring(interp, s);
    SETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    SETATTR_ResizableBooleanArray_bit_array(interp, pmc, bit_array);
#line 364 "./src/pmc/resizablebooleanarray.c"
}
static  void 
Parrot_ResizableBooleanArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 233 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL head_pos;
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    /* If the current head position offset is 0, size this thing up by one
     * allocation unit */
    if (head_pos<= 0) {

        UINTVAL         tail_pos;
        unsigned char * old_bit_array;
        size_t          old_mem_size, new_mem_size;
        unsigned char * new_bit_array;

        GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
        GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
        GETATTR_ResizableBooleanArray_bit_array(interp, pmc, old_bit_array);

        /* Allocate an extra allocation unit of space in new array */
        new_mem_size  = ROUND_BYTES(tail_pos+ MIN_ALLOC);
        new_bit_array = (unsigned char *)mem_sys_allocate_zeroed(new_mem_size);

        /* Copy contents of old array to new array, moving the head
         * position forward by one allocation unit (in bytes). */
        old_mem_size = ROUND_BYTES(tail_pos);
        mem_sys_memmove(new_bit_array + (BITS_TO_BYTES(MIN_ALLOC)),
                old_bit_array, old_mem_size);

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc, new_bit_array);
        mem_sys_free(old_bit_array);

        /* Added one allocation unit to the head position offset */
        SETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos + MIN_ALLOC);
        SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos + MIN_ALLOC);

    }

    /* Move the head position */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc,   head_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, --head_pos);

    /* Assign the new value as the first item */
    VTABLE_set_integer_keyed_int(interp, pmc, 0, value);
#line 413 "./src/pmc/resizablebooleanarray.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizableBooleanArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizableBooleanArray_clone;
    vt->elements = Parrot_ResizableBooleanArray_elements;
    vt->freeze = Parrot_ResizableBooleanArray_freeze;
    vt->get_integer = Parrot_ResizableBooleanArray_get_integer;
    vt->get_integer_keyed_int = Parrot_ResizableBooleanArray_get_integer_keyed_int;
    vt->pop_integer = Parrot_ResizableBooleanArray_pop_integer;
    vt->push_integer = Parrot_ResizableBooleanArray_push_integer;
    vt->set_integer_keyed_int = Parrot_ResizableBooleanArray_set_integer_keyed_int;
    vt->set_integer_native = Parrot_ResizableBooleanArray_set_integer_native;
    vt->shift_integer = Parrot_ResizableBooleanArray_shift_integer;
    vt->thaw = Parrot_ResizableBooleanArray_thaw;
    vt->unshift_integer = Parrot_ResizableBooleanArray_unshift_integer;
    vt->attr_size = sizeof(Parrot_ResizableBooleanArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizableBooleanArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizableBooleanArray_clone;
    vt->elements = Parrot_ResizableBooleanArray_elements;
    vt->freeze = Parrot_ResizableBooleanArray_freeze;
    vt->get_integer = Parrot_ResizableBooleanArray_get_integer;
    vt->get_integer_keyed_int = Parrot_ResizableBooleanArray_get_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_ResizableBooleanArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableBooleanArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedBooleanArray_get_vtable(interp);
    Parrot_ResizableBooleanArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableBooleanArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedBooleanArray_ro_get_vtable(interp);
    Parrot_ResizableBooleanArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizableBooleanArray_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedBooleanArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "ResizableBooleanArray", 21, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizableBooleanArray_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_FixedBooleanArray_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizableBooleanArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizableBooleanArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":size :resize_threshold :bit_array ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizableBooleanArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizableBooleanArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizableBooleanArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizableBooleanArray_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ResizableBooleanArray_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ResizableBooleanArray;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizableBooleanArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ResizableBooleanArray_class_init */
#line 461 "./src/pmc/resizablebooleanarray.pmc"
  /* pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11

Changed allocator to double size - Matt Fowles 2004-06-15

Added push_integer               - Bernhard Schmalhofer 2004-10-17

Changed allocation code, added   - Dino Morelli 2005-06-10
  push_, pop_, shift_,
  unshift_integer, freeze, thaw

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
