/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizableintegerarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizableintegerarray.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_default.h"
#include "resizableintegerarray.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/resizableintegerarray.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: resizableintegerarray.pmc 40946 2009-09-03 05:30:53Z NotFound $

=head1 NAME

src/pmc/resizableintegerarray.pmc - resizable array for integers only

=head1 DESCRIPTION

This class, ResizableIntegerArray, implements an array of resizable
size, which stores INTVALs.  It uses Integer PMCs for all of the
conversions.

=head2 Functions

=over 4

=cut

*/
#line 44 "./src/pmc/resizableintegerarray.c"
static  PMC  * Parrot_ResizableIntegerArray_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ResizableIntegerArray_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  Parrot_ResizableIntegerArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  INTVAL  Parrot_ResizableIntegerArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL  Parrot_ResizableIntegerArray_pop_integer(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ResizableIntegerArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_ResizableIntegerArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void  Parrot_ResizableIntegerArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size);
static  INTVAL  Parrot_ResizableIntegerArray_shift_integer(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ResizableIntegerArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void  Parrot_ResizableIntegerArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
void    Parrot_ResizableIntegerArray_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableIntegerArray_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableIntegerArray_get_vtable(PARROT_INTERP);
void    Parrot_ResizableIntegerArray_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableIntegerArray_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableIntegerArray_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_ResizableIntegerArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 253 "./src/pmc/resizableintegerarray.pmc"

    INTVAL  size;
    PMC    *copy = interp->vtables[enum_class_FixedIntegerArray]->clone(interp, pmc);

    /* copy trimmed extra space */
    GETATTR_ResizableIntegerArray_size(interp, pmc, size);
    SETATTR_ResizableIntegerArray_resize_threshold(interp, copy, size);

    return copy;
#line 75 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 227 "./src/pmc/resizableintegerarray.pmc"

    INTVAL size = VTABLE_get_integer(interp, pmc);

    if (size < 1 || key >= size) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableIntegerArray: index out of bounds!");
    }
    else {
        INTVAL *int_array;
        GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
        --size;
        mem_sys_memmove(int_array + key, int_array + key + 1, (size - key) * sizeof (INTVAL));
        VTABLE_set_integer_native(interp, pmc, size);
    }
#line 95 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 278 "./src/pmc/resizableintegerarray.pmc"

    IMAGE_IO *io = info->image_io;
    INTVAL   *int_array;
    INTVAL    i, n, rt;

    interp->vtables[enum_class_FixedIntegerArray]->freeze(interp, pmc, info);

    n  = VTABLE_get_integer(interp, pmc);
    GETATTR_ResizableIntegerArray_resize_threshold(interp, pmc, rt);
    VTABLE_push_integer(interp, io, n);
    VTABLE_push_integer(interp, io, rt);

    GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);

    for (i = 0; i < n; ++i)
        VTABLE_push_integer(interp, io, int_array[i]);
#line 117 "./src/pmc/resizableintegerarray.c"
}
static  INTVAL 
Parrot_ResizableIntegerArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 36 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;

    if (key < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableIntegerArray: index out of bounds!");

    if (key >= VTABLE_get_integer(interp, pmc))
        return 0;

    GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
    return int_array[key];
#line 135 "./src/pmc/resizableintegerarray.c"
}
static  INTVAL 
Parrot_ResizableIntegerArray_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 158 "./src/pmc/resizableintegerarray.pmc"

    INTVAL value;
    INTVAL size = VTABLE_get_integer(interp, pmc);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableIntegerArray: Can't pop from an empty array!");

    value = VTABLE_get_integer_keyed_int(interp, pmc, size-1);
    VTABLE_set_integer_native(interp, pmc, size - 1);
    return value;
#line 152 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 143 "./src/pmc/resizableintegerarray.pmc"

    INTVAL nextix = VTABLE_get_integer(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);
#line 161 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 60 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;

    if (key < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableIntegerArray: index out of bounds!");

    if (key >= VTABLE_get_integer(interp, pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
    int_array[key] = value;
#line 179 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 84 "./src/pmc/resizableintegerarray.pmc"


    INTVAL *int_array;
    INTVAL  resize_threshold;

    if (size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableIntegerArray: Can't resize!");

    GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
    GETATTR_ResizableIntegerArray_resize_threshold(interp, pmc, resize_threshold);
    if (!int_array) {
        /* empty - used fixed routine */
        if (size < 8) {
            interp->vtables[enum_class_FixedIntegerArray]->set_integer_native(interp, pmc, 8);
            SETATTR_ResizableIntegerArray_size(interp, pmc, size);
            SETATTR_ResizableIntegerArray_resize_threshold(interp, pmc, 8);
        }
        else {
            interp->vtables[enum_class_FixedIntegerArray]->set_integer_native(interp, pmc, size);
            SETATTR_ResizableIntegerArray_resize_threshold(interp, pmc, size);
        }
    }
    else if (size <= resize_threshold) {
        /* we could shrink here if necessary */
        SETATTR_ResizableIntegerArray_size(interp, pmc, size);
        return;
    }
    else {
        INTVAL  cur = resize_threshold;
        INTVAL *int_array;

        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            INTVAL needed = size - cur;
            cur          += needed + 4096;
            cur          &= ~0xfff;
        }

        GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
        int_array = (INTVAL*) mem_sys_realloc((void*) int_array, cur * sizeof (INTVAL));
        SETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
        SETATTR_ResizableIntegerArray_size(interp, pmc, size);
        SETATTR_ResizableIntegerArray_resize_threshold(interp, pmc, cur);
    }
#line 231 "./src/pmc/resizableintegerarray.c"
}
static  INTVAL 
Parrot_ResizableIntegerArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 180 "./src/pmc/resizableintegerarray.pmc"

    INTVAL value, *int_array;
    INTVAL size = VTABLE_get_integer(interp, pmc);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableIntegerArray: Can't shift from an empty array!");

    GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
    value = int_array[0];

    --size;
    mem_sys_memmove(int_array, int_array + 1, size * sizeof (INTVAL));
    VTABLE_set_integer_native(interp, pmc, size);
    return value;
#line 252 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 296 "./src/pmc/resizableintegerarray.pmc"

    if (info->extra_flags == EXTRA_IS_NULL) {
        IMAGE_IO * const io = info->image_io;
        const INTVAL n = VTABLE_shift_integer(interp, io);
        const INTVAL rt = VTABLE_shift_integer(interp, io);

        SETATTR_ResizableIntegerArray_size(interp, pmc, 0);
        SETATTR_ResizableIntegerArray_resize_threshold(interp, pmc, rt);
        SETATTR_ResizableIntegerArray_int_array(interp, pmc, NULL);

        if (n) {
            INTVAL  i;
            INTVAL *int_array;

            VTABLE_set_integer_native(interp, pmc, n);
            GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);

            for (i = 0; i < n; ++i)
                int_array[i] = VTABLE_shift_integer(interp, io);
        }
    }
    else
        interp->vtables[enum_class_FixedIntegerArray]->thaw(interp, pmc, info);
#line 281 "./src/pmc/resizableintegerarray.c"
}
static  void 
Parrot_ResizableIntegerArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 207 "./src/pmc/resizableintegerarray.pmc"

    INTVAL *int_array;
    INTVAL size = VTABLE_get_integer(interp, pmc);

    VTABLE_set_integer_native(interp, pmc, size + 1);
    GETATTR_ResizableIntegerArray_int_array(interp, pmc, int_array);
    mem_sys_memmove(int_array + 1, int_array, size * sizeof (INTVAL));
    int_array[0] = value;
#line 295 "./src/pmc/resizableintegerarray.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizableIntegerArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizableIntegerArray_clone;
    vt->delete_keyed_int = Parrot_ResizableIntegerArray_delete_keyed_int;
    vt->freeze = Parrot_ResizableIntegerArray_freeze;
    vt->get_integer_keyed_int = Parrot_ResizableIntegerArray_get_integer_keyed_int;
    vt->pop_integer = Parrot_ResizableIntegerArray_pop_integer;
    vt->push_integer = Parrot_ResizableIntegerArray_push_integer;
    vt->set_integer_keyed_int = Parrot_ResizableIntegerArray_set_integer_keyed_int;
    vt->set_integer_native = Parrot_ResizableIntegerArray_set_integer_native;
    vt->shift_integer = Parrot_ResizableIntegerArray_shift_integer;
    vt->thaw = Parrot_ResizableIntegerArray_thaw;
    vt->unshift_integer = Parrot_ResizableIntegerArray_unshift_integer;
    vt->attr_size = sizeof(Parrot_ResizableIntegerArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizableIntegerArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizableIntegerArray_clone;
    vt->freeze = Parrot_ResizableIntegerArray_freeze;
    vt->get_integer_keyed_int = Parrot_ResizableIntegerArray_get_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_ResizableIntegerArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableIntegerArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedIntegerArray_get_vtable(interp);
    Parrot_ResizableIntegerArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableIntegerArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedIntegerArray_ro_get_vtable(interp);
    Parrot_ResizableIntegerArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizableIntegerArray_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedIntegerArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "ResizableIntegerArray", 21, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizableIntegerArray_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_FixedIntegerArray_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizableIntegerArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizableIntegerArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :int_array Iresize_threshold ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizableIntegerArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizableIntegerArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizableIntegerArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizableIntegerArray_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ResizableIntegerArray_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ResizableIntegerArray;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizableIntegerArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ResizableIntegerArray_class_init */
#line 321 "./src/pmc/resizableintegerarray.pmc"

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
Added push_integer               - Bernhard Schmalhofer 2004-10-17
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
