/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/scalar.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "scalar.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/scalar.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: scalar.pmc 41257 2009-09-14 07:38:34Z mikehh $

=head1 NAME

src/pmc/scalar.pmc - Scalar Abstract Superclass

=head1 DESCRIPTION

These are the vtable functions for the scalar base PMC class

=head2 Methods

=over 4

=cut

*/

#include "pmc_bigint.h"

static PMC *
bitwise_left_shift_internal(PARROT_INTERP, PMC *self,
                            PMC *dest, INTVAL shift_amount)
{
    /* This handles both left and right shifts; the sign of shift_amount
       controls the direction, shifting left if positive and right if negative.
       If we get an error (which can only happen for left shifts) and
       PARROT_ERRORS_OVERFLOW_FLAG is set, then we throw an error, else the
       destination is promoted to a BigInt before shifting.  If dest == self,
       then the shift is done in place.  */
    const INTVAL base = VTABLE_get_integer(interp, self);
    INTVAL result     = 0;
    int overflow_p    = 0;

    /* Compute the shift. */
    if (shift_amount >= 8*INTVAL_SIZE) {
        /* Extreme left shift; no need to do an integer shift first. */
        overflow_p = 1;
    }
    else if (shift_amount >= 0) {
        /* Left shift. */
        result = base << shift_amount;
        overflow_p = (result >> shift_amount) != base;
    }
    else if (shift_amount > -8*INTVAL_SIZE) {
        /* Right shift.  By definition, this can never overflow. */
        result = base >> -shift_amount;
    }
    else {
        /* Extreme right shift. */
        result = 0;
    }

    /* Store the result. */
    if (! overflow_p) {
        /* If SELF is the destination, we won't want to create a
           new PMC, because then we won't have the result in SELF.
           Only create a new PMC if we aren't saving the result
           to SELF, or if they are both NULL */
        if (dest != self || dest == NULL)
            dest = pmc_new(interp, VTABLE_type(interp, self));

        VTABLE_set_integer_native(interp, dest, result);
    }
    else if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ERR_OVERFLOW,
            "Integer overflow");
    }
    else {
        /* Overflow; must promote dest to BigInt, and do a BigInt shift. */
        if (self == dest)
            pmc_reuse(interp, self, enum_class_BigInt, 0);
        else
            dest = pmc_new(interp, enum_class_BigInt);

        VTABLE_set_integer_native(interp, dest, base);
        VTABLE_i_bitwise_shl_int(interp, dest, shift_amount);
    }

    return dest;
}
#line 105 "./src/pmc/scalar.c"
static  PMC * Parrot_scalar_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_scalar_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_scalar_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_scalar_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_scalar_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  INTVAL Parrot_scalar_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_scalar_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_scalar_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  INTVAL  Parrot_scalar_defined(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_scalar_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_scalar_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_scalar_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_scalar_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_scalar_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_scalar_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_bitwise_not(PARROT_INTERP, PMC *pmc);
static  void  Parrot_scalar_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_scalar_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_scalar_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_scalar_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_logical_not(PARROT_INTERP, PMC *pmc);
static  void  Parrot_scalar_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_scalar_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_scalar_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_scalar_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_neg(PARROT_INTERP, PMC *pmc);
static  void  Parrot_scalar_i_pow(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_scalar_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_scalar_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_scalar_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_scalar_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  INTVAL Parrot_scalar_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_scalar_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_scalar_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_scalar_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_scalar_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_scalar_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_scalar_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_scalar_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_neg(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_scalar_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_scalar_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_share_ro(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_scalar_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length);
static  PMC * Parrot_scalar_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_scalar_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_scalar_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_scalar_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_scalar_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_scalar_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_scalar_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_scalar_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_scalar_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_scalar_multi_divide_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multi_floor_divide_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multi_modulus_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multi_pow_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_scalar_multi_bitwise_xor_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  INTVAL  Parrot_scalar_multi_cmp_num_PMC(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_scalar_multi_cmp_string_PMC(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_scalar_multi_is_equal_num_PMC(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_scalar_multi_is_equal_string_PMC(PARROT_INTERP, PMC *pmc, PMC *value);
void    Parrot_scalar_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_scalar_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_scalar_get_vtable(PARROT_INTERP);
void    Parrot_scalar_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_scalar_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_scalar_ro_get_vtable(PARROT_INTERP);
static  PMC *
Parrot_scalar_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_scalar_multi_add_Complex_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_add_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 202 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + value);
    return dest;
#line 258 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 194 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + (FLOATVAL)value);
    return dest;
#line 270 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 98 "./src/pmc/scalar.pmc"

    INTVAL  self_type = VTABLE_type(interp, pmc);
    INTVAL  val_type  = VTABLE_type(interp, value);

    if (self_type == enum_class_Boolean)
        /* doesn't morph */
        pmc_reuse(interp, pmc, val_type, 0);

    if (val_type == enum_class_Undef) {
        pmc_reuse(interp, pmc, val_type, 0);
        return;
    }

    if (VTABLE_isa(interp, value, CONST_STRING(interp, "Undef"))) {
        pmc_reuse(interp, pmc, enum_class_Undef, 0);
        return;
    }

    if (VTABLE_isa(interp, value, CONST_STRING(interp, "Integer"))) {
        const INTVAL v = VTABLE_get_integer(interp, value);
        VTABLE_set_integer_native(interp, pmc, v);
        return;
    }

    if (VTABLE_isa(interp, value, CONST_STRING(interp, "Float"))) {
        const FLOATVAL v = VTABLE_get_number(interp, value);
        VTABLE_set_number_native(interp, pmc, v);
        return;
    }

    if (VTABLE_isa(interp, value, CONST_STRING(interp, "String"))) {
        STRING * const v = VTABLE_get_string(interp, value);
        VTABLE_set_string_native(interp, pmc, v);
        return;
    }
    pmc_reuse(interp, pmc, val_type, 0);
    VTABLE_set_pmc(interp, pmc, value);
#line 313 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 807 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 327 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 817 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) & value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 340 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 970 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >>
        VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 354 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 980 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >> value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 367 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 898 "./src/pmc/scalar.pmc"

    const INTVAL a = ~VTABLE_get_integer(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;
#line 380 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 757 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 393 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 767 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 406 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1020 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest,
                                       VTABLE_get_integer(interp, value));
#line 415 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1025 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest, value);
#line 423 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 934 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest,
                                       -VTABLE_get_integer(interp, value));
#line 432 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 939 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest, -value);
#line 440 "./src/pmc/scalar.c"
}
static  PMC *
Parrot_scalar_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_bitwise_xor_PMC_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "bitwise_xor", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 866 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) ^ value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 473 "./src/pmc/scalar.c"
}
static  INTVAL
Parrot_scalar_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_cmp_num_PMC(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp_num", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  INTVAL
Parrot_scalar_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_cmp_string_PMC(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp_string", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1062 "./src/pmc/scalar.pmc"

    STRING * const s = Parrot_str_concat(interp, VTABLE_get_string(interp, pmc),
        VTABLE_get_string(interp, value), 0);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest, s);
    return dest;
#line 527 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 1072 "./src/pmc/scalar.pmc"

    STRING * const s = Parrot_str_concat(interp,
        VTABLE_get_string(interp, pmc), value, 0);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest, s);
    return dest;
#line 541 "./src/pmc/scalar.c"
}
static  INTVAL 
Parrot_scalar_defined(PARROT_INTERP, PMC *pmc)
{
#line 1339 "./src/pmc/scalar.pmc"

    return 1;
#line 549 "./src/pmc/scalar.c"
}
static  PMC *
Parrot_scalar_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_divide_PMC_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 426 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / value);
    return dest;
#line 584 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 415 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / value);
    return dest;
#line 599 "./src/pmc/scalar.c"
}
static  PMC *
Parrot_scalar_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_floor_divide_PMC_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 511 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floor(VTABLE_get_number(interp, pmc) / value));
    return dest;
#line 635 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 499 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floor(VTABLE_get_number(interp, pmc) / value));
    return dest;
#line 651 "./src/pmc/scalar.c"
}
static  void
Parrot_scalar_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_scalar_multi_i_add_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_scalar_multi_i_add_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_scalar_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 230 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) + value);
#line 684 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 225 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) + (FLOATVAL)value);
#line 693 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 826 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 703 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 833 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) & value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 712 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 989 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >>
            VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 722 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 995 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >> value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 731 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
#line 907 "./src/pmc/scalar.pmc"

    VTABLE_set_integer_native(interp, pmc, ~VTABLE_get_integer(interp, pmc));
#line 739 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 776 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);

    VTABLE_set_integer_native(interp, pmc, result);
#line 750 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 784 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 759 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1029 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc,
                                VTABLE_get_integer(interp, value));
#line 768 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1034 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc, value);
#line 776 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 943 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc,
                                -VTABLE_get_integer(interp, value));
#line 785 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 948 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc, -value);
#line 793 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 875 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 803 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 881 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) ^ value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 812 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1082 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    STRING * const v = VTABLE_get_string(interp, value);
    VTABLE_set_string_native(interp, pmc, Parrot_str_append(interp, s, v));
#line 822 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 1088 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    VTABLE_set_string_native(interp, pmc, Parrot_str_append(interp, s, value));
#line 831 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 437 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / d);
#line 845 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 455 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / value);
#line 857 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 447 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / value);
#line 869 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 523 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / d));
#line 884 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 543 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / value));
#line 897 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 534 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / value));
#line 910 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_logical_not(PARROT_INTERP, PMC *pmc)
{
#line 1325 "./src/pmc/scalar.pmc"

    VTABLE_set_bool(interp, pmc, ! VTABLE_get_bool(interp, pmc));
#line 918 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 613 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc), d));
#line 933 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 633 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc), value));
#line 946 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 624 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc), (FLOATVAL)value));
#line 959 "./src/pmc/scalar.c"
}
static  void
Parrot_scalar_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_scalar_multi_i_multiply_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_scalar_multi_i_multiply_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_scalar_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 376 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) * value);
#line 991 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 371 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) * (FLOATVAL)value);
#line 1000 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 729 "./src/pmc/scalar.pmc"

    VTABLE_set_integer_native(interp, pmc, -VTABLE_get_integer(interp, pmc));
#line 1008 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 691 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), d));
#line 1019 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 703 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), value));
#line 1028 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 698 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), (float)value));
#line 1037 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1134 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = (UINTVAL)VTABLE_get_integer(interp, value);
    VTABLE_set_string_native(interp, pmc, Parrot_str_repeat(interp, s, n));
#line 1047 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1140 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = value;
    VTABLE_set_string_native(interp, pmc, Parrot_str_repeat(interp, s, n));
#line 1057 "./src/pmc/scalar.c"
}
static  void
Parrot_scalar_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_scalar_multi_i_subtract_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_scalar_multi_i_subtract_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_scalar_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 312 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) - value);
#line 1090 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 307 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) - (FLOATVAL)value);
#line 1099 "./src/pmc/scalar.c"
}
static  INTVAL
Parrot_scalar_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_is_equal_num_PMC(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal_num", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  INTVAL
Parrot_scalar_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_is_equal_string_PMC(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal_string", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1272 "./src/pmc/scalar.pmc"

    if (VTABLE_get_bool(interp, pmc))
        return value;

    return pmc;
#line 1150 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1316 "./src/pmc/scalar.pmc"

    const INTVAL a = ! VTABLE_get_bool(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_bool(interp, dest, a);
    return dest;
#line 1163 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1254 "./src/pmc/scalar.pmc"

    if (VTABLE_get_bool(interp, pmc))
        return pmc;

    return value;
#line 1174 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1289 "./src/pmc/scalar.pmc"

    const INTVAL my_bool    = VTABLE_get_bool(interp, pmc);
    const INTVAL value_bool = VTABLE_get_bool(interp, value);

    if (my_bool && ! value_bool)
        return pmc;
    else if (value_bool && ! my_bool)
        return value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    VTABLE_set_bool(interp, dest, 0);
    return dest;
#line 1192 "./src/pmc/scalar.c"
}
static  PMC *
Parrot_scalar_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_modulus_PMC_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "modulus", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 601 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floatval_mod(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 1228 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 589 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floatval_mod(VTABLE_get_number(interp, pmc), (FLOATVAL)value));
    return dest;
#line 1244 "./src/pmc/scalar.c"
}
static  PMC *
Parrot_scalar_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_scalar_multi_multiply_Complex_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_multiply_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 352 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
        VTABLE_get_number(interp, pmc) * value);
    return dest;
#line 1280 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 344 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
        VTABLE_get_number(interp, pmc) * value);
    return dest;
#line 1292 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 720 "./src/pmc/scalar.pmc"

    const INTVAL a = -VTABLE_get_integer(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;
#line 1305 "./src/pmc/scalar.c"
}
static  PMC *
Parrot_scalar_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_pow_PMC_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "pow", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 683 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            pow(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 1337 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 674 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            pow(VTABLE_get_number(interp, pmc), (double)value));

    return dest;
#line 1350 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1111 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = (UINTVAL)VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest,
        Parrot_str_repeat(interp, s, n));
    return dest;
#line 1365 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1122 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest,
        Parrot_str_repeat(interp, s, n));
    return dest;
#line 1380 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 1368 "./src/pmc/scalar.pmc"

    PMC         *ret  = pt_shared_fixup(interp, pmc);
    PMC * const _true = pmc_new(interp, enum_class_Integer);

    VTABLE_set_integer_native(interp, _true, 1);

    /* first set readonly */
    VTABLE_setprop(interp, ret, CONST_STRING(interp, "_ro"), _true);

    /* We're sharing this, so make sure it has a PMC_sync */
    Parrot_gc_add_pmc_sync(interp, ret);
    PObj_is_PMC_shared_SET(ret);

    /* XXX FIXME workaround lack of metadata sharing*/
    PMC_metadata(pmc) = NULL;

    return ret;
#line 1403 "./src/pmc/scalar.c"
}
static  STRING  *
Parrot_scalar_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
#line 1354 "./src/pmc/scalar.pmc"

    return Parrot_str_substr(interp, VTABLE_get_string(interp, pmc),
        offset, length, NULL, 0);
#line 1412 "./src/pmc/scalar.c"
}
static  PMC *
Parrot_scalar_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_scalar_multi_subtract_Complex_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_scalar_multi_subtract_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_scalar_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 284 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) - value);
    return dest;
#line 1448 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 276 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) - (FLOATVAL)value);
    return dest;
#line 1460 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 174 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));
    return dest;
#line 1476 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 186 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_number(interp, pmc) + VTABLE_get_number(interp, value));
    return dest;
#line 1488 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 210 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, pmc, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));
#line 1502 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 220 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        pmc->vtable->get_number(interp, pmc) + VTABLE_get_number(interp, value));
#line 1511 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 258 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);
    dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
    return dest;
#line 1526 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 269 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value));
    return dest;
#line 1537 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 292 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, pmc, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
#line 1551 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 302 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value));
#line 1560 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 331 "./src/pmc/scalar.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED, "TODO mul<Float, Complex>");
#line 1569 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 336 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
        pmc->vtable->get_number(interp, pmc) * VTABLE_get_number(interp, value));
    return dest;
#line 1581 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 360 "./src/pmc/scalar.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "TODO i_mul<Float, Complex>");
#line 1591 "./src/pmc/scalar.c"
}
static  void 
Parrot_scalar_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 366 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        pmc->vtable->get_number(interp, pmc) * VTABLE_get_number(interp, value));
#line 1600 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_divide_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 402 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) / d);
    return dest;
#line 1617 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_floor_divide_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 485 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    d    = floor(pmc->vtable->get_number(interp, pmc) / d);

    VTABLE_set_integer_native(interp, dest, (INTVAL)d);
    return dest;
#line 1635 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_modulus_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 575 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floatval_mod(pmc->vtable->get_number(interp, pmc), d));
    return dest;
#line 1653 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_pow_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 665 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, pow(pmc->vtable->get_number(interp, pmc), d));
    return dest;
#line 1666 "./src/pmc/scalar.c"
}
static  PMC  *
Parrot_scalar_multi_bitwise_xor_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 856 "./src/pmc/scalar.pmc"

    const INTVAL result =
        pmc->vtable->get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 1680 "./src/pmc/scalar.c"
}
static  INTVAL 
Parrot_scalar_multi_cmp_num_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1165 "./src/pmc/scalar.pmc"

    /* XXX - Floating-point precision errors possible? */
    FLOATVAL diff = VTABLE_get_number(interp, value) -
                    pmc->vtable->get_number(interp, pmc);

    return FLOAT_IS_ZERO(diff) ? 0 : diff < 0.0 ? -1 : 1;
#line 1692 "./src/pmc/scalar.c"
}
static  INTVAL 
Parrot_scalar_multi_cmp_string_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1184 "./src/pmc/scalar.pmc"

    return Parrot_str_compare(interp, pmc->vtable->get_string(interp, pmc),
        VTABLE_get_string(interp, value));
#line 1701 "./src/pmc/scalar.c"
}
static  INTVAL 
Parrot_scalar_multi_is_equal_num_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1216 "./src/pmc/scalar.pmc"

    return (VTABLE_get_number(interp, pmc) ==
            VTABLE_get_number(interp, value));
#line 1710 "./src/pmc/scalar.c"
}
static  INTVAL 
Parrot_scalar_multi_is_equal_string_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1231 "./src/pmc/scalar.pmc"

    return (0 != Parrot_str_equal(interp, VTABLE_get_string(interp, pmc),
                                      VTABLE_get_string(interp, value)));
#line 1719 "./src/pmc/scalar.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_scalar_update_vtable(VTABLE *vt) {
    vt->add = Parrot_scalar_add;
    vt->add_float = Parrot_scalar_add_float;
    vt->add_int = Parrot_scalar_add_int;
    vt->assign_pmc = Parrot_scalar_assign_pmc;
    vt->bitwise_and = Parrot_scalar_bitwise_and;
    vt->bitwise_and_int = Parrot_scalar_bitwise_and_int;
    vt->bitwise_lsr = Parrot_scalar_bitwise_lsr;
    vt->bitwise_lsr_int = Parrot_scalar_bitwise_lsr_int;
    vt->bitwise_not = Parrot_scalar_bitwise_not;
    vt->bitwise_or = Parrot_scalar_bitwise_or;
    vt->bitwise_or_int = Parrot_scalar_bitwise_or_int;
    vt->bitwise_shl = Parrot_scalar_bitwise_shl;
    vt->bitwise_shl_int = Parrot_scalar_bitwise_shl_int;
    vt->bitwise_shr = Parrot_scalar_bitwise_shr;
    vt->bitwise_shr_int = Parrot_scalar_bitwise_shr_int;
    vt->bitwise_xor = Parrot_scalar_bitwise_xor;
    vt->bitwise_xor_int = Parrot_scalar_bitwise_xor_int;
    vt->cmp_num = Parrot_scalar_cmp_num;
    vt->cmp_string = Parrot_scalar_cmp_string;
    vt->concatenate = Parrot_scalar_concatenate;
    vt->concatenate_str = Parrot_scalar_concatenate_str;
    vt->defined = Parrot_scalar_defined;
    vt->divide = Parrot_scalar_divide;
    vt->divide_float = Parrot_scalar_divide_float;
    vt->divide_int = Parrot_scalar_divide_int;
    vt->floor_divide = Parrot_scalar_floor_divide;
    vt->floor_divide_float = Parrot_scalar_floor_divide_float;
    vt->floor_divide_int = Parrot_scalar_floor_divide_int;
    vt->i_add = Parrot_scalar_i_add;
    vt->i_add_float = Parrot_scalar_i_add_float;
    vt->i_add_int = Parrot_scalar_i_add_int;
    vt->i_bitwise_and = Parrot_scalar_i_bitwise_and;
    vt->i_bitwise_and_int = Parrot_scalar_i_bitwise_and_int;
    vt->i_bitwise_lsr = Parrot_scalar_i_bitwise_lsr;
    vt->i_bitwise_lsr_int = Parrot_scalar_i_bitwise_lsr_int;
    vt->i_bitwise_not = Parrot_scalar_i_bitwise_not;
    vt->i_bitwise_or = Parrot_scalar_i_bitwise_or;
    vt->i_bitwise_or_int = Parrot_scalar_i_bitwise_or_int;
    vt->i_bitwise_shl = Parrot_scalar_i_bitwise_shl;
    vt->i_bitwise_shl_int = Parrot_scalar_i_bitwise_shl_int;
    vt->i_bitwise_shr = Parrot_scalar_i_bitwise_shr;
    vt->i_bitwise_shr_int = Parrot_scalar_i_bitwise_shr_int;
    vt->i_bitwise_xor = Parrot_scalar_i_bitwise_xor;
    vt->i_bitwise_xor_int = Parrot_scalar_i_bitwise_xor_int;
    vt->i_concatenate = Parrot_scalar_i_concatenate;
    vt->i_concatenate_str = Parrot_scalar_i_concatenate_str;
    vt->i_divide = Parrot_scalar_i_divide;
    vt->i_divide_float = Parrot_scalar_i_divide_float;
    vt->i_divide_int = Parrot_scalar_i_divide_int;
    vt->i_floor_divide = Parrot_scalar_i_floor_divide;
    vt->i_floor_divide_float = Parrot_scalar_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_scalar_i_floor_divide_int;
    vt->i_logical_not = Parrot_scalar_i_logical_not;
    vt->i_modulus = Parrot_scalar_i_modulus;
    vt->i_modulus_float = Parrot_scalar_i_modulus_float;
    vt->i_modulus_int = Parrot_scalar_i_modulus_int;
    vt->i_multiply = Parrot_scalar_i_multiply;
    vt->i_multiply_float = Parrot_scalar_i_multiply_float;
    vt->i_multiply_int = Parrot_scalar_i_multiply_int;
    vt->i_neg = Parrot_scalar_i_neg;
    vt->i_pow = Parrot_scalar_i_pow;
    vt->i_pow_float = Parrot_scalar_i_pow_float;
    vt->i_pow_int = Parrot_scalar_i_pow_int;
    vt->i_repeat = Parrot_scalar_i_repeat;
    vt->i_repeat_int = Parrot_scalar_i_repeat_int;
    vt->i_subtract = Parrot_scalar_i_subtract;
    vt->i_subtract_float = Parrot_scalar_i_subtract_float;
    vt->i_subtract_int = Parrot_scalar_i_subtract_int;
    vt->is_equal_num = Parrot_scalar_is_equal_num;
    vt->is_equal_string = Parrot_scalar_is_equal_string;
    vt->logical_and = Parrot_scalar_logical_and;
    vt->logical_not = Parrot_scalar_logical_not;
    vt->logical_or = Parrot_scalar_logical_or;
    vt->logical_xor = Parrot_scalar_logical_xor;
    vt->modulus = Parrot_scalar_modulus;
    vt->modulus_float = Parrot_scalar_modulus_float;
    vt->modulus_int = Parrot_scalar_modulus_int;
    vt->multiply = Parrot_scalar_multiply;
    vt->multiply_float = Parrot_scalar_multiply_float;
    vt->multiply_int = Parrot_scalar_multiply_int;
    vt->neg = Parrot_scalar_neg;
    vt->pow = Parrot_scalar_pow;
    vt->pow_float = Parrot_scalar_pow_float;
    vt->pow_int = Parrot_scalar_pow_int;
    vt->repeat = Parrot_scalar_repeat;
    vt->repeat_int = Parrot_scalar_repeat_int;
    vt->share_ro = Parrot_scalar_share_ro;
    vt->substr_str = Parrot_scalar_substr_str;
    vt->subtract = Parrot_scalar_subtract;
    vt->subtract_float = Parrot_scalar_subtract_float;
    vt->subtract_int = Parrot_scalar_subtract_int;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_scalar_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->add = Parrot_scalar_add;
    vt->add_float = Parrot_scalar_add_float;
    vt->add_int = Parrot_scalar_add_int;
    vt->bitwise_and = Parrot_scalar_bitwise_and;
    vt->bitwise_and_int = Parrot_scalar_bitwise_and_int;
    vt->bitwise_lsr = Parrot_scalar_bitwise_lsr;
    vt->bitwise_lsr_int = Parrot_scalar_bitwise_lsr_int;
    vt->bitwise_not = Parrot_scalar_bitwise_not;
    vt->bitwise_or = Parrot_scalar_bitwise_or;
    vt->bitwise_or_int = Parrot_scalar_bitwise_or_int;
    vt->bitwise_shl = Parrot_scalar_bitwise_shl;
    vt->bitwise_shl_int = Parrot_scalar_bitwise_shl_int;
    vt->bitwise_shr = Parrot_scalar_bitwise_shr;
    vt->bitwise_shr_int = Parrot_scalar_bitwise_shr_int;
    vt->bitwise_xor = Parrot_scalar_bitwise_xor;
    vt->bitwise_xor_int = Parrot_scalar_bitwise_xor_int;
    vt->cmp_num = Parrot_scalar_cmp_num;
    vt->cmp_string = Parrot_scalar_cmp_string;
    vt->concatenate = Parrot_scalar_concatenate;
    vt->concatenate_str = Parrot_scalar_concatenate_str;
    vt->defined = Parrot_scalar_defined;
    vt->divide = Parrot_scalar_divide;
    vt->divide_float = Parrot_scalar_divide_float;
    vt->divide_int = Parrot_scalar_divide_int;
    vt->floor_divide = Parrot_scalar_floor_divide;
    vt->floor_divide_float = Parrot_scalar_floor_divide_float;
    vt->floor_divide_int = Parrot_scalar_floor_divide_int;
    vt->is_equal_num = Parrot_scalar_is_equal_num;
    vt->is_equal_string = Parrot_scalar_is_equal_string;
    vt->logical_and = Parrot_scalar_logical_and;
    vt->logical_not = Parrot_scalar_logical_not;
    vt->logical_or = Parrot_scalar_logical_or;
    vt->logical_xor = Parrot_scalar_logical_xor;
    vt->modulus = Parrot_scalar_modulus;
    vt->modulus_float = Parrot_scalar_modulus_float;
    vt->modulus_int = Parrot_scalar_modulus_int;
    vt->multiply = Parrot_scalar_multiply;
    vt->multiply_float = Parrot_scalar_multiply_float;
    vt->multiply_int = Parrot_scalar_multiply_int;
    vt->neg = Parrot_scalar_neg;
    vt->pow = Parrot_scalar_pow;
    vt->pow_float = Parrot_scalar_pow_float;
    vt->pow_int = Parrot_scalar_pow_int;
    vt->repeat = Parrot_scalar_repeat;
    vt->repeat_int = Parrot_scalar_repeat_int;
    vt->share_ro = Parrot_scalar_share_ro;
    vt->substr_str = Parrot_scalar_substr_str;
    vt->subtract = Parrot_scalar_subtract;
    vt->subtract_float = Parrot_scalar_subtract_float;
    vt->subtract_int = Parrot_scalar_subtract_int;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_scalar_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_scalar_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_scalar_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_scalar_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_scalar_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "scalar", 6, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_scalar_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "scalar")), PMCNULL);
    return isa;
}

void
Parrot_scalar_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_scalar_get_vtable(interp);
        vt->base_type      = enum_class_scalar;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "scalar");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_scalar_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_scalar;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_scalar_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
        STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
        STRING * const mfl_2 = CONST_STRING_GEN(interp, "scalar,Complex,PMC");
        STRING * const mfl_3 = CONST_STRING_GEN(interp, "scalar");
        STRING * const mfl_4 = CONST_STRING_GEN(interp, "scalar,DEFAULT,PMC");
        STRING * const mfl_5 = CONST_STRING_GEN(interp, "i_add");
        STRING * const mfl_6 = CONST_STRING_GEN(interp, "vJPP");
        STRING * const mfl_7 = CONST_STRING_GEN(interp, "scalar,Complex");
        STRING * const mfl_8 = CONST_STRING_GEN(interp, "scalar,DEFAULT");
        STRING * const mfl_9 = CONST_STRING_GEN(interp, "subtract");
        STRING * const mfl_10 = CONST_STRING_GEN(interp, "i_subtract");
        STRING * const mfl_11 = CONST_STRING_GEN(interp, "multiply");
        STRING * const mfl_12 = CONST_STRING_GEN(interp, "i_multiply");
        STRING * const mfl_13 = CONST_STRING_GEN(interp, "divide");
        STRING * const mfl_14 = CONST_STRING_GEN(interp, "scalar,PMC,PMC");
        STRING * const mfl_15 = CONST_STRING_GEN(interp, "floor_divide");
        STRING * const mfl_16 = CONST_STRING_GEN(interp, "modulus");
        STRING * const mfl_17 = CONST_STRING_GEN(interp, "pow");
        STRING * const mfl_18 = CONST_STRING_GEN(interp, "bitwise_xor");
        STRING * const mfl_19 = CONST_STRING_GEN(interp, "cmp_num");
        STRING * const mfl_20 = CONST_STRING_GEN(interp, "IJPP");
        STRING * const mfl_21 = CONST_STRING_GEN(interp, "scalar,PMC");
        STRING * const mfl_22 = CONST_STRING_GEN(interp, "cmp_string");
        STRING * const mfl_23 = CONST_STRING_GEN(interp, "is_equal_num");
        STRING * const mfl_24 = CONST_STRING_GEN(interp, "is_equal_string");

             const  multi_func_list _temp_multi_func_list[] = {
                        { mfl_0,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_add_Complex_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_add_DEFAULT_PMC }
,
        { mfl_5,
          mfl_6,
          mfl_7,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_i_add_Complex }
,
        { mfl_5,
          mfl_6,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_i_add_DEFAULT }
,
        { mfl_9,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_subtract_Complex_PMC }
,
        { mfl_9,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_subtract_DEFAULT_PMC }
,
        { mfl_10,
          mfl_6,
          mfl_7,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_i_subtract_Complex }
,
        { mfl_10,
          mfl_6,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_i_subtract_DEFAULT }
,
        { mfl_11,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_multiply_Complex_PMC }
,
        { mfl_11,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_multiply_DEFAULT_PMC }
,
        { mfl_12,
          mfl_6,
          mfl_7,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_i_multiply_Complex }
,
        { mfl_12,
          mfl_6,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_i_multiply_DEFAULT }
,
        { mfl_13,
          mfl_1,
          mfl_14,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_divide_PMC_PMC }
,
        { mfl_15,
          mfl_1,
          mfl_14,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_floor_divide_PMC_PMC }
,
        { mfl_16,
          mfl_1,
          mfl_14,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_modulus_PMC_PMC }
,
        { mfl_17,
          mfl_1,
          mfl_14,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_pow_PMC_PMC }
,
        { mfl_18,
          mfl_1,
          mfl_14,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_bitwise_xor_PMC_PMC }
,
        { mfl_19,
          mfl_20,
          mfl_21,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_cmp_num_PMC }
,
        { mfl_22,
          mfl_20,
          mfl_21,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_cmp_string_PMC }
,
        { mfl_23,
          mfl_20,
          mfl_21,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_is_equal_num_PMC }
,
        { mfl_24,
          mfl_20,
          mfl_21,
          mfl_3,
          (funcptr_t) Parrot_scalar_multi_is_equal_string_PMC }

            };
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_scalar_class_init */
#line 1386 "./src/pmc/scalar.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
