/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/timer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_timer.h"
#include "pmc_task.h"
#include "pmc_default.h"
#include "timer.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/timer.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: timer.pmc 41108 2009-09-07 12:34:51Z whiteknight $

=head1 NAME

src/pmc/timer.pmc - Timer

=head1 SYNOPSIS

    new P0, 'Timer'
    set P0[.PARROT_TIMER_SEC],     I_seconds       # whole seconds
    set P0[.PARROT_TIMER_USEC],    I_micro seconds # and/or micro seconds
    set P0[.PARROT_TIMER_NSEC],    N_seconds_frac  # or fraction in seconds
    set P0[.PARROT_TIMER_REPEAT],  I_repeat        # 0 = one shot ...
    set P0[.PARROT_TIMER_HANDLER], P_sub           # set handler sub PMC
    invoke P0                                      # start timer
    set P0[.PARROT_TIMER_RUNNING], 1               # same

    new P0, 'Timer', P1                            # set everything

    set I0, P0[.PARROT_TIMER_SEC]                  # query current timer status
    set N0, P0[.PARROT_TIMER_NSEC]
    ...
    set P0[.PARROT_TIMER_RUNNING], 0               # turn timer off


=head1 DESCRIPTION

This is the Timer base class

Running timers are kept in a linked list. Each timer has a tick count,
which gets decremented if the system timer expires. If the tick count
reaches zero, the timer handler gets invoked via Parrot's event handling
code.

The Timer resolution is operating system dependent. It's only guaranteed
that the Timer will fire some time after the programmed interval.

The Timer stops after invoking the handler (repeat + 1) times. To create a
Timer that will run forever, set "repeat" to -1. Turning the Timer off
preserves set values; the Timer is not destroyed.

When setting both C<PARROT_TIMER_SEC> and C<PARROT_TIMER_USEC> it must
be done in that sequence, whole seconds first. If a timer is constructed
with an initializer and it should be run immediately, the
C<PARROT_TIMER_RUNNING> value has to be in the last key of the
initializer.

=head2 Functions

=over 4

=cut

*/

#include "parrot/scheduler_private.h"
#line 81 "./src/pmc/timer.c"
static  PMC  * Parrot_Timer_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Timer_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Timer_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  FLOATVAL  Parrot_Timer_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_Timer_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  Parrot_Timer_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Timer_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init);
static  opcode_t  * Parrot_Timer_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_Timer_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void  Parrot_Timer_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value);
static  void  Parrot_Timer_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value);
void    Parrot_Timer_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Timer_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Timer_get_vtable(PARROT_INTERP);
void    Parrot_Timer_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Timer_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Timer_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Timer_clone(PARROT_INTERP, PMC *pmc)
{
#line 156 "./src/pmc/timer.pmc"

    PMC * const copy = interp->vtables[enum_class_Task]->clone(interp, pmc);
    Parrot_Timer_attributes * const new_struct = PARROT_TIMER(copy);
    Parrot_Timer_attributes * const old_struct = PARROT_TIMER(pmc);

    new_struct->duration  = old_struct->duration;
    new_struct->interval  = old_struct->interval;
    new_struct->repeat    = old_struct->repeat;

    return copy;
#line 113 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_destroy(PARROT_INTERP, PMC *pmc)
{
#line 178 "./src/pmc/timer.pmc"

    Parrot_cx_delete_task(interp, pmc);
#line 121 "./src/pmc/timer.c"
}
static  INTVAL 
Parrot_Timer_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 192 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);
    const FLOATVAL absolute_time = core_struct->birthtime + core_struct->duration;

    switch (key) {
        case PARROT_TIMER_SEC:
            return (INTVAL)absolute_time;
        case PARROT_TIMER_USEC:
            return (INTVAL)((absolute_time - (INTVAL)absolute_time) *1000000.0);
        case PARROT_TIMER_REPEAT:
            return (INTVAL) core_struct->repeat;
        case PARROT_TIMER_INTERVAL:
            return (INTVAL) core_struct->interval;
        case PARROT_TIMER_RUNNING:
            return 0;
        default:
            return -1;
    }
#line 145 "./src/pmc/timer.c"
}
static  FLOATVAL 
Parrot_Timer_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 241 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);

    switch (key) {
        case PARROT_TIMER_NSEC:
            return core_struct->birthtime + core_struct->duration;
        case PARROT_TIMER_INTERVAL:
            return core_struct->interval;
        default:
            break;
    }

    return -1.0;
#line 164 "./src/pmc/timer.c"
}
static  PMC  *
Parrot_Timer_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 222 "./src/pmc/timer.pmc"

    if (key == PARROT_TIMER_HANDLER) {
        const Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);
        return core_struct->codeblock;
    }

    return PMCNULL;
#line 177 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_init(PARROT_INTERP, PMC *pmc)
{
#line 76 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_custom_destroy_SET(pmc);

    /* Set up the core struct. */
    core_struct->id          = 0;
    core_struct->type        = CONST_STRING(interp, "timer");
    core_struct->subtype     = CONST_STRING(interp, "");
    core_struct->priority    = 0;
    core_struct->status      = CONST_STRING(interp, "created");
    core_struct->birthtime   = 0.0;
    core_struct->codeblock   = PMCNULL;
    core_struct->interp      = interp;
    core_struct->duration    = 0.0;
    core_struct->interval    = 0.0;
    core_struct->repeat      = 0;

    /* Make sure the flag is cleared by default */
    TASK_terminate_runloop_CLEAR(pmc);
#line 205 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 110 "./src/pmc/timer.pmc"

    const INTVAL n = VTABLE_get_integer(interp, init);
    INTVAL       i;

    VTABLE_init(interp, pmc);

    for (i = 0; i < n; i += 2) {
        const INTVAL key = VTABLE_get_integer_keyed_int(interp, init, i);
        switch (key) {
            case PARROT_TIMER_SEC:
            case PARROT_TIMER_USEC:
            case PARROT_TIMER_REPEAT:
            case PARROT_TIMER_RUNNING:
                {
                const INTVAL val = VTABLE_get_integer_keyed_int(interp, init, i+1);
                VTABLE_set_integer_keyed_int(interp, pmc, key, val);
                }
                break;
            case PARROT_TIMER_NSEC:
                {
                const FLOATVAL nval = VTABLE_get_number_keyed_int(interp, init, i+1);
                VTABLE_set_number_keyed_int(interp, pmc, key, nval);
                }
                break;
            case PARROT_TIMER_HANDLER:
                {
                PMC * const pval = VTABLE_get_pmc_keyed_int(interp, init, i+1);
                VTABLE_set_pmc_keyed_int(interp, pmc, key, pval);
                }
                break;
            default:
                break;
        }
    }
#line 245 "./src/pmc/timer.c"
}
static  opcode_t  *
Parrot_Timer_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 326 "./src/pmc/timer.pmc"

    Parrot_cx_schedule_task(interp, pmc);
    return (opcode_t *)next;
#line 254 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 266 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);

    switch (key) {
        case PARROT_TIMER_SEC:
            core_struct->duration = value;
            break;
        case PARROT_TIMER_USEC:
            core_struct->duration += value / 1000000.0;
            break;
        case PARROT_TIMER_REPEAT:
            core_struct->repeat = value;
            break;
        case PARROT_TIMER_INTERVAL:
            core_struct->interval = value;
            break;
        case PARROT_TIMER_RUNNING:
            if (value)
                Parrot_cx_schedule_task(interp, pmc);
            else
                Parrot_cx_delete_task(interp, pmc);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Unknown timer type in Timer.set_integer_keyed_int: %d",
                key);
    }
#line 288 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 341 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);

    switch (key) {
        case PARROT_TIMER_NSEC:
            core_struct->duration = value;
            break;
        case PARROT_TIMER_INTERVAL:
            core_struct->interval = value;
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Unknown timer attribute in Timer.set_number_keyed_int: %d",
                key);
    }
#line 310 "./src/pmc/timer.c"
}
static  void 
Parrot_Timer_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
#line 306 "./src/pmc/timer.pmc"

    if (key == PARROT_TIMER_HANDLER) {
/*
        Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);
        core_struct->codeblock = value;
*/
        SETATTR_Timer_codeblock(interp, pmc, value);
    }
#line 324 "./src/pmc/timer.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Timer_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Timer_clone;
    vt->destroy = Parrot_Timer_destroy;
    vt->get_integer_keyed_int = Parrot_Timer_get_integer_keyed_int;
    vt->get_number_keyed_int = Parrot_Timer_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_Timer_get_pmc_keyed_int;
    vt->init = Parrot_Timer_init;
    vt->init_pmc = Parrot_Timer_init_pmc;
    vt->invoke = Parrot_Timer_invoke;
    vt->set_integer_keyed_int = Parrot_Timer_set_integer_keyed_int;
    vt->set_number_keyed_int = Parrot_Timer_set_number_keyed_int;
    vt->set_pmc_keyed_int = Parrot_Timer_set_pmc_keyed_int;
    vt->attr_size = sizeof(Parrot_Timer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Timer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Timer_clone;
    vt->destroy = Parrot_Timer_destroy;
    vt->get_integer_keyed_int = Parrot_Timer_get_integer_keyed_int;
    vt->get_number_keyed_int = Parrot_Timer_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_Timer_get_pmc_keyed_int;
    vt->init = Parrot_Timer_init;
    vt->init_pmc = Parrot_Timer_init_pmc;
    vt->invoke = Parrot_Timer_invoke;
    vt->attr_size = sizeof(Parrot_Timer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Timer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Task_get_vtable(interp);
    Parrot_Timer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Timer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Task_ro_get_vtable(interp);
    Parrot_Timer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Timer_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Task_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Timer", 5, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Timer_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Task_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Timer")), PMCNULL);
    return isa;
}

void
Parrot_Timer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iid Ipriority Fbirthtime Stype Ssubtype Sstatus :interp Fcodeblock Fdata :cb_data Fduration Finterval Irepeat ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Timer_get_vtable(interp);
        vt->base_type      = enum_class_Timer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Timer");
        vt->provides_str = CONST_STRING_GEN(interp, "event");
        vt->isa_hash     = Parrot_Timer_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Timer_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Timer;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Timer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Timer_class_init */
#line 357 "./src/pmc/timer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
