/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/unmanagedstruct.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_unmanagedstruct.h"
#include "pmc_default.h"
#include "unmanagedstruct.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/unmanagedstruct.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: unmanagedstruct.pmc 41235 2009-09-12 14:03:11Z NotFound $

=head1 NAME

src/pmc/unmanagedstruct.pmc - C struct with unmanaged memory

=head1 DESCRIPTION

PMC class to hold C C<struct>s that Parrot's not responsible for
disposing of.

Buffer can be accessed using keyed assignments to PMC. Out of
bounds access will very likely segfault.

=head2 Functions

=over 4

=cut

*/

#include "parrot/compiler.h"

static INTVAL key_2_idx(PARROT_INTERP, PMC *pmc, PMC *key);
static size_t calc_offsets(PARROT_INTERP, PMC*, PMC *init, size_t toff);

/*

=item C<static char *
char_offset_int(PARROT_INTERP, PMC *pmc, INTVAL ix, int *type)>

Returns the pointer for the element at index C<ix>, and sets the element
type in C<*type>.

=cut

*/

static char *
char_offset_int(PARROT_INTERP, PMC *pmc, INTVAL ix, int *type)
{
    size_t offs, n;
    ix *= 3;

    if (!PARROT_UNMANAGEDSTRUCT(pmc)->init)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNEXPECTED_NULL,
            "Missing struct initializer");

    n = (size_t)VTABLE_elements(interp, PARROT_UNMANAGEDSTRUCT(pmc)->init);

    if ((size_t)ix >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNEXPECTED_NULL,
            "Non existent elements in struct ix = %d n=%d", (int)ix, (int)n);

    /* use structure init */
    *type = (int) VTABLE_get_integer_keyed_int(interp,
        PARROT_UNMANAGEDSTRUCT(pmc)->init, ix);

    offs  = (size_t) VTABLE_get_integer_keyed_int(interp,
        PARROT_UNMANAGEDSTRUCT(pmc)->init, ix + 2);

    return ((char *)VTABLE_get_pointer(interp, pmc)) + offs;
}

/*

=item C<static INTVAL
key_2_idx(PARROT_INTERP, PMC *pmc, PMC *key)>

Returns the index for the element associated with key C<*key>. Raises an
exception if the key doesn't exist.

=cut

*/

static INTVAL
key_2_idx(PARROT_INTERP, PMC *pmc, PMC *key)
{
    int ix = 0;

    if (!PARROT_UNMANAGEDSTRUCT(pmc)->init)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNEXPECTED_NULL,
            "Missing struct initializer");

    if (PObj_get_FLAGS(key) & KEY_string_FLAG) {
        PMC * const types = PARROT_UNMANAGEDSTRUCT(pmc)->init;

        if (types->vtable->base_type == enum_class_OrderedHash) {
            Hash       * const hash = (Hash *)VTABLE_get_pointer(interp, types);
            HashBucket * const b    = parrot_hash_get_bucket(interp, hash,
                VTABLE_get_string(interp, key));

            if (!b)
                Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                    "key doesn't exist");

            ix = b - hash->bs;
        }
        else
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "unhandled type aggregate");

        ix /= 3;
    }
    else
        ix = VTABLE_get_integer(interp, key);

    return ix;
}

/*

=item C<static char *
char_offset_key(PARROT_INTERP, PMC *pmc, PMC *key, int *type)>

Returns the pointer for the element associated with key C<*key>, and
sets the element type in C<*type>.

=cut

*/

static char *
char_offset_key(PARROT_INTERP, PMC *pmc, PMC *key, int *type)
{
    size_t offs, count, size, max;
    int    ix;
    PMC   *next, *init;
    char  *p;

#ifdef STRUCT_DEBUG
    trace_key_dump(interp, key);
#endif

    ix   = key_2_idx(interp, pmc, key);
    next = key_next(interp, key);
    p    = char_offset_int(interp, pmc, ix, type);
    ix  *= 3;

    if (!next)
        return p;

    if (PObj_get_FLAGS(next) & KEY_integer_FLAG)
        count = VTABLE_get_integer(interp, next);
    else
        count = 1;

    init = PARROT_UNMANAGEDSTRUCT(pmc)->init;
    max  = (size_t)VTABLE_get_integer_keyed_int(interp, init, ix + 1);

#ifdef STRUCT_DEBUG
    Parrot_io_eprintf(interp, " count = %d ix = %d max = %d\n",
            (int)count, (int)ix, (int)max);
#endif

    if (*type == enum_type_struct_ptr || *type == enum_type_struct) {
        /* the struct PMC is hanging off the initializer element
         * as property "_struct" */
        PMC * const ptr = VTABLE_get_pmc_keyed_int(interp, init, ix);
        init            = VTABLE_getprop(interp, ptr, CONST_STRING(interp, "_struct"));

        PARROT_ASSERT(init
            && (init->vtable->base_type == enum_class_UnManagedStruct
            ||  init->vtable->base_type == enum_class_ManagedStruct));

        /* array of structs */
        if (max > 1) {
            if (key_next(interp, next))
                next = key_next(interp, next);

            offs = VTABLE_get_integer(interp, init);

#ifdef STRUCT_DEBUG
            Parrot_io_eprintf(interp, "offs = %d\n", (int)offs);
#endif

            p += offs * count;
        }

        if (init->vtable->base_type == enum_class_UnManagedStruct) {
            /* now point ptr to the real data */
            if (*type == enum_type_struct_ptr) {
                /* that is either a pointer */
                PARROT_ASSERT((PTR2INTVAL(p) & (PARROT_PTR_ALIGNMENT - 1)) == 0);
                VTABLE_set_pointer(interp, init, *(void**)p);
            }

            /* or just an offset for nested structs */
            else
                VTABLE_set_pointer(interp, init, p);
        }
        else if (init->vtable->base_type == enum_class_ManagedStruct
             && *type                    == enum_type_struct_ptr) {
            /* a nested struct pointer belonging to us
             * p is the location of the struct pointer in the
             * outer struct, the inner is at PMC_data(init) */

            PARROT_ASSERT((PTR2INTVAL(p) & (PARROT_PTR_ALIGNMENT - 1)) == 0);
            *(void **)p = VTABLE_get_pointer(interp, init);
        }

        return char_offset_key(interp, init, next, type);
    }

    if (count >= max)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Non existent array element in struct: "
            "count = %d max=%d", (int)count, (int)max);

    size = data_types[*type - enum_first_type].size;
    return p + count * size;
}


/*

=item C<static INTVAL
ret_int(PARROT_INTERP, const char *p, int type)>

Returns the element of type C<type> starting at C<*p> as an C<INTVAL>.

If, for example, C<char> or c<short> type size doesn't match, this will fail
we need some more configure support for type sizes.

=cut

*/

static INTVAL
ret_int(PARROT_INTERP, const char *p, int type)
    __attribute__nonnull__(1);

static INTVAL
ret_int(PARROT_INTERP, const char *p, int type)
{
    switch (type) {
        case enum_type_INTVAL:
            return *(const INTVAL*) p;

#if INT_SIZE == 4
        case enum_type_int32:
        case enum_type_uint32:
#endif

#if INT_SIZE == 8
        case enum_type_int64:
        case enum_type_uint64:
#endif

        case enum_type_int:
            return *(const int *)p;

#if (LONG_SIZE == 4) && !(INT_SIZE == 4) /* Unlikely combination. */
        case enum_type_int32:
        case enum_type_uint32:
#endif

#if (LONG_SIZE == 8) && !(INT_SIZE == 8)
        case enum_type_int64:
        case enum_type_uint64:
#endif

        case enum_type_long:
        case enum_type_ulong:
            return *(const long *)p;

#if SHORT_SIZE == 2
        case enum_type_int16:
        case enum_type_uint16:
#endif

        /* If SHORT_SIZE != 2 getting int16s requires extra tricks. */
        case enum_type_short:
            return *(const short *)p;
        case enum_type_uint8:
        case enum_type_uchar:
        {
            const unsigned char *uc = (const unsigned char *)p;
            return (INTVAL)*uc;
        }
        case enum_type_int8:
        case enum_type_char:
            return *p;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "returning unhandled int type in struct");
    }
}

/*

=item C<static FLOATVAL
ret_float(PARROT_INTERP, const char *p, int type)>

Returns the element of type C<type> starting at C<*p> as a C<FLOATVAL>.

=cut

*/

static FLOATVAL
ret_float(PARROT_INTERP, const char *p, int type)
    __attribute__nonnull__(1);

static FLOATVAL
ret_float(PARROT_INTERP, const char *p, int type)
{
    switch (type) {
        case enum_type_FLOATVAL:
            return (FLOATVAL) *(const FLOATVAL *)p;
        case enum_type_float:
            return (FLOATVAL) *(const float *)p;
        case enum_type_double:
            return (FLOATVAL) *(const double *)p;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "returning unhandled float type in struct");
    }
}

/*

=item C<static STRING*
ret_string(PARROT_INTERP, char *p, int type)>

Returns the element of type C<type> starting at C<*p> as a Parrot string.

=cut

*/

static STRING*
ret_string(PARROT_INTERP, char *p, int type)
{
    if (type == enum_type_cstr) {
        char  *cstr = *(char **) p;
        if (cstr) {
            size_t len  = strlen(cstr);
            /* TODO
               Can't assume that the C string is constant during the
               life of the returned parrot string, so can't be
               flagged as external in general.
               If avoid the copy for speed reasons is a concern,
               other type or flag must be added.
               Need to provide some way to specify charset and encoding.
             */
            return string_make(interp, cstr, len, "iso-8859-1", 0);
        }
        else
            return NULL;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
        "returning unhandled string type in struct");
}

/*

=item C<static PMC*
ret_pmc(PARROT_INTERP, PMC *pmc, char *p, int type, INTVAL idx)>

Returns the element of type C<type> starting at C<*p> as a PMC.

=cut

*/

static PMC*
ret_pmc(PARROT_INTERP, PMC *pmc, char *p, int type, INTVAL idx)
{
    PMC *ret  = NULL;
    PMC *init = PARROT_UNMANAGEDSTRUCT(pmc)->init;
    PMC *ptr  = VTABLE_get_pmc_keyed_int(interp, init, idx * 3);

    switch (type) {
        case enum_type_func_ptr:
            /* this is a raw function pointer - not a PMC */
            ret  = *(PMC**) p;

            /* now check if initializer has a signature attached */
            if (PMC_metadata(ptr)) {
                STRING *signature_str = CONST_STRING(interp, "_signature");
                PMC *sig = VTABLE_getprop(interp, ptr, signature_str);
                if (VTABLE_defined(interp, sig)) {
                    STRING *sig_str = VTABLE_get_string(interp, sig);
                    ret             = pmc_new(interp, enum_class_NCI);
                    VTABLE_set_pointer_keyed_str(interp, ret, sig_str,
                            *(PMC **)p);
                }
            }

            return ret;
        case enum_type_struct_ptr:
            /* check the metadata for an initializer */

            /* grab the struct from the metadata */
            if (PMC_metadata(ptr))
                ret = VTABLE_getprop(interp, ptr, CONST_STRING(interp, "_struct"));
            else {
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "no initializer available for nested struct");
            }

            VTABLE_set_pointer(interp, ret, *(void**)p);

            return ret;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                    "returning unhandled pmc type (%d) in struct", type);
    }
}

/*

=item C<static void
set_int(PARROT_INTERP, char *p, int type, INTVAL value)>

=cut

*/

static void
set_int(PARROT_INTERP, char *p, int type, INTVAL value)
{
    switch (type) {
        case enum_type_uint8:
        case enum_type_int8:
        case enum_type_char:
        case enum_type_uchar:
            *(char *)p = (char)(value & 0xff);
            break;
        case enum_type_INTVAL:
            *(INTVAL *)p = value;
            break;
        case enum_type_int:
            *(int *)p = value;
            break;
        case enum_type_int16:
        case enum_type_uint16:
        case enum_type_short:
            *(short *)p = (short)value;
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "setting unhandled int type in struct");
            break;
    }
}

/*

=item C<static void
set_float(PARROT_INTERP, char *p, int type, FLOATVAL value)>

Sets the value of the element of type C<type> starting at C<*p> to
C<value>.

=cut

*/

static void
set_float(PARROT_INTERP, char *p, int type, FLOATVAL value)
{
    switch (type) {
        case enum_type_FLOATVAL:
            *(FLOATVAL *)p = (FLOATVAL)value;
            break;
        case enum_type_float:
            *(float *)p = (float)value;
            break;
        case enum_type_double:
            *(double *)p = (double)value;
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "setting unhandled float type in struct");
            break;
    }
}

/*

=item C<static void
set_string(PARROT_INTERP, char *p, int type, STRING *value)>

Sets the value of the element of type C<type> starting at C<*p> to
C<*value>.

=cut

*/

static void
set_string(PARROT_INTERP, char *p, int type, STRING *value)
{
    if (type == enum_type_cstr) {
        /* assuming 0-terminated C-string here;
         * we can't use Parrot_str_to_cstring easily */
        char *cstr  = (char *)Buffer_bufstart(value);
        *(char **)p = cstr;
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "setting unhandled string type in struct (%d)", type);
}

/*

=item C<static int
calc_align(PARROT_INTERP, PMC *pmc, PMC *type_pmc,
        int type, size_t offs)>

Alignment of contained structures is the alignment of the biggest item in that
C<struct>.

i386: C<long long> or C<double> is aligned on 4.

This is recursive as structure definitions.

=cut

*/

static int
calc_align(PARROT_INTERP, PMC *pmc, PMC *type_pmc,
        int type, size_t offs)
{
    int  align       = data_types[type - enum_first_type].size;
    PMC *nested      = NULL;
    PMC *nested_init = NULL;

    if (type == enum_type_struct || type == enum_type_struct_ptr) {
        /* a nested structs alignment is the biggest item in it
         * so go through that struct and check */
        nested = VTABLE_getprop(interp, type_pmc, CONST_STRING(interp, "_struct"));
        nested_init = PARROT_UNMANAGEDSTRUCT(nested)->init;
    }
    if (type == enum_type_struct) {
        INTVAL i, n    = (size_t)VTABLE_elements(interp, nested_init);
        int    a_max   = 0;
        int    new_offs;

        if (n % 3)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                    "Illegal initializer for struct");

        for (i = 0; i < n; i += 3) {
            PMC *nested_type_pmc = VTABLE_get_pmc_keyed_int(interp,
                    nested_init, i);
            int  nested_type     = (int)VTABLE_get_integer(interp,
                nested_type_pmc);
            new_offs             = calc_align(interp, nested,
                    nested_type_pmc, nested_type, offs);

            if (new_offs > a_max)
                a_max = new_offs;
        }

        align = a_max;
    }

    if (align && offs % align) {
        const int diff = align - (offs % align);
        offs += diff;
    }

    if (type == enum_type_struct || type == enum_type_struct_ptr)
        calc_offsets(interp, nested, nested_init, 0);

    return offs;
}

/*

=item C<static size_t
calc_offsets(PARROT_INTERP, PMC *pmc, PMC *value, size_t toff)>

Calculates the offsets for the C<struct>. See C<init_pmc()> for a description
of C<*value>.

=cut

*/

static size_t
calc_offsets(PARROT_INTERP, PMC *pmc, PMC *value, size_t toff)
{
    STRING *_struct = CONST_STRING(interp, "_struct");
    INTVAL  n       = (size_t)VTABLE_elements(interp, value);
    INTVAL  i;
    int     size;

    if (n % 3)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Illegal initializer for struct");

    for (i = 0; i < n; i += 3) {
        PMC *type_pmc = VTABLE_get_pmc_keyed_int(interp, value, i);
        int  type     = (int)VTABLE_get_integer(interp, type_pmc);
        int  count    = (int)VTABLE_get_integer_keyed_int(interp, value, i + 1);
        int  offs     = (int)VTABLE_get_integer_keyed_int(interp, value, i + 2);

        if (type < enum_first_type || type >= enum_last_type)
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Illegal type in initializer for struct");

        if (count <= 0) {
            count = 1;
            VTABLE_set_integer_keyed_int(interp, value, i + 1, count);
        }

        if (offs <= 0) {
            offs = toff = calc_align(interp, pmc, type_pmc, type, toff);
            VTABLE_set_integer_keyed_int(interp, value, i + 2, offs);
        }
        else
            toff = offs;

        if (type == enum_type_struct) {
            PMC *nested = VTABLE_getprop(interp, type_pmc, _struct);
            size        = VTABLE_get_integer(interp, nested);
        }
        else if (type == enum_type_struct_ptr) {
            PMC *nested = VTABLE_getprop(interp, type_pmc, _struct);

            /* must clone this struct so as not to share its memory */
            if (nested->vtable->base_type == enum_class_ManagedStruct)
                VTABLE_setprop(interp, type_pmc, _struct,
                    VTABLE_clone(interp, nested));

            size = data_types[type - enum_first_type].size;
        }
        else
            size = data_types[type - enum_first_type].size;

        toff += count * size;

        /* set / allocate size */
        if (i == n - 3)
            VTABLE_set_integer_native(interp, pmc, (INTVAL)toff);
    }

    return toff;
}
#line 673 "./src/pmc/unmanagedstruct.c"
static  PMC  * Parrot_UnManagedStruct_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_UnManagedStruct_defined(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_UnManagedStruct_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_UnManagedStruct_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_UnManagedStruct_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL ix);
static  FLOATVAL  Parrot_UnManagedStruct_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_UnManagedStruct_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_UnManagedStruct_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_UnManagedStruct_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  * Parrot_UnManagedStruct_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_UnManagedStruct_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_UnManagedStruct_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  Parrot_UnManagedStruct_init_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_UnManagedStruct_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_UnManagedStruct_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_UnManagedStruct_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_UnManagedStruct_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL ix, INTVAL value);
static  void  Parrot_UnManagedStruct_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size);
static  void  Parrot_UnManagedStruct_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_UnManagedStruct_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value);
static  void  Parrot_UnManagedStruct_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_UnManagedStruct_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void  Parrot_UnManagedStruct_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_UnManagedStruct_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value);
void    Parrot_UnManagedStruct_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_UnManagedStruct_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_UnManagedStruct_get_vtable(PARROT_INTERP);
void    Parrot_UnManagedStruct_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_UnManagedStruct_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_UnManagedStruct_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_UnManagedStruct_clone(PARROT_INTERP, PMC *pmc)
{
#line 706 "./src/pmc/unmanagedstruct.pmc"

    PMC *clone = pmc_new(interp, enum_class_UnManagedStruct);
    mem_sys_memmove(PMC_data(clone), PMC_data(pmc),
            sizeof (Parrot_UnManagedStruct_attributes));
    PARROT_UNMANAGEDSTRUCT(clone)->init =
        VTABLE_clone(interp, PARROT_UNMANAGEDSTRUCT(pmc)->init);
    return clone;
#line 715 "./src/pmc/unmanagedstruct.c"
}
static  INTVAL 
Parrot_UnManagedStruct_defined(PARROT_INTERP, PMC *pmc)
{
#line 771 "./src/pmc/unmanagedstruct.pmc"

    return VTABLE_get_pointer(interp, pmc) != NULL;
#line 723 "./src/pmc/unmanagedstruct.c"
}
static  INTVAL 
Parrot_UnManagedStruct_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 785 "./src/pmc/unmanagedstruct.pmc"

    return PARROT_UNMANAGEDSTRUCT(pmc)->size;
#line 731 "./src/pmc/unmanagedstruct.c"
}
static  INTVAL 
Parrot_UnManagedStruct_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 829 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_int(interp, p, type);
#line 741 "./src/pmc/unmanagedstruct.c"
}
static  INTVAL 
Parrot_UnManagedStruct_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL ix)
{
#line 813 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_int(interp, pmc, ix, &type);
    return ret_int(interp, p, type);
#line 751 "./src/pmc/unmanagedstruct.c"
}
static  FLOATVAL 
Parrot_UnManagedStruct_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 861 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_float(interp, p, type);
#line 761 "./src/pmc/unmanagedstruct.c"
}
static  FLOATVAL 
Parrot_UnManagedStruct_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 845 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_int(interp, pmc, key, &type);
    return ret_float(interp, p, type);
#line 771 "./src/pmc/unmanagedstruct.c"
}
static  PMC  *
Parrot_UnManagedStruct_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 925 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_pmc(interp, pmc, p, type, key_2_idx(interp, pmc, key));
#line 781 "./src/pmc/unmanagedstruct.c"
}
static  PMC  *
Parrot_UnManagedStruct_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 909 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_int(interp, pmc, key, &type);
    return ret_pmc(interp, pmc, p, type, key);
#line 791 "./src/pmc/unmanagedstruct.c"
}
static  void  *
Parrot_UnManagedStruct_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 941 "./src/pmc/unmanagedstruct.pmc"

    return PARROT_UNMANAGEDSTRUCT(pmc)->ptr;
#line 799 "./src/pmc/unmanagedstruct.c"
}
static  STRING  *
Parrot_UnManagedStruct_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 893 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_string(interp, p, type);
#line 809 "./src/pmc/unmanagedstruct.c"
}
static  STRING  *
Parrot_UnManagedStruct_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 877 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_int(interp, pmc, key, &type);
    return ret_string(interp, p, type);
#line 819 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_init_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 692 "./src/pmc/unmanagedstruct.pmc"

    VTABLE_set_pmc(interp, pmc, value);
#line 827 "./src/pmc/unmanagedstruct.c"
}
static  INTVAL 
Parrot_UnManagedStruct_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 756 "./src/pmc/unmanagedstruct.pmc"

    return (pmc->vtable   == value->vtable
    &&      VTABLE_get_pointer(interp, pmc) == VTABLE_get_pointer(interp, value));
#line 836 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_mark(PARROT_INTERP, PMC *pmc)
{
#line 741 "./src/pmc/unmanagedstruct.pmc"

    if (PARROT_UNMANAGEDSTRUCT(pmc)->init)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)PARROT_UNMANAGEDSTRUCT(pmc)->init);
#line 845 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 987 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_key(interp, pmc, key, &type);
    set_int(interp, p, type, value);
#line 855 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL ix, INTVAL value)
{
#line 969 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_int(interp, pmc, ix, &type);
    set_int(interp, p, type, value);
#line 865 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 799 "./src/pmc/unmanagedstruct.pmc"

    PARROT_UNMANAGEDSTRUCT(pmc)->size = size;
#line 873 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 1019 "./src/pmc/unmanagedstruct.pmc"

    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    set_float(interp, p, type, value);
#line 883 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 1003 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_int(interp, pmc, key, &type);
    set_float(interp, p, type, value);
#line 893 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 725 "./src/pmc/unmanagedstruct.pmc"

    PARROT_UNMANAGEDSTRUCT(pmc)->init = value;
    PObj_custom_mark_SET(pmc);
    calc_offsets(interp, pmc, value, 0);
#line 903 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 955 "./src/pmc/unmanagedstruct.pmc"

    PARROT_UNMANAGEDSTRUCT(pmc)->ptr = value;
#line 911 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 1051 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_key(interp, pmc, key, &type);
    set_string(interp, p, type, value);
#line 921 "./src/pmc/unmanagedstruct.c"
}
static  void 
Parrot_UnManagedStruct_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 1035 "./src/pmc/unmanagedstruct.pmc"

    int   type;
    char *p = char_offset_int(interp, pmc, key, &type);
    set_string(interp, p, type, value);
#line 931 "./src/pmc/unmanagedstruct.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_UnManagedStruct_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_UnManagedStruct_clone;
    vt->defined = Parrot_UnManagedStruct_defined;
    vt->get_integer = Parrot_UnManagedStruct_get_integer;
    vt->get_integer_keyed = Parrot_UnManagedStruct_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_UnManagedStruct_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_UnManagedStruct_get_number_keyed;
    vt->get_number_keyed_int = Parrot_UnManagedStruct_get_number_keyed_int;
    vt->get_pmc_keyed = Parrot_UnManagedStruct_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_UnManagedStruct_get_pmc_keyed_int;
    vt->get_pointer = Parrot_UnManagedStruct_get_pointer;
    vt->get_string_keyed = Parrot_UnManagedStruct_get_string_keyed;
    vt->get_string_keyed_int = Parrot_UnManagedStruct_get_string_keyed_int;
    vt->init_pmc = Parrot_UnManagedStruct_init_pmc;
    vt->is_equal = Parrot_UnManagedStruct_is_equal;
    vt->mark = Parrot_UnManagedStruct_mark;
    vt->set_integer_keyed = Parrot_UnManagedStruct_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_UnManagedStruct_set_integer_keyed_int;
    vt->set_integer_native = Parrot_UnManagedStruct_set_integer_native;
    vt->set_number_keyed = Parrot_UnManagedStruct_set_number_keyed;
    vt->set_number_keyed_int = Parrot_UnManagedStruct_set_number_keyed_int;
    vt->set_pmc = Parrot_UnManagedStruct_set_pmc;
    vt->set_pointer = Parrot_UnManagedStruct_set_pointer;
    vt->set_string_keyed = Parrot_UnManagedStruct_set_string_keyed;
    vt->set_string_keyed_int = Parrot_UnManagedStruct_set_string_keyed_int;
    vt->attr_size = sizeof(Parrot_UnManagedStruct_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_UnManagedStruct_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_UnManagedStruct_clone;
    vt->defined = Parrot_UnManagedStruct_defined;
    vt->get_integer = Parrot_UnManagedStruct_get_integer;
    vt->get_integer_keyed = Parrot_UnManagedStruct_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_UnManagedStruct_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_UnManagedStruct_get_number_keyed;
    vt->get_number_keyed_int = Parrot_UnManagedStruct_get_number_keyed_int;
    vt->get_pmc_keyed = Parrot_UnManagedStruct_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_UnManagedStruct_get_pmc_keyed_int;
    vt->get_pointer = Parrot_UnManagedStruct_get_pointer;
    vt->get_string_keyed = Parrot_UnManagedStruct_get_string_keyed;
    vt->get_string_keyed_int = Parrot_UnManagedStruct_get_string_keyed_int;
    vt->init_pmc = Parrot_UnManagedStruct_init_pmc;
    vt->is_equal = Parrot_UnManagedStruct_is_equal;
    vt->mark = Parrot_UnManagedStruct_mark;
    vt->attr_size = sizeof(Parrot_UnManagedStruct_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_UnManagedStruct_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_UnManagedStruct_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_UnManagedStruct_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_UnManagedStruct_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_UnManagedStruct_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "UnManagedStruct", 15, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_UnManagedStruct_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "UnManagedStruct")), PMCNULL);
    return isa;
}

void
Parrot_UnManagedStruct_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":ptr Finit Isize ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_UnManagedStruct_get_vtable(interp);
        vt->base_type      = enum_class_UnManagedStruct;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "UnManagedStruct");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_UnManagedStruct_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_UnManagedStruct;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_UnManagedStruct_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_UnManagedStruct_class_init */
#line 1056 "./src/pmc/unmanagedstruct.pmc"


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04

=head1 SEE ALSO

F<docs/pmc/struct.pod>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
