/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically by tools/build/nativecall.pl
 * from definitions in src/call_list.txt
 *
 * Any changes made here will be lost!
 *
 */

/* nci.c
 *  Copyright (C) 2001-2007, Parrot Foundation.
 *  SVN Info
 *     $Id$
 *  Overview:
 *     Native Call Interface routines. The code needed to build a
 *     parrot to C call frame is in here
 *  Data Structure and Algorithms:
 *  History:
 *  Notes:
 *  References:
 */
#include "parrot/parrot.h"
#include "parrot/hash.h"
#include "parrot/oplib/ops.h"
#include "pmc/pmc_managedstruct.h"
#include "pmc/pmc_nci.h"
#include "pmc/pmc_pointer.h"
#include "nci.str"
#include "jit.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

/*
 * if the architecture can build some or all of these signatures
 * enable the define below
 * - the JITed function will be called first
 * - if it returns NULL, the hardcoded version will do the job
 */

#if defined(HAS_JIT) && defined(I386)
#  include "parrot/exec.h"
#  include "jit.h"
#  define CAN_BUILD_CALL_FRAMES
#endif

/*
 * helper funcs - get argument n
 */
static INTVAL
get_nci_I(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    if (n >= st->src.n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "too few arguments passed to NCI function");

    Parrot_fetch_arg_nci(interp, st);

    return UVal_int(st->val);
}

static FLOATVAL
get_nci_N(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    if (n >= st->src.n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "too few arguments passed to NCI function");

    Parrot_fetch_arg_nci(interp, st);

    return UVal_num(st->val);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static STRING*
get_nci_S(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    /* TODO or act like below? */
    if (n >= st->src.n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "too few arguments passed to NCI function");

    Parrot_fetch_arg_nci(interp, st);

    return UVal_str(st->val);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC*
get_nci_P(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    /*
     * excessive args are passed as NULL
     * used by e.g. MMD infix like __add
     */
    if (n < st->src.n)
        Parrot_fetch_arg_nci(interp, st);
    else
        UVal_pmc(st->val) = PMCNULL;

    return UVal_pmc(st->val);
}

#define GET_NCI_I(n) get_nci_I(interp, &st, n)
#define GET_NCI_S(n) get_nci_S(interp, &st, n)
#define GET_NCI_N(n) get_nci_N(interp, &st, n)
#define GET_NCI_P(n) get_nci_P(interp, &st, n)

/*
 * set return value
 */
static void
set_nci_I(PARROT_INTERP, ARGOUT(call_state *st), INTVAL val)
{
    Parrot_init_ret_nci(interp, st, "I");
    if (st->dest.i < st->dest.n) {
        UVal_int(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_N(PARROT_INTERP, ARGOUT(call_state *st), FLOATVAL val)
{
    Parrot_init_ret_nci(interp, st, "N");
    if (st->dest.i < st->dest.n) {
        UVal_num(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_S(PARROT_INTERP, ARGOUT(call_state *st), STRING *val)
{
    Parrot_init_ret_nci(interp, st, "S");
    if (st->dest.i < st->dest.n) {
        UVal_str(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_P(PARROT_INTERP, ARGOUT(call_state *st), PMC* val)
{
    Parrot_init_ret_nci(interp, st, "P");
    if (st->dest.i < st->dest.n) {
        UVal_pmc(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

#ifndef CAN_BUILD_CALL_FRAMES
/* All our static functions that call in various ways. Yes, terribly
   hackish, but that is just fine */

static void
pcf_d_JOd(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(PARROT_INTERP, PMC *, double);
    func_t pointer;
    void *orig_func;
    call_state st;
    double return_data;
    PMC *t_1;
    double t_2;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_1 = GET_NCI_P(0);
    t_2 = (double)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (double)(*pointer)(interp,PMC_IS_NULL(t_1) ? NULL : t_1,t_2);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_I_JOS(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_4;
    STRING * t_5;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_4 = GET_NCI_P(0);
    t_5 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_4) ? NULL : t_4,t_5);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOl(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_7;
    long t_8;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_7 = GET_NCI_P(0);
    t_8 = (long)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_7) ? NULL : t_7,t_8);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_Jt(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    char *t_10;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_10 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,t_10);
    set_nci_P(interp, &st, return_data);
    do { if (t_10) Parrot_str_free_cstring(t_10); } while (0);
}
static void
pcf_S_JOS(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_12;
    STRING * t_13;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_12 = GET_NCI_P(0);
    t_13 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_12) ? NULL : t_12,t_13);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_I_JI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    INTVAL t_15;
    Parrot_init_arg_nci(interp, &st, "I");
    t_15 = (INTVAL)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,t_15);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JOSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_17;
    STRING * t_18;
    PMC *t_19;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_17 = GET_NCI_P(0);
    t_18 = (STRING *)GET_NCI_S(1);
    t_19 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_17) ? NULL : t_17,t_18,PMC_IS_NULL(t_19) ? NULL : t_19);
    
    
}
static void
pcf_v_JOS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_21;
    STRING * t_22;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_21 = GET_NCI_P(0);
    t_22 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_21) ? NULL : t_21,t_22);
    
    
}
static void
pcf_P_JOS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_24;
    STRING * t_25;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_24 = GET_NCI_P(0);
    t_25 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_24) ? NULL : t_24,t_25);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_27;
    INTVAL t_28;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_27 = GET_NCI_P(0);
    t_28 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_27) ? NULL : t_27,t_28);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_30;
    PMC *t_31;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_30 = GET_NCI_P(0);
    t_31 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_30) ? NULL : t_30,PMC_IS_NULL(t_31) ? NULL : t_31);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_33;
    PMC *t_34;
    STRING * t_35;
    Parrot_init_arg_nci(interp, &st, "PPS");
    t_33 = GET_NCI_P(0);
    t_34 = GET_NCI_P(1);
    t_35 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_33) ? NULL : t_33,PMC_IS_NULL(t_34) ? NULL : t_34,t_35);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_37;
    PMC *t_38;
    STRING * t_39;
    PMC *t_40;
    Parrot_init_arg_nci(interp, &st, "PPSP");
    t_37 = GET_NCI_P(0);
    t_38 = GET_NCI_P(1);
    t_39 = (STRING *)GET_NCI_S(2);
    t_40 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_37) ? NULL : t_37,PMC_IS_NULL(t_38) ? NULL : t_38,t_39,PMC_IS_NULL(t_40) ? NULL : t_40);
    
    
}
static void
pcf_v_JPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_42;
    PMC *t_43;
    PMC *t_44;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_42 = GET_NCI_P(0);
    t_43 = GET_NCI_P(1);
    t_44 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_42) ? NULL : t_42,PMC_IS_NULL(t_43) ? NULL : t_43,PMC_IS_NULL(t_44) ? NULL : t_44);
    
    
}
static void
pcf_v_JPIP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_46;
    INTVAL t_47;
    PMC *t_48;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_46 = GET_NCI_P(0);
    t_47 = (INTVAL)GET_NCI_I(1);
    t_48 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_46) ? NULL : t_46,t_47,PMC_IS_NULL(t_48) ? NULL : t_48);
    
    
}
static void
pcf_v_JPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_50;
    STRING * t_51;
    PMC *t_52;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_50 = GET_NCI_P(0);
    t_51 = (STRING *)GET_NCI_S(1);
    t_52 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_50) ? NULL : t_50,t_51,PMC_IS_NULL(t_52) ? NULL : t_52);
    
    
}
static void
pcf_v_JPNP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_54;
    FLOATVAL t_55;
    PMC *t_56;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_54 = GET_NCI_P(0);
    t_55 = (FLOATVAL)GET_NCI_N(1);
    t_56 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_54) ? NULL : t_54,t_55,PMC_IS_NULL(t_56) ? NULL : t_56);
    
    
}
static void
pcf_v_JPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_58;
    PMC *t_59;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_58 = GET_NCI_P(0);
    t_59 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_58) ? NULL : t_58,PMC_IS_NULL(t_59) ? NULL : t_59);
    
    
}
static void
pcf_v_JPI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_61;
    INTVAL t_62;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_61 = GET_NCI_P(0);
    t_62 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_61) ? NULL : t_61,t_62);
    
    
}
static void
pcf_v_JPS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_64;
    STRING * t_65;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_64 = GET_NCI_P(0);
    t_65 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_64) ? NULL : t_64,t_65);
    
    
}
static void
pcf_v_JPN(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_67;
    FLOATVAL t_68;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_67 = GET_NCI_P(0);
    t_68 = (FLOATVAL)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_67) ? NULL : t_67,t_68);
    
    
}
static void
pcf_P_JPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_70;
    PMC *t_71;
    PMC *t_72;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_70 = GET_NCI_P(0);
    t_71 = GET_NCI_P(1);
    t_72 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_70) ? NULL : t_70,PMC_IS_NULL(t_71) ? NULL : t_71,PMC_IS_NULL(t_72) ? NULL : t_72);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPIP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_74;
    INTVAL t_75;
    PMC *t_76;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_74 = GET_NCI_P(0);
    t_75 = (INTVAL)GET_NCI_I(1);
    t_76 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_74) ? NULL : t_74,t_75,PMC_IS_NULL(t_76) ? NULL : t_76);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPSP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_78;
    STRING * t_79;
    PMC *t_80;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_78 = GET_NCI_P(0);
    t_79 = (STRING *)GET_NCI_S(1);
    t_80 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_78) ? NULL : t_78,t_79,PMC_IS_NULL(t_80) ? NULL : t_80);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPNP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_82;
    FLOATVAL t_83;
    PMC *t_84;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_82 = GET_NCI_P(0);
    t_83 = (FLOATVAL)GET_NCI_N(1);
    t_84 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_82) ? NULL : t_82,t_83,PMC_IS_NULL(t_84) ? NULL : t_84);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JPP(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_86;
    PMC *t_87;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_86 = GET_NCI_P(0);
    t_87 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_86) ? NULL : t_86,PMC_IS_NULL(t_87) ? NULL : t_87);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JPS(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_89;
    STRING * t_90;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_89 = GET_NCI_P(0);
    t_90 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_89) ? NULL : t_89,t_90);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JPN(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_92;
    FLOATVAL t_93;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_92 = GET_NCI_P(0);
    t_93 = (FLOATVAL)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_92) ? NULL : t_92,t_93);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_95;
    Parrot_init_arg_nci(interp, &st, "P");
    t_95 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_95) ? NULL : t_95);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_97;
    Parrot_init_arg_nci(interp, &st, "P");
    t_97 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_97) ? NULL : t_97);
    
    
}
static void
pcf_i_JPi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_99;
    int t_100;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_99 = GET_NCI_P(0);
    t_100 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_99) ? NULL : t_99,t_100);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_102;
    int t_103;
    int t_104;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_102 = GET_NCI_P(0);
    t_103 = (int)GET_NCI_I(1);
    t_104 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_102) ? NULL : t_102,t_103,t_104);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_106;
    int t_107;
    int t_108;
    int t_109;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_106 = GET_NCI_P(0);
    t_107 = (int)GET_NCI_I(1);
    t_108 = (int)GET_NCI_I(2);
    t_109 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_106) ? NULL : t_106,t_107,t_108,t_109);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_111;
    char *t_112;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_111 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_112 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_111) ? NULL : t_111,t_112);
    set_nci_I(interp, &st, return_data);
    do { if (t_112) Parrot_str_free_cstring(t_112); } while (0);
}
static void
pcf_P_JOSSS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_114;
    STRING * t_115;
    STRING * t_116;
    STRING * t_117;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_114 = GET_NCI_P(0);
    t_115 = (STRING *)GET_NCI_S(1);
    t_116 = (STRING *)GET_NCI_S(2);
    t_117 = (STRING *)GET_NCI_S(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_114) ? NULL : t_114,t_115,t_116,t_117);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOSS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_119;
    STRING * t_120;
    STRING * t_121;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_119 = GET_NCI_P(0);
    t_120 = (STRING *)GET_NCI_S(1);
    t_121 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_119) ? NULL : t_119,t_120,t_121);
    
    
}
static void
pcf_S_JOI(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_123;
    INTVAL t_124;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_123 = GET_NCI_P(0);
    t_124 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_123) ? NULL : t_123,t_124);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_v_JOb(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_126;
    STRING *t_127;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_126 = GET_NCI_P(0);
    t_127 = GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_126) ? NULL : t_126,Buffer_bufstart(t_127));
    
    
}
static void
pcf_i_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_129;
    PMC *t_130;
    PMC *t_131;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_129 = GET_NCI_P(0);
    t_130 = GET_NCI_P(1);
    t_131 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_129) ? NULL : t_129,PMC_IS_NULL(t_130) ? NULL : t_130,PMC_IS_NULL(t_131) ? NULL : t_131);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_133;
    PMC *t_134;
    PMC *t_135;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_133 = GET_NCI_P(0);
    t_134 = GET_NCI_P(1);
    t_135 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_133) ? NULL : t_133,PMC_IS_NULL(t_134) ? NULL : t_134,PMC_IS_NULL(t_135) ? NULL : t_135);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOIPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_137;
    INTVAL t_138;
    PMC *t_139;
    PMC *t_140;
    Parrot_init_arg_nci(interp, &st, "PIP@");
    t_137 = GET_NCI_P(0);
    t_138 = (INTVAL)GET_NCI_I(1);
    t_139 = GET_NCI_P(2);
    t_140 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_137) ? NULL : t_137,t_138,PMC_IS_NULL(t_139) ? NULL : t_139,PMC_IS_NULL(t_140) ? NULL : t_140);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JO(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_142;
    Parrot_init_arg_nci(interp, &st, "P");
    t_142 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_142) ? NULL : t_142);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_144;
    PMC *t_145;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_144 = GET_NCI_P(0);
    t_145 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_144) ? NULL : t_144,PMC_IS_NULL(t_145) ? NULL : t_145);
    
    
}
static void
pcf_P_Ji(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    int t_147;
    Parrot_init_arg_nci(interp, &st, "I");
    t_147 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,t_147);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_J(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    
    Parrot_init_arg_nci(interp, &st, "");
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp);
    
    
}
static void
pcf_i_ip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_149;
    PMC *t_150;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_149 = (int)GET_NCI_I(0);
    t_150 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_149,(PMC_IS_NULL(t_150) ? NULL : VTABLE_get_pointer(interp, t_150)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_152;
    int t_153;
    PMC *t_154;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_152 = GET_NCI_P(0);
    t_153 = (int)GET_NCI_I(1);
    t_154 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_152) ? NULL : t_152,t_153,(PMC_IS_NULL(t_154) ? NULL : VTABLE_get_pointer(interp, t_154)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JpP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_156;
    PMC *t_157;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_156 = GET_NCI_P(0);
    t_157 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,(PMC_IS_NULL(t_156) ? NULL : VTABLE_get_pointer(interp, t_156)),PMC_IS_NULL(t_157) ? NULL : t_157);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_Jpii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_159;
    int t_160;
    int t_161;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_159 = GET_NCI_P(0);
    t_160 = (int)GET_NCI_I(1);
    t_161 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,(PMC_IS_NULL(t_159) ? NULL : VTABLE_get_pointer(interp, t_159)),t_160,t_161);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_162;
    Parrot_init_arg_nci(interp, &st, "P");
    t_162 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_162) ? NULL : VTABLE_get_pointer(interp, t_162)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_tp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_163;
    PMC *t_164;
    Parrot_init_arg_nci(interp, &st, "SP");
    {STRING * s= GET_NCI_S(0); t_163 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_164 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_163,(PMC_IS_NULL(t_164) ? NULL : VTABLE_get_pointer(interp, t_164)));
    set_nci_I(interp, &st, return_data);
    do { if (t_163) Parrot_str_free_cstring(t_163); } while (0);
}
static void
pcf_p_J(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    Parrot_init_arg_nci(interp, &st, "");
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_167;
    Parrot_init_arg_nci(interp, &st, "P");
    t_167 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,(PMC_IS_NULL(t_167) ? NULL : VTABLE_get_pointer(interp, t_167)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_t_J(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;
    Parrot_init_arg_nci(interp, &st, "");
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(interp);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_Jpti(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP, void *, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_170;
    char *t_171;
    int t_172;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_170 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_171 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_172 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(interp,(PMC_IS_NULL(t_170) ? NULL : VTABLE_get_pointer(interp, t_170)),t_171,t_172);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_171) Parrot_str_free_cstring(t_171); } while (0);
}
static void
pcf_t_p(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_173;
    Parrot_init_arg_nci(interp, &st, "P");
    t_173 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)((PMC_IS_NULL(t_173) ? NULL : VTABLE_get_pointer(interp, t_173)));
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_174;
    char *t_175;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_174 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_175 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)((PMC_IS_NULL(t_174) ? NULL : VTABLE_get_pointer(interp, t_174)),t_175);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_175) Parrot_str_free_cstring(t_175); } while (0);
}
static void
pcf_v_p(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_176;
    Parrot_init_arg_nci(interp, &st, "P");
    t_176 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_176) ? NULL : VTABLE_get_pointer(interp, t_176)));
    
    
}
static void
pcf_v_pit(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_177;
    int t_178;
    char *t_179;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_177 = GET_NCI_P(0);
    t_178 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_179 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_177) ? NULL : VTABLE_get_pointer(interp, t_177)),t_178,t_179);
    
    do { if (t_179) Parrot_str_free_cstring(t_179); } while (0);
}
static void
pcf_v_ptt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_180;
    char *t_181;
    char *t_182;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_180 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_181 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_182 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_180) ? NULL : VTABLE_get_pointer(interp, t_180)),t_181,t_182);
    
    do { if (t_181) Parrot_str_free_cstring(t_181); } while (0);
    do { if (t_182) Parrot_str_free_cstring(t_182); } while (0);
}
static void
pcf_v_Jtiiipt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, char *, int, int, int, void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    char *t_184;
    int t_185;
    int t_186;
    int t_187;
    PMC *t_188;
    char *t_189;
    Parrot_init_arg_nci(interp, &st, "SIIIPS");
    {STRING * s= GET_NCI_S(0); t_184 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_185 = (int)GET_NCI_I(1);
    t_186 = (int)GET_NCI_I(2);
    t_187 = (int)GET_NCI_I(3);
    t_188 = GET_NCI_P(4);
    {STRING * s= GET_NCI_S(5); t_189 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,t_184,t_185,t_186,t_187,(PMC_IS_NULL(t_188) ? NULL : VTABLE_get_pointer(interp, t_188)),t_189);
    
    do { if (t_184) Parrot_str_free_cstring(t_184); } while (0);
    do { if (t_189) Parrot_str_free_cstring(t_189); } while (0);
}
static void
pcf_p_JttPP(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, char *, char *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_191;
    char *t_192;
    PMC *t_193;
    PMC *t_194;
    Parrot_init_arg_nci(interp, &st, "SSPP");
    {STRING * s= GET_NCI_S(0); t_191 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_192 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_193 = GET_NCI_P(2);
    t_194 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_191,t_192,PMC_IS_NULL(t_193) ? NULL : t_193,PMC_IS_NULL(t_194) ? NULL : t_194);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_191) Parrot_str_free_cstring(t_191); } while (0);
    do { if (t_192) Parrot_str_free_cstring(t_192); } while (0);
}
static void
pcf_P_Jtpi(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, char *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    char *t_196;
    PMC *t_197;
    int t_198;
    Parrot_init_arg_nci(interp, &st, "SPI");
    {STRING * s= GET_NCI_S(0); t_196 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_197 = GET_NCI_P(1);
    t_198 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,t_196,(PMC_IS_NULL(t_197) ? NULL : VTABLE_get_pointer(interp, t_197)),t_198);
    set_nci_P(interp, &st, return_data);
    do { if (t_196) Parrot_str_free_cstring(t_196); } while (0);
}
static void
pcf_v_JpPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_204;
    PMC *t_205;
    PMC *t_206;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_204 = GET_NCI_P(0);
    t_205 = GET_NCI_P(1);
    t_206 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,(PMC_IS_NULL(t_204) ? NULL : VTABLE_get_pointer(interp, t_204)),PMC_IS_NULL(t_205) ? NULL : t_205,PMC_IS_NULL(t_206) ? NULL : t_206);
    
    
}
static void
pcf_v_pt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_207;
    char *t_208;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_207 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_208 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_207) ? NULL : VTABLE_get_pointer(interp, t_207)),t_208);
    
    do { if (t_208) Parrot_str_free_cstring(t_208); } while (0);
}
static void
pcf_v_Jpt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_210;
    char *t_211;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_210 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_211 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,(PMC_IS_NULL(t_210) ? NULL : VTABLE_get_pointer(interp, t_210)),t_211);
    
    do { if (t_211) Parrot_str_free_cstring(t_211); } while (0);
}
static void
pcf_v_(PARROT_INTERP, PMC *self)
{
    void (*pointer)(void);
    void *orig_func;
    
    
    
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (void (*)(void))D2FPTR(orig_func);
     (void)(*pointer)();
    
    
}
static void
pcf_v_Jiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, int, int, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_213;
    int t_214;
    int t_215;
    PMC *t_216;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_213 = (int)GET_NCI_I(0);
    t_214 = (int)GET_NCI_I(1);
    t_215 = (int)GET_NCI_I(2);
    t_216 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,t_213,t_214,t_215,(PMC_IS_NULL(t_216) ? NULL : VTABLE_get_pointer(interp, t_216)));
    
    
}
static void
pcf_v_i(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_217;
    Parrot_init_arg_nci(interp, &st, "I");
    t_217 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_217);
    
    
}
static void
pcf_v_ii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_218;
    int t_219;
    Parrot_init_arg_nci(interp, &st, "II");
    t_218 = (int)GET_NCI_I(0);
    t_219 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_218,t_219);
    
    
}
static void
pcf_v_illllllll(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, long, long, long, long, long, long, long, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_220;
    long t_221;
    long t_222;
    long t_223;
    long t_224;
    long t_225;
    long t_226;
    long t_227;
    long t_228;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIII");
    t_220 = (int)GET_NCI_I(0);
    t_221 = (long)GET_NCI_I(1);
    t_222 = (long)GET_NCI_I(2);
    t_223 = (long)GET_NCI_I(3);
    t_224 = (long)GET_NCI_I(4);
    t_225 = (long)GET_NCI_I(5);
    t_226 = (long)GET_NCI_I(6);
    t_227 = (long)GET_NCI_I(7);
    t_228 = (long)GET_NCI_I(8);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_220,t_221,t_222,t_223,t_224,t_225,t_226,t_227,t_228);
    
    
}
static void
pcf_v_l(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(long);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    long t_229;
    Parrot_init_arg_nci(interp, &st, "I");
    t_229 = (long)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_229);
    
    
}
static void
pcf_v_pbip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_230;
    STRING *t_231;
    int t_232;
    PMC *t_233;
    Parrot_init_arg_nci(interp, &st, "PSIP");
    t_230 = GET_NCI_P(0);
    t_231 = GET_NCI_S(1);
    t_232 = (int)GET_NCI_I(2);
    t_233 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_230) ? NULL : VTABLE_get_pointer(interp, t_230)),Buffer_bufstart(t_231),t_232,(PMC_IS_NULL(t_233) ? NULL : VTABLE_get_pointer(interp, t_233)));
    
    
}
static void
pcf_v_pi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_234;
    int t_235;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_234 = GET_NCI_P(0);
    t_235 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_234) ? NULL : VTABLE_get_pointer(interp, t_234)),t_235);
    
    
}
static void
pcf_v_piiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_236;
    int t_237;
    int t_238;
    int t_239;
    int t_240;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_236 = GET_NCI_P(0);
    t_237 = (int)GET_NCI_I(1);
    t_238 = (int)GET_NCI_I(2);
    t_239 = (int)GET_NCI_I(3);
    t_240 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_236) ? NULL : VTABLE_get_pointer(interp, t_236)),t_237,t_238,t_239,t_240);
    
    
}
static void
pcf_v_pl(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_241;
    long t_242;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_241 = GET_NCI_P(0);
    t_242 = (long)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_241) ? NULL : VTABLE_get_pointer(interp, t_241)),t_242);
    
    
}
static void
pcf_v_pp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_243;
    PMC *t_244;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_243 = GET_NCI_P(0);
    t_244 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_243) ? NULL : VTABLE_get_pointer(interp, t_243)),(PMC_IS_NULL(t_244) ? NULL : VTABLE_get_pointer(interp, t_244)));
    
    
}
static void
pcf_i_JPP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_246;
    PMC *t_247;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_246 = GET_NCI_P(0);
    t_247 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_246) ? NULL : t_246,PMC_IS_NULL(t_247) ? NULL : t_247);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_249;
    Parrot_init_arg_nci(interp, &st, "P");
    t_249 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_249) ? NULL : t_249);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_251;
    PMC *t_252;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_251 = GET_NCI_P(0);
    t_252 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_251) ? NULL : t_251,PMC_IS_NULL(t_252) ? NULL : t_252);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JO(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_254;
    Parrot_init_arg_nci(interp, &st, "P");
    t_254 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_254) ? NULL : t_254);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_P(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_255;
    Parrot_init_arg_nci(interp, &st, "P");
    t_255 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_IS_NULL(t_255) ? NULL : t_255);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_257;
    PMC *t_258;
    PMC *t_259;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_257 = GET_NCI_P(0);
    t_258 = GET_NCI_P(1);
    t_259 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_257) ? NULL : t_257,PMC_IS_NULL(t_258) ? NULL : t_258,PMC_IS_NULL(t_259) ? NULL : t_259);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_261;
    PMC *t_262;
    PMC *t_263;
    PMC *t_264;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_261 = GET_NCI_P(0);
    t_262 = GET_NCI_P(1);
    t_263 = GET_NCI_P(2);
    t_264 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_261) ? NULL : t_261,PMC_IS_NULL(t_262) ? NULL : t_262,PMC_IS_NULL(t_263) ? NULL : t_263,PMC_IS_NULL(t_264) ? NULL : t_264);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_266;
    PMC *t_267;
    PMC *t_268;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_266 = GET_NCI_P(0);
    t_267 = GET_NCI_P(1);
    t_268 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_266) ? NULL : t_266,PMC_IS_NULL(t_267) ? NULL : t_267,PMC_IS_NULL(t_268) ? NULL : t_268);
    
    
}
static void
pcf_v_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_270;
    PMC *t_271;
    PMC *t_272;
    PMC *t_273;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_270 = GET_NCI_P(0);
    t_271 = GET_NCI_P(1);
    t_272 = GET_NCI_P(2);
    t_273 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_270) ? NULL : t_270,PMC_IS_NULL(t_271) ? NULL : t_271,PMC_IS_NULL(t_272) ? NULL : t_272,PMC_IS_NULL(t_273) ? NULL : t_273);
    
    
}
static void
pcf_P_JOPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_275;
    PMC *t_276;
    PMC *t_277;
    PMC *t_278;
    PMC *t_279;
    Parrot_init_arg_nci(interp, &st, "PPPPP");
    t_275 = GET_NCI_P(0);
    t_276 = GET_NCI_P(1);
    t_277 = GET_NCI_P(2);
    t_278 = GET_NCI_P(3);
    t_279 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_275) ? NULL : t_275,PMC_IS_NULL(t_276) ? NULL : t_276,PMC_IS_NULL(t_277) ? NULL : t_277,PMC_IS_NULL(t_278) ? NULL : t_278,PMC_IS_NULL(t_279) ? NULL : t_279);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_281;
    PMC *t_282;
    PMC *t_283;
    PMC *t_284;
    PMC *t_285;
    PMC *t_286;
    Parrot_init_arg_nci(interp, &st, "PPPPPP");
    t_281 = GET_NCI_P(0);
    t_282 = GET_NCI_P(1);
    t_283 = GET_NCI_P(2);
    t_284 = GET_NCI_P(3);
    t_285 = GET_NCI_P(4);
    t_286 = GET_NCI_P(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_281) ? NULL : t_281,PMC_IS_NULL(t_282) ? NULL : t_282,PMC_IS_NULL(t_283) ? NULL : t_283,PMC_IS_NULL(t_284) ? NULL : t_284,PMC_IS_NULL(t_285) ? NULL : t_285,PMC_IS_NULL(t_286) ? NULL : t_286);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOSI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_288;
    STRING * t_289;
    INTVAL t_290;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_288 = GET_NCI_P(0);
    t_289 = (STRING *)GET_NCI_S(1);
    t_290 = (INTVAL)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_288) ? NULL : t_288,t_289,t_290);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOSII(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_292;
    STRING * t_293;
    INTVAL t_294;
    INTVAL t_295;
    Parrot_init_arg_nci(interp, &st, "PSII");
    t_292 = GET_NCI_P(0);
    t_293 = (STRING *)GET_NCI_S(1);
    t_294 = (INTVAL)GET_NCI_I(2);
    t_295 = (INTVAL)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_292) ? NULL : t_292,t_293,t_294,t_295);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_p_Ji(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_297;
    Parrot_init_arg_nci(interp, &st, "I");
    t_297 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_297);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jipp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_299;
    PMC *t_300;
    PMC *t_301;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_299 = (int)GET_NCI_I(0);
    t_300 = GET_NCI_P(1);
    t_301 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_299,(PMC_IS_NULL(t_300) ? NULL : VTABLE_get_pointer(interp, t_300)),(PMC_IS_NULL(t_301) ? NULL : VTABLE_get_pointer(interp, t_301)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jbip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_303;
    int t_304;
    PMC *t_305;
    Parrot_init_arg_nci(interp, &st, "SIP");
    t_303 = GET_NCI_S(0);
    t_304 = (int)GET_NCI_I(1);
    t_305 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,Buffer_bufstart(t_303),t_304,(PMC_IS_NULL(t_305) ? NULL : VTABLE_get_pointer(interp, t_305)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_v_Jp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_307;
    Parrot_init_arg_nci(interp, &st, "P");
    t_307 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,(PMC_IS_NULL(t_307) ? NULL : VTABLE_get_pointer(interp, t_307)));
    
    
}
static void
pcf_v_JS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    STRING * t_309;
    Parrot_init_arg_nci(interp, &st, "S");
    t_309 = (STRING *)GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,t_309);
    
    
}
static void
pcf_t_tt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_310;
    char *t_311;
    Parrot_init_arg_nci(interp, &st, "SS");
    {STRING * s= GET_NCI_S(0); t_310 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_311 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_310,t_311);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_310) Parrot_str_free_cstring(t_310); } while (0);
    do { if (t_311) Parrot_str_free_cstring(t_311); } while (0);
}
static void
pcf_I_JOt(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_313;
    char *t_314;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_313 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_314 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_313) ? NULL : t_313,t_314);
    set_nci_I(interp, &st, return_data);
    do { if (t_314) Parrot_str_free_cstring(t_314); } while (0);
}
static void
pcf_v_JOSI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_316;
    STRING * t_317;
    INTVAL t_318;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_316 = GET_NCI_P(0);
    t_317 = (STRING *)GET_NCI_S(1);
    t_318 = (INTVAL)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_316) ? NULL : t_316,t_317,t_318);
    
    
}
static void
pcf_S_JOi(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_320;
    int t_321;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_320 = GET_NCI_P(0);
    t_321 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_320) ? NULL : t_320,t_321);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_v_JOi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_323;
    int t_324;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_323 = GET_NCI_P(0);
    t_324 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_323) ? NULL : t_323,t_324);
    
    
}
static void
pcf_I_JO(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_326;
    Parrot_init_arg_nci(interp, &st, "P");
    t_326 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_326) ? NULL : t_326);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_N_JO(PARROT_INTERP, PMC *self)
{
    typedef FLOATVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    FLOATVAL return_data;
    PMC *t_328;
    Parrot_init_arg_nci(interp, &st, "P");
    t_328 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (FLOATVAL)(*pointer)(interp,PMC_IS_NULL(t_328) ? NULL : t_328);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_v_JON(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_330;
    FLOATVAL t_331;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_330 = GET_NCI_P(0);
    t_331 = (FLOATVAL)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_330) ? NULL : t_330,t_331);
    
    
}
static void
pcf_P_JOi(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_333;
    int t_334;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_333 = GET_NCI_P(0);
    t_334 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_333) ? NULL : t_333,t_334);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_336;
    INTVAL t_337;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_336 = GET_NCI_P(0);
    t_337 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_336) ? NULL : t_336,t_337);
    
    
}
static void
pcf_P_JOI(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_339;
    INTVAL t_340;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_339 = GET_NCI_P(0);
    t_340 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_339) ? NULL : t_339,t_340);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOIS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_342;
    INTVAL t_343;
    STRING * t_344;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_342 = GET_NCI_P(0);
    t_343 = (INTVAL)GET_NCI_I(1);
    t_344 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_342) ? NULL : t_342,t_343,t_344);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JOSP(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_346;
    STRING * t_347;
    PMC *t_348;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_346 = GET_NCI_P(0);
    t_347 = (STRING *)GET_NCI_S(1);
    t_348 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_346) ? NULL : t_346,t_347,PMC_IS_NULL(t_348) ? NULL : t_348);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_(PARROT_INTERP, PMC *self)
{
    int (*pointer)(void);
    void *orig_func;
    int return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (int (*)(void))D2FPTR(orig_func);
    return_data =  (int)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_352;
    STRING *t_353;
    int t_354;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_352 = (int)GET_NCI_I(0);
    t_353 = GET_NCI_S(1);
    t_354 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_352,Buffer_bufstart(t_353),t_354);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_lttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, char *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    long t_355;
    char *t_356;
    char *t_357;
    long t_358;
    Parrot_init_arg_nci(interp, &st, "ISSI");
    t_355 = (long)GET_NCI_I(0);
    {STRING * s= GET_NCI_S(1); t_356 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_357 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_358 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_355,t_356,t_357,t_358);
    set_nci_I(interp, &st, return_data);
    do { if (t_356) Parrot_str_free_cstring(t_356); } while (0);
    do { if (t_357) Parrot_str_free_cstring(t_357); } while (0);
}
static void
pcf_i_pip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_359;
    int t_360;
    PMC *t_361;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_359 = GET_NCI_P(0);
    t_360 = (int)GET_NCI_I(1);
    t_361 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_359) ? NULL : VTABLE_get_pointer(interp, t_359)),t_360,(PMC_IS_NULL(t_361) ? NULL : VTABLE_get_pointer(interp, t_361)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piS(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_362;
    int t_363;
    STRING * t_364;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_362 = GET_NCI_P(0);
    t_363 = (int)GET_NCI_I(1);
    t_364 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_362) ? NULL : VTABLE_get_pointer(interp, t_362)),t_363,t_364);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_S_i(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    int t_365;
    Parrot_init_arg_nci(interp, &st, "I");
    t_365 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(t_365);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_l_p(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_366;
    Parrot_init_arg_nci(interp, &st, "P");
    t_366 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)((PMC_IS_NULL(t_366) ? NULL : VTABLE_get_pointer(interp, t_366)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_p(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    PMC *t_367;
    Parrot_init_arg_nci(interp, &st, "P");
    t_367 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)((PMC_IS_NULL(t_367) ? NULL : VTABLE_get_pointer(interp, t_367)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_pi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_368;
    int t_369;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_368 = GET_NCI_P(0);
    t_369 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_368) ? NULL : VTABLE_get_pointer(interp, t_368)),t_369);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_p(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_370;
    Parrot_init_arg_nci(interp, &st, "P");
    t_370 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_370) ? NULL : VTABLE_get_pointer(interp, t_370)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_pttttt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, char *, char *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_371;
    char *t_372;
    char *t_373;
    char *t_374;
    char *t_375;
    char *t_376;
    Parrot_init_arg_nci(interp, &st, "PSSSSS");
    t_371 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_372 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_373 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_374 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_375 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(5); t_376 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_371) ? NULL : VTABLE_get_pointer(interp, t_371)),t_372,t_373,t_374,t_375,t_376);
    set_nci_I(interp, &st, return_data);
    do { if (t_372) Parrot_str_free_cstring(t_372); } while (0);
    do { if (t_373) Parrot_str_free_cstring(t_373); } while (0);
    do { if (t_374) Parrot_str_free_cstring(t_374); } while (0);
    do { if (t_375) Parrot_str_free_cstring(t_375); } while (0);
    do { if (t_376) Parrot_str_free_cstring(t_376); } while (0);
}
static void
pcf_c_pttt(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, char *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    PMC *t_377;
    char *t_378;
    char *t_379;
    char *t_380;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_377 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_378 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_379 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_380 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)((PMC_IS_NULL(t_377) ? NULL : VTABLE_get_pointer(interp, t_377)),t_378,t_379,t_380);
    set_nci_I(interp, &st, return_data);
    do { if (t_378) Parrot_str_free_cstring(t_378); } while (0);
    do { if (t_379) Parrot_str_free_cstring(t_379); } while (0);
    do { if (t_380) Parrot_str_free_cstring(t_380); } while (0);
}
static void
pcf_p_pttttiti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, char *, char *, int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_381;
    char *t_382;
    char *t_383;
    char *t_384;
    char *t_385;
    int t_386;
    char *t_387;
    int t_388;
    Parrot_init_arg_nci(interp, &st, "PSSSSISI");
    t_381 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_382 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_383 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_384 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_385 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_386 = (int)GET_NCI_I(5);
    {STRING * s= GET_NCI_S(6); t_387 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_388 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_381) ? NULL : VTABLE_get_pointer(interp, t_381)),t_382,t_383,t_384,t_385,t_386,t_387,t_388);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_382) Parrot_str_free_cstring(t_382); } while (0);
    do { if (t_383) Parrot_str_free_cstring(t_383); } while (0);
    do { if (t_384) Parrot_str_free_cstring(t_384); } while (0);
    do { if (t_385) Parrot_str_free_cstring(t_385); } while (0);
    do { if (t_387) Parrot_str_free_cstring(t_387); } while (0);
}
static void
pcf_i_pt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_389;
    char *t_390;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_389 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_390 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_389) ? NULL : VTABLE_get_pointer(interp, t_389)),t_390);
    set_nci_I(interp, &st, return_data);
    do { if (t_390) Parrot_str_free_cstring(t_390); } while (0);
}
static void
pcf_i_ptl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_391;
    char *t_392;
    long t_393;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_391 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_392 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_393 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_391) ? NULL : VTABLE_get_pointer(interp, t_391)),t_392,t_393);
    set_nci_I(interp, &st, return_data);
    do { if (t_392) Parrot_str_free_cstring(t_392); } while (0);
}
static void
pcf_i_pi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_394;
    int t_395;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_394 = GET_NCI_P(0);
    t_395 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_394) ? NULL : VTABLE_get_pointer(interp, t_394)),t_395);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_396;
    long t_397;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_396 = GET_NCI_P(0);
    t_397 = (long)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_396) ? NULL : VTABLE_get_pointer(interp, t_396)),t_397);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_(PARROT_INTERP, PMC *self)
{
    long (*pointer)(void);
    void *orig_func;
    long return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (long (*)(void))D2FPTR(orig_func);
    return_data =  (long)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_pt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_398;
    char *t_399;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_398 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_399 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_398) ? NULL : VTABLE_get_pointer(interp, t_398)),t_399);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_399) Parrot_str_free_cstring(t_399); } while (0);
}
static void
pcf_p_ptt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_400;
    char *t_401;
    char *t_402;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_400 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_401 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_402 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_400) ? NULL : VTABLE_get_pointer(interp, t_400)),t_401,t_402);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_401) Parrot_str_free_cstring(t_401); } while (0);
    do { if (t_402) Parrot_str_free_cstring(t_402); } while (0);
}
static void
pcf_i_pit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_403;
    int t_404;
    char *t_405;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_403 = GET_NCI_P(0);
    t_404 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_405 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_403) ? NULL : VTABLE_get_pointer(interp, t_403)),t_404,t_405);
    set_nci_I(interp, &st, return_data);
    do { if (t_405) Parrot_str_free_cstring(t_405); } while (0);
}
static void
pcf_p_pp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_406;
    PMC *t_407;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_406 = GET_NCI_P(0);
    t_407 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_406) ? NULL : VTABLE_get_pointer(interp, t_406)),(PMC_IS_NULL(t_407) ? NULL : VTABLE_get_pointer(interp, t_407)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_l_ttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(char *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    char *t_408;
    char *t_409;
    long t_410;
    Parrot_init_arg_nci(interp, &st, "SSI");
    {STRING * s= GET_NCI_S(0); t_408 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_409 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_410 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_408,t_409,t_410);
    set_nci_I(interp, &st, return_data);
    do { if (t_408) Parrot_str_free_cstring(t_408); } while (0);
    do { if (t_409) Parrot_str_free_cstring(t_409); } while (0);
}
static void
pcf_l_pttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, char *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_411;
    char *t_412;
    char *t_413;
    long t_414;
    Parrot_init_arg_nci(interp, &st, "PSSI");
    t_411 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_412 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_413 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_414 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)((PMC_IS_NULL(t_411) ? NULL : VTABLE_get_pointer(interp, t_411)),t_412,t_413,t_414);
    set_nci_I(interp, &st, return_data);
    do { if (t_412) Parrot_str_free_cstring(t_412); } while (0);
    do { if (t_413) Parrot_str_free_cstring(t_413); } while (0);
}
static void
pcf_v_t(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    char *t_415;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_415 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_415);
    
    do { if (t_415) Parrot_str_free_cstring(t_415); } while (0);
}
static void
pcf_p_pttttitl(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, char *, char *, int, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_416;
    char *t_417;
    char *t_418;
    char *t_419;
    char *t_420;
    int t_421;
    char *t_422;
    long t_423;
    Parrot_init_arg_nci(interp, &st, "PSSSSISI");
    t_416 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_417 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_418 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_419 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_420 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_421 = (int)GET_NCI_I(5);
    {STRING * s= GET_NCI_S(6); t_422 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_423 = (long)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_416) ? NULL : VTABLE_get_pointer(interp, t_416)),t_417,t_418,t_419,t_420,t_421,t_422,t_423);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_417) Parrot_str_free_cstring(t_417); } while (0);
    do { if (t_418) Parrot_str_free_cstring(t_418); } while (0);
    do { if (t_419) Parrot_str_free_cstring(t_419); } while (0);
    do { if (t_420) Parrot_str_free_cstring(t_420); } while (0);
    do { if (t_422) Parrot_str_free_cstring(t_422); } while (0);
}
static void
pcf_i_pPtiiipi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, PMC *, char *, int, int, int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_434;
    PMC *t_435;
    char *t_436;
    int t_437;
    int t_438;
    int t_439;
    PMC *t_440;
    int t_441;
    Parrot_init_arg_nci(interp, &st, "PPSIIIPI");
    t_434 = GET_NCI_P(0);
    t_435 = GET_NCI_P(1);
    {STRING * s= GET_NCI_S(2); t_436 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_437 = (int)GET_NCI_I(3);
    t_438 = (int)GET_NCI_I(4);
    t_439 = (int)GET_NCI_I(5);
    t_440 = GET_NCI_P(6);
    t_441 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_434) ? NULL : VTABLE_get_pointer(interp, t_434)),PMC_IS_NULL(t_435) ? NULL : t_435,t_436,t_437,t_438,t_439,(PMC_IS_NULL(t_440) ? NULL : VTABLE_get_pointer(interp, t_440)),t_441);
    set_nci_I(interp, &st, return_data);
    do { if (t_436) Parrot_str_free_cstring(t_436); } while (0);
}
static void
pcf_i_tpiibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *, int, int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_442;
    PMC *t_443;
    int t_444;
    int t_445;
    STRING *t_446;
    int t_447;
    Parrot_init_arg_nci(interp, &st, "SPIISI");
    {STRING * s= GET_NCI_S(0); t_442 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_443 = GET_NCI_P(1);
    t_444 = (int)GET_NCI_I(2);
    t_445 = (int)GET_NCI_I(3);
    t_446 = GET_NCI_S(4);
    t_447 = (int)GET_NCI_I(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_442,(PMC_IS_NULL(t_443) ? NULL : VTABLE_get_pointer(interp, t_443)),t_444,t_445,Buffer_bufstart(t_446),t_447);
    set_nci_I(interp, &st, return_data);
    do { if (t_442) Parrot_str_free_cstring(t_442); } while (0);
}
static void
pcf_p_ptippppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_448;
    char *t_449;
    int t_450;
    PMC *t_451;
    PMC *t_452;
    PMC *t_453;
    PMC *t_454;
    int t_455;
    Parrot_init_arg_nci(interp, &st, "PSIPPPPI");
    t_448 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_449 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_450 = (int)GET_NCI_I(2);
    t_451 = GET_NCI_P(3);
    t_452 = GET_NCI_P(4);
    t_453 = GET_NCI_P(5);
    t_454 = GET_NCI_P(6);
    t_455 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_448) ? NULL : VTABLE_get_pointer(interp, t_448)),t_449,t_450,(PMC_IS_NULL(t_451) ? NULL : VTABLE_get_pointer(interp, t_451)),(PMC_IS_NULL(t_452) ? NULL : VTABLE_get_pointer(interp, t_452)),(PMC_IS_NULL(t_453) ? NULL : VTABLE_get_pointer(interp, t_453)),(PMC_IS_NULL(t_454) ? NULL : VTABLE_get_pointer(interp, t_454)),t_455);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_449) Parrot_str_free_cstring(t_449); } while (0);
}
static void
pcf_p_pttip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_463;
    char *t_464;
    char *t_465;
    int t_466;
    PMC *t_467;
    Parrot_init_arg_nci(interp, &st, "PSSIP");
    t_463 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_464 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_465 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_466 = (int)GET_NCI_I(3);
    t_467 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_463) ? NULL : VTABLE_get_pointer(interp, t_463)),t_464,t_465,t_466,(PMC_IS_NULL(t_467) ? NULL : VTABLE_get_pointer(interp, t_467)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_464) Parrot_str_free_cstring(t_464); } while (0);
    do { if (t_465) Parrot_str_free_cstring(t_465); } while (0);
}
static void
pcf_p_ptipppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_468;
    char *t_469;
    int t_470;
    PMC *t_471;
    PMC *t_472;
    PMC *t_473;
    int t_474;
    Parrot_init_arg_nci(interp, &st, "PSIPPPI");
    t_468 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_469 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_470 = (int)GET_NCI_I(2);
    t_471 = GET_NCI_P(3);
    t_472 = GET_NCI_P(4);
    t_473 = GET_NCI_P(5);
    t_474 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_468) ? NULL : VTABLE_get_pointer(interp, t_468)),t_469,t_470,(PMC_IS_NULL(t_471) ? NULL : VTABLE_get_pointer(interp, t_471)),(PMC_IS_NULL(t_472) ? NULL : VTABLE_get_pointer(interp, t_472)),(PMC_IS_NULL(t_473) ? NULL : VTABLE_get_pointer(interp, t_473)),t_474);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_469) Parrot_str_free_cstring(t_469); } while (0);
}
static void
pcf_p_ppP(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_475;
    PMC *t_476;
    PMC *t_477;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_475 = GET_NCI_P(0);
    t_476 = GET_NCI_P(1);
    t_477 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_475) ? NULL : VTABLE_get_pointer(interp, t_475)),(PMC_IS_NULL(t_476) ? NULL : VTABLE_get_pointer(interp, t_476)),PMC_IS_NULL(t_477) ? NULL : t_477);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiil(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_478;
    int t_479;
    int t_480;
    long t_481;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_478 = (int)GET_NCI_I(0);
    t_479 = (int)GET_NCI_I(1);
    t_480 = (int)GET_NCI_I(2);
    t_481 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_478,t_479,t_480,t_481);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_ppl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_482;
    PMC *t_483;
    long t_484;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_482 = GET_NCI_P(0);
    t_483 = GET_NCI_P(1);
    t_484 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_482) ? NULL : VTABLE_get_pointer(interp, t_482)),(PMC_IS_NULL(t_483) ? NULL : VTABLE_get_pointer(interp, t_483)),t_484);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_pip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_485;
    int t_486;
    PMC *t_487;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_485 = GET_NCI_P(0);
    t_486 = (int)GET_NCI_I(1);
    t_487 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_485) ? NULL : VTABLE_get_pointer(interp, t_485)),t_486,(PMC_IS_NULL(t_487) ? NULL : VTABLE_get_pointer(interp, t_487)));
    
    
}
static void
pcf_p_pti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_488;
    char *t_489;
    int t_490;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_488 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_489 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_490 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_488) ? NULL : VTABLE_get_pointer(interp, t_488)),t_489,t_490);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_489) Parrot_str_free_cstring(t_489); } while (0);
}
static void
pcf_i_ppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_491;
    PMC *t_492;
    PMC *t_493;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_491 = GET_NCI_P(0);
    t_492 = GET_NCI_P(1);
    t_493 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_491) ? NULL : VTABLE_get_pointer(interp, t_491)),(PMC_IS_NULL(t_492) ? NULL : VTABLE_get_pointer(interp, t_492)),(PMC_IS_NULL(t_493) ? NULL : VTABLE_get_pointer(interp, t_493)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_ptii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_494;
    char *t_495;
    int t_496;
    int t_497;
    Parrot_init_arg_nci(interp, &st, "PSII");
    t_494 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_495 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_496 = (int)GET_NCI_I(2);
    t_497 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_494) ? NULL : VTABLE_get_pointer(interp, t_494)),t_495,t_496,t_497);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_495) Parrot_str_free_cstring(t_495); } while (0);
}
static void
pcf_p_ti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_498;
    int t_499;
    Parrot_init_arg_nci(interp, &st, "SI");
    {STRING * s= GET_NCI_S(0); t_498 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_499 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_498,t_499);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_498) Parrot_str_free_cstring(t_498); } while (0);
}
static void
pcf_p_ptp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_500;
    char *t_501;
    PMC *t_502;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_500 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_501 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_502 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_500) ? NULL : VTABLE_get_pointer(interp, t_500)),t_501,(PMC_IS_NULL(t_502) ? NULL : VTABLE_get_pointer(interp, t_502)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_501) Parrot_str_free_cstring(t_501); } while (0);
}
static void
pcf_c_(PARROT_INTERP, PMC *self)
{
    char (*pointer)(void);
    void *orig_func;
    char return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (char (*)(void))D2FPTR(orig_func);
    return_data =  (char)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_pi(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    PMC *t_507;
    int t_508;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_507 = GET_NCI_P(0);
    t_508 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)((PMC_IS_NULL(t_507) ? NULL : VTABLE_get_pointer(interp, t_507)),t_508);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_d_(PARROT_INTERP, PMC *self)
{
    double (*pointer)(void);
    void *orig_func;
    double return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (double (*)(void))D2FPTR(orig_func);
    return_data =  (double)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_d_d(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(double);
    func_t pointer;
    void *orig_func;
    call_state st;
    double return_data;
    double t_509;
    Parrot_init_arg_nci(interp, &st, "N");
    t_509 = (double)GET_NCI_N(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (double)(*pointer)(t_509);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_(PARROT_INTERP, PMC *self)
{
    float (*pointer)(void);
    void *orig_func;
    float return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (float (*)(void))D2FPTR(orig_func);
    return_data =  (float)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_ff(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(float, float);
    func_t pointer;
    void *orig_func;
    call_state st;
    float return_data;
    float t_510;
    float t_511;
    Parrot_init_arg_nci(interp, &st, "NN");
    t_510 = (float)GET_NCI_N(0);
    t_511 = (float)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (float)(*pointer)(t_510,t_511);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_is(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(int, short);
    func_t pointer;
    void *orig_func;
    call_state st;
    float return_data;
    int t_512;
    short t_513;
    Parrot_init_arg_nci(interp, &st, "II");
    t_512 = (int)GET_NCI_I(0);
    t_513 = (short)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (float)(*pointer)(t_512,t_513);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_i_b(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    STRING *t_514;
    Parrot_init_arg_nci(interp, &st, "S");
    t_514 = GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(Buffer_bufstart(t_514));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_d(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(double);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    double t_515;
    Parrot_init_arg_nci(interp, &st, "N");
    t_515 = (double)GET_NCI_N(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_515);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_516;
    Parrot_init_arg_nci(interp, &st, "I");
    t_516 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_516);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_517;
    int t_518;
    Parrot_init_arg_nci(interp, &st, "II");
    t_517 = (int)GET_NCI_I(0);
    t_518 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_517,t_518);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_526;
    int t_527;
    int t_528;
    int t_529;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_526 = (int)GET_NCI_I(0);
    t_527 = (int)GET_NCI_I(1);
    t_528 = (int)GET_NCI_I(2);
    t_529 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_526,t_527,t_528,t_529);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_530;
    int t_531;
    int t_532;
    long t_533;
    short t_534;
    PMC *t_535;
    Parrot_init_arg_nci(interp, &st, "IIIIIP");
    t_530 = (int)GET_NCI_I(0);
    t_531 = (int)GET_NCI_I(1);
    t_532 = (int)GET_NCI_I(2);
    t_533 = (long)GET_NCI_I(3);
    t_534 = (short)GET_NCI_I(4);
    t_535 = GET_NCI_P(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_530,t_531,t_532,t_533,t_534,(PMC_IS_NULL(t_535) ? NULL : VTABLE_get_pointer(interp, t_535)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_536;
    int t_537;
    long t_538;
    Parrot_init_arg_nci(interp, &st, "III");
    t_536 = (int)GET_NCI_I(0);
    t_537 = (int)GET_NCI_I(1);
    t_538 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_536,t_537,t_538);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_539;
    int t_540;
    long t_541;
    int t_542;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_539 = (int)GET_NCI_I(0);
    t_540 = (int)GET_NCI_I(1);
    t_541 = (long)GET_NCI_I(2);
    t_542 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_539,t_540,t_541,t_542);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_543;
    int t_544;
    PMC *t_545;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_543 = (int)GET_NCI_I(0);
    t_544 = (int)GET_NCI_I(1);
    t_545 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_543,t_544,(PMC_IS_NULL(t_545) ? NULL : VTABLE_get_pointer(interp, t_545)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_546;
    int t_547;
    char *t_548;
    Parrot_init_arg_nci(interp, &st, "IIS");
    t_546 = (int)GET_NCI_I(0);
    t_547 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_548 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_546,t_547,t_548);
    set_nci_I(interp, &st, return_data);
    do { if (t_548) Parrot_str_free_cstring(t_548); } while (0);
}
static void
pcf_i_iiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_549;
    int t_550;
    char *t_551;
    int t_552;
    Parrot_init_arg_nci(interp, &st, "IISI");
    t_549 = (int)GET_NCI_I(0);
    t_550 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_551 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_552 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_549,t_550,t_551,t_552);
    set_nci_I(interp, &st, return_data);
    do { if (t_551) Parrot_str_free_cstring(t_551); } while (0);
}
static void
pcf_i_ilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_553;
    long t_554;
    short t_555;
    PMC *t_556;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_553 = (int)GET_NCI_I(0);
    t_554 = (long)GET_NCI_I(1);
    t_555 = (short)GET_NCI_I(2);
    t_556 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_553,t_554,t_555,(PMC_IS_NULL(t_556) ? NULL : VTABLE_get_pointer(interp, t_556)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_557;
    char *t_558;
    int t_559;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_557 = (int)GET_NCI_I(0);
    {STRING * s= GET_NCI_S(1); t_558 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_559 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_557,t_558,t_559);
    set_nci_I(interp, &st, return_data);
    do { if (t_558) Parrot_str_free_cstring(t_558); } while (0);
}
static void
pcf_i_l(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_560;
    Parrot_init_arg_nci(interp, &st, "I");
    t_560 = (long)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_560);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_li(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_561;
    int t_562;
    Parrot_init_arg_nci(interp, &st, "II");
    t_561 = (long)GET_NCI_I(0);
    t_562 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_561,t_562);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_563;
    PMC *t_564;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_563 = (long)GET_NCI_I(0);
    t_564 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_563,(PMC_IS_NULL(t_564) ? NULL : VTABLE_get_pointer(interp, t_564)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_565;
    short t_566;
    PMC *t_567;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_565 = (long)GET_NCI_I(0);
    t_566 = (short)GET_NCI_I(1);
    t_567 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_565,t_566,(PMC_IS_NULL(t_567) ? NULL : VTABLE_get_pointer(interp, t_567)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pb(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_591;
    STRING *t_592;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_591 = GET_NCI_P(0);
    t_592 = GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_591) ? NULL : VTABLE_get_pointer(interp, t_591)),Buffer_bufstart(t_592));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_593;
    int t_594;
    int t_595;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_593 = GET_NCI_P(0);
    t_594 = (int)GET_NCI_I(1);
    t_595 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_593) ? NULL : VTABLE_get_pointer(interp, t_593)),t_594,t_595);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_605;
    int t_606;
    int t_607;
    int t_608;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_605 = GET_NCI_P(0);
    t_606 = (int)GET_NCI_I(1);
    t_607 = (int)GET_NCI_I(2);
    t_608 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_605) ? NULL : VTABLE_get_pointer(interp, t_605)),t_606,t_607,t_608);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_609;
    int t_610;
    int t_611;
    int t_612;
    int t_613;
    int t_614;
    int t_615;
    Parrot_init_arg_nci(interp, &st, "PIIIIII");
    t_609 = GET_NCI_P(0);
    t_610 = (int)GET_NCI_I(1);
    t_611 = (int)GET_NCI_I(2);
    t_612 = (int)GET_NCI_I(3);
    t_613 = (int)GET_NCI_I(4);
    t_614 = (int)GET_NCI_I(5);
    t_615 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_609) ? NULL : VTABLE_get_pointer(interp, t_609)),t_610,t_611,t_612,t_613,t_614,t_615);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_616;
    int t_617;
    int t_618;
    int t_619;
    long t_620;
    short t_621;
    PMC *t_622;
    Parrot_init_arg_nci(interp, &st, "PIIIIIP");
    t_616 = GET_NCI_P(0);
    t_617 = (int)GET_NCI_I(1);
    t_618 = (int)GET_NCI_I(2);
    t_619 = (int)GET_NCI_I(3);
    t_620 = (long)GET_NCI_I(4);
    t_621 = (short)GET_NCI_I(5);
    t_622 = GET_NCI_P(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_616) ? NULL : VTABLE_get_pointer(interp, t_616)),t_617,t_618,t_619,t_620,t_621,(PMC_IS_NULL(t_622) ? NULL : VTABLE_get_pointer(interp, t_622)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_623;
    int t_624;
    int t_625;
    long t_626;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_623 = GET_NCI_P(0);
    t_624 = (int)GET_NCI_I(1);
    t_625 = (int)GET_NCI_I(2);
    t_626 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_623) ? NULL : VTABLE_get_pointer(interp, t_623)),t_624,t_625,t_626);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_627;
    int t_628;
    int t_629;
    long t_630;
    int t_631;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_627 = GET_NCI_P(0);
    t_628 = (int)GET_NCI_I(1);
    t_629 = (int)GET_NCI_I(2);
    t_630 = (long)GET_NCI_I(3);
    t_631 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_627) ? NULL : VTABLE_get_pointer(interp, t_627)),t_628,t_629,t_630,t_631);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_632;
    int t_633;
    int t_634;
    char *t_635;
    Parrot_init_arg_nci(interp, &st, "PIIS");
    t_632 = GET_NCI_P(0);
    t_633 = (int)GET_NCI_I(1);
    t_634 = (int)GET_NCI_I(2);
    {STRING * s= GET_NCI_S(3); t_635 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_632) ? NULL : VTABLE_get_pointer(interp, t_632)),t_633,t_634,t_635);
    set_nci_I(interp, &st, return_data);
    do { if (t_635) Parrot_str_free_cstring(t_635); } while (0);
}
static void
pcf_i_piiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_636;
    int t_637;
    int t_638;
    char *t_639;
    int t_640;
    Parrot_init_arg_nci(interp, &st, "PIISI");
    t_636 = GET_NCI_P(0);
    t_637 = (int)GET_NCI_I(1);
    t_638 = (int)GET_NCI_I(2);
    {STRING * s= GET_NCI_S(3); t_639 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_640 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_636) ? NULL : VTABLE_get_pointer(interp, t_636)),t_637,t_638,t_639,t_640);
    set_nci_I(interp, &st, return_data);
    do { if (t_639) Parrot_str_free_cstring(t_639); } while (0);
}
static void
pcf_i_pilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_641;
    int t_642;
    long t_643;
    short t_644;
    PMC *t_645;
    Parrot_init_arg_nci(interp, &st, "PIIIP");
    t_641 = GET_NCI_P(0);
    t_642 = (int)GET_NCI_I(1);
    t_643 = (long)GET_NCI_I(2);
    t_644 = (short)GET_NCI_I(3);
    t_645 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_641) ? NULL : VTABLE_get_pointer(interp, t_641)),t_642,t_643,t_644,(PMC_IS_NULL(t_645) ? NULL : VTABLE_get_pointer(interp, t_645)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pli(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_646;
    long t_647;
    int t_648;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_646 = GET_NCI_P(0);
    t_647 = (long)GET_NCI_I(1);
    t_648 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_646) ? NULL : VTABLE_get_pointer(interp, t_646)),t_647,t_648);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_649;
    long t_650;
    long t_651;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_649 = GET_NCI_P(0);
    t_650 = (long)GET_NCI_I(1);
    t_651 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_649) ? NULL : VTABLE_get_pointer(interp, t_649)),t_650,t_651);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pllllllll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long, long, long, long, long, long, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_652;
    long t_653;
    long t_654;
    long t_655;
    long t_656;
    long t_657;
    long t_658;
    long t_659;
    long t_660;
    Parrot_init_arg_nci(interp, &st, "PIIIIIIII");
    t_652 = GET_NCI_P(0);
    t_653 = (long)GET_NCI_I(1);
    t_654 = (long)GET_NCI_I(2);
    t_655 = (long)GET_NCI_I(3);
    t_656 = (long)GET_NCI_I(4);
    t_657 = (long)GET_NCI_I(5);
    t_658 = (long)GET_NCI_I(6);
    t_659 = (long)GET_NCI_I(7);
    t_660 = (long)GET_NCI_I(8);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_652) ? NULL : VTABLE_get_pointer(interp, t_652)),t_653,t_654,t_655,t_656,t_657,t_658,t_659,t_660);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_661;
    long t_662;
    PMC *t_663;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_661 = GET_NCI_P(0);
    t_662 = (long)GET_NCI_I(1);
    t_663 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_661) ? NULL : VTABLE_get_pointer(interp, t_661)),t_662,(PMC_IS_NULL(t_663) ? NULL : VTABLE_get_pointer(interp, t_663)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_664;
    long t_665;
    short t_666;
    PMC *t_667;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_664 = GET_NCI_P(0);
    t_665 = (long)GET_NCI_I(1);
    t_666 = (short)GET_NCI_I(2);
    t_667 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_664) ? NULL : VTABLE_get_pointer(interp, t_664)),t_665,t_666,(PMC_IS_NULL(t_667) ? NULL : VTABLE_get_pointer(interp, t_667)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_668;
    PMC *t_669;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_668 = GET_NCI_P(0);
    t_669 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_668) ? NULL : VTABLE_get_pointer(interp, t_668)),(PMC_IS_NULL(t_669) ? NULL : VTABLE_get_pointer(interp, t_669)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_670;
    PMC *t_671;
    int t_672;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_670 = GET_NCI_P(0);
    t_671 = GET_NCI_P(1);
    t_672 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_670) ? NULL : VTABLE_get_pointer(interp, t_670)),(PMC_IS_NULL(t_671) ? NULL : VTABLE_get_pointer(interp, t_671)),t_672);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int, int, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_673;
    PMC *t_674;
    int t_675;
    int t_676;
    int t_677;
    int t_678;
    int t_679;
    int t_680;
    int t_681;
    int t_682;
    Parrot_init_arg_nci(interp, &st, "PPIIIIIIII");
    t_673 = GET_NCI_P(0);
    t_674 = GET_NCI_P(1);
    t_675 = (int)GET_NCI_I(2);
    t_676 = (int)GET_NCI_I(3);
    t_677 = (int)GET_NCI_I(4);
    t_678 = (int)GET_NCI_I(5);
    t_679 = (int)GET_NCI_I(6);
    t_680 = (int)GET_NCI_I(7);
    t_681 = (int)GET_NCI_I(8);
    t_682 = (int)GET_NCI_I(9);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_673) ? NULL : VTABLE_get_pointer(interp, t_673)),(PMC_IS_NULL(t_674) ? NULL : VTABLE_get_pointer(interp, t_674)),t_675,t_676,t_677,t_678,t_679,t_680,t_681,t_682);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_683;
    PMC *t_684;
    PMC *t_685;
    PMC *t_686;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_683 = GET_NCI_P(0);
    t_684 = GET_NCI_P(1);
    t_685 = GET_NCI_P(2);
    t_686 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_683) ? NULL : VTABLE_get_pointer(interp, t_683)),(PMC_IS_NULL(t_684) ? NULL : VTABLE_get_pointer(interp, t_684)),(PMC_IS_NULL(t_685) ? NULL : VTABLE_get_pointer(interp, t_685)),(PMC_IS_NULL(t_686) ? NULL : VTABLE_get_pointer(interp, t_686)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_psp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_687;
    short t_688;
    PMC *t_689;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_687 = GET_NCI_P(0);
    t_688 = (short)GET_NCI_I(1);
    t_689 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_687) ? NULL : VTABLE_get_pointer(interp, t_687)),t_688,(PMC_IS_NULL(t_689) ? NULL : VTABLE_get_pointer(interp, t_689)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_690;
    char *t_691;
    int t_692;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_690 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_691 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_692 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_690) ? NULL : VTABLE_get_pointer(interp, t_690)),t_691,t_692);
    set_nci_I(interp, &st, return_data);
    do { if (t_691) Parrot_str_free_cstring(t_691); } while (0);
}
static void
pcf_i_pitl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_693;
    int t_694;
    char *t_695;
    long t_696;
    Parrot_init_arg_nci(interp, &st, "PISI");
    t_693 = GET_NCI_P(0);
    t_694 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_695 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_696 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_693) ? NULL : VTABLE_get_pointer(interp, t_693)),t_694,t_695,t_696);
    set_nci_I(interp, &st, return_data);
    do { if (t_695) Parrot_str_free_cstring(t_695); } while (0);
}
static void
pcf_i_s(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_697;
    Parrot_init_arg_nci(interp, &st, "I");
    t_697 = (short)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_697);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_sp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_705;
    PMC *t_706;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_705 = (short)GET_NCI_I(0);
    t_706 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_705,(PMC_IS_NULL(t_706) ? NULL : VTABLE_get_pointer(interp, t_706)));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_sss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_707;
    short t_708;
    short t_709;
    Parrot_init_arg_nci(interp, &st, "III");
    t_707 = (short)GET_NCI_I(0);
    t_708 = (short)GET_NCI_I(1);
    t_709 = (short)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_707,t_708,t_709);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ssss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short, short);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_710;
    short t_711;
    short t_712;
    short t_713;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_710 = (short)GET_NCI_I(0);
    t_711 = (short)GET_NCI_I(1);
    t_712 = (short)GET_NCI_I(2);
    t_713 = (short)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_710,t_711,t_712,t_713);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_t(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_714;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_714 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_714);
    set_nci_I(interp, &st, return_data);
    do { if (t_714) Parrot_str_free_cstring(t_714); } while (0);
}
static void
pcf_i_ti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_715;
    int t_716;
    Parrot_init_arg_nci(interp, &st, "SI");
    {STRING * s= GET_NCI_S(0); t_715 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_716 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_715,t_716);
    set_nci_I(interp, &st, return_data);
    do { if (t_715) Parrot_str_free_cstring(t_715); } while (0);
}
static void
pcf_l_ii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    int t_723;
    int t_724;
    Parrot_init_arg_nci(interp, &st, "II");
    t_723 = (int)GET_NCI_I(0);
    t_724 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_723,t_724);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pi(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_727;
    int t_728;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_727 = GET_NCI_P(0);
    t_728 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)((PMC_IS_NULL(t_727) ? NULL : VTABLE_get_pointer(interp, t_727)),t_728);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_729;
    int t_730;
    int t_731;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_729 = GET_NCI_P(0);
    t_730 = (int)GET_NCI_I(1);
    t_731 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)((PMC_IS_NULL(t_729) ? NULL : VTABLE_get_pointer(interp, t_729)),t_730,t_731);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_(PARROT_INTERP, PMC *self)
{
    void * (*pointer)(void);
    void *orig_func;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (void * (*)(void))D2FPTR(orig_func);
    return_data =  (void *)(*pointer)();
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_B(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *s_739;
    char *t_739;
    void** v_739 = (void **) &t_739;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_739 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL; s_739 = t_739;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(v_739);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (s_739) Parrot_str_free_cstring(s_739); } while (0);
}
static void
pcf_p_b(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_740;
    Parrot_init_arg_nci(interp, &st, "S");
    t_740 = GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(Buffer_bufstart(t_740));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_742;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_742 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_742);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_742) Parrot_str_free_cstring(t_742); } while (0);
}
static void
pcf_p_i(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_743;
    Parrot_init_arg_nci(interp, &st, "I");
    t_743 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_743);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_ii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_744;
    int t_745;
    Parrot_init_arg_nci(interp, &st, "II");
    t_744 = (int)GET_NCI_I(0);
    t_745 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_744,t_745);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_746;
    int t_747;
    int t_748;
    int t_749;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_746 = (int)GET_NCI_I(0);
    t_747 = (int)GET_NCI_I(1);
    t_748 = (int)GET_NCI_I(2);
    t_749 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_746,t_747,t_748,t_749);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_750;
    int t_751;
    int t_752;
    int t_753;
    int t_754;
    int t_755;
    Parrot_init_arg_nci(interp, &st, "IIIIII");
    t_750 = (int)GET_NCI_I(0);
    t_751 = (int)GET_NCI_I(1);
    t_752 = (int)GET_NCI_I(2);
    t_753 = (int)GET_NCI_I(3);
    t_754 = (int)GET_NCI_I(4);
    t_755 = (int)GET_NCI_I(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_750,t_751,t_752,t_753,t_754,t_755);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_756;
    int t_757;
    int t_758;
    int t_759;
    int t_760;
    int t_761;
    int t_762;
    int t_763;
    Parrot_init_arg_nci(interp, &st, "IIIIIIII");
    t_756 = (int)GET_NCI_I(0);
    t_757 = (int)GET_NCI_I(1);
    t_758 = (int)GET_NCI_I(2);
    t_759 = (int)GET_NCI_I(3);
    t_760 = (int)GET_NCI_I(4);
    t_761 = (int)GET_NCI_I(5);
    t_762 = (int)GET_NCI_I(6);
    t_763 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_756,t_757,t_758,t_759,t_760,t_761,t_762,t_763);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_764;
    int t_765;
    int t_766;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_764 = GET_NCI_P(0);
    t_765 = (int)GET_NCI_I(1);
    t_766 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_764) ? NULL : VTABLE_get_pointer(interp, t_764)),t_765,t_766);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_piiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_767;
    int t_768;
    int t_769;
    int t_770;
    int t_771;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_767 = GET_NCI_P(0);
    t_768 = (int)GET_NCI_I(1);
    t_769 = (int)GET_NCI_I(2);
    t_770 = (int)GET_NCI_I(3);
    t_771 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_767) ? NULL : VTABLE_get_pointer(interp, t_767)),t_768,t_769,t_770,t_771);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_t(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_772;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_772 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_772);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_772) Parrot_str_free_cstring(t_772); } while (0);
}
static void
pcf_p_tpp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_773;
    PMC *t_774;
    PMC *t_775;
    Parrot_init_arg_nci(interp, &st, "SPP");
    {STRING * s= GET_NCI_S(0); t_773 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_774 = GET_NCI_P(1);
    t_775 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_773,(PMC_IS_NULL(t_774) ? NULL : VTABLE_get_pointer(interp, t_774)),(PMC_IS_NULL(t_775) ? NULL : VTABLE_get_pointer(interp, t_775)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_773) Parrot_str_free_cstring(t_773); } while (0);
}
static void
pcf_p_ttttttt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, char *, char *, char *, char *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_776;
    char *t_777;
    char *t_778;
    char *t_779;
    char *t_780;
    char *t_781;
    char *t_782;
    Parrot_init_arg_nci(interp, &st, "SSSSSSS");
    {STRING * s= GET_NCI_S(0); t_776 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_777 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_778 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_779 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_780 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(5); t_781 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(6); t_782 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_776,t_777,t_778,t_779,t_780,t_781,t_782);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_776) Parrot_str_free_cstring(t_776); } while (0);
    do { if (t_777) Parrot_str_free_cstring(t_777); } while (0);
    do { if (t_778) Parrot_str_free_cstring(t_778); } while (0);
    do { if (t_779) Parrot_str_free_cstring(t_779); } while (0);
    do { if (t_780) Parrot_str_free_cstring(t_780); } while (0);
    do { if (t_781) Parrot_str_free_cstring(t_781); } while (0);
    do { if (t_782) Parrot_str_free_cstring(t_782); } while (0);
}
static void
pcf_s_(PARROT_INTERP, PMC *self)
{
    short (*pointer)(void);
    void *orig_func;
    short return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (short (*)(void))D2FPTR(orig_func);
    return_data =  (short)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_t_(PARROT_INTERP, PMC *self)
{
    char * (*pointer)(void);
    void *orig_func;
    char * return_data;
    STRING *final_destination;
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (char * (*)(void))D2FPTR(orig_func);
    return_data =  (char *)(*pointer)();
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_i(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;int t_783;
    Parrot_init_arg_nci(interp, &st, "I");
    t_783 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_783);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_ii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;int t_784;
    int t_785;
    Parrot_init_arg_nci(interp, &st, "II");
    t_784 = (int)GET_NCI_I(0);
    t_785 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_784,t_785);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pi(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_786;
    int t_787;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_786 = GET_NCI_P(0);
    t_787 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)((PMC_IS_NULL(t_786) ? NULL : VTABLE_get_pointer(interp, t_786)),t_787);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_788;
    int t_789;
    int t_790;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_788 = GET_NCI_P(0);
    t_789 = (int)GET_NCI_I(1);
    t_790 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)((PMC_IS_NULL(t_788) ? NULL : VTABLE_get_pointer(interp, t_788)),t_789,t_790);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_t(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_791;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_791 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_791);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_791) Parrot_str_free_cstring(t_791); } while (0);
}
static void
pcf_i_sc(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, char);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_797;
    char t_798;
    Parrot_init_arg_nci(interp, &st, "II");
    t_797 = (short)GET_NCI_I(0);
    t_798 = (char)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_797,t_798);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_s_sc(PARROT_INTERP, PMC *self)
{
    typedef short (*func_t)(short, char);
    func_t pointer;
    void *orig_func;
    call_state st;
    short return_data;
    short t_799;
    char t_800;
    Parrot_init_arg_nci(interp, &st, "II");
    t_799 = (short)GET_NCI_I(0);
    t_800 = (char)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (short)(*pointer)(t_799,t_800);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_sc(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(short, char);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    short t_801;
    char t_802;
    Parrot_init_arg_nci(interp, &st, "II");
    t_801 = (short)GET_NCI_I(0);
    t_802 = (char)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)(t_801,t_802);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_803;
    int t_804;
    int t_805;
    Parrot_init_arg_nci(interp, &st, "III");
    t_803 = (int)GET_NCI_I(0);
    t_804 = (int)GET_NCI_I(1);
    t_805 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_803,t_804,t_805);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_t_b(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;STRING *t_808;
    Parrot_init_arg_nci(interp, &st, "S");
    t_808 = GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(Buffer_bufstart(t_808));
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_B(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *s_809;
    char *t_809;
    void** v_809 = (void **) &t_809;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_809 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL; s_809 = t_809;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(v_809);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (s_809) Parrot_str_free_cstring(s_809); } while (0);
}
static void
pcf_v_P(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_810;
    Parrot_init_arg_nci(interp, &st, "P");
    t_810 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_IS_NULL(t_810) ? NULL : t_810);
    
    
}
static void
pcf_v_pP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_811;
    PMC *t_812;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_811 = GET_NCI_P(0);
    t_812 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_811) ? NULL : VTABLE_get_pointer(interp, t_811)),PMC_IS_NULL(t_812) ? NULL : t_812);
    
    
}
static void
pcf_p_ip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_813;
    PMC *t_814;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_813 = (int)GET_NCI_I(0);
    t_814 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_813,(PMC_IS_NULL(t_814) ? NULL : VTABLE_get_pointer(interp, t_814)));
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_v_pii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_817;
    int t_818;
    int t_819;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_817 = GET_NCI_P(0);
    t_818 = (int)GET_NCI_I(1);
    t_819 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((PMC_IS_NULL(t_817) ? NULL : VTABLE_get_pointer(interp, t_817)),t_818,t_819);
    
    
}
static void
pcf_v_JO(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_821;
    Parrot_init_arg_nci(interp, &st, "P");
    t_821 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_821) ? NULL : t_821);
    
    
}
static void
pcf_i_JO(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_823;
    Parrot_init_arg_nci(interp, &st, "P");
    t_823 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_823) ? NULL : t_823);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_825;
    int t_826;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_825 = GET_NCI_P(0);
    t_826 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_825) ? NULL : t_825,t_826);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_828;
    char *t_829;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_828 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_829 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_828) ? NULL : t_828,t_829);
    set_nci_I(interp, &st, return_data);
    do { if (t_829) Parrot_str_free_cstring(t_829); } while (0);
}
static void
pcf_i_Jt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_831;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_831 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,t_831);
    set_nci_I(interp, &st, return_data);
    do { if (t_831) Parrot_str_free_cstring(t_831); } while (0);
}
static void
pcf_i_Ji(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_833;
    Parrot_init_arg_nci(interp, &st, "I");
    t_833 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,t_833);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_ppiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_836;
    PMC *t_837;
    int t_838;
    int t_839;
    int t_840;
    Parrot_init_arg_nci(interp, &st, "PPIII");
    t_836 = GET_NCI_P(0);
    t_837 = GET_NCI_P(1);
    t_838 = (int)GET_NCI_I(2);
    t_839 = (int)GET_NCI_I(3);
    t_840 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_836) ? NULL : VTABLE_get_pointer(interp, t_836)),(PMC_IS_NULL(t_837) ? NULL : VTABLE_get_pointer(interp, t_837)),t_838,t_839,t_840);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_ppiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, int, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_841;
    PMC *t_842;
    int t_843;
    int t_844;
    int t_845;
    int t_846;
    int t_847;
    int t_848;
    int t_849;
    Parrot_init_arg_nci(interp, &st, "PPIIIIIII");
    t_841 = GET_NCI_P(0);
    t_842 = GET_NCI_P(1);
    t_843 = (int)GET_NCI_I(2);
    t_844 = (int)GET_NCI_I(3);
    t_845 = (int)GET_NCI_I(4);
    t_846 = (int)GET_NCI_I(5);
    t_847 = (int)GET_NCI_I(6);
    t_848 = (int)GET_NCI_I(7);
    t_849 = (int)GET_NCI_I(8);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_841) ? NULL : VTABLE_get_pointer(interp, t_841)),(PMC_IS_NULL(t_842) ? NULL : VTABLE_get_pointer(interp, t_842)),t_843,t_844,t_845,t_846,t_847,t_848,t_849);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_ppt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_850;
    PMC *t_851;
    char *t_852;
    Parrot_init_arg_nci(interp, &st, "PPS");
    t_850 = GET_NCI_P(0);
    t_851 = GET_NCI_P(1);
    {STRING * s= GET_NCI_S(2); t_852 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_850) ? NULL : VTABLE_get_pointer(interp, t_850)),(PMC_IS_NULL(t_851) ? NULL : VTABLE_get_pointer(interp, t_851)),t_852);
    set_nci_I(interp, &st, return_data);
    do { if (t_852) Parrot_str_free_cstring(t_852); } while (0);
}
static void
pcf_i_pppi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_853;
    PMC *t_854;
    PMC *t_855;
    int t_856;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_853 = GET_NCI_P(0);
    t_854 = GET_NCI_P(1);
    t_855 = GET_NCI_P(2);
    t_856 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_853) ? NULL : VTABLE_get_pointer(interp, t_853)),(PMC_IS_NULL(t_854) ? NULL : VTABLE_get_pointer(interp, t_854)),(PMC_IS_NULL(t_855) ? NULL : VTABLE_get_pointer(interp, t_855)),t_856);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_857;
    PMC *t_858;
    PMC *t_859;
    int t_860;
    int t_861;
    Parrot_init_arg_nci(interp, &st, "PPPII");
    t_857 = GET_NCI_P(0);
    t_858 = GET_NCI_P(1);
    t_859 = GET_NCI_P(2);
    t_860 = (int)GET_NCI_I(3);
    t_861 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_857) ? NULL : VTABLE_get_pointer(interp, t_857)),(PMC_IS_NULL(t_858) ? NULL : VTABLE_get_pointer(interp, t_858)),(PMC_IS_NULL(t_859) ? NULL : VTABLE_get_pointer(interp, t_859)),t_860,t_861);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_862;
    PMC *t_863;
    PMC *t_864;
    int t_865;
    int t_866;
    int t_867;
    int t_868;
    Parrot_init_arg_nci(interp, &st, "PPPIIII");
    t_862 = GET_NCI_P(0);
    t_863 = GET_NCI_P(1);
    t_864 = GET_NCI_P(2);
    t_865 = (int)GET_NCI_I(3);
    t_866 = (int)GET_NCI_I(4);
    t_867 = (int)GET_NCI_I(5);
    t_868 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_862) ? NULL : VTABLE_get_pointer(interp, t_862)),(PMC_IS_NULL(t_863) ? NULL : VTABLE_get_pointer(interp, t_863)),(PMC_IS_NULL(t_864) ? NULL : VTABLE_get_pointer(interp, t_864)),t_865,t_866,t_867,t_868);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppppiiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, void *, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_869;
    PMC *t_870;
    PMC *t_871;
    PMC *t_872;
    int t_873;
    int t_874;
    int t_875;
    int t_876;
    int t_877;
    int t_878;
    Parrot_init_arg_nci(interp, &st, "PPPPIIIIII");
    t_869 = GET_NCI_P(0);
    t_870 = GET_NCI_P(1);
    t_871 = GET_NCI_P(2);
    t_872 = GET_NCI_P(3);
    t_873 = (int)GET_NCI_I(4);
    t_874 = (int)GET_NCI_I(5);
    t_875 = (int)GET_NCI_I(6);
    t_876 = (int)GET_NCI_I(7);
    t_877 = (int)GET_NCI_I(8);
    t_878 = (int)GET_NCI_I(9);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_869) ? NULL : VTABLE_get_pointer(interp, t_869)),(PMC_IS_NULL(t_870) ? NULL : VTABLE_get_pointer(interp, t_870)),(PMC_IS_NULL(t_871) ? NULL : VTABLE_get_pointer(interp, t_871)),(PMC_IS_NULL(t_872) ? NULL : VTABLE_get_pointer(interp, t_872)),t_873,t_874,t_875,t_876,t_877,t_878);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_fff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    float t_879;
    float t_880;
    float t_881;
    Parrot_init_arg_nci(interp, &st, "NNN");
    t_879 = (float)GET_NCI_N(0);
    t_880 = (float)GET_NCI_N(1);
    t_881 = (float)GET_NCI_N(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_879,t_880,t_881);
    
    
}
static void
pcf_i_pid(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, double);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_893;
    int t_894;
    double t_895;
    Parrot_init_arg_nci(interp, &st, "PIN");
    t_893 = GET_NCI_P(0);
    t_894 = (int)GET_NCI_I(1);
    t_895 = (double)GET_NCI_N(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_893) ? NULL : VTABLE_get_pointer(interp, t_893)),t_894,t_895);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pitii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_896;
    int t_897;
    char *t_898;
    int t_899;
    int t_900;
    Parrot_init_arg_nci(interp, &st, "PISII");
    t_896 = GET_NCI_P(0);
    t_897 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_898 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_899 = (int)GET_NCI_I(3);
    t_900 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_896) ? NULL : VTABLE_get_pointer(interp, t_896)),t_897,t_898,t_899,t_900);
    set_nci_I(interp, &st, return_data);
    do { if (t_898) Parrot_str_free_cstring(t_898); } while (0);
}

#endif
static void
pcf_i_Vppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void **, void *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_199;
    void *v_199;
    PMC *t_200;
    PMC *t_201;
    PMC *t_202;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_199 = GET_NCI_P(0);
    v_199 = VTABLE_get_pointer(interp, t_199);
    t_200 = GET_NCI_P(1);
    t_201 = GET_NCI_P(2);
    t_202 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&v_199,(PMC_IS_NULL(t_200) ? NULL : VTABLE_get_pointer(interp, t_200)),(PMC_IS_NULL(t_201) ? NULL : VTABLE_get_pointer(interp, t_201)),(PMC_IS_NULL(t_202) ? NULL : VTABLE_get_pointer(interp, t_202)));
    set_nci_I(interp, &st, return_data);
    VTABLE_set_pointer(interp, t_199, v_199);
}
 static void
pcf_i_i3i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_349;
    PMC *t_350;
    int i_350;
    int t_351;
    Parrot_init_arg_nci(interp, &st, "IPI");
    t_349 = (int)GET_NCI_I(0);
    t_350 = GET_NCI_P(1);
    i_350 = (int) VTABLE_get_integer(interp, t_350);
    t_351 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_349,&i_350,t_351);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_350, i_350);
}
 static void
pcf_p_tiB3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void **, int *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_424;
    int t_425;
    char *s_426;
    char *t_426;
    void** v_426 = (void **) &t_426;
    PMC *t_427;
    int i_427;
    PMC *t_428;
    Parrot_init_arg_nci(interp, &st, "SISPP");
    {STRING * s= GET_NCI_S(0); t_424 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_425 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_426 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL; s_426 = t_426;}
    t_427 = GET_NCI_P(3);
    i_427 = (int) VTABLE_get_integer(interp, t_427);
    t_428 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_424,t_425,v_426,&i_427,PMC_IS_NULL(t_428) ? NULL : t_428);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_424) Parrot_str_free_cstring(t_424); } while (0);
    do { if (s_426) Parrot_str_free_cstring(s_426); } while (0);
    VTABLE_set_integer_native(interp, t_427, i_427);
}
 static void
pcf_p_tip3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void *, int *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_429;
    int t_430;
    PMC *t_431;
    PMC *t_432;
    int i_432;
    PMC *t_433;
    Parrot_init_arg_nci(interp, &st, "SIPPP");
    {STRING * s= GET_NCI_S(0); t_429 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_430 = (int)GET_NCI_I(1);
    t_431 = GET_NCI_P(2);
    t_432 = GET_NCI_P(3);
    i_432 = (int) VTABLE_get_integer(interp, t_432);
    t_433 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_429,t_430,(PMC_IS_NULL(t_431) ? NULL : VTABLE_get_pointer(interp, t_431)),&i_432,PMC_IS_NULL(t_433) ? NULL : t_433);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    do { if (t_429) Parrot_str_free_cstring(t_429); } while (0);
    VTABLE_set_integer_native(interp, t_432, i_432);
}
 static void
pcf_p_pi33ipi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int *, int *, int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_456;
    int t_457;
    PMC *t_458;
    int i_458;
    PMC *t_459;
    int i_459;
    int t_460;
    PMC *t_461;
    int t_462;
    Parrot_init_arg_nci(interp, &st, "PIPPIPI");
    t_456 = GET_NCI_P(0);
    t_457 = (int)GET_NCI_I(1);
    t_458 = GET_NCI_P(2);
    i_458 = (int) VTABLE_get_integer(interp, t_458);
    t_459 = GET_NCI_P(3);
    i_459 = (int) VTABLE_get_integer(interp, t_459);
    t_460 = (int)GET_NCI_I(4);
    t_461 = GET_NCI_P(5);
    t_462 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)((PMC_IS_NULL(t_456) ? NULL : VTABLE_get_pointer(interp, t_456)),t_457,&i_458,&i_459,t_460,(PMC_IS_NULL(t_461) ? NULL : VTABLE_get_pointer(interp, t_461)),t_462);
    VTABLE_set_pointer(interp, final_destination, return_data);    set_nci_P(interp, &st, final_destination);
    VTABLE_set_integer_native(interp, t_458, i_458);
    VTABLE_set_integer_native(interp, t_459, i_459);
}
 static void
pcf_i_pt33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_503;
    char *t_504;
    PMC *t_505;
    int i_505;
    PMC *t_506;
    int i_506;
    Parrot_init_arg_nci(interp, &st, "PSPP");
    t_503 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_504 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_505 = GET_NCI_P(2);
    i_505 = (int) VTABLE_get_integer(interp, t_505);
    t_506 = GET_NCI_P(3);
    i_506 = (int) VTABLE_get_integer(interp, t_506);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_503) ? NULL : VTABLE_get_pointer(interp, t_503)),t_504,&i_505,&i_506);
    set_nci_I(interp, &st, return_data);
    do { if (t_504) Parrot_str_free_cstring(t_504); } while (0);
    VTABLE_set_integer_native(interp, t_505, i_505);
    VTABLE_set_integer_native(interp, t_506, i_506);
}
 static void
pcf_i_ii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_519;
    int t_520;
    PMC *t_521;
    long i_521;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_519 = (int)GET_NCI_I(0);
    t_520 = (int)GET_NCI_I(1);
    t_521 = GET_NCI_P(2);
    i_521 = (long) VTABLE_get_integer(interp, t_521);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_519,t_520,&i_521);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_521, i_521);
}
 static void
pcf_i_ii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_522;
    int t_523;
    PMC *t_524;
    long i_524;
    int t_525;
    Parrot_init_arg_nci(interp, &st, "IIPI");
    t_522 = (int)GET_NCI_I(0);
    t_523 = (int)GET_NCI_I(1);
    t_524 = GET_NCI_P(2);
    i_524 = (long) VTABLE_get_integer(interp, t_524);
    t_525 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_522,t_523,&i_524,t_525);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_524, i_524);
}
 static void
pcf_i_p33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_568;
    PMC *t_569;
    int i_569;
    PMC *t_570;
    int i_570;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_568 = GET_NCI_P(0);
    t_569 = GET_NCI_P(1);
    i_569 = (int) VTABLE_get_integer(interp, t_569);
    t_570 = GET_NCI_P(2);
    i_570 = (int) VTABLE_get_integer(interp, t_570);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_568) ? NULL : VTABLE_get_pointer(interp, t_568)),&i_569,&i_570);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_569, i_569);
    VTABLE_set_integer_native(interp, t_570, i_570);
}
 static void
pcf_i_p333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_571;
    PMC *t_572;
    int i_572;
    PMC *t_573;
    int i_573;
    PMC *t_574;
    int i_574;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_571 = GET_NCI_P(0);
    t_572 = GET_NCI_P(1);
    i_572 = (int) VTABLE_get_integer(interp, t_572);
    t_573 = GET_NCI_P(2);
    i_573 = (int) VTABLE_get_integer(interp, t_573);
    t_574 = GET_NCI_P(3);
    i_574 = (int) VTABLE_get_integer(interp, t_574);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_571) ? NULL : VTABLE_get_pointer(interp, t_571)),&i_572,&i_573,&i_574);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_572, i_572);
    VTABLE_set_integer_native(interp, t_573, i_573);
    VTABLE_set_integer_native(interp, t_574, i_574);
}
 static void
pcf_i_p333333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *, int *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_575;
    PMC *t_576;
    int i_576;
    PMC *t_577;
    int i_577;
    PMC *t_578;
    int i_578;
    PMC *t_579;
    int i_579;
    PMC *t_580;
    int i_580;
    PMC *t_581;
    int i_581;
    Parrot_init_arg_nci(interp, &st, "PPPPPPP");
    t_575 = GET_NCI_P(0);
    t_576 = GET_NCI_P(1);
    i_576 = (int) VTABLE_get_integer(interp, t_576);
    t_577 = GET_NCI_P(2);
    i_577 = (int) VTABLE_get_integer(interp, t_577);
    t_578 = GET_NCI_P(3);
    i_578 = (int) VTABLE_get_integer(interp, t_578);
    t_579 = GET_NCI_P(4);
    i_579 = (int) VTABLE_get_integer(interp, t_579);
    t_580 = GET_NCI_P(5);
    i_580 = (int) VTABLE_get_integer(interp, t_580);
    t_581 = GET_NCI_P(6);
    i_581 = (int) VTABLE_get_integer(interp, t_581);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_575) ? NULL : VTABLE_get_pointer(interp, t_575)),&i_576,&i_577,&i_578,&i_579,&i_580,&i_581);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_576, i_576);
    VTABLE_set_integer_native(interp, t_577, i_577);
    VTABLE_set_integer_native(interp, t_578, i_578);
    VTABLE_set_integer_native(interp, t_579, i_579);
    VTABLE_set_integer_native(interp, t_580, i_580);
    VTABLE_set_integer_native(interp, t_581, i_581);
}
 static void
pcf_i_p4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_582;
    PMC *t_583;
    long i_583;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_582 = GET_NCI_P(0);
    t_583 = GET_NCI_P(1);
    i_583 = (long) VTABLE_get_integer(interp, t_583);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_582) ? NULL : VTABLE_get_pointer(interp, t_582)),&i_583);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_583, i_583);
}
 static void
pcf_i_p42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, short *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_584;
    PMC *t_585;
    long i_585;
    PMC *t_586;
    short i_586;
    PMC *t_587;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_584 = GET_NCI_P(0);
    t_585 = GET_NCI_P(1);
    i_585 = (long) VTABLE_get_integer(interp, t_585);
    t_586 = GET_NCI_P(2);
    i_586 = (short) VTABLE_get_integer(interp, t_586);
    t_587 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_584) ? NULL : VTABLE_get_pointer(interp, t_584)),&i_585,&i_586,(PMC_IS_NULL(t_587) ? NULL : VTABLE_get_pointer(interp, t_587)));
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_585, i_585);
    VTABLE_set_integer_native(interp, t_586, i_586);
}
 static void
pcf_i_p4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_588;
    PMC *t_589;
    long i_589;
    int t_590;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_588 = GET_NCI_P(0);
    t_589 = GET_NCI_P(1);
    i_589 = (long) VTABLE_get_integer(interp, t_589);
    t_590 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_588) ? NULL : VTABLE_get_pointer(interp, t_588)),&i_589,t_590);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_589, i_589);
}
 static void
pcf_i_pii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_596;
    int t_597;
    int t_598;
    PMC *t_599;
    long i_599;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_596 = GET_NCI_P(0);
    t_597 = (int)GET_NCI_I(1);
    t_598 = (int)GET_NCI_I(2);
    t_599 = GET_NCI_P(3);
    i_599 = (long) VTABLE_get_integer(interp, t_599);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_596) ? NULL : VTABLE_get_pointer(interp, t_596)),t_597,t_598,&i_599);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_599, i_599);
}
 static void
pcf_i_pii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_600;
    int t_601;
    int t_602;
    PMC *t_603;
    long i_603;
    int t_604;
    Parrot_init_arg_nci(interp, &st, "PIIPI");
    t_600 = GET_NCI_P(0);
    t_601 = (int)GET_NCI_I(1);
    t_602 = (int)GET_NCI_I(2);
    t_603 = GET_NCI_P(3);
    i_603 = (long) VTABLE_get_integer(interp, t_603);
    t_604 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_600) ? NULL : VTABLE_get_pointer(interp, t_600)),t_601,t_602,&i_603,t_604);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_603, i_603);
}
 static void
pcf_i_s22(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_698;
    PMC *t_699;
    short i_699;
    PMC *t_700;
    short i_700;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_698 = (short)GET_NCI_I(0);
    t_699 = GET_NCI_P(1);
    i_699 = (short) VTABLE_get_integer(interp, t_699);
    t_700 = GET_NCI_P(2);
    i_700 = (short) VTABLE_get_integer(interp, t_700);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_698,&i_699,&i_700);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_699, i_699);
    VTABLE_set_integer_native(interp, t_700, i_700);
}
 static void
pcf_i_s222(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *, short *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_701;
    PMC *t_702;
    short i_702;
    PMC *t_703;
    short i_703;
    PMC *t_704;
    short i_704;
    Parrot_init_arg_nci(interp, &st, "IPPP");
    t_701 = (short)GET_NCI_I(0);
    t_702 = GET_NCI_P(1);
    i_702 = (short) VTABLE_get_integer(interp, t_702);
    t_703 = GET_NCI_P(2);
    i_703 = (short) VTABLE_get_integer(interp, t_703);
    t_704 = GET_NCI_P(3);
    i_704 = (short) VTABLE_get_integer(interp, t_704);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_701,&i_702,&i_703,&i_704);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_702, i_702);
    VTABLE_set_integer_native(interp, t_703, i_703);
    VTABLE_set_integer_native(interp, t_704, i_704);
}
 static void
pcf_i_4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_717;
    long i_717;
    Parrot_init_arg_nci(interp, &st, "P");
    t_717 = GET_NCI_P(0);
    i_717 = (long) VTABLE_get_integer(interp, t_717);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_717);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_717, i_717);
}
 static void
pcf_i_4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_718;
    long i_718;
    int t_719;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_718 = GET_NCI_P(0);
    i_718 = (long) VTABLE_get_integer(interp, t_718);
    t_719 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_718,t_719);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_718, i_718);
}
 static void
pcf_i_42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, short *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_720;
    long i_720;
    PMC *t_721;
    short i_721;
    PMC *t_722;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_720 = GET_NCI_P(0);
    i_720 = (long) VTABLE_get_integer(interp, t_720);
    t_721 = GET_NCI_P(1);
    i_721 = (short) VTABLE_get_integer(interp, t_721);
    t_722 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_720,&i_721,(PMC_IS_NULL(t_722) ? NULL : VTABLE_get_pointer(interp, t_722)));
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_720, i_720);
    VTABLE_set_integer_native(interp, t_721, i_721);
}
 static void
pcf_l_l4(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    long t_725;
    PMC *t_726;
    long i_726;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_725 = (long)GET_NCI_I(0);
    t_726 = GET_NCI_P(1);
    i_726 = (long) VTABLE_get_integer(interp, t_726);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_725,&i_726);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_726, i_726);
}
 static void
pcf_l_p33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int *, int *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_732;
    PMC *t_733;
    int i_733;
    PMC *t_734;
    int i_734;
    long t_735;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_732 = GET_NCI_P(0);
    t_733 = GET_NCI_P(1);
    i_733 = (int) VTABLE_get_integer(interp, t_733);
    t_734 = GET_NCI_P(2);
    i_734 = (int) VTABLE_get_integer(interp, t_734);
    t_735 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)((PMC_IS_NULL(t_732) ? NULL : VTABLE_get_pointer(interp, t_732)),&i_733,&i_734,t_735);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_733, i_733);
    VTABLE_set_integer_native(interp, t_734, i_734);
}
 static void
pcf_l_33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int *, int *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_736;
    int i_736;
    PMC *t_737;
    int i_737;
    long t_738;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_736 = GET_NCI_P(0);
    i_736 = (int) VTABLE_get_integer(interp, t_736);
    t_737 = GET_NCI_P(1);
    i_737 = (int) VTABLE_get_integer(interp, t_737);
    t_738 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(&i_736,&i_737,t_738);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_736, i_736);
    VTABLE_set_integer_native(interp, t_737, i_737);
}
 static void
pcf_t_tl4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_792;
    long t_793;
    PMC *t_794;
    long i_794;
    Parrot_init_arg_nci(interp, &st, "SIP");
    {STRING * s= GET_NCI_S(0); t_792 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_793 = (long)GET_NCI_I(1);
    t_794 = GET_NCI_P(2);
    i_794 = (long) VTABLE_get_integer(interp, t_794);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_792,t_793,&i_794);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_792) Parrot_str_free_cstring(t_792); } while (0);
    VTABLE_set_integer_native(interp, t_794, i_794);
}
 static void
pcf_t_t4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_795;
    PMC *t_796;
    long i_796;
    Parrot_init_arg_nci(interp, &st, "SP");
    {STRING * s= GET_NCI_S(0); t_795 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_796 = GET_NCI_P(1);
    i_796 = (long) VTABLE_get_integer(interp, t_796);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_795,&i_796);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_795) Parrot_str_free_cstring(t_795); } while (0);
    VTABLE_set_integer_native(interp, t_796, i_796);
}
 static void
pcf_i_i3(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_806;
    PMC *t_807;
    int i_807;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_806 = (int)GET_NCI_I(0);
    t_807 = GET_NCI_P(1);
    i_807 = (int) VTABLE_get_integer(interp, t_807);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_806,&i_807);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_807, i_807);
}
 static void
pcf_i_33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_815;
    int i_815;
    PMC *t_816;
    int i_816;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_815 = GET_NCI_P(0);
    i_815 = (int) VTABLE_get_integer(interp, t_815);
    t_816 = GET_NCI_P(1);
    i_816 = (int) VTABLE_get_integer(interp, t_816);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_815,&i_816);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_815, i_815);
    VTABLE_set_integer_native(interp, t_816, i_816);
}
 static void
pcf_v_Vi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void **, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_834;
    void *v_834;
    int t_835;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_834 = GET_NCI_P(0);
    v_834 = VTABLE_get_pointer(interp, t_834);
    t_835 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(&v_834,t_835);
    
    VTABLE_set_pointer(interp, t_834, v_834);
}
 static void
pcf_v_V(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_882;
    void *v_882;
    Parrot_init_arg_nci(interp, &st, "P");
    t_882 = GET_NCI_P(0);
    v_882 = VTABLE_get_pointer(interp, t_882);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(&v_882);
    
    VTABLE_set_pointer(interp, t_882, v_882);
}
 static void
pcf_v_VVV(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void **, void **, void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_883;
    void *v_883;
    PMC *t_884;
    void *v_884;
    PMC *t_885;
    void *v_885;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_883 = GET_NCI_P(0);
    v_883 = VTABLE_get_pointer(interp, t_883);
    t_884 = GET_NCI_P(1);
    v_884 = VTABLE_get_pointer(interp, t_884);
    t_885 = GET_NCI_P(2);
    v_885 = VTABLE_get_pointer(interp, t_885);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(&v_883,&v_884,&v_885);
    
    VTABLE_set_pointer(interp, t_883, v_883);
    VTABLE_set_pointer(interp, t_884, v_884);
    VTABLE_set_pointer(interp, t_885, v_885);
}
 static void
pcf_i_tV(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_886;
    PMC *t_887;
    void *v_887;
    Parrot_init_arg_nci(interp, &st, "SP");
    {STRING * s= GET_NCI_S(0); t_886 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_887 = GET_NCI_P(1);
    v_887 = VTABLE_get_pointer(interp, t_887);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_886,&v_887);
    set_nci_I(interp, &st, return_data);
    do { if (t_886) Parrot_str_free_cstring(t_886); } while (0);
    VTABLE_set_pointer(interp, t_887, v_887);
}
 static void
pcf_i_ptiVp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int, void **, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_888;
    char *t_889;
    int t_890;
    PMC *t_891;
    void *v_891;
    PMC *t_892;
    Parrot_init_arg_nci(interp, &st, "PSIPP");
    t_888 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_889 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_890 = (int)GET_NCI_I(2);
    t_891 = GET_NCI_P(3);
    v_891 = VTABLE_get_pointer(interp, t_891);
    t_892 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((PMC_IS_NULL(t_888) ? NULL : VTABLE_get_pointer(interp, t_888)),t_889,t_890,&v_891,(PMC_IS_NULL(t_892) ? NULL : VTABLE_get_pointer(interp, t_892)));
    set_nci_I(interp, &st, return_data);
    do { if (t_889) Parrot_str_free_cstring(t_889); } while (0);
    VTABLE_set_pointer(interp, t_891, v_891);
}




/* This function serves a single purpose. It takes the function
   signature for a C function we want to call and returns a pointer
   to a function that can call it. */
void *
build_call_func(PARROT_INTERP,
#if defined(CAN_BUILD_CALL_FRAMES)
PMC *pmc_nci, NOTNULL(STRING *signature), NOTNULL(int *jitted))
#else
SHIM(PMC *pmc_nci), NOTNULL(STRING *signature), SHIM(int *jitted))
#endif
{
    char       *c;
    STRING     *ns, *message;
    PMC        *b;
    PMC        *iglobals;
    PMC        *temp_pmc;
    UINTVAL    signature_len;

    PMC        *HashPointer   = NULL;

    /* And in here is the platform-independent way. Which is to say
       "here there be hacks" */
    signature_len = Parrot_str_byte_length(interp, signature);

#ifndef CAN_BUILD_CALL_FRAMES
    if (0 == signature_len)
       return F2DPTR(pcf_v_);
#endif

    /* remove deprecated void argument 'v' character */
    if (2 == signature_len && 'v' == Parrot_str_indexed(interp, signature, 1)) {
       Parrot_warn(interp, PARROT_WARNINGS_ALL_FLAG, "function signature argument character 'v' ignored");
       Parrot_str_chopn_inplace(interp, signature, 1);
       signature_len = Parrot_str_byte_length(interp, signature);
    }

    iglobals = interp->iglobals;

    if (PMC_IS_NULL(iglobals))
        PANIC(interp, "iglobals isn't created yet");
    HashPointer = VTABLE_get_pmc_keyed_int(interp, iglobals,
            IGLOBALS_NCI_FUNCS);

    if (!HashPointer) {
        HashPointer = pmc_new(interp, enum_class_Hash);
        VTABLE_set_pmc_keyed_int(interp, iglobals, IGLOBALS_NCI_FUNCS,
                HashPointer);
    }

#if defined(CAN_BUILD_CALL_FRAMES)
    /* Try if JIT code can build that signature. If yes, we are done */
    b            = VTABLE_get_pmc_keyed_str(interp, HashPointer, signature);

    PARROT_ASSERT(PMC_IS_NULL(b) || b->vtable);

    if ((!PMC_IS_NULL(b)) && b->vtable->base_type == enum_class_ManagedStruct) {
        *jitted = 1;
        return F2DPTR(VTABLE_get_pointer(interp, b));
    }
    else {
        int jit_size;
        void * const result = Parrot_jit_build_call_func(interp, pmc_nci, signature, &jit_size);
        if (result) {
            struct jit_buffer_private_data *priv;
            *jitted = 1;
            temp_pmc = pmc_new(interp, enum_class_ManagedStruct);
            VTABLE_set_pointer(interp, temp_pmc, (void *)result);
#ifdef PARROT_HAS_EXEC_PROTECT
            priv = (struct jit_buffer_private_data *)
                mem_sys_allocate(sizeof(struct jit_buffer_private_data));
            priv->size = jit_size;
            SETATTR_ManagedStruct_custom_free_func(interp, temp_pmc, Parrot_jit_free_buffer);
            SETATTR_ManagedStruct_custom_free_priv(interp, temp_pmc, priv);
            SETATTR_ManagedStruct_custom_clone_func(interp, temp_pmc, Parrot_jit_clone_buffer);
            SETATTR_ManagedStruct_custom_clone_priv(interp, temp_pmc, priv);
#endif /* PARROT_HAS_EXEC_PROTECT */
            VTABLE_set_pmc_keyed_str(interp, HashPointer, signature, temp_pmc);
            return result;
        }
    }

#endif

    b = VTABLE_get_pmc_keyed_str(interp, HashPointer, signature);

    if (PMC_IS_NULL(b)) {
        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_Vppp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iVppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_i3i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ii3i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_tiB3P);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ptiB3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_tip3P);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ptip3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pi33ipi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppi33ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pt33);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipt33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ii4);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ii4i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_p33);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_p333);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_p333333);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip333333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_p4);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_p42p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_p4i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pii4);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pii4i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_s22);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "is22"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_s222);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "is222"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_4);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_4i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_42p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_l4);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ll4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_p33l);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lp33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_33l);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "l33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_tl4);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ttl4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_t4);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tt4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_i3);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ii3"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_33);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_Vi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vVi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_V);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vV"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_VVV);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vVVV"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_tV);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "itV"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ptiVp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iptiVp"), temp_pmc);

#ifndef CAN_BUILD_CALL_FRAMES
        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_d_JOd);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "dJOd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JOS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_Jt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_S_JOS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOSP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JOI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOPS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOPSP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPIP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPSP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPNP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JPN);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPN"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JPPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JPIP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JPSP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JPNP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JPS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JPN);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJPN"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JPi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JPii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JPiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JPt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOSSS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOSSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOSS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_S_JOI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOb);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JOPxAT_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JOPxAT_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JOIPxAT_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOIP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JO);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_Ji);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_J);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JPip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JpP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_Jpii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_tp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "itp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_J);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_Jp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_J);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_Jpti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tJpti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_pt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pit);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_ptt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_Jtiiipt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJtiiipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_JttPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJttPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_Jtpi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJtpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JpPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJpPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_Jpt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "v"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_Jiiip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_ii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_illllllll);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "villllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_l);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pbip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_piiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_S_JO);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_P);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOPPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOPPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOPPPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOPPPPP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JOSI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOSII);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOSII"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_Ji);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_Jipp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_Jbip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_Jp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_tt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JOt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOSI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_S_JOi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_I_JO);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_N_JO);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "NJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JON);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJON"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JOI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOI);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_P_JOIS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOIS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_S_JOSP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ibi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_lttl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "llttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piS);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_S_i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "Si"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_c_p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "cp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_p);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pttttt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_c_pttt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "cpttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pttttiti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppttttiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ptl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iptl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ptt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pit);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_ttl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_pttl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lpttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_t);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pttttitl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppttttitl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pPtiiipi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipPtiiipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_tpiibi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "itpiibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ptippppi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptippppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pttip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppttip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ptipppi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptipppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ppP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pppP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_iiil);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ppl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ppp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ptii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ptp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_c_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "c"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_c_pi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "cpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_d_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "d"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_d_d);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "dd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_f_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "f"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_f_ff);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "fff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_f_is);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "fis"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_b);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ib"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_d);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "id"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iiilsp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iil);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iili);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iit);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iiti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ilsp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_l);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "il"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_li);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_lp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ilp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_lsp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pb);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piiiiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piiilsp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piil);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piili);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piit);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_piiti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pilsp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pli);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipli"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pll);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pllllllll);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipllllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_plp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iplp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_plsp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iplsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ppi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ppiiiiiiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pppp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_psp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pitl);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipitl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_s);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "is"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_sp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "isp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_sss);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "isss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ssss);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "issss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_t);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "it"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ti);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_ii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_pi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_l_pii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_B);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_b);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_Jt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_iiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_iiiiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_iiiiiiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_pii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_piiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_t);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_tpp);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ptpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ttttttt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pttttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_s_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "s"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "t"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_i);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_ii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_pi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_pii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_t);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_sc);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "isc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_s_sc);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ssc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_c_sc);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "csc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_iii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_b);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_t_B);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_P);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pP);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ip);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_pii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_JO);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JO);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JOi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_JOt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_Jt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_Ji);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ppiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pppiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_p_ppiiiiiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pppiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ppt);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pppi);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pppii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pppiiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_ppppiiiiii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippppiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_v_fff);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vfff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pid);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipid"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        VTABLE_set_pointer(interp, temp_pmc, (void *)pcf_i_pitii);
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipitii"), temp_pmc);

#endif

        b = VTABLE_get_pmc_keyed_str(interp, HashPointer, signature);
    }

    PARROT_ASSERT(PMC_IS_NULL(b) || b->vtable);

    if ((!PMC_IS_NULL(b)) && b->vtable->base_type == enum_class_UnManagedStruct)
        return F2DPTR(VTABLE_get_pointer(interp, b));

    /*
      These three lines have been added to aid debugging. I want to be able to
      see which signature has an unknown type. I am sure someone can come up
      with a neater way to do this.
     */
    ns = string_make(interp, " is an unknown signature type", 29, "ascii", 0);
    message = Parrot_str_concat(interp, signature, ns, 0);

#if defined(CAN_BUILD_CALL_FRAMES)
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is enabled, this should not happen", 58, "ascii", 0);
#else
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is disabled, add the signature to src/call_list.txt", 75, "ascii", 0);
#endif
    message = Parrot_str_concat(interp, message, ns, 0);

    /*
     * I think there may be memory issues with this but if we get to here we are
     * aborting.
     */
    c = Parrot_str_to_cstring(interp, message);
    PANIC(interp, c);
}


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
