/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/object.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_object.h"
#include "pmc_default.h"
#include "object.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/object.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: object.pmc 40958 2009-09-03 11:56:50Z bacek $

=head1 NAME

src/pmc/object.pmc - An instance of a class

=head1 DESCRIPTION

Implements an instance of a class.

=head2 Functions

=over 4

=cut

*/

#include "parrot/oo_private.h"
#include "pmc_class.h"

/* This finds the index of an attribute in an object's attribute store and
 * returns it. Returns -1 if the attribute does not exist. */
static INTVAL
get_attrib_index(PARROT_INTERP, PMC *self, STRING *name)
{
    Parrot_Class_attributes * const _class  = PARROT_CLASS(self);
    const INTVAL                    cur_hll = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp));
    int                             num_classes, i;
    INTVAL                          retval;

    Parrot_pcc_set_HLL(interp, CURRENT_CONTEXT(interp), 0);

    /* First see if we can find it in the cache. */
    retval                       = VTABLE_get_integer_keyed_str(interp,
                                         _class->attrib_cache, name);

    /* there's a semi-predicate problem with a retval of 0 */
    if (retval
    || VTABLE_exists_keyed_str(interp, _class->attrib_cache, name)) {
        Parrot_pcc_set_HLL(interp, CURRENT_CONTEXT(interp), cur_hll);
        return retval;
    }

    /* No hit. We need to walk up the list of parents to try and find the
     * attribute. */
    num_classes = VTABLE_elements(interp, _class->all_parents);

    for (i = 0; i < num_classes; i++) {
        /* Get the class and its attribute metadata hash. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp,
            _class->all_parents, i);

        /* Build a string representing the fully qualified attribute name. */
        STRING *fq_name = VTABLE_get_string(interp, cur_class);
        fq_name         = Parrot_str_append(interp, fq_name, name);

        /* Look up. */
        if (VTABLE_exists_keyed_str(interp, _class->attrib_index, fq_name)) {
            /* Found it. Get value, cache it and we're done. */
            const INTVAL index = VTABLE_get_integer_keyed_str(interp,
                _class->attrib_index, fq_name);
            VTABLE_set_integer_keyed_str(interp, _class->attrib_cache, name,
                index);

            Parrot_pcc_set_HLL(interp, CURRENT_CONTEXT(interp), cur_hll);
            return index;
        }
    }

    Parrot_pcc_set_HLL(interp, CURRENT_CONTEXT(interp), cur_hll);
    return -1;
}

/* This variation bypasses the cache and finds the index of a particular
 * parent's attribute in an object's attribute store and returns it. Returns -1
 * if the attribute does not exist. */

static INTVAL
get_attrib_index_keyed(PARROT_INTERP, PMC *self, PMC *key, STRING *name)
{
    Parrot_Class_attributes * const _class       = PARROT_CLASS(self);
    PMC          * const class_cache  = VTABLE_get_pmc_keyed_str(interp,
                    _class->attrib_cache, VTABLE_get_string(interp, key));
    PMC                 *parent_class;
    STRING              *fq_name;

    if (!PMC_IS_NULL(class_cache))
        if (VTABLE_exists_keyed_str(interp, class_cache, name))
            return VTABLE_get_integer_keyed_str(interp, class_cache, name);

    /* Build a string representing the fully qualified attribute name. */
    parent_class = Parrot_oo_get_class(interp, key);
    fq_name      = VTABLE_get_string(interp, parent_class);
    fq_name      = Parrot_str_append(interp, fq_name, name);

    /* Look up. */
    if (VTABLE_exists_keyed_str(interp, _class->attrib_index, fq_name)) {
        /* Found it. Get value and we're done. */
        const INTVAL index = VTABLE_get_integer_keyed_str(interp,
            _class->attrib_index, fq_name);
        return index;
    }

    return -1;
}
#line 130 "./src/pmc/object.c"
static  PMC * Parrot_Object_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_Object_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void Parrot_Object_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type);
static  PMC * Parrot_Object_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC * Parrot_Object_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_Object_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc);
static  void Parrot_Object_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent);
static  void Parrot_Object_add_role(PARROT_INTERP, PMC *pmc, PMC *role);
static  void Parrot_Object_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc);
static  void Parrot_Object_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  PMC * Parrot_Object_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Object_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Object_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_Object_bitwise_nots(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_Object_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Object_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Object_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Object_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Object_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  INTVAL  Parrot_Object_can(PARROT_INTERP, PMC *pmc, STRING *method_name);
static  PMC *  Parrot_Object_clone(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args);
static  INTVAL Parrot_Object_cmp(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_Object_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC * Parrot_Object_cmp_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_Object_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC * Parrot_Object_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  void Parrot_Object_decrement(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_defined(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL Parrot_Object_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_Object_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void Parrot_Object_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void Parrot_Object_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void Parrot_Object_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void Parrot_Object_delprop(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Object_destroy(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC * Parrot_Object_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  INTVAL  Parrot_Object_does(PARROT_INTERP, PMC *pmc, STRING *role_name);
static  INTVAL  Parrot_Object_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role);
static  INTVAL Parrot_Object_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL Parrot_Object_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_Object_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_Object_find_method(PARROT_INTERP, PMC *pmc, STRING *name);
static  PMC * Parrot_Object_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC * Parrot_Object_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_Object_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  PMC  * Parrot_Object_get_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name);
static  PMC  * Parrot_Object_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *name);
static  PMC * Parrot_Object_get_bignum(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_get_bool(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Object_get_class(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Object_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL Parrot_Object_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_Object_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_Object_get_iter(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Object_get_namespace(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_Object_get_number(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_Object_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL Parrot_Object_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  FLOATVAL Parrot_Object_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_Object_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC * Parrot_Object_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC * Parrot_Object_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void * Parrot_Object_get_pointer(PARROT_INTERP, PMC *pmc);
static  void * Parrot_Object_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void * Parrot_Object_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void * Parrot_Object_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING * Parrot_Object_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_Object_get_string(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_Object_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING * Parrot_Object_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  STRING * Parrot_Object_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_Object_getprop(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_Object_getprops(PARROT_INTERP, PMC *pmc);
static  void Parrot_Object_i_absolute(PARROT_INTERP, PMC *pmc);
static  void Parrot_Object_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_Object_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_bitwise_not(PARROT_INTERP, PMC *pmc);
static  void Parrot_Object_i_bitwise_nots(PARROT_INTERP, PMC *pmc);
static  void Parrot_Object_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_Object_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_Object_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_Object_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_logical_not(PARROT_INTERP, PMC *pmc);
static  void Parrot_Object_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_neg(PARROT_INTERP, PMC *pmc);
static  void Parrot_Object_i_pow(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Object_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Object_init_pmc(PARROT_INTERP, PMC *pmc, PMC *worreva);
static  PMC * Parrot_Object_inspect(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what);
static  PMC * Parrot_Object_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig);
static  PMC * Parrot_Object_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags);
static  opcode_t *  Parrot_Object_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  INTVAL Parrot_Object_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_Object_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_Object_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_Object_is_same(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Object_isa(PARROT_INTERP, PMC *pmc, STRING *classname);
static  INTVAL  Parrot_Object_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup);
static  PMC * Parrot_Object_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_Object_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Object_mark(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC * Parrot_Object_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_Object_morph(PARROT_INTERP, PMC *pmc, PMC *type);
static  PMC * Parrot_Object_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC * Parrot_Object_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  STRING  * Parrot_Object_name(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_neg(PARROT_INTERP, PMC *pmc, PMC *dest);
static  FLOATVAL Parrot_Object_pop_float(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_pop_integer(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_pop_pmc(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_Object_pop_string(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC * Parrot_Object_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_Object_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_push_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_Object_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name);
static  void Parrot_Object_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name);
static  void Parrot_Object_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent);
static  void Parrot_Object_remove_role(PARROT_INTERP, PMC *pmc, PMC *role);
static  void Parrot_Object_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name);
static  PMC * Parrot_Object_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_Object_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name, PMC *value);
static  void  Parrot_Object_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *name, PMC *value);
static  void Parrot_Object_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_Object_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void Parrot_Object_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void Parrot_Object_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void Parrot_Object_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void Parrot_Object_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value);
static  void Parrot_Object_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value);
static  void Parrot_Object_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void Parrot_Object_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value);
static  void Parrot_Object_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_Object_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void Parrot_Object_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value);
static  void Parrot_Object_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value);
static  void Parrot_Object_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value);
static  void Parrot_Object_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void Parrot_Object_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value);
static  void Parrot_Object_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void Parrot_Object_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_Object_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_Object_share(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Object_share_ro(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_Object_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_Object_shift_string(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Object_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL flag);
static  void Parrot_Object_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count);
static  void Parrot_Object_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest);
static  STRING * Parrot_Object_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length);
static  PMC * Parrot_Object_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Object_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC * Parrot_Object_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_Object_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void  Parrot_Object_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info);
static  INTVAL  Parrot_Object_type(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Object_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void Parrot_Object_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_Object_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Object_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Object_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_Object_visit(PARROT_INTERP, PMC *pmc, visit_info *info);
void    Parrot_Object_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Object_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Object_get_vtable(PARROT_INTERP);
void    Parrot_Object_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Object_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Object_ro_get_vtable(PARROT_INTERP);
static  PMC *
Parrot_Object_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "absolute");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", dest);
            
        }
        /* method name is absolute */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_absolute(interp, del_object, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->absolute(interp, pmc, dest);
    
}
static  PMC *
Parrot_Object_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is add */
    }
    return (PMC*)interp->vtables[enum_class_default]->add(interp, pmc, value, dest);
    
}
static  void
Parrot_Object_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add_attribute");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSP", name, type);
            return;
        }
        /* method name is add_attribute */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_add_attribute(interp, del_object, name, type);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->add_attribute(interp, pmc, name, type);
    return;
}
static  PMC *
Parrot_Object_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PNP", value, dest);
            
        }
        /* method name is add_float */
    }
    return (PMC*)interp->vtables[enum_class_default]->add_float(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is add_int */
    }
    return (PMC*)interp->vtables[enum_class_default]->add_int(interp, pmc, value, dest);
    
}
static  void
Parrot_Object_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add_method");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSP", method_name, sub_pmc);
            return;
        }
        /* method name is add_method */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_add_method(interp, del_object, method_name, sub_pmc);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->add_method(interp, pmc, method_name, sub_pmc);
    return;
}
static  void
Parrot_Object_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add_parent");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", parent);
            return;
        }
        /* method name is add_parent */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_add_parent(interp, del_object, parent);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->add_parent(interp, pmc, parent);
    return;
}
static  void
Parrot_Object_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add_role");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", role);
            return;
        }
        /* method name is add_role */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_add_role(interp, del_object, role);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->add_role(interp, pmc, role);
    return;
}
static  void
Parrot_Object_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "add_vtable_override");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSP", vtable_name, sub_pmc);
            return;
        }
        /* method name is add_vtable_override */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_add_vtable_override(interp, del_object, vtable_name, sub_pmc);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->add_vtable_override(interp, pmc, vtable_name, sub_pmc);
    return;
}
static  void
Parrot_Object_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "assign_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is assign_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_assign_pmc(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->assign_pmc(interp, pmc, value);
    return;
}
static  void
Parrot_Object_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "assign_string_native");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is assign_string_native */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_assign_string_native(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->assign_string_native(interp, pmc, value);
    return;
}
static  PMC *
Parrot_Object_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_and");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_and */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_and(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_and(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_and_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is bitwise_and_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_and_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_and_int(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_ands");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_ands */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_ands(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_ands(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_ands_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PSP", value, dest);
            
        }
        /* method name is bitwise_ands_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_ands_str(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_ands_str(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_lsr");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_lsr */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_lsr(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_lsr(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_lsr_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is bitwise_lsr_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_lsr_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_lsr_int(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_not");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", dest);
            
        }
        /* method name is bitwise_not */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_not(interp, del_object, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_not(interp, pmc, dest);
    
}
static  PMC *
Parrot_Object_bitwise_nots(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_nots");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", dest);
            
        }
        /* method name is bitwise_nots */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_nots(interp, del_object, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_nots(interp, pmc, dest);
    
}
static  PMC *
Parrot_Object_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_or");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_or */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_or(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_or(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_or_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is bitwise_or_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_or_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_or_int(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_ors");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_ors */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_ors(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_ors(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_ors_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PSP", value, dest);
            
        }
        /* method name is bitwise_ors_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_ors_str(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_ors_str(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_shl");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_shl */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_shl(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_shl(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_shl_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is bitwise_shl_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_shl_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_shl_int(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_shr");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_shr */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_shr(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_shr(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_shr_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is bitwise_shr_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_shr_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_shr_int(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_xor");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_xor */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_xor(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_xor(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_xor_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is bitwise_xor_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_xor_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_xor_int(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_xors");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is bitwise_xors */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_xors(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_xors(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "bitwise_xors_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PSP", value, dest);
            
        }
        /* method name is bitwise_xors_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_bitwise_xors_str(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->bitwise_xors_str(interp, pmc, value, dest);
    
}
static  INTVAL 
Parrot_Object_can(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
#line 474 "./src/pmc/object.pmc"

    /* Just use find_method and see it if finds anything. */
    const PMC * const method = VTABLE_find_method(interp, pmc, method_name);
    return !PMC_IS_NULL(method);
#line 1406 "./src/pmc/object.c"
}
static  PMC * 
Parrot_Object_clone(PARROT_INTERP, PMC *pmc)
{
#line 644 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj = PARROT_OBJECT(pmc);
    /* If we have a custom override, invoke it.
     * If not, use the oo function. */
    STRING * const meth_name = CONST_STRING(interp, "clone");
    PMC * const meth =
            Parrot_oo_find_vtable_override(interp, obj->_class, meth_name);
    if (!PMC_IS_NULL(meth))
        return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
    else
        return Parrot_oo_clone_object(interp, pmc, obj->_class, NULL);
#line 1423 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "clone_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", args);
            
        }
        /* method name is clone_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_clone_pmc(interp, del_object, args);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->clone_pmc(interp, pmc, args);
    
}
static  INTVAL
Parrot_Object_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "cmp");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", value);
            
        }
        /* method name is cmp */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_cmp(interp, del_object, value);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->cmp(interp, pmc, value);
    
}
static  INTVAL
Parrot_Object_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "cmp_num");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", value);
            
        }
        /* method name is cmp_num */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_cmp_num(interp, del_object, value);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->cmp_num(interp, pmc, value);
    
}
static  PMC *
Parrot_Object_cmp_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "cmp_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", value);
            
        }
        /* method name is cmp_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_cmp_pmc(interp, del_object, value);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->cmp_pmc(interp, pmc, value);
    
}
static  INTVAL
Parrot_Object_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "cmp_string");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", value);
            
        }
        /* method name is cmp_string */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_cmp_string(interp, del_object, value);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->cmp_string(interp, pmc, value);
    
}
static  PMC *
Parrot_Object_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "concatenate");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is concatenate */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_concatenate(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->concatenate(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "concatenate_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PSP", value, dest);
            
        }
        /* method name is concatenate_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_concatenate_str(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->concatenate_str(interp, pmc, value, dest);
    
}
static  void
Parrot_Object_decrement(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "decrement");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is decrement */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_decrement(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->decrement(interp, pmc);
    return;
}
static  INTVAL
Parrot_Object_defined(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "defined");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "I");
            
        }
        /* method name is defined */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_defined(interp, del_object);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->defined(interp, pmc);
    
}
static  INTVAL
Parrot_Object_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "defined_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", key);
            
        }
        /* method name is defined_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_defined_keyed(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->defined_keyed(interp, pmc, key);
    
}
static  INTVAL
Parrot_Object_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "defined_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "II", key);
            
        }
        /* method name is defined_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_defined_keyed_int(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->defined_keyed_int(interp, pmc, key);
    
}
static  INTVAL
Parrot_Object_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "defined_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IS", key);
            
        }
        /* method name is defined_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_defined_keyed_str(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->defined_keyed_str(interp, pmc, key);
    
}
static  void
Parrot_Object_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "delete_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", key);
            return;
        }
        /* method name is delete_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_delete_keyed(interp, del_object, key);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->delete_keyed(interp, pmc, key);
    return;
}
static  void
Parrot_Object_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "delete_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", key);
            return;
        }
        /* method name is delete_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_delete_keyed_int(interp, del_object, key);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->delete_keyed_int(interp, pmc, key);
    return;
}
static  void
Parrot_Object_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "delete_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", key);
            return;
        }
        /* method name is delete_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_delete_keyed_str(interp, del_object, key);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->delete_keyed_str(interp, pmc, key);
    return;
}
static  void
Parrot_Object_delprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "delprop");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", key);
            return;
        }
        /* method name is delprop */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_delprop(interp, del_object, key);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->delprop(interp, pmc, key);
    return;
}
static  void 
Parrot_Object_destroy(PARROT_INTERP, PMC *pmc)
{
#line 154 "./src/pmc/object.pmc"

#line 1974 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "divide");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is divide */
    }
    return (PMC*)interp->vtables[enum_class_default]->divide(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "divide_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PNP", value, dest);
            
        }
        /* method name is divide_float */
    }
    return (PMC*)interp->vtables[enum_class_default]->divide_float(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "divide_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is divide_int */
    }
    return (PMC*)interp->vtables[enum_class_default]->divide_int(interp, pmc, value, dest);
    
}
static  INTVAL 
Parrot_Object_does(PARROT_INTERP, PMC *pmc, STRING *role_name)
{
#line 531 "./src/pmc/object.pmc"

    /* If it's a null string, return false */
    if (!role_name)
        return 0;
    else {
        PMC    * const classobj  = VTABLE_get_class(interp, pmc);
        STRING * const meth_name = CONST_STRING(interp, "does");

        PMC * const method = Parrot_oo_find_vtable_override(interp,
            classobj, meth_name);

        if (!PMC_IS_NULL(method)
         && Parrot_run_meth_fromc_args_reti(interp, method, pmc, meth_name, "IS", role_name))
            return 1;
    }
    /* Check the superclass's vtable interface, if any. */
    if (interp->vtables[enum_class_default]->does(interp, pmc, role_name))
        return 1;

    /* Dispatch to the object's class */
    return VTABLE_does(interp, VTABLE_get_class(interp, pmc), role_name);
#line 2073 "./src/pmc/object.c"
}
static  INTVAL 
Parrot_Object_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 564 "./src/pmc/object.pmc"

    if (PMC_IS_NULL(role))
        return 0;

    if (interp->vtables[enum_class_default]->does_pmc(interp, pmc, role))
        return 1;

    /* Dispatch to the object's class */
    return VTABLE_does_pmc(interp, VTABLE_get_class(interp, pmc), role);
#line 2088 "./src/pmc/object.c"
}
static  INTVAL
Parrot_Object_elements(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "elements");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "I");
            
        }
        /* method name is elements */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_elements(interp, del_object);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->elements(interp, pmc);
    
}
static  INTVAL
Parrot_Object_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "exists_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", key);
            
        }
        /* method name is exists_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_exists_keyed(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->exists_keyed(interp, pmc, key);
    
}
static  INTVAL
Parrot_Object_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "exists_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "II", key);
            
        }
        /* method name is exists_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_exists_keyed_int(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->exists_keyed_int(interp, pmc, key);
    
}
static  INTVAL
Parrot_Object_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "exists_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IS", key);
            
        }
        /* method name is exists_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_exists_keyed_str(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->exists_keyed_str(interp, pmc, key);
    
}
static  PMC  *
Parrot_Object_find_method(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 326 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj         = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class      = PARROT_CLASS(obj->_class);
    STRING                   * const find_method = CONST_STRING(interp, "find_method");
    PMC           *method        = PMCNULL;

    /* Walk and search. One day, we'll use the cache first. */
    const int num_classes        = VTABLE_elements(interp,
                                                  _class->all_parents);
    const int all_in_universe    = !CLASS_has_alien_parents_TEST(obj->_class);
    int i;

    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class =
            VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        const Parrot_Class_attributes * const class_info = PARROT_CLASS(cur_class);

        /* If there's a vtable override for 'find_method' in the current
         * class, run that first. */
        method = Parrot_oo_find_vtable_override_for_class(interp, cur_class,
                find_method);

        if (!PMC_IS_NULL(method))
            return (PMC *)Parrot_run_meth_fromc_args(interp, method, pmc,
                    find_method, "PS", name);

        /* If it's from this universe or the class doesn't inherit from
         * anything outside of it... */
        if (all_in_universe || VTABLE_isa(interp, cur_class, CONST_STRING(interp, "Class"))) {
            method = VTABLE_get_pmc_keyed_str(interp, class_info->methods, name);
            /* Found it! */
            if (!PMC_IS_NULL(method))
                break;
        }
        else {
            Parrot_ex_throw_from_c_args(interp, NULL, -1,
                    "Class %Ss inherits from alien parents.", class_info->name);
        }
    }

    return method;
#line 2273 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "floor_divide");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is floor_divide */
    }
    return (PMC*)interp->vtables[enum_class_default]->floor_divide(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "floor_divide_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PNP", value, dest);
            
        }
        /* method name is floor_divide_float */
    }
    return (PMC*)interp->vtables[enum_class_default]->floor_divide_float(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "floor_divide_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is floor_divide_int */
    }
    return (PMC*)interp->vtables[enum_class_default]->floor_divide_int(interp, pmc, value, dest);
    
}
static  void
Parrot_Object_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "freeze");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v?", info);
            return;
        }
        /* method name is freeze */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_freeze(interp, del_object, info);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->freeze(interp, pmc, info);
    return;
}
static  PMC  *
Parrot_Object_get_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name)
{
#line 244 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj = PARROT_OBJECT(pmc);

    /* Look up the index. */
    const INTVAL index = get_attrib_index_keyed(interp, obj->_class, key, name);

    /* If lookup failed, exception. */
    if (index == -1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S' in class '%S'", name,
            VTABLE_get_string(interp, key));

    return VTABLE_get_pmc_keyed_int(interp, obj->attrib_store, index);
#line 2398 "./src/pmc/object.c"
}
static  PMC  *
Parrot_Object_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 210 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj      = PARROT_OBJECT(pmc);
    STRING        * const get_attr = CONST_STRING(interp, "get_attr_str");
    INTVAL index;

    /* If there's a vtable override for 'get_attr_str' run that first. */
    PMC * const method = Parrot_oo_find_vtable_override(interp,
            VTABLE_get_class(interp, pmc), get_attr);

    if (!PMC_IS_NULL(method))
        return (PMC *)Parrot_run_meth_fromc_args(interp, method, pmc,
                get_attr, "PS", name);

    /* Look up the index. */
    index = get_attrib_index(interp, obj->_class, name);

    /* If lookup failed, exception. */
    if (index == -1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S'", name);

    return VTABLE_get_pmc_keyed_int(interp, obj->attrib_store, index);
#line 2426 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_get_bignum(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_bignum");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
            
        }
        /* method name is get_bignum */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_get_bignum(interp, del_object);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->get_bignum(interp, pmc);
    
}
static  INTVAL
Parrot_Object_get_bool(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_bool");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "I");
            
        }
        /* method name is get_bool */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_get_bool(interp, del_object);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->get_bool(interp, pmc);
    
}
static  PMC  *
Parrot_Object_get_class(PARROT_INTERP, PMC *pmc)
{
#line 425 "./src/pmc/object.pmc"

    PMC    * const classobj  = PARROT_OBJECT(pmc)->_class;
    STRING * const get_class = CONST_STRING(interp, "get_class");
    /* If there's a vtable override for 'get_class' run that instead. */
    PMC * const method = Parrot_oo_find_vtable_override(interp,
            classobj, get_class);

    if (!PMC_IS_NULL(method))
        return (PMC *)Parrot_run_meth_fromc_args(interp, method, pmc,
                get_class, "P");

    return classobj;
#line 2512 "./src/pmc/object.c"
}
static  INTVAL 
Parrot_Object_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 380 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING * const meth_name = CONST_STRING(interp, "get_integer");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp,
                cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            INTVAL result;
            Parrot_pcc_invoke_sub_from_c_args(interp, meth, "P->I", pmc, &result);
            return result;
/*            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "I"); */

        }
        /* method name is get_integer */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_get_integer(interp, del_object);

            }
        }
    }
    return interp->vtables[enum_class_default]->get_integer(interp, pmc);
#line 2552 "./src/pmc/object.c"
}
static  INTVAL
Parrot_Object_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_integer_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", key);
            
        }
        /* method name is get_integer_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_get_integer_keyed(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->get_integer_keyed(interp, pmc, key);
    
}
static  INTVAL
Parrot_Object_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_integer_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "II", key);
            
        }
        /* method name is get_integer_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_get_integer_keyed_int(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->get_integer_keyed_int(interp, pmc, key);
    
}
static  INTVAL
Parrot_Object_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_integer_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IS", key);
            
        }
        /* method name is get_integer_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_get_integer_keyed_str(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->get_integer_keyed_str(interp, pmc, key);
    
}
static  PMC *
Parrot_Object_get_iter(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_iter");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
            
        }
        /* method name is get_iter */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_get_iter(interp, del_object);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->get_iter(interp, pmc);
    
}
static  PMC  *
Parrot_Object_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 449 "./src/pmc/object.pmc"

    PMC    * const classobj      = VTABLE_get_class(interp, pmc);
    STRING * const get_namespace = CONST_STRING(interp, "get_namespace");
    /* If there's a vtable override for 'get_namespace' run that instead. */
    PMC * const method = Parrot_oo_find_vtable_override(interp,
            classobj, get_namespace);

    if (!PMC_IS_NULL(method))
        return (PMC *)Parrot_run_meth_fromc_args(interp, method, pmc,
                get_namespace, "P");
    else
        return VTABLE_inspect_str(interp, classobj, CONST_STRING(interp, "namespace"));

#line 2707 "./src/pmc/object.c"
}
static  FLOATVAL
Parrot_Object_get_number(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_number");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, meth, pmc, meth_name, "N");
            
        }
        /* method name is get_number */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (FLOATVAL)VTABLE_get_number(interp, del_object);
                
            }
        }
    }
    return (FLOATVAL)interp->vtables[enum_class_default]->get_number(interp, pmc);
    
}
static  FLOATVAL
Parrot_Object_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_number_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, meth, pmc, meth_name, "NP", key);
            
        }
        /* method name is get_number_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (FLOATVAL)VTABLE_get_number_keyed(interp, del_object, key);
                
            }
        }
    }
    return (FLOATVAL)interp->vtables[enum_class_default]->get_number_keyed(interp, pmc, key);
    
}
static  FLOATVAL
Parrot_Object_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_number_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, meth, pmc, meth_name, "NI", key);
            
        }
        /* method name is get_number_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (FLOATVAL)VTABLE_get_number_keyed_int(interp, del_object, key);
                
            }
        }
    }
    return (FLOATVAL)interp->vtables[enum_class_default]->get_number_keyed_int(interp, pmc, key);
    
}
static  FLOATVAL
Parrot_Object_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_number_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, meth, pmc, meth_name, "NS", key);
            
        }
        /* method name is get_number_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (FLOATVAL)VTABLE_get_number_keyed_str(interp, del_object, key);
                
            }
        }
    }
    return (FLOATVAL)interp->vtables[enum_class_default]->get_number_keyed_str(interp, pmc, key);
    
}
static  PMC *
Parrot_Object_get_pmc(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
            
        }
        /* method name is get_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_get_pmc(interp, del_object);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->get_pmc(interp, pmc);
    
}
static  PMC *
Parrot_Object_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pmc_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", key);
            
        }
        /* method name is get_pmc_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_get_pmc_keyed(interp, del_object, key);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->get_pmc_keyed(interp, pmc, key);
    
}
static  PMC *
Parrot_Object_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pmc_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PI", key);
            
        }
        /* method name is get_pmc_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_get_pmc_keyed_int(interp, del_object, key);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->get_pmc_keyed_int(interp, pmc, key);
    
}
static  PMC *
Parrot_Object_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pmc_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PS", key);
            
        }
        /* method name is get_pmc_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_get_pmc_keyed_str(interp, del_object, key);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->get_pmc_keyed_str(interp, pmc, key);
    
}
static  void *
Parrot_Object_get_pointer(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pointer");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (void*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "V");
            
        }
        /* method name is get_pointer */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (void*)VTABLE_get_pointer(interp, del_object);
                
            }
        }
    }
    return (void*)interp->vtables[enum_class_default]->get_pointer(interp, pmc);
    
}
static  void *
Parrot_Object_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pointer_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (void*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "VP", key);
            
        }
        /* method name is get_pointer_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (void*)VTABLE_get_pointer_keyed(interp, del_object, key);
                
            }
        }
    }
    return (void*)interp->vtables[enum_class_default]->get_pointer_keyed(interp, pmc, key);
    
}
static  void *
Parrot_Object_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pointer_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (void*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "VI", key);
            
        }
        /* method name is get_pointer_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (void*)VTABLE_get_pointer_keyed_int(interp, del_object, key);
                
            }
        }
    }
    return (void*)interp->vtables[enum_class_default]->get_pointer_keyed_int(interp, pmc, key);
    
}
static  void *
Parrot_Object_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_pointer_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (void*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "VS", key);
            
        }
        /* method name is get_pointer_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (void*)VTABLE_get_pointer_keyed_str(interp, del_object, key);
                
            }
        }
    }
    return (void*)interp->vtables[enum_class_default]->get_pointer_keyed_str(interp, pmc, key);
    
}
static  STRING *
Parrot_Object_get_repr(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_repr");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "S");
            
        }
        /* method name is get_repr */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_get_repr(interp, del_object);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->get_repr(interp, pmc);
    
}
static  STRING *
Parrot_Object_get_string(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_string");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "S");
            
        }
        /* method name is get_string */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_get_string(interp, del_object);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->get_string(interp, pmc);
    
}
static  STRING *
Parrot_Object_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_string_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "SP", key);
            
        }
        /* method name is get_string_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_get_string_keyed(interp, del_object, key);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->get_string_keyed(interp, pmc, key);
    
}
static  STRING *
Parrot_Object_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_string_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "SI", key);
            
        }
        /* method name is get_string_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_get_string_keyed_int(interp, del_object, key);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->get_string_keyed_int(interp, pmc, key);
    
}
static  STRING *
Parrot_Object_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "get_string_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "SS", key);
            
        }
        /* method name is get_string_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_get_string_keyed_str(interp, del_object, key);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->get_string_keyed_str(interp, pmc, key);
    
}
static  PMC *
Parrot_Object_getprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "getprop");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PS", key);
            
        }
        /* method name is getprop */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_getprop(interp, del_object, key);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->getprop(interp, pmc, key);
    
}
static  PMC *
Parrot_Object_getprops(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "getprops");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
            
        }
        /* method name is getprops */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_getprops(interp, del_object);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->getprops(interp, pmc);
    
}
static  void
Parrot_Object_i_absolute(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_absolute");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is i_absolute */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_absolute(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_absolute(interp, pmc);
    return;
}
static  void
Parrot_Object_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_add");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_add */
    }
    interp->vtables[enum_class_default]->i_add(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_add_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is i_add_float */
    }
    interp->vtables[enum_class_default]->i_add_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_add_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_add_int */
    }
    interp->vtables[enum_class_default]->i_add_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_and");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_and */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_and(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_and(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_and_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_bitwise_and_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_and_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_and_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_ands");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_ands */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_ands(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_ands(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_ands_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is i_bitwise_ands_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_ands_str(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_ands_str(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_lsr");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_lsr */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_lsr(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_lsr(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_lsr_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_bitwise_lsr_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_lsr_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_lsr_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_not");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is i_bitwise_not */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_not(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_not(interp, pmc);
    return;
}
static  void
Parrot_Object_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_nots");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is i_bitwise_nots */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_nots(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_nots(interp, pmc);
    return;
}
static  void
Parrot_Object_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_or");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_or */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_or(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_or(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_or_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_bitwise_or_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_or_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_or_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_ors");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_ors */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_ors(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_ors(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_ors_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is i_bitwise_ors_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_ors_str(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_ors_str(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_shl");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_shl */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_shl(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_shl(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_shl_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_bitwise_shl_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_shl_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_shl_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_shr");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_shr */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_shr(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_shr(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_shr_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_bitwise_shr_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_shr_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_shr_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_xor");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_xor */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_xor(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_xor(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_xor_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_bitwise_xor_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_xor_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_xor_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_xors");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_bitwise_xors */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_xors(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_xors(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_bitwise_xors_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is i_bitwise_xors_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_bitwise_xors_str(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_bitwise_xors_str(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_concatenate");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_concatenate */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_concatenate(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_concatenate(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_concatenate_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is i_concatenate_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_concatenate_str(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_concatenate_str(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_divide");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_divide */
    }
    interp->vtables[enum_class_default]->i_divide(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_divide_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is i_divide_float */
    }
    interp->vtables[enum_class_default]->i_divide_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_divide_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_divide_int */
    }
    interp->vtables[enum_class_default]->i_divide_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_floor_divide");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_floor_divide */
    }
    interp->vtables[enum_class_default]->i_floor_divide(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_floor_divide_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is i_floor_divide_float */
    }
    interp->vtables[enum_class_default]->i_floor_divide_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_floor_divide_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_floor_divide_int */
    }
    interp->vtables[enum_class_default]->i_floor_divide_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_logical_not");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is i_logical_not */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_logical_not(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_logical_not(interp, pmc);
    return;
}
static  void
Parrot_Object_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_modulus");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_modulus */
    }
    interp->vtables[enum_class_default]->i_modulus(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_modulus_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is i_modulus_float */
    }
    interp->vtables[enum_class_default]->i_modulus_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_modulus_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_modulus_int */
    }
    interp->vtables[enum_class_default]->i_modulus_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_multiply");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_multiply */
    }
    interp->vtables[enum_class_default]->i_multiply(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_multiply_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is i_multiply_float */
    }
    interp->vtables[enum_class_default]->i_multiply_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_multiply_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_multiply_int */
    }
    interp->vtables[enum_class_default]->i_multiply_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_neg(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_neg");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is i_neg */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_neg(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_neg(interp, pmc);
    return;
}
static  void
Parrot_Object_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_pow");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_pow */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_pow(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_pow(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_pow_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is i_pow_float */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_pow_float(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_pow_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_pow_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_pow_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_pow_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_pow_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_repeat");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_repeat */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_repeat(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_repeat(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_repeat_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_repeat_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_i_repeat_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->i_repeat_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_subtract");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is i_subtract */
    }
    interp->vtables[enum_class_default]->i_subtract(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_subtract_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is i_subtract_float */
    }
    interp->vtables[enum_class_default]->i_subtract_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "i_subtract_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is i_subtract_int */
    }
    interp->vtables[enum_class_default]->i_subtract_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_increment(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "increment");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is increment */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_increment(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->increment(interp, pmc);
    return;
}
static  void 
Parrot_Object_init(PARROT_INTERP, PMC *pmc)
{
#line 124 "./src/pmc/object.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
        "Object must be created by a class.");
#line 4848 "./src/pmc/object.c"
}
static  void 
Parrot_Object_init_pmc(PARROT_INTERP, PMC *pmc, PMC *worreva)
{
#line 140 "./src/pmc/object.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Object must be created by a class.");
#line 4857 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_inspect(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "inspect");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
            
        }
        /* method name is inspect */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_inspect(interp, del_object);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->inspect(interp, pmc);
    
}
static  PMC *
Parrot_Object_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "inspect_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PS", what);
            
        }
        /* method name is inspect_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_inspect_str(interp, del_object, what);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->inspect_str(interp, pmc, what);
    
}
static  PMC *
Parrot_Object_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "instantiate");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", sig);
            
        }
        /* method name is instantiate */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_instantiate(interp, del_object, sig);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->instantiate(interp, pmc, sig);
    
}
static  PMC *
Parrot_Object_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "instantiate_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PSI", rep, flags);
            
        }
        /* method name is instantiate_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_instantiate_str(interp, del_object, rep, flags);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->instantiate_str(interp, pmc, rep, flags);
    
}
static  opcode_t * 
Parrot_Object_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 585 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj    = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class = PARROT_CLASS(obj->_class);

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;

    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        STRING * const meth_name = CONST_STRING(interp, "invoke");
        STRING * const proxy     = CONST_STRING(interp, "proxy");
        PMC * const cur_class =
            VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth =
            Parrot_oo_find_vtable_override_for_class(interp, cur_class,
                                                     meth_name);
        if (!PMC_IS_NULL(meth))
            return VTABLE_invoke(interp, meth, next);

        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            PMC * const del_object =
                VTABLE_get_attr_keyed(interp, pmc, cur_class, proxy);

            if (!PMC_IS_NULL(del_object))
                return VTABLE_invoke(interp, del_object, next);
        }
    }

    return (opcode_t *)interp->vtables[enum_class_default]->invoke(interp, pmc, next);
#line 5031 "./src/pmc/object.c"
}
static  INTVAL
Parrot_Object_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "is_equal");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", value);
            
        }
        /* method name is is_equal */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_is_equal(interp, del_object, value);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->is_equal(interp, pmc, value);
    
}
static  INTVAL
Parrot_Object_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "is_equal_num");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", value);
            
        }
        /* method name is is_equal_num */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_is_equal_num(interp, del_object, value);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->is_equal_num(interp, pmc, value);
    
}
static  INTVAL
Parrot_Object_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "is_equal_string");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", value);
            
        }
        /* method name is is_equal_string */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_is_equal_string(interp, del_object, value);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->is_equal_string(interp, pmc, value);
    
}
static  INTVAL
Parrot_Object_is_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "is_same");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", value);
            
        }
        /* method name is is_same */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_is_same(interp, del_object, value);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->is_same(interp, pmc, value);
    
}
static  INTVAL 
Parrot_Object_isa(PARROT_INTERP, PMC *pmc, STRING *classname)
{
#line 511 "./src/pmc/object.pmc"

    PMC   *_class;

    if (interp->vtables[enum_class_default]->isa(interp, pmc, classname))
        return 1;

    _class = VTABLE_get_class(interp, pmc);
    return VTABLE_isa(interp, _class, classname);
#line 5181 "./src/pmc/object.c"
}
static  INTVAL 
Parrot_Object_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup)
{
#line 490 "./src/pmc/object.pmc"

    if (PMC_IS_NULL(lookup))
        return 0;

    if (interp->vtables[enum_class_default]->isa_pmc(interp, pmc, lookup))
        return 1;

    /* Dispatch isa to the object's class */
    return VTABLE_isa_pmc(interp, VTABLE_get_class(interp, pmc), lookup);
#line 5196 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "logical_and");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is logical_and */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_logical_and(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->logical_and(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "logical_not");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", dest);
            
        }
        /* method name is logical_not */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_logical_not(interp, del_object, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->logical_not(interp, pmc, dest);
    
}
static  PMC *
Parrot_Object_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "logical_or");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is logical_or */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_logical_or(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->logical_or(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "logical_xor");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is logical_xor */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_logical_xor(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->logical_xor(interp, pmc, value, dest);
    
}
static  void 
Parrot_Object_mark(PARROT_INTERP, PMC *pmc)
{
#line 189 "./src/pmc/object.pmc"

    if (PARROT_OBJECT(pmc)) {
        Parrot_Object_attributes * const obj = PARROT_OBJECT(pmc);

        if (obj->_class)
            Parrot_gc_mark_PObj_alive(interp, (PObj*)obj->_class);
        if (obj->attrib_store)
            Parrot_gc_mark_PObj_alive(interp, (PObj*)obj->attrib_store);
    }
#line 5347 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "modulus");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is modulus */
    }
    return (PMC*)interp->vtables[enum_class_default]->modulus(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "modulus_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PNP", value, dest);
            
        }
        /* method name is modulus_float */
    }
    return (PMC*)interp->vtables[enum_class_default]->modulus_float(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "modulus_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is modulus_int */
    }
    return (PMC*)interp->vtables[enum_class_default]->modulus_int(interp, pmc, value, dest);
    
}
static  void 
Parrot_Object_morph(PARROT_INTERP, PMC *pmc, PMC *type)
{
#line 790 "./src/pmc/object.pmc"

    PMC    * const classobj  = VTABLE_get_class(interp, pmc);
    STRING * const meth_name = CONST_STRING(interp, "morph");
    /* If there's a vtable override for 'morph' run that instead. */
    PMC * const method = Parrot_oo_find_vtable_override(interp,
            classobj, meth_name);

    if (!PMC_IS_NULL(method))
        Parrot_run_meth_fromc_args(interp, method, pmc, meth_name, "vP", type);
    else
        interp->vtables[enum_class_default]->morph(interp, pmc, type);
#line 5436 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "multiply");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is multiply */
    }
    return (PMC*)interp->vtables[enum_class_default]->multiply(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "multiply_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PNP", value, dest);
            
        }
        /* method name is multiply_float */
    }
    return (PMC*)interp->vtables[enum_class_default]->multiply_float(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "multiply_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is multiply_int */
    }
    return (PMC*)interp->vtables[enum_class_default]->multiply_int(interp, pmc, value, dest);
    
}
static  STRING  *
Parrot_Object_name(PARROT_INTERP, PMC *pmc)
{
#line 167 "./src/pmc/object.pmc"

    PMC    * const _class     = VTABLE_get_class(interp, pmc);
    STRING * const name       = CONST_STRING(interp, "name");

    /* If there's a vtable override for 'name' run that instead. */
    PMC * const method = Parrot_oo_find_vtable_override(interp, _class, name);

    if (!PMC_IS_NULL(method))
        return (STRING *)Parrot_run_meth_fromc_args(interp, method, pmc, name, "S");
    else
        return VTABLE_get_string(interp, _class);
#line 5525 "./src/pmc/object.c"
}
static  PMC *
Parrot_Object_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "neg");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PP", dest);
            
        }
        /* method name is neg */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_neg(interp, del_object, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->neg(interp, pmc, dest);
    
}
static  FLOATVAL
Parrot_Object_pop_float(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "pop_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, meth, pmc, meth_name, "N");
            
        }
        /* method name is pop_float */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (FLOATVAL)VTABLE_pop_float(interp, del_object);
                
            }
        }
    }
    return (FLOATVAL)interp->vtables[enum_class_default]->pop_float(interp, pmc);
    
}
static  INTVAL
Parrot_Object_pop_integer(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "pop_integer");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "I");
            
        }
        /* method name is pop_integer */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_pop_integer(interp, del_object);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->pop_integer(interp, pmc);
    
}
static  PMC *
Parrot_Object_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "pop_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
            
        }
        /* method name is pop_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_pop_pmc(interp, del_object);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->pop_pmc(interp, pmc);
    
}
static  STRING *
Parrot_Object_pop_string(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "pop_string");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "S");
            
        }
        /* method name is pop_string */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_pop_string(interp, del_object);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->pop_string(interp, pmc);
    
}
static  PMC *
Parrot_Object_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "pow");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is pow */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_pow(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->pow(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "pow_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PNP", value, dest);
            
        }
        /* method name is pow_float */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_pow_float(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->pow_float(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "pow_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is pow_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_pow_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->pow_int(interp, pmc, value, dest);
    
}
static  void
Parrot_Object_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "push_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is push_float */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_push_float(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->push_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "push_integer");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is push_integer */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_push_integer(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->push_integer(interp, pmc, value);
    return;
}
static  void
Parrot_Object_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "push_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is push_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_push_pmc(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->push_pmc(interp, pmc, value);
    return;
}
static  void
Parrot_Object_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "push_string");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is push_string */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_push_string(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->push_string(interp, pmc, value);
    return;
}
static  void
Parrot_Object_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "remove_attribute");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", name);
            return;
        }
        /* method name is remove_attribute */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_remove_attribute(interp, del_object, name);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->remove_attribute(interp, pmc, name);
    return;
}
static  void
Parrot_Object_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "remove_method");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", method_name);
            return;
        }
        /* method name is remove_method */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_remove_method(interp, del_object, method_name);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->remove_method(interp, pmc, method_name);
    return;
}
static  void
Parrot_Object_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "remove_parent");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", parent);
            return;
        }
        /* method name is remove_parent */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_remove_parent(interp, del_object, parent);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->remove_parent(interp, pmc, parent);
    return;
}
static  void
Parrot_Object_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "remove_role");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", role);
            return;
        }
        /* method name is remove_role */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_remove_role(interp, del_object, role);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->remove_role(interp, pmc, role);
    return;
}
static  void
Parrot_Object_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "remove_vtable_override");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", vtable_name);
            return;
        }
        /* method name is remove_vtable_override */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_remove_vtable_override(interp, del_object, vtable_name);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->remove_vtable_override(interp, pmc, vtable_name);
    return;
}
static  PMC *
Parrot_Object_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "repeat");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is repeat */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_repeat(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->repeat(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "repeat_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is repeat_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_repeat_int(interp, del_object, value, dest);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->repeat_int(interp, pmc, value, dest);
    
}
static  void 
Parrot_Object_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name, PMC *value)
{
#line 304 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj = PARROT_OBJECT(pmc);
    const INTVAL index        = get_attrib_index_keyed(interp, obj->_class, key, name);

    /* If lookup failed, exception. */
    if (index == -1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S' in class '%S'", name,
            VTABLE_get_string(interp, key));

    VTABLE_set_pmc_keyed_int(interp, obj->attrib_store, index, value);
#line 6188 "./src/pmc/object.c"
}
static  void 
Parrot_Object_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *name, PMC *value)
{
#line 269 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    STRING        * const vtable_meth_name = CONST_STRING(interp, "set_attr_str");
    INTVAL         index;

    /* If there's a vtable override for 'set_attr_str' run that first. */
    PMC * const method = Parrot_oo_find_vtable_override(interp,
            VTABLE_get_class(interp, pmc), vtable_meth_name);
    if (!PMC_IS_NULL(method)) {
        PMC *unused = (PMC *)Parrot_run_meth_fromc_args(interp, method,
            pmc, vtable_meth_name, "vSP", name, value);
        UNUSED(unused);
        return;
    }

    index = get_attrib_index(interp, obj->_class, name);

    /* If lookup failed, exception. */
    if (index == -1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S'", name);

    VTABLE_set_pmc_keyed_int(interp, obj->attrib_store, index, value);
#line 6217 "./src/pmc/object.c"
}
static  void
Parrot_Object_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_bignum_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is set_bignum_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_bignum_int(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_bignum_int(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_bignum_num");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is set_bignum_num */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_bignum_num(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_bignum_num(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_bignum_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is set_bignum_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_bignum_str(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_bignum_str(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_bool");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is set_bool */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_bool(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_bool(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_integer_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vPI", key, value);
            return;
        }
        /* method name is set_integer_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_integer_keyed(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_integer_keyed(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_integer_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vII", key, value);
            return;
        }
        /* method name is set_integer_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_integer_keyed_int(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_integer_keyed_int(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_integer_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSI", key, value);
            return;
        }
        /* method name is set_integer_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_integer_keyed_str(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_integer_keyed_str(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_integer_native");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is set_integer_native */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_integer_native(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_integer_native(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_number_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vPN", key, value);
            return;
        }
        /* method name is set_number_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_number_keyed(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_number_keyed(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_number_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vIN", key, value);
            return;
        }
        /* method name is set_number_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_number_keyed_int(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_number_keyed_int(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_number_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSN", key, value);
            return;
        }
        /* method name is set_number_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_number_keyed_str(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_number_keyed_str(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_number_native");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is set_number_native */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_number_native(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_number_native(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is set_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pmc(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pmc(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pmc_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vPP", key, value);
            return;
        }
        /* method name is set_pmc_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pmc_keyed(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pmc_keyed(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pmc_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vIP", key, value);
            return;
        }
        /* method name is set_pmc_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pmc_keyed_int(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pmc_keyed_int(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pmc_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSP", key, value);
            return;
        }
        /* method name is set_pmc_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pmc_keyed_str(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pmc_keyed_str(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pointer");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vV", value);
            return;
        }
        /* method name is set_pointer */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pointer(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pointer(interp, pmc, value);
    return;
}
static  void
Parrot_Object_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pointer_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vPV", key, value);
            return;
        }
        /* method name is set_pointer_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pointer_keyed(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pointer_keyed(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pointer_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vIV", key, value);
            return;
        }
        /* method name is set_pointer_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pointer_keyed_int(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pointer_keyed_int(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_pointer_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSV", key, value);
            return;
        }
        /* method name is set_pointer_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_pointer_keyed_str(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_pointer_keyed_str(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_string_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vPS", key, value);
            return;
        }
        /* method name is set_string_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_string_keyed(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_string_keyed(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_string_keyed_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vIS", key, value);
            return;
        }
        /* method name is set_string_keyed_int */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_string_keyed_int(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_string_keyed_int(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_string_keyed_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSS", key, value);
            return;
        }
        /* method name is set_string_keyed_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_string_keyed_str(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_string_keyed_str(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "set_string_native");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is set_string_native */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_set_string_native(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->set_string_native(interp, pmc, value);
    return;
}
static  void
Parrot_Object_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "setprop");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vSP", key, value);
            return;
        }
        /* method name is setprop */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_setprop(interp, del_object, key, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->setprop(interp, pmc, key, value);
    return;
}
static  void
Parrot_Object_share(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "share");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "v");
            return;
        }
        /* method name is share */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_share(interp, del_object);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->share(interp, pmc);
    return;
}
static  PMC  *
Parrot_Object_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 728 "./src/pmc/object.pmc"

    PMC   *ret, *_true, *data;
    INTVAL i, n;
    PMC *classobj;
    Parrot_Interp  master;
    INTVAL         type_num;

    if (PObj_is_PMC_shared_TEST(pmc))
        return pmc;

    master = interpreter_array[0];
    classobj = VTABLE_get_class(interp, pmc);
    type_num = pmc->vtable->base_type;

    /* make sure metadata doesn't go away unexpectedly */
    if (PMC_metadata(pmc))
        PMC_metadata(pmc) = pt_shared_fixup(interp, PMC_metadata(pmc));

    PARROT_ASSERT(master->vtables[type_num]->pmc_class);
    /* don't want the referenced class disappearing on us */
    LOCK_INTERPRETER(master);
    pmc->vtable->pmc_class = master->vtables[type_num]->pmc_class;
    UNLOCK_INTERPRETER(master);

    ret = pmc;
    _true = pmc_new(interp, enum_class_Integer);

    /* Setting the '_ro' property switches to the read-only vtable */
    VTABLE_set_integer_native(interp, _true, 1);
    VTABLE_setprop(interp, ret, CONST_STRING(interp, "_ro"), _true);
    pmc->vtable->pmc_class = master->vtables[type_num]->pmc_class;
    Parrot_gc_add_pmc_sync(interp, ret);
    PObj_is_PMC_shared_SET(ret);

    data = PARROT_CLASS(classobj)->parents;
    n    = VTABLE_elements(interp, data);

    for (i = 0; i < n; ++i) {
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, data, i);
        VTABLE_set_pmc_keyed_int(interp, data, i, VTABLE_share_ro(interp, cur_class));
    }

    /* XXX This is perhaps not the best way to fix this up, but we
     * need to ensure that the class object won't go away when
     * this interpreter dies.
     */
    PARROT_ASSERT(ret->vtable->pmc_class);
    PARROT_ASSERT(ret->vtable->share_ro == Parrot_Object_share_ro);

    return ret;
#line 7157 "./src/pmc/object.c"
}
static  FLOATVAL
Parrot_Object_shift_float(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "shift_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, meth, pmc, meth_name, "N");
            
        }
        /* method name is shift_float */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (FLOATVAL)VTABLE_shift_float(interp, del_object);
                
            }
        }
    }
    return (FLOATVAL)interp->vtables[enum_class_default]->shift_float(interp, pmc);
    
}
static  INTVAL
Parrot_Object_shift_integer(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "shift_integer");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "I");
            
        }
        /* method name is shift_integer */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_shift_integer(interp, del_object);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->shift_integer(interp, pmc);
    
}
static  PMC *
Parrot_Object_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "shift_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "P");
            
        }
        /* method name is shift_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_shift_pmc(interp, del_object);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->shift_pmc(interp, pmc);
    
}
static  STRING *
Parrot_Object_shift_string(PARROT_INTERP, PMC *pmc)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "shift_string");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "S");
            
        }
        /* method name is shift_string */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_shift_string(interp, del_object);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->shift_string(interp, pmc);
    
}
static  PMC *
Parrot_Object_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL flag)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "slice");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPI", key, flag);
            
        }
        /* method name is slice */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (PMC*)VTABLE_slice(interp, del_object, key, flag);
                
            }
        }
    }
    return (PMC*)interp->vtables[enum_class_default]->slice(interp, pmc, key, flag);
    
}
static  void
Parrot_Object_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "splice");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vPII", value, offset, count);
            return;
        }
        /* method name is splice */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_splice(interp, del_object, value, offset, count);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->splice(interp, pmc, value, offset, count);
    return;
}
static  void
Parrot_Object_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "substr");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vIIP", offset, length, dest);
            return;
        }
        /* method name is substr */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_substr(interp, del_object, offset, length, dest);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->substr(interp, pmc, offset, length, dest);
    return;
}
static  STRING *
Parrot_Object_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "substr_str");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (STRING*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "SII", offset, length);
            
        }
        /* method name is substr_str */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (STRING*)VTABLE_substr_str(interp, del_object, offset, length);
                
            }
        }
    }
    return (STRING*)interp->vtables[enum_class_default]->substr_str(interp, pmc, offset, length);
    
}
static  PMC *
Parrot_Object_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "subtract");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PPP", value, dest);
            
        }
        /* method name is subtract */
    }
    return (PMC*)interp->vtables[enum_class_default]->subtract(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "subtract_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PNP", value, dest);
            
        }
        /* method name is subtract_float */
    }
    return (PMC*)interp->vtables[enum_class_default]->subtract_float(interp, pmc, value, dest);
    
}
static  PMC *
Parrot_Object_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "subtract_int");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (PMC*)Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "PIP", value, dest);
            
        }
        /* method name is subtract_int */
    }
    return (PMC*)interp->vtables[enum_class_default]->subtract_int(interp, pmc, value, dest);
    
}
static  void 
Parrot_Object_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 694 "./src/pmc/object.pmc"

    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        interp->vtables[enum_class_default]->thaw(interp, pmc, info);
    }
#line 7511 "./src/pmc/object.c"
}
static  void 
Parrot_Object_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 710 "./src/pmc/object.pmc"

    /* Set custom GC mark and destroy on the object. */
    PObj_custom_mark_SET(pmc);
    PObj_custom_destroy_SET(pmc);

    /* Flag that it is an object */
    PObj_is_object_SET(pmc);
#line 7524 "./src/pmc/object.c"
}
static  INTVAL 
Parrot_Object_type(PARROT_INTERP, PMC *pmc)
{
#line 629 "./src/pmc/object.pmc"

    PMC * const _class = VTABLE_get_class(interp, pmc);
    return VTABLE_type(interp, _class);
#line 7533 "./src/pmc/object.c"
}
static  INTVAL
Parrot_Object_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "type_keyed");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, meth, pmc, meth_name, "IP", key);
            
        }
        /* method name is type_keyed */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                return (INTVAL)VTABLE_type_keyed(interp, del_object, key);
                
            }
        }
    }
    return (INTVAL)interp->vtables[enum_class_default]->type_keyed(interp, pmc, key);
    
}
static  void
Parrot_Object_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "unshift_float");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vN", value);
            return;
        }
        /* method name is unshift_float */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_unshift_float(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->unshift_float(interp, pmc, value);
    return;
}
static  void
Parrot_Object_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "unshift_integer");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vI", value);
            return;
        }
        /* method name is unshift_integer */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_unshift_integer(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->unshift_integer(interp, pmc, value);
    return;
}
static  void
Parrot_Object_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "unshift_pmc");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vP", value);
            return;
        }
        /* method name is unshift_pmc */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_unshift_pmc(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->unshift_pmc(interp, pmc, value);
    return;
}
static  void
Parrot_Object_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    Parrot_Object_attributes * const obj       = PARROT_OBJECT(pmc);
    Parrot_Class_attributes  * const _class    = PARROT_CLASS(obj->_class);
    STRING        * const meth_name = CONST_STRING_GEN(interp, "unshift_string");

    /* Walk and search for the vtable method. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);
    int i;
    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        PMC * const meth = Parrot_oo_find_vtable_override_for_class(interp, cur_class, meth_name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, pmc, meth_name, "vS", value);
            return;
        }
        /* method name is unshift_string */
        if (cur_class->vtable->base_type == enum_class_PMCProxy) {
            /* Get the PMC instance and call the vtable method on that. */
            STRING * const proxy      = CONST_STRING_GEN(interp, "proxy");
            PMC    * const del_object = VTABLE_get_attr_str(interp, pmc, proxy);

            if (!PMC_IS_NULL(del_object)) {
                VTABLE_unshift_string(interp, del_object, value);
                return;
            }
        }
    }
    interp->vtables[enum_class_default]->unshift_string(interp, pmc, value);
    return;
}
static  void 
Parrot_Object_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 669 "./src/pmc/object.pmc"

    Parrot_Object_attributes * const obj_data = PARROT_OBJECT(pmc);
    PMC **pos;

    /* 1) visit class */
    pos            = &obj_data->_class;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    /* 2) visit the attributes */
    pos      = &obj_data->attrib_store;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);
#line 7722 "./src/pmc/object.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Object_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Object_absolute;
    vt->add = Parrot_Object_add;
    vt->add_attribute = Parrot_Object_add_attribute;
    vt->add_float = Parrot_Object_add_float;
    vt->add_int = Parrot_Object_add_int;
    vt->add_method = Parrot_Object_add_method;
    vt->add_parent = Parrot_Object_add_parent;
    vt->add_role = Parrot_Object_add_role;
    vt->add_vtable_override = Parrot_Object_add_vtable_override;
    vt->assign_pmc = Parrot_Object_assign_pmc;
    vt->assign_string_native = Parrot_Object_assign_string_native;
    vt->bitwise_and = Parrot_Object_bitwise_and;
    vt->bitwise_and_int = Parrot_Object_bitwise_and_int;
    vt->bitwise_ands = Parrot_Object_bitwise_ands;
    vt->bitwise_ands_str = Parrot_Object_bitwise_ands_str;
    vt->bitwise_lsr = Parrot_Object_bitwise_lsr;
    vt->bitwise_lsr_int = Parrot_Object_bitwise_lsr_int;
    vt->bitwise_not = Parrot_Object_bitwise_not;
    vt->bitwise_nots = Parrot_Object_bitwise_nots;
    vt->bitwise_or = Parrot_Object_bitwise_or;
    vt->bitwise_or_int = Parrot_Object_bitwise_or_int;
    vt->bitwise_ors = Parrot_Object_bitwise_ors;
    vt->bitwise_ors_str = Parrot_Object_bitwise_ors_str;
    vt->bitwise_shl = Parrot_Object_bitwise_shl;
    vt->bitwise_shl_int = Parrot_Object_bitwise_shl_int;
    vt->bitwise_shr = Parrot_Object_bitwise_shr;
    vt->bitwise_shr_int = Parrot_Object_bitwise_shr_int;
    vt->bitwise_xor = Parrot_Object_bitwise_xor;
    vt->bitwise_xor_int = Parrot_Object_bitwise_xor_int;
    vt->bitwise_xors = Parrot_Object_bitwise_xors;
    vt->bitwise_xors_str = Parrot_Object_bitwise_xors_str;
    vt->can = Parrot_Object_can;
    vt->clone = Parrot_Object_clone;
    vt->clone_pmc = Parrot_Object_clone_pmc;
    vt->cmp = Parrot_Object_cmp;
    vt->cmp_num = Parrot_Object_cmp_num;
    vt->cmp_pmc = Parrot_Object_cmp_pmc;
    vt->cmp_string = Parrot_Object_cmp_string;
    vt->concatenate = Parrot_Object_concatenate;
    vt->concatenate_str = Parrot_Object_concatenate_str;
    vt->decrement = Parrot_Object_decrement;
    vt->defined = Parrot_Object_defined;
    vt->defined_keyed = Parrot_Object_defined_keyed;
    vt->defined_keyed_int = Parrot_Object_defined_keyed_int;
    vt->defined_keyed_str = Parrot_Object_defined_keyed_str;
    vt->delete_keyed = Parrot_Object_delete_keyed;
    vt->delete_keyed_int = Parrot_Object_delete_keyed_int;
    vt->delete_keyed_str = Parrot_Object_delete_keyed_str;
    vt->delprop = Parrot_Object_delprop;
    vt->destroy = Parrot_Object_destroy;
    vt->divide = Parrot_Object_divide;
    vt->divide_float = Parrot_Object_divide_float;
    vt->divide_int = Parrot_Object_divide_int;
    vt->does = Parrot_Object_does;
    vt->does_pmc = Parrot_Object_does_pmc;
    vt->elements = Parrot_Object_elements;
    vt->exists_keyed = Parrot_Object_exists_keyed;
    vt->exists_keyed_int = Parrot_Object_exists_keyed_int;
    vt->exists_keyed_str = Parrot_Object_exists_keyed_str;
    vt->find_method = Parrot_Object_find_method;
    vt->floor_divide = Parrot_Object_floor_divide;
    vt->floor_divide_float = Parrot_Object_floor_divide_float;
    vt->floor_divide_int = Parrot_Object_floor_divide_int;
    vt->freeze = Parrot_Object_freeze;
    vt->get_attr_keyed = Parrot_Object_get_attr_keyed;
    vt->get_attr_str = Parrot_Object_get_attr_str;
    vt->get_bignum = Parrot_Object_get_bignum;
    vt->get_bool = Parrot_Object_get_bool;
    vt->get_class = Parrot_Object_get_class;
    vt->get_integer = Parrot_Object_get_integer;
    vt->get_integer_keyed = Parrot_Object_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Object_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Object_get_integer_keyed_str;
    vt->get_iter = Parrot_Object_get_iter;
    vt->get_namespace = Parrot_Object_get_namespace;
    vt->get_number = Parrot_Object_get_number;
    vt->get_number_keyed = Parrot_Object_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Object_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Object_get_number_keyed_str;
    vt->get_pmc = Parrot_Object_get_pmc;
    vt->get_pmc_keyed = Parrot_Object_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Object_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Object_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Object_get_pointer;
    vt->get_pointer_keyed = Parrot_Object_get_pointer_keyed;
    vt->get_pointer_keyed_int = Parrot_Object_get_pointer_keyed_int;
    vt->get_pointer_keyed_str = Parrot_Object_get_pointer_keyed_str;
    vt->get_repr = Parrot_Object_get_repr;
    vt->get_string = Parrot_Object_get_string;
    vt->get_string_keyed = Parrot_Object_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Object_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Object_get_string_keyed_str;
    vt->getprop = Parrot_Object_getprop;
    vt->getprops = Parrot_Object_getprops;
    vt->i_absolute = Parrot_Object_i_absolute;
    vt->i_add = Parrot_Object_i_add;
    vt->i_add_float = Parrot_Object_i_add_float;
    vt->i_add_int = Parrot_Object_i_add_int;
    vt->i_bitwise_and = Parrot_Object_i_bitwise_and;
    vt->i_bitwise_and_int = Parrot_Object_i_bitwise_and_int;
    vt->i_bitwise_ands = Parrot_Object_i_bitwise_ands;
    vt->i_bitwise_ands_str = Parrot_Object_i_bitwise_ands_str;
    vt->i_bitwise_lsr = Parrot_Object_i_bitwise_lsr;
    vt->i_bitwise_lsr_int = Parrot_Object_i_bitwise_lsr_int;
    vt->i_bitwise_not = Parrot_Object_i_bitwise_not;
    vt->i_bitwise_nots = Parrot_Object_i_bitwise_nots;
    vt->i_bitwise_or = Parrot_Object_i_bitwise_or;
    vt->i_bitwise_or_int = Parrot_Object_i_bitwise_or_int;
    vt->i_bitwise_ors = Parrot_Object_i_bitwise_ors;
    vt->i_bitwise_ors_str = Parrot_Object_i_bitwise_ors_str;
    vt->i_bitwise_shl = Parrot_Object_i_bitwise_shl;
    vt->i_bitwise_shl_int = Parrot_Object_i_bitwise_shl_int;
    vt->i_bitwise_shr = Parrot_Object_i_bitwise_shr;
    vt->i_bitwise_shr_int = Parrot_Object_i_bitwise_shr_int;
    vt->i_bitwise_xor = Parrot_Object_i_bitwise_xor;
    vt->i_bitwise_xor_int = Parrot_Object_i_bitwise_xor_int;
    vt->i_bitwise_xors = Parrot_Object_i_bitwise_xors;
    vt->i_bitwise_xors_str = Parrot_Object_i_bitwise_xors_str;
    vt->i_concatenate = Parrot_Object_i_concatenate;
    vt->i_concatenate_str = Parrot_Object_i_concatenate_str;
    vt->i_divide = Parrot_Object_i_divide;
    vt->i_divide_float = Parrot_Object_i_divide_float;
    vt->i_divide_int = Parrot_Object_i_divide_int;
    vt->i_floor_divide = Parrot_Object_i_floor_divide;
    vt->i_floor_divide_float = Parrot_Object_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_Object_i_floor_divide_int;
    vt->i_logical_not = Parrot_Object_i_logical_not;
    vt->i_modulus = Parrot_Object_i_modulus;
    vt->i_modulus_float = Parrot_Object_i_modulus_float;
    vt->i_modulus_int = Parrot_Object_i_modulus_int;
    vt->i_multiply = Parrot_Object_i_multiply;
    vt->i_multiply_float = Parrot_Object_i_multiply_float;
    vt->i_multiply_int = Parrot_Object_i_multiply_int;
    vt->i_neg = Parrot_Object_i_neg;
    vt->i_pow = Parrot_Object_i_pow;
    vt->i_pow_float = Parrot_Object_i_pow_float;
    vt->i_pow_int = Parrot_Object_i_pow_int;
    vt->i_repeat = Parrot_Object_i_repeat;
    vt->i_repeat_int = Parrot_Object_i_repeat_int;
    vt->i_subtract = Parrot_Object_i_subtract;
    vt->i_subtract_float = Parrot_Object_i_subtract_float;
    vt->i_subtract_int = Parrot_Object_i_subtract_int;
    vt->increment = Parrot_Object_increment;
    vt->init = Parrot_Object_init;
    vt->init_pmc = Parrot_Object_init_pmc;
    vt->inspect = Parrot_Object_inspect;
    vt->inspect_str = Parrot_Object_inspect_str;
    vt->instantiate = Parrot_Object_instantiate;
    vt->instantiate_str = Parrot_Object_instantiate_str;
    vt->invoke = Parrot_Object_invoke;
    vt->is_equal = Parrot_Object_is_equal;
    vt->is_equal_num = Parrot_Object_is_equal_num;
    vt->is_equal_string = Parrot_Object_is_equal_string;
    vt->is_same = Parrot_Object_is_same;
    vt->isa = Parrot_Object_isa;
    vt->isa_pmc = Parrot_Object_isa_pmc;
    vt->logical_and = Parrot_Object_logical_and;
    vt->logical_not = Parrot_Object_logical_not;
    vt->logical_or = Parrot_Object_logical_or;
    vt->logical_xor = Parrot_Object_logical_xor;
    vt->mark = Parrot_Object_mark;
    vt->modulus = Parrot_Object_modulus;
    vt->modulus_float = Parrot_Object_modulus_float;
    vt->modulus_int = Parrot_Object_modulus_int;
    vt->morph = Parrot_Object_morph;
    vt->multiply = Parrot_Object_multiply;
    vt->multiply_float = Parrot_Object_multiply_float;
    vt->multiply_int = Parrot_Object_multiply_int;
    vt->name = Parrot_Object_name;
    vt->neg = Parrot_Object_neg;
    vt->pop_float = Parrot_Object_pop_float;
    vt->pop_integer = Parrot_Object_pop_integer;
    vt->pop_pmc = Parrot_Object_pop_pmc;
    vt->pop_string = Parrot_Object_pop_string;
    vt->pow = Parrot_Object_pow;
    vt->pow_float = Parrot_Object_pow_float;
    vt->pow_int = Parrot_Object_pow_int;
    vt->push_float = Parrot_Object_push_float;
    vt->push_integer = Parrot_Object_push_integer;
    vt->push_pmc = Parrot_Object_push_pmc;
    vt->push_string = Parrot_Object_push_string;
    vt->remove_attribute = Parrot_Object_remove_attribute;
    vt->remove_method = Parrot_Object_remove_method;
    vt->remove_parent = Parrot_Object_remove_parent;
    vt->remove_role = Parrot_Object_remove_role;
    vt->remove_vtable_override = Parrot_Object_remove_vtable_override;
    vt->repeat = Parrot_Object_repeat;
    vt->repeat_int = Parrot_Object_repeat_int;
    vt->set_attr_keyed = Parrot_Object_set_attr_keyed;
    vt->set_attr_str = Parrot_Object_set_attr_str;
    vt->set_bignum_int = Parrot_Object_set_bignum_int;
    vt->set_bignum_num = Parrot_Object_set_bignum_num;
    vt->set_bignum_str = Parrot_Object_set_bignum_str;
    vt->set_bool = Parrot_Object_set_bool;
    vt->set_integer_keyed = Parrot_Object_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_Object_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_Object_set_integer_keyed_str;
    vt->set_integer_native = Parrot_Object_set_integer_native;
    vt->set_number_keyed = Parrot_Object_set_number_keyed;
    vt->set_number_keyed_int = Parrot_Object_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_Object_set_number_keyed_str;
    vt->set_number_native = Parrot_Object_set_number_native;
    vt->set_pmc = Parrot_Object_set_pmc;
    vt->set_pmc_keyed = Parrot_Object_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_Object_set_pmc_keyed_int;
    vt->set_pmc_keyed_str = Parrot_Object_set_pmc_keyed_str;
    vt->set_pointer = Parrot_Object_set_pointer;
    vt->set_pointer_keyed = Parrot_Object_set_pointer_keyed;
    vt->set_pointer_keyed_int = Parrot_Object_set_pointer_keyed_int;
    vt->set_pointer_keyed_str = Parrot_Object_set_pointer_keyed_str;
    vt->set_string_keyed = Parrot_Object_set_string_keyed;
    vt->set_string_keyed_int = Parrot_Object_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_Object_set_string_keyed_str;
    vt->set_string_native = Parrot_Object_set_string_native;
    vt->setprop = Parrot_Object_setprop;
    vt->share = Parrot_Object_share;
    vt->share_ro = Parrot_Object_share_ro;
    vt->shift_float = Parrot_Object_shift_float;
    vt->shift_integer = Parrot_Object_shift_integer;
    vt->shift_pmc = Parrot_Object_shift_pmc;
    vt->shift_string = Parrot_Object_shift_string;
    vt->slice = Parrot_Object_slice;
    vt->splice = Parrot_Object_splice;
    vt->substr = Parrot_Object_substr;
    vt->substr_str = Parrot_Object_substr_str;
    vt->subtract = Parrot_Object_subtract;
    vt->subtract_float = Parrot_Object_subtract_float;
    vt->subtract_int = Parrot_Object_subtract_int;
    vt->thaw = Parrot_Object_thaw;
    vt->thawfinish = Parrot_Object_thawfinish;
    vt->type = Parrot_Object_type;
    vt->type_keyed = Parrot_Object_type_keyed;
    vt->unshift_float = Parrot_Object_unshift_float;
    vt->unshift_integer = Parrot_Object_unshift_integer;
    vt->unshift_pmc = Parrot_Object_unshift_pmc;
    vt->unshift_string = Parrot_Object_unshift_string;
    vt->visit = Parrot_Object_visit;
    vt->attr_size = sizeof(Parrot_Object_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Object_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Object_absolute;
    vt->add = Parrot_Object_add;
    vt->add_float = Parrot_Object_add_float;
    vt->add_int = Parrot_Object_add_int;
    vt->bitwise_and = Parrot_Object_bitwise_and;
    vt->bitwise_and_int = Parrot_Object_bitwise_and_int;
    vt->bitwise_ands = Parrot_Object_bitwise_ands;
    vt->bitwise_ands_str = Parrot_Object_bitwise_ands_str;
    vt->bitwise_lsr = Parrot_Object_bitwise_lsr;
    vt->bitwise_lsr_int = Parrot_Object_bitwise_lsr_int;
    vt->bitwise_not = Parrot_Object_bitwise_not;
    vt->bitwise_nots = Parrot_Object_bitwise_nots;
    vt->bitwise_or = Parrot_Object_bitwise_or;
    vt->bitwise_or_int = Parrot_Object_bitwise_or_int;
    vt->bitwise_ors = Parrot_Object_bitwise_ors;
    vt->bitwise_ors_str = Parrot_Object_bitwise_ors_str;
    vt->bitwise_shl = Parrot_Object_bitwise_shl;
    vt->bitwise_shl_int = Parrot_Object_bitwise_shl_int;
    vt->bitwise_shr = Parrot_Object_bitwise_shr;
    vt->bitwise_shr_int = Parrot_Object_bitwise_shr_int;
    vt->bitwise_xor = Parrot_Object_bitwise_xor;
    vt->bitwise_xor_int = Parrot_Object_bitwise_xor_int;
    vt->bitwise_xors = Parrot_Object_bitwise_xors;
    vt->bitwise_xors_str = Parrot_Object_bitwise_xors_str;
    vt->can = Parrot_Object_can;
    vt->clone = Parrot_Object_clone;
    vt->clone_pmc = Parrot_Object_clone_pmc;
    vt->cmp = Parrot_Object_cmp;
    vt->cmp_num = Parrot_Object_cmp_num;
    vt->cmp_pmc = Parrot_Object_cmp_pmc;
    vt->cmp_string = Parrot_Object_cmp_string;
    vt->concatenate = Parrot_Object_concatenate;
    vt->concatenate_str = Parrot_Object_concatenate_str;
    vt->defined = Parrot_Object_defined;
    vt->defined_keyed = Parrot_Object_defined_keyed;
    vt->defined_keyed_int = Parrot_Object_defined_keyed_int;
    vt->defined_keyed_str = Parrot_Object_defined_keyed_str;
    vt->delprop = Parrot_Object_delprop;
    vt->destroy = Parrot_Object_destroy;
    vt->divide = Parrot_Object_divide;
    vt->divide_float = Parrot_Object_divide_float;
    vt->divide_int = Parrot_Object_divide_int;
    vt->does = Parrot_Object_does;
    vt->does_pmc = Parrot_Object_does_pmc;
    vt->elements = Parrot_Object_elements;
    vt->exists_keyed = Parrot_Object_exists_keyed;
    vt->exists_keyed_int = Parrot_Object_exists_keyed_int;
    vt->exists_keyed_str = Parrot_Object_exists_keyed_str;
    vt->find_method = Parrot_Object_find_method;
    vt->floor_divide = Parrot_Object_floor_divide;
    vt->floor_divide_float = Parrot_Object_floor_divide_float;
    vt->floor_divide_int = Parrot_Object_floor_divide_int;
    vt->freeze = Parrot_Object_freeze;
    vt->get_attr_keyed = Parrot_Object_get_attr_keyed;
    vt->get_attr_str = Parrot_Object_get_attr_str;
    vt->get_bignum = Parrot_Object_get_bignum;
    vt->get_bool = Parrot_Object_get_bool;
    vt->get_class = Parrot_Object_get_class;
    vt->get_integer = Parrot_Object_get_integer;
    vt->get_integer_keyed = Parrot_Object_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Object_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Object_get_integer_keyed_str;
    vt->get_iter = Parrot_Object_get_iter;
    vt->get_namespace = Parrot_Object_get_namespace;
    vt->get_number = Parrot_Object_get_number;
    vt->get_number_keyed = Parrot_Object_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Object_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Object_get_number_keyed_str;
    vt->get_pmc = Parrot_Object_get_pmc;
    vt->get_pmc_keyed = Parrot_Object_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Object_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Object_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Object_get_pointer;
    vt->get_pointer_keyed = Parrot_Object_get_pointer_keyed;
    vt->get_pointer_keyed_int = Parrot_Object_get_pointer_keyed_int;
    vt->get_pointer_keyed_str = Parrot_Object_get_pointer_keyed_str;
    vt->get_repr = Parrot_Object_get_repr;
    vt->get_string = Parrot_Object_get_string;
    vt->get_string_keyed = Parrot_Object_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Object_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Object_get_string_keyed_str;
    vt->getprop = Parrot_Object_getprop;
    vt->getprops = Parrot_Object_getprops;
    vt->init = Parrot_Object_init;
    vt->init_pmc = Parrot_Object_init_pmc;
    vt->inspect = Parrot_Object_inspect;
    vt->inspect_str = Parrot_Object_inspect_str;
    vt->instantiate = Parrot_Object_instantiate;
    vt->instantiate_str = Parrot_Object_instantiate_str;
    vt->invoke = Parrot_Object_invoke;
    vt->is_equal = Parrot_Object_is_equal;
    vt->is_equal_num = Parrot_Object_is_equal_num;
    vt->is_equal_string = Parrot_Object_is_equal_string;
    vt->is_same = Parrot_Object_is_same;
    vt->isa = Parrot_Object_isa;
    vt->isa_pmc = Parrot_Object_isa_pmc;
    vt->logical_and = Parrot_Object_logical_and;
    vt->logical_not = Parrot_Object_logical_not;
    vt->logical_or = Parrot_Object_logical_or;
    vt->logical_xor = Parrot_Object_logical_xor;
    vt->mark = Parrot_Object_mark;
    vt->modulus = Parrot_Object_modulus;
    vt->modulus_float = Parrot_Object_modulus_float;
    vt->modulus_int = Parrot_Object_modulus_int;
    vt->multiply = Parrot_Object_multiply;
    vt->multiply_float = Parrot_Object_multiply_float;
    vt->multiply_int = Parrot_Object_multiply_int;
    vt->name = Parrot_Object_name;
    vt->neg = Parrot_Object_neg;
    vt->pow = Parrot_Object_pow;
    vt->pow_float = Parrot_Object_pow_float;
    vt->pow_int = Parrot_Object_pow_int;
    vt->repeat = Parrot_Object_repeat;
    vt->repeat_int = Parrot_Object_repeat_int;
    vt->setprop = Parrot_Object_setprop;
    vt->share = Parrot_Object_share;
    vt->share_ro = Parrot_Object_share_ro;
    vt->slice = Parrot_Object_slice;
    vt->substr = Parrot_Object_substr;
    vt->substr_str = Parrot_Object_substr_str;
    vt->subtract = Parrot_Object_subtract;
    vt->subtract_float = Parrot_Object_subtract_float;
    vt->subtract_int = Parrot_Object_subtract_int;
    vt->type = Parrot_Object_type;
    vt->type_keyed = Parrot_Object_type_keyed;
    vt->visit = Parrot_Object_visit;
    vt->attr_size = sizeof(Parrot_Object_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Object_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Object_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Object_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Object_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Object_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Object", 6, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Object_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Object")), PMCNULL);
    return isa;
}

void
Parrot_Object_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "F_class Fattrib_store ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Object_get_vtable(interp);
        vt->base_type      = enum_class_Object;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Object");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Object_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Object;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Object_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Object_class_init */
#line 801 "./src/pmc/object.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd15_objects.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
